'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5168] on 16 October 2006 at 4:35:31 pm'!
B3DFloatArray variableWordSubclass: #B3DVector3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Vectors'!
!B3DVector3 commentStamp: '<historical>' prior: 0!
I represent simple 3D coordinates, used throughout the entire Balloon 3D engine.!


!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
x
	^self at: 1! !

!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
x: aFloat
	self at: 1 put: aFloat! !

!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
y
	^self at: 2! !

!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
y: aFloat
	self at: 2 put: aFloat! !

!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
z
	^self at: 3! !

!B3DVector3 methodsFor: 'accessing' stamp: 'ar 2/1/1999 21:24'!
z: aFloat
	self at: 3 put: aFloat! !


!B3DVector3 methodsFor: 'vector functions'!
cross: aVector 
	"calculate the cross product from the receiver with aVector"
	^self species
		x: self y * aVector z - (aVector y * self z)
		y: self z * aVector x - (aVector z * self x)
		z: self x * aVector y - (aVector x * self y)! !

!B3DVector3 methodsFor: 'vector functions'!
length: newLength
	self safelyNormalize *= newLength! !

!B3DVector3 methodsFor: 'vector functions' stamp: 'ar 2/6/1999 00:32'!
max: aVector
	^B3DVector3 
		x: (self x max: aVector x)
		y: (self y max: aVector y)
		z: (self z max: aVector z)! !

!B3DVector3 methodsFor: 'vector functions' stamp: 'ar 2/6/1999 00:31'!
min: aVector
	^B3DVector3 
		x: (self x min: aVector x)
		y: (self y min: aVector y)
		z: (self z min: aVector z)! !

!B3DVector3 methodsFor: 'vector functions'!
normalize
	self /= self length! !

!B3DVector3 methodsFor: 'vector functions'!
normalized
	^self / self length! !

!B3DVector3 methodsFor: 'vector functions' stamp: 'ar 2/7/1999 00:43'!
safelyNormalize
	"Safely normalize the receiver, e.g. check if the length is non-zero"
	| length |
	length _ self length.
	length = 1.0 ifTrue:[^self].
	length = 0.0 ifFalse:[self /= length].! !

!B3DVector3 methodsFor: 'vector functions'!
safelyNormalized
	"Safely normalize the receiver, e.g. check if the length is non-zero"
	^self copy safelyNormalize! !

!B3DVector3 methodsFor: 'vector functions'!
squaredLength: newLength
	self length: newLength sqrt! !


!B3DVector3 methodsFor: 'private'!
privateLoadFrom: srcObject
	self x: srcObject x y: srcObject y z: srcObject z.! !


!B3DVector3 methodsFor: 'initialize'!
x: x y: y z: z
	self x: x.
	self y: y.
	self z: z.! !


!B3DVector3 methodsFor: 'converting' stamp: 'ar 2/6/1999 00:06'!
asB3DVector3
	^self! !

!B3DVector3 methodsFor: 'converting' stamp: 'ar 2/6/1999 00:07'!
asB3DVector4
	^B3DVector4 x: self x y: self y z: self z w: 1.0! !

!B3DVector3 methodsFor: 'converting' stamp: 'ar 5/23/2001 00:24'!
asPoint
	^self x @ self y! !


!B3DVector3 methodsFor: 'interpolating' stamp: 'jsp 2/9/1999 11:17'!
interpolateTo: end at: amountDone
	"Interpolates a new vector based on the instance vector, the end state vector, and the amount already done (between 0 and 1)."

	| tX tY tZ |
	tX _ self x.
	tY _ self y.
	tZ _ self z.

	^ (B3DVector3 x: (tX + (((end x) - tX) * amountDone))
				y: (tY + (((end y) - tY) * amountDone))
				z: (tZ + (((end z) - tZ) * amountDone))).
! !


!B3DVector3 methodsFor: 'testing' stamp: 'laza 3/16/2000 16:30'!
isZero
	^self = B3DVector3 zero! !


!B3DVector3 methodsFor: 'enumerating' stamp: 'ar 5/20/2001 00:05'!
vertexPositionsDo: aBlock
	aBlock value: self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

B3DVector3 class
	instanceVariableNames: ''!

!B3DVector3 class methodsFor: 'instance creation' stamp: 'ar 2/1/1999 21:23'!
numElements
	^3! !

!B3DVector3 class methodsFor: 'instance creation' stamp: 'ar 2/15/1999 02:56'!
value: aFloat
	^self x: aFloat y: aFloat z: aFloat! !

!B3DVector3 class methodsFor: 'instance creation'!
x: x y: y z: z
	^self new x: x y: y z: z! !

!B3DVector3 class methodsFor: 'instance creation'!
zero
	^self new! !
