'From Squeak3.1alpha of 7 March 2001 [latest update: #4261] on 21 August 2001 at 10:39:58 pm'!
"Change Set:		BackgroundTweaks
Date:			7 July 2001
Author:			Jim Benson

Adds two more styles of background images;

Stretch   which takes an image and stretches it to take up the space of the world
Center    which centers an image in the middle of the world

A test of these attributes are available as a menu option on an image file under FileList"!


!FileList methodsFor: 'file list menu' stamp: 'jlb 8/21/2001 22:39'!
centerBackground
	| world myStream image |
	world _ self currentWorld.
	myStream _ (directory readOnlyFileNamed: fileName) binary.
	image _ Form fromBinaryStream: myStream.
	myStream close.
	world backgroundSketch: ( SketchMorph withForm: image ).
	world centerBackground.! !

!FileList methodsFor: 'file list menu' stamp: 'jlb 7/7/2001 13:49'!
openAsBackground
	"Set an image as a background image.  Support Squeak's common file format 
	(GIF, JPG, PNG, 'Form stoteOn: (run coded)' and BMP)"

	| aMenu |
	Smalltalk isMorphic ifTrue: [
		aMenu _ MenuMorph new defaultTarget: self.
		aMenu addTitle: 'Background Style'.
		aMenu add: 'tiled' action: #tileBackground.
		aMenu add: 'centered' action: #centerBackground.
		aMenu add: 'stretched' action: #stretchBackground.
		aMenu popUpInWorld.
		^ self.
	].
	(Form fromFileNamed: self fullName) setAsBackground! !

!FileList methodsFor: 'file list menu' stamp: 'jlb 8/21/2001 22:35'!
stretchBackground
	| world myStream image |
	world _ self currentWorld.
	world color: Preferences desktopColor.
	myStream _ (directory readOnlyFileNamed: fileName) binary.
	image _ Form fromBinaryStream: myStream.
	myStream close.

	world
		backgroundSketch: (SketchMorph withForm: image).
	world stretchBackground! !

!FileList methodsFor: 'file list menu' stamp: 'jlb 7/7/2001 14:55'!
tileBackground
	| world |
	world _ self currentWorld.
	world color: Preferences desktopColor.
	world backgroundSketch: nil.
	(Form fromFileNamed: self fullName) setAsBackground! !


!PasteUpMorph methodsFor: 'painting' stamp: 'jlb 7/7/2001 12:39'!
centerBackground

	" Center the background sketch in the middle of the world "
	backgroundMorph ifNil: [^ nil].
	backgroundMorph setProperty: #backgroundStyle toValue: #center.
	" extent will recenter the background "
	self extent: ( self extent ).
! !

!PasteUpMorph methodsFor: 'painting' stamp: 'jlb 7/7/2001 12:40'!
stretchBackground

	" stretch the background sketch to cover the entire world "
	backgroundMorph ifNil: [^ nil].
	backgroundMorph setProperty: #backgroundStyle toValue: #stretch ;
		position: 0 @ 0.
	self extent: ( self extent ).
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'jlb 7/7/2001 14:41'!
allNonFlapRelatedSubmorphs
	"Answer all non-window submorphs that are not flap-related"
	" don't add the worlds backgroundMorph to this list "
	^ submorphs select:
		[:m | ((m isKindOf: SystemWindow) not and: [m isFlapOrTab not]) and: [(m == backgroundMorph) not]]! !

!PasteUpMorph methodsFor: 'world state' stamp: 'jlb 7/7/2001 12:31'!
extent: aPoint 
	| picExtent |
	super extent: aPoint.
	"if we have a background check to see if it wants to be resized"
	" backgroundMorphs have three styles -
			#none
			#stretch    -- stretch the sketch to fill the whole world
			#center		  center the sketch in the world ; sketch will be surrounded by color of world
    "
	backgroundMorph
		ifNotNil: [backgroundMorph
				valueOfProperty: #backgroundStyle
				ifPresentDo: [:bStyle | 
					bStyle == #stretch
						ifTrue: [backgroundMorph extent: aPoint].
					bStyle == #center
						ifTrue: [picExtent _ backgroundMorph extent.
							picExtent > aPoint
								ifTrue: [backgroundMorph position: 0 @ 0]
								ifFalse: [backgroundMorph position: (aPoint - picExtent / 2) asIntegerPoint]]]].
	worldState
		ifNotNil: [worldState viewBox
				ifNotNil: [worldState canvas: nil.
					worldState viewBox: bounds]]! !

