'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 22 April 2002 at 2:30:11 pm'!
Smalltalk renameClassNamed: #BlinkingCursorMorph as: #BlinkingCaretMorph!
Morph subclass: #BlinkingCaretMorph
	instanceVariableNames: ''
	classVariableNames: 'BlinkTime '
	poolDictionaries: ''
	category: 'Zurgle-True Type Fonts'!

!BlinkingCaretMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/21/2002 20:06'!
step
	self visible: self visible not.! !

!BlinkingCaretMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/22/2002 13:51'!
stepTime
	^ BlinkTime! !

!BlinkingCaretMorph methodsFor: 'initialization' stamp: 'jlb 4/21/2002 20:07'!
initialize
	super initialize.
	self extent: 1@16.
	self color: Color black.! !


!BlinkingCaretMorph class methodsFor: 'class initialization' stamp: 'jlb 4/22/2002 13:51'!
blinkTime: anInteger
	BlinkTime _ anInteger! !

!BlinkingCaretMorph class methodsFor: 'class initialization' stamp: 'jlb 4/22/2002 13:50'!
initialize
	" BlinkingCaretMorph initialize "
	super initialize.
	BlinkTime _ 500.! !


!NewParagraph methodsFor: 'access' stamp: 'jlb 4/21/2002 22:09'!
selectionStart
	^ selectionStart! !

!NewParagraph methodsFor: 'access' stamp: 'jlb 4/21/2002 22:09'!
selectionStop
	^ selectionStop! !

!NewParagraph methodsFor: 'display' stamp: 'jlb 4/22/2002 14:02'!
displaySelectionInLine: line on: aCanvas
	| leftX rightX |
	selectionStart ifNil: [^ self].  "No selection"
	selectionStart = selectionStop
		ifTrue: ["Only show caret on line where clicked"
				selectionStart textLine ~= line ifTrue: [^ self]]
		ifFalse: ["Test entire selection before or after here"
				(selectionStop stringIndex < line first
					or: [selectionStart stringIndex > (line last+1)])
					ifTrue: [^ self].  "No selection on this line"
				(selectionStop stringIndex = line first
					and: [selectionStop textLine ~= line])
					ifTrue: [^ self].  "Selection ends on line above"
				(selectionStart stringIndex = (line last+1)
					and: [selectionStop textLine ~= line])
					ifTrue: [^ self]].  "Selection begins on line below"

	selectionStart stringIndex < line first
		ifTrue: [leftX _ line left]
		ifFalse: [leftX _ selectionStart left].
	(selectionStop stringIndex > (line last+1)
			or: [selectionStop stringIndex = (line last+1)
					and: [selectionStop textLine ~= line]])
		ifTrue: [rightX _ line right]
		ifFalse: [rightX _ selectionStop left].
	selectionStart = selectionStop

	ifFalse:
		[aCanvas fillRectangle: (leftX@line top corner: rightX@line bottom)
				color: self selectionColor]
! !


!TextMorph methodsFor: 'editing' stamp: 'jlb 4/22/2002 13:09'!
keyboardFocusChange: aBoolean
	| w |
	aBoolean
		ifTrue: ["A hand is wanting to send us characters..."
				self hasFocus ifFalse: [self editor "Forces install"]]
		ifFalse: ["A hand has clicked elsewhere..."
				(w _ self world) == nil ifFalse:
					[w handsDo: [:h | h keyboardFocus == self ifTrue: [^ self]].
					"Release control unless some hand is still holding on"
					self releaseEditor]].
	self
		submorphsDo: [:m | (m isKindOf: BlinkingCaretMorph)
				ifTrue: [self hasFocus
						ifFalse: [m delete]]]! !

!TextMorph methodsFor: 'private' stamp: 'jlb 4/22/2002 14:28'!
selectionChanged
	"check to see if this paragraph should have a blinking caret"
	| blinker blinkFlag blinkBounds |
	blinkFlag _ paragraph selectionStart = paragraph selectionStop & self hasFocus.
	self paragraph selectionRects
		do: [:r | self invalidRect: r].
	self
		submorphsDo: [:m | (m isKindOf: BlinkingCaretMorph)
				ifTrue: [blinker _ m.
					blinkFlag
						ifTrue: [m visible: true]
						ifFalse: [m delete]]].
	paragraph selectionStart
		ifNil: [^ self].
	blinkFlag
		ifTrue: ["get the bounding rectangle of the cursor"
			(paragraph selectionRectsFrom: paragraph selectionStart to: paragraph selectionStop)
				do: [:r1 | 
					"the blinker is 1 pixel wide in this implementation"
					blinkBounds _ r1 topCenter corner: r1 bottomCenter + (1 @ 0).
					blinker
						ifNil: [self
								addMorph: (BlinkingCaretMorph new bounds: blinkBounds)]
						ifNotNil: [blinker bounds: blinkBounds]]]! !

BlinkingCaretMorph initialize!
