'From Squeak3.1alpha of 4 February 2001 [latest update: #3641] on 18 February 2001 at 8:31:26 pm'!
InterpreterPlugin subclass: #FontPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak-Plugins'!

!FontPlugin commentStamp: 'ar 2/18/2001 19:36' prior: 0!
FontPlugin translate.!

StrikeFont subclass: #HostFont
	instanceVariableNames: 'fullWidth kernPairs '
	classVariableNames: ''
	poolDictionaries: 'TextConstants '
	category: 'Graphics-Text'!

!FontPlugin methodsFor: 'initialize' stamp: 'ar 6/4/2000 19:18'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'ioFontInit()' inSmalltalk:[true]! !

!FontPlugin methodsFor: 'initialize' stamp: 'ar 6/4/2000 19:18'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'ioFontShutdown()' inSmalltalk:[true]! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:11'!
primitiveCreateFont
	| fontName fontFlags fontSize fontNameLength fontNameIndex fontID |
	self export: true.
	interpreterProxy methodArgumentCount = 3
		ifFalse:[^interpreterProxy primitiveFail].
	fontFlags _ interpreterProxy stackIntegerValue: 0.
	fontSize _ interpreterProxy stackIntegerValue: 1.
	fontName _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].
	(interpreterProxy isBytes: fontName)
		ifFalse:[^interpreterProxy primitiveFail].
	fontNameLength _ interpreterProxy byteSizeOf: fontName.
	fontNameIndex _ self cCoerce: (interpreterProxy firstIndexableField: fontName) to:'int'.
	fontID _ self cCode:'ioCreateFont(fontNameIndex, fontNameLength, fontSize, fontFlags)' inSmalltalk:[-1].
	fontID < 0 ifTrue:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 4.
	interpreterProxy pushInteger: fontID.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 20:57'!
primitiveDestroyFont
	| fontIndex |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	(self ioDestroyFont: fontIndex)
		ifFalse:[^interpreterProxy primitiveFail].
	^interpreterProxy pop: 1! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 22:24'!
primitiveFontAscent
	| fontIndex ascent |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	ascent _ self ioFontAscent: fontIndex.
	ascent >= 0
		ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: ascent.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 2/18/2001 19:33'!
primitiveFontDataSize
	| fontIndex size |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	size _ self ioGetFontDataSize: fontIndex.
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: size.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 22:25'!
primitiveFontDescent
	| fontIndex descent |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	descent _ self ioFontDescent: fontIndex.
	descent >= 0
		ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: descent.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 2/18/2001 19:57'!
primitiveFontEmbeddingFlags
	| fontIndex flags |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	flags _ self ioFontEmbeddingFlags: fontIndex.
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: flags! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 21:08'!
primitiveFontEncoding
	| fontIndex encoding |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	encoding _ self ioFontEncoding: fontIndex.
	encoding >= 0
		ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: encoding.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 8/28/2000 17:31'!
primitiveFontFullWidthOfChar
	| fontIndex charIndex array fullWidth |
	self var: #fullWidth declareC:'int fullWidth[3]'.
	self export: true.
	interpreterProxy methodArgumentCount = 2
		ifFalse:[^interpreterProxy primitiveFail].
	charIndex _ interpreterProxy stackIntegerValue: 0.
	fontIndex _ interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue:[^nil].
	(self cCode: 'ioFontFullWidthOfChar(fontIndex, charIndex, fullWidth)' inSmalltalk:[false])
		ifFalse:[^interpreterProxy primitiveFail].
	array _ interpreterProxy 
					instantiateClass: interpreterProxy classArray 
					indexableSize: 3.
	0 to: 2 do:[:i|
		interpreterProxy storeInteger: i ofObject: array withValue: (fullWidth at: i).
	].
	interpreterProxy pop: 3.
	^interpreterProxy push: array! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 8/28/2000 17:31'!
primitiveFontGetKernPair
	| fontIndex kernIndex array kernPair |
	self var: #kernPair declareC:'int kernPair[3]'.
	self export: true.
	interpreterProxy methodArgumentCount = 2
		ifFalse:[^interpreterProxy primitiveFail].
	kernIndex _ interpreterProxy stackIntegerValue: 0.
	fontIndex _ interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue:[^nil].
	(self cCode: 'ioFontGetKernPair(fontIndex, kernIndex, kernPair)' inSmalltalk:[false])
		ifFalse:[^interpreterProxy primitiveFail].
	array _ interpreterProxy 
					instantiateClass: interpreterProxy classArray 
					indexableSize: 3.
	0 to: 2 do:[:i|
		interpreterProxy storeInteger: i ofObject: array withValue: (kernPair at: i).
	].
	interpreterProxy pop: 3.
	^interpreterProxy push: array! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 21:11'!
primitiveFontGlyphOfChar
	| fontIndex charIndex formOop formBits formWidth formHeight formDepth ppw pitch |
	self export: true.
	interpreterProxy methodArgumentCount = 3
		ifFalse:[^interpreterProxy primitiveFail].
	formOop _ interpreterProxy stackObjectValue: 0.
	charIndex _ interpreterProxy stackIntegerValue: 1.
	fontIndex _ interpreterProxy stackIntegerValue: 2.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isPointers: formOop) and:[
		(interpreterProxy slotSizeOf: formOop) >= 4])
			ifFalse:[^interpreterProxy primitiveFail].
	formBits _ interpreterProxy fetchPointer: 0 ofObject: formOop.
	formWidth _ interpreterProxy fetchInteger: 1 ofObject: formOop.
	formHeight _ interpreterProxy fetchInteger: 2 ofObject: formOop.
	formDepth _ interpreterProxy fetchInteger: 3 ofObject: formOop.
	(formWidth > 0 and:[formHeight > 0 and:[formDepth > 0]])
		ifFalse:[^interpreterProxy primitiveFail].
	ppw _ 32 // formDepth.
	pitch _ formWidth + (ppw-1) // ppw * 4.
	((interpreterProxy fetchClassOf: formBits) == interpreterProxy classBitmap
		and:[(interpreterProxy byteSizeOf: formBits) = (pitch * formHeight)])
			ifFalse:[^interpreterProxy primitiveFail].
	formBits _ self cCoerce: (interpreterProxy firstIndexableField: formBits) to: 'int'.
	(self cCode:'ioFontGlyphOfChar(fontIndex, charIndex, formBits, formWidth, formHeight, formDepth)' inSmalltalk:[false])
		ifFalse:[^interpreterProxy primitiveFail].
	^interpreterProxy pop: 3.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 8/28/2000 16:06'!
primitiveFontNumKernPairs
	| fontIndex nKernPairs |
	self export: true.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	nKernPairs _ self ioFontNumKernPairs: fontIndex.
	nKernPairs >= 0
		ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 2.
	^interpreterProxy pushInteger: nKernPairs.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 21:08'!
primitiveFontWidthOfChar
	| fontIndex charIndex charWidth |
	self export: true.
	interpreterProxy methodArgumentCount = 2
		ifFalse:[^interpreterProxy primitiveFail].
	charIndex _ interpreterProxy stackIntegerValue: 0.
	fontIndex _ interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue:[^nil].
	charWidth _ self ioFont: fontIndex WidthOfChar: charIndex.
	(charWidth >= 0)
		ifFalse:[^interpreterProxy primitiveFail].
	interpreterProxy pop: 3.
	^interpreterProxy pushInteger: charWidth! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 2/18/2001 19:39'!
primitiveGetFontData
	| fontIndex buffer bufSize bufPtr result |
	self export: true.
	self var: #bufPtr type:'char *'.
	interpreterProxy methodArgumentCount = 2
		ifFalse:[^interpreterProxy primitiveFail].
	buffer _ interpreterProxy stackObjectValue: 0.
	fontIndex _ interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue:[^nil].
	(interpreterProxy isBytes: buffer) 
		ifFalse:[^interpreterProxy primitiveFail].
	bufSize _ interpreterProxy byteSizeOf: buffer.
	bufPtr _ interpreterProxy firstIndexableField: buffer.
	result _ self cCode: 'ioGetFontData(fontIndex, bufPtr, bufSize)'.
	interpreterProxy pop: 3.
	^interpreterProxy pushInteger: result.! !

!FontPlugin methodsFor: 'primitives' stamp: 'ar 6/4/2000 19:23'!
primitiveListFont
	| fontIndex fontName fontNameLen fontOop fontPtr |
	self export: true.
	self var: #fontName type:'char *'.
	self var: #fontPtr type:'char *'.
	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	fontIndex _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	fontName _ self ioListFont: fontIndex.
	fontName == nil ifTrue:[
		interpreterProxy pop: 2.
		^interpreterProxy push: interpreterProxy nilObject].
	fontNameLen _ fontName strlen.
	fontOop _ interpreterProxy 
					instantiateClass: interpreterProxy classString 
					indexableSize: fontNameLen.
	fontPtr _ interpreterProxy firstIndexableField: fontOop.
	0 to: fontNameLen-1 do:[:i| fontPtr at: i put: (fontName at: i)].
	interpreterProxy pop: 2.
	interpreterProxy push: fontOop.! !


!FontPlugin class methodsFor: 'translation' stamp: 'ar 2/18/2001 19:58'!
headerFile
^'/* FontPlugin header file */

char *ioListFont(int fontIndex);
int ioCreateFont(int fontNameIndex, int fontNameLength, int pixelSize, int flags);
int ioDestroyFont(int fontIndex);
int ioFontWidthOfChar(int fontIndex, int characterIndex);
int ioFontFullWidthOfChar(int fontIndex, int characterIndex, int width[3]);
int ioFontNumKernPairs(int fontIndex);
int ioFontGetKernPair(int fontIndex, int kernIndex, int kernPair[3]);

int ioFontGlyphOfChar(int fontIndex, int characterIndex, 
					  int formBitsIndex, int formWidth, int formHeight, int formDepth);
int ioFontEncoding(int fontIndex);
int ioFontAscent(int fontIndex);
int ioFontDescent(int fontIndex);

int ioFontEmbeddingFlags(int fontIndex);
int ioGetFontDataSize(int fontIndex);
int ioGetFontData(int fontIndex, char *buffer, int bufSize);

'! !


!HostFont methodsFor: 'accessing' stamp: 'ar 2/18/2001 20:01'!
getFontData
	| fontHandle bufSize buffer |
	fontHandle _ self primitiveCreateFont: name size: pointSize emphasis: emphasis.
	fontHandle ifNil:[^nil].
	bufSize _ self primitiveFontDataSize: fontHandle.
	buffer _ ByteArray new: bufSize.
	self primitiveFont: fontHandle getData: buffer.
	^buffer! !

!HostFont methodsFor: 'accessing' stamp: 'ar 2/18/2001 20:04'!
testEmbeddingFlags
	"HostFont basicNew testEmbeddingFlags"
	| list fontHandle |
	list _ self class listFontNames.
	list do:[:fName|
		fontHandle _ self primitiveCreateFont: fName size: 12 emphasis: 0.
		fontHandle ifNotNil:[
			type _ self primitiveFontEmbeddingFlags: fontHandle.
			Transcript cr; show: fName,': ', type printString.
			self primitiveDestroyFont: fontHandle.
		].
	].! !

!HostFont methodsFor: 'emphasis' stamp: 'ar 8/29/2000 21:18'!
emphasized: code
	| derivative addedEmphasis base safeCode |
	code = 0 ifTrue: [^ self].
	derivativeFonts == nil ifTrue:[derivativeFonts _ Array new: 32].
	derivative _ derivativeFonts at: (safeCode _ code min: derivativeFonts size).
	derivative == nil ifFalse: [^ derivative].  "Already have this style"

	"Dont have it -- derive from another with one with less emphasis"
	addedEmphasis _ 1 bitShift: safeCode highBit - 1.
	base _ self emphasized: safeCode - addedEmphasis.  "Order is Bold, Ital, Under, Narrow"
	addedEmphasis = 1 ifTrue:   "Compute synthetic bold version of the font"
		[derivative _ (base copy name: base name) makeBoldGlyphs].
	addedEmphasis = 2 ifTrue:   "Compute synthetic italic version of the font"
		[ derivative _ (base copy name: base name) makeItalicGlyphs].
	addedEmphasis = 4 ifTrue:   "Compute underlined version of the font"
		[derivative _ (base copy name: base name) makeUnderlinedGlyphs].
	addedEmphasis = 8 ifTrue:   "Compute narrow version of the font"
		[derivative _ (base copy name: base name) makeCondensedGlyphs].
	addedEmphasis = 16 ifTrue:   "Compute struck-out version of the font"
		[derivative _ (base copy name: base name) makeStruckOutGlyphs].
	derivative emphasis: safeCode.
	derivativeFonts at: safeCode put: derivative.
	^ derivative! !

!HostFont methodsFor: 'emphasis' stamp: 'ar 8/29/2000 21:20'!
makeBoldGlyphs
	"First check if we can use some OS support for this"
	(self class listFontNames includes: name) ifFalse:[^super makeBoldGlyphs].
	"Now attempt a direct creation through the appropriate primitives"
	(self fontName: name size: pointSize emphasis: (emphasis bitOr: 1)) 
		ifNil:[^super makeBoldGlyphs]. "nil means we failed"! !

!HostFont methodsFor: 'emphasis' stamp: 'ar 6/4/2000 23:22'!
makeItalicGlyphs
	"First check if we can use some OS support for this"
	(self class listFontNames includes: name) ifFalse:[^super makeItalicGlyphs].
	"Now attempt a direct creation through the appropriate primitives"
	(self fontName: name size: pointSize emphasis: (emphasis bitOr: 2)) 
		ifNil:[^super makeItalicGlyphs]. "nil means we failed"! !

!HostFont methodsFor: 'emphasis' stamp: 'ar 6/4/2000 23:22'!
makeStruckOutGlyphs
	"First check if we can use some OS support for this"
	(self class listFontNames includes: name) ifFalse:[^super makeStruckOutGlyphs].
	"Now attempt a direct creation through the appropriate primitives"
	(self fontName: name size: pointSize emphasis: (emphasis bitOr: 8)) 
		ifNil:[^super makeStruckOutGlyphs]. "nil means we failed"! !

!HostFont methodsFor: 'emphasis' stamp: 'ar 6/5/2000 00:12'!
makeUnderlinedGlyphs
	"First check if we can use some OS support for this"
	(self class listFontNames includes: name) ifFalse:[^super makeUnderlinedGlyphs].
	"Now attempt a direct creation through the appropriate primitives"
	(self fontName: name size: pointSize emphasis: (emphasis bitOr: 4)) 
		ifNil:[^super makeUnderlinedGlyphs]. "nil means we failed"! !

!HostFont methodsFor: 'private-creation' stamp: 'ar 8/29/2000 21:41'!
fontName: fontName size: ptSize emphasis: emphasisCode
	"
		^HostFont fontName: (HostFont fontNameFromUser) size: 12 emphasis: 0.
	"
	| fontHandle xStart w glyphForm fontHeight fw |
	fontHandle _ self primitiveCreateFont: fontName size: ptSize emphasis: emphasisCode.
	fontHandle ifNil:[^nil].
	pointSize _ ptSize.
	name _ fontName.
	emphasis _ emphasisCode.
	minAscii _ 0.
	maxAscii _ 255.
	ascent _ self primitiveFontAscent: fontHandle.
	descent _ self primitiveFontDescent: fontHandle.
	kernPairs _ Array new: (self primitiveFontNumKernPairs: fontHandle).
	1 to: kernPairs size do:[:i|
		kernPairs at: i put: (self primitiveFont: fontHandle getKernPair: i)].
	fontHeight _ ascent + descent.
	xTable _ Array new: 258.
	fullWidth _ Array new: 256.
	xStart _ maxWidth _ 0.
	0 to: 255 do:[:i|
		xTable at: i+1 put: xStart.
		fw _ self primitiveFont: fontHandle fullWidthOfChar: i.
		fullWidth at: i+1 put: fw.
		w _ fw at: 2.
		(fw at: 1) > 0 ifTrue:[w _ w + (fw at: 1)].
		(fw at: 3) > 0 ifTrue:[w _ w + (fw at: 3)].
		w > maxWidth ifTrue:[maxWidth _ w].
		xStart _ xStart + w].
	xStart = 0 ifTrue:[^nil].
	strikeLength _ xStart.
	xTable at: 256 put: xStart.
	xTable at: 257 put: xStart.
	xTable at: 258 put: xStart.
	glyphs _ Form extent: xTable last @ fontHeight depth: 1.
	glyphForm _ Form extent: maxWidth @ fontHeight depth: 1.
	0 to: 255 do:[:i|
		glyphForm fillWhite.
		self primitiveFont: fontHandle glyphOfChar: i into: glyphForm.
		xStart _ xTable at: i+1.
		glyphForm displayOn: glyphs at: xStart@0.
		"glyphForm displayOn: Display at: xStart@0."
	].
	self primitiveDestroyFont: fontHandle.
	^self! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:11'!
primitiveCreateFont: fontName size: fontSize emphasis: fontFlags
	<primitive:'primitiveCreateFont' module:'FontPlugin'>
	^nil! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:01'!
primitiveDestroyFont: fontHandle
	<primitive:'primitiveDestroyFont' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 8/28/2000 16:04'!
primitiveFont: fontHandle fullWidthOfChar: charIndex
	<primitive:'primitiveFontFullWidthOfChar' module:'FontPlugin'>
	^Array 
		with: 0
		with: (self primitiveFont: fontHandle widthOfChar: charIndex)
		with: 0! !

!HostFont methodsFor: 'primitives' stamp: 'ar 2/18/2001 19:46'!
primitiveFont: fontHandle getData: buffer
	<primitive:'primitiveGetFontData' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 8/28/2000 16:05'!
primitiveFont: fontHandle getKernPair: kernIndex
	<primitive:'primitiveFontGetKernPair' module:'FontPlugin'>
	^0! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:01'!
primitiveFont: fontHandle glyphOfChar: charIndex into: glyphForm
	<primitive:'primitiveFontGlyphOfChar' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:01'!
primitiveFont: fontHandle widthOfChar: charIndex
	<primitive:'primitiveFontWidthOfChar' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:01'!
primitiveFontAscent: fontHandle
	<primitive:'primitiveFontAscent' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 2/18/2001 19:45'!
primitiveFontDataSize: fontHandle
	<primitive:'primitiveFontDataSize' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:01'!
primitiveFontDescent: fontHandle
	<primitive:'primitiveFontDescent' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 2/18/2001 20:00'!
primitiveFontEmbeddingFlags: fontHandle
	<primitive:'primitiveFontEmbeddingFlags' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 6/4/2000 23:02'!
primitiveFontEncoding: fontHandle
	<primitive:'primitiveFontEncoding' module:'FontPlugin'>
	^self primitiveFailed! !

!HostFont methodsFor: 'primitives' stamp: 'ar 8/28/2000 16:04'!
primitiveFontNumKernPairs: fontHandle
	<primitive:'primitiveFontNumKernPairs' module:'FontPlugin'>
	^0! !


!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 22:27'!
fromHostFont: fontName size: fontSize flags: fontFlags weight: fontWeight
	"
		^StrikeFont fromHostFont: (StrikeFont hostFontFromUser)
					size: 12 flags: 0 weight: 4.
	"
	| fontHandle glyphs xTable xStart maxWidth w glyphForm ascent descent fontHeight |
	fontHandle _ self primitiveCreateFont: fontName size: fontSize flags: fontFlags weight: fontWeight.
	ascent _ self primitiveFontAscent: fontHandle.
	descent _ self primitiveFontDescent: fontHandle.
	fontHeight _ ascent + descent.
	xTable _ Array new: 258.
	xStart _ maxWidth _ 0.
	0 to: 255 do:[:i|
		xTable at: i+1 put: xStart.
		w _ self primitiveFont: fontHandle widthOfChar: i.
		w > maxWidth ifTrue:[maxWidth _ w].
		xStart _ xStart + w].
	xTable at: 256 put: xStart.
	xTable at: 257 put: xStart.
	xTable at: 258 put: xStart.
	glyphs _ Form extent: xTable last @ fontHeight depth: 1.
	glyphForm _ Form extent: maxWidth @ fontHeight depth: 1.
	0 to: 255 do:[:i|
		glyphForm fillWhite.
		self primitiveFont: fontHandle glyphOfChar: i into: glyphForm.
		xStart _ xTable at: i+1.
		glyphForm displayOn: glyphs at: xStart@0.
		glyphForm displayOn: Display at: xStart@0.
	].
	self primitiveDestroyFont: fontHandle.
	^Array with: glyphs with: xTable! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:25'!
hostFontFromUser
	"StrikeFont hostFontFromUser"
	| fontNames index labels |
	fontNames _ self listFontNames asSortedCollection.
	labels _ WriteStream on: (String new: 100).
	fontNames do:[:fn| labels nextPutAll: fn] separatedBy:[labels cr].
	index _ (PopUpMenu labels: labels contents) startUpWithCaption:'Choose your font'.
	index = 0 ifTrue:[^nil].
	^fontNames at: index! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:12'!
listFont: index
	<primitive:'primitiveListFont' module:'FontPlugin'>
	^nil! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:12'!
listFontNames
	"StrikeFont listFontNames"
	"List all the OS font names"
	| font fontNames index |
	fontNames _ WriteStream on: Array new.
	index _ 0.
	[font _ self listFont: index.
	font == nil] whileFalse:[
		fontNames nextPut: font.
		index _ index + 1].
	^fontNames contents! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:13'!
primitiveCreateFont: fontName size: fontSize flags: fontFlags weight: fontWeight
	<primitive:'primitiveCreateFont' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:13'!
primitiveDestroyFont: fontHandle
	<primitive:'primitiveDestroyFont' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:14'!
primitiveFont: fontHandle glyphOfChar: charIndex into: glyphForm
	<primitive:'primitiveFontGlyphOfChar' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:15'!
primitiveFont: fontHandle widthOfChar: charIndex
	<primitive:'primitiveFontWidthOfChar' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 22:25'!
primitiveFontAscent: fontHandle
	<primitive:'primitiveFontAscent' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 22:25'!
primitiveFontDescent: fontHandle
	<primitive:'primitiveFontDescent' module:'FontPlugin'>
	^self primitiveFailed! !

!StrikeFont class methodsFor: 'font creation' stamp: 'ar 6/4/2000 21:14'!
primitiveFontEncoding: fontHandle
	<primitive:'primitiveFontEncoding' module:'FontPlugin'>
	^self primitiveFailed! !


!HostFont class methodsFor: 'instance creation' stamp: 'ar 6/4/2000 23:13'!
fontName: fontName size: ptSize emphasis: emphasisCode
	"
		^HostFont fontName: (HostFont fontNameFromUser) size: 12 emphasis: 0.
	"
	^self new fontName: fontName size: ptSize emphasis: emphasisCode! !

!HostFont class methodsFor: 'accessing' stamp: 'ar 6/4/2000 23:03'!
fontNameFromUser
	"HostFont fontNameFromUser"
	| fontNames index labels |
	fontNames _ self listFontNames asSortedCollection.
	labels _ WriteStream on: (String new: 100).
	fontNames do:[:fn| labels nextPutAll: fn] separatedBy:[labels cr].
	index _ (PopUpMenu labels: labels contents) startUpWithCaption:'Choose your font'.
	index = 0 ifTrue:[^nil].
	^fontNames at: index! !

!HostFont class methodsFor: 'accessing' stamp: 'ar 6/4/2000 23:18'!
listFontName: index
	<primitive:'primitiveListFont' module:'FontPlugin'>
	^nil! !

!HostFont class methodsFor: 'accessing' stamp: 'ar 6/4/2000 23:18'!
listFontNames
	"HostFont listFontNames"
	"List all the OS font names"
	| font fontNames index |
	fontNames _ WriteStream on: Array new.
	index _ 0.
	[font _ self listFontName: index.
	font == nil] whileFalse:[
		fontNames nextPut: font.
		index _ index + 1].
	^fontNames contents! !

!HostFont class methodsFor: 'accessing' stamp: 'ar 8/28/2000 17:27'!
textStyleFromUser
	"HostFont textStyleFromUser"
	| styleName fonts |
	styleName _ self fontNameFromUser ifNil:[^self].
	styleName _ styleName asSymbol.
	(TextConstants includesKey: styleName)
		ifTrue:[(self confirm: 
styleName , ' is already defined in TextConstants.
Do you want to replace that definition?')
			ifFalse: [^ self]].
	fonts _ #(10 12 14 16 18 20 22 24 26 28 30 36 48 60 72 90).
	('Rendering ', styleName) displayProgressAt: Sensor cursorPoint
		from: 1 to: fonts size during:[:bar|
			fonts _ fonts
				collect:[:ptSize| bar value: (fonts indexOf: ptSize).
							   self fontName: styleName 
									size: ptSize
									emphasis: 0]
				thenSelect:[:font| font notNil]]. "reject those that failed"
	fonts size = 0 ifTrue:[^self error:'Could not create font style', styleName].
	TextConstants
		at: styleName
		put: (TextStyle fontArray: fonts).! !

