'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 10 May 2002 at 10:52:26 am'!
"Change Set:		MenuFixes
Date:			7 March 2002
Author:			Jim Benson

Makes menus better citizens. First, clicking on a menu brings it to the front of the morphic world. Second, clicking-dragging on title bar becomes the way to drag a menu. This makes menu interaction feel more natural, as 'click off by one' or 'click on separator line' does not place menu in hand"!


!MenuItemMorph methodsFor: 'events' stamp: 'jlb 3/7/2002 09:10'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	" make sure the menu is the frontmost morph in the world "
	owner comeToFront.
	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt.! !


!MenuMorph methodsFor: 'construction' stamp: 'jlb 3/24/2002 08:03'!
addTitle: aString updatingSelector: aSelector updateTarget: aTarget
	"Add a title line at the top of this menu  Make aString its initial contents.  If aSelector is not nil, then periodically obtain fresh values for its contents by sending aSelector to aTarget.."

	| title |
	title _ MenuTitleMorph new.
	ButtonTheme current ifNil: [
	self setTitleParametersFor: title.
	title vResizing: #shrinkWrap.
	title listDirection: #topToBottom.
	title wrapCentering: #center; cellPositioning: #topCenter. ].
	aSelector
		ifNotNil:
			[title addMorphBack: (UpdatingStringMorph new lock; useStringFormat; target: aTarget; getSelector: aSelector)]
		ifNil:
			[(aString asString findTokens: String cr) do:
				[:line | title addMorphBack: (StringMorph contents: line font: Preferences standardMenuFont)]].
	
	title on: #mouseDown send: #putInHand: to: self.
	self addMorphFront: title.
! !

!MenuMorph methodsFor: 'control' stamp: 'jlb 3/9/2002 09:18'!
putInHand: event
	" Put me in the hand "
	" Don't pick the menu up if it is sticking to it's owner "
	self isSticky ifTrue: [^self].
	event hand grabMorph: self.! !

!MenuMorph methodsFor: 'events' stamp: 'jlb 3/7/2002 09:08'!
mouseDown: evt
	"Handle a mouse down event."
	self comeToFront.
	(stayUp or:[self fullContainsPoint: evt position]) 
		ifFalse:[^self deleteIfPopUp: evt]. "click outside"
! !

