'From Squeak3.2gamma of 15 January 2002 [latest update: #4827] on 10 May 2002 at 10:23:39 am'!
"Change Set:		Post Fixes
Date:			10 May 2002
Author:			Jim Benson

These are the changes that happened post 4646
These include some enhancements:

The 'resize frame' that is used by the mouse to resize the frame now overlays the window, that is, it is the first submorph of the window. This is useful for overlaying the boundary conditions, and adds the ability to have a grab corner at the bottom of the window ala a status bar or a grow icon on an old style Mac

Slight fix to have tab buttons line up better ;
Fix so that tab panel click doesn't pick up window
Replace scroll bar thumb shadow with a translucent version of the thumb"!


!CheckBoxControlMorph commentStamp: '<historical>' prior: 0!
I represent an OS style check box control with a check box and a label!


!ComboBoxMorph commentStamp: '<historical>' prior: 0!
I represent an OS like combo box control!


!DefaultFrameMorph commentStamp: '<historical>' prior: 0!
I represent a drawn system window frame.!


!DialogTextMorph commentStamp: '<historical>' prior: 0!
I represent a place to store text that responds to a windows activation cycle.!


!ComboButtonMorph commentStamp: '<historical>' prior: 0!
I represent an OS like combo button!


!FancyCheckBoxMorph commentStamp: '<historical>' prior: 0!
I represent an OS style check box!


!FrameEdgeImageMorph commentStamp: '<historical>' prior: 0!
I represent an individual image that is part of a WindowFrameImagedMorph!


!GroupBoxMorph commentStamp: '<historical>' prior: 0!
I represent a box to group different controls in!


!ListTheme commentStamp: '<historical>' prior: 0!
I represent an accessor to the List theme elements such as background, hilight, and text color!


!OSButtonMorph commentStamp: '<historical>' prior: 0!
I represent an OSButtonMorph!


!ScreenPreferencesPanel commentStamp: '<historical>' prior: 0!
I represent a simple preference panel to Windows, Menus, Scrollbars, and Flaps settings!


!ScrollBarTheme commentStamp: '<historical>' prior: 0!
I am a factory which builds parts for a theme based scrollbar!


!TabButtonMorph commentStamp: '<historical>' prior: 0!
I represent a tab button!


!PluggableTabButtonMorph commentStamp: '<historical>' prior: 0!
I represent a tab button!


!TabPanelMorph commentStamp: '<historical>' prior: 0!
I represent a panel that contains tab buttons!


!InvisibleTabPanelMorph commentStamp: '<historical>' prior: 0!
I represent a panel on which OS style tab buttons are stored. I am invisible, and serve as a placeholder to organize the buttons.!

ImageMorph subclass: #TranslucentImageMorph
	instanceVariableNames: 'alpha '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!UpdatingCheckBoxMorph commentStamp: '<historical>' prior: 0!
I represent a OS style check box!


!UpdatingFancyCheckBoxMorph commentStamp: '<historical>' prior: 0!
I represent an OS style check box!


!UpdatingRadioButtonMorph commentStamp: '<historical>' prior: 0!
I represent an OS style radio button!


!WindowFrameImagedMorph commentStamp: '<historical>' prior: 0!
I represent an instance of a system window frame that is constructed from forms (images).!


!WindowTitleMorph commentStamp: '<historical>' prior: 0!
I represent the title of a system window.!


!Browser methodsFor: 'initialize-release' stamp: 'jlb 2/17/2002 00:04'!
addAListPane: aListPane to: window at: nominalFractions plus: verticalOffset

	| row switchHeight divider |

	row _ AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		layoutPolicy: ProportionalLayout new.
	switchHeight _ 24.

	row 
		addMorph: aListPane
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@0 corner: 0@switchHeight negated)
		).	
	divider _ BorderedSubpaneDividerMorph forTopEdge.
	Preferences alternativeWindowLook ifTrue:[
		divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	].
	row 
		addMorph: divider
		fullFrame: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@switchHeight negated corner: 0@(1-switchHeight))
		).	

	self 
		addMorphicSwitchesTo: row 
		at: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (-1@(1-switchHeight-2)  corner: 1@2)
		).

	window 
		addMorph: row
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@verticalOffset corner: 0@0)
		).	
	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.

! !

!Browser methodsFor: 'initialize-release' stamp: 'jlb 2/17/2002 00:06'!
buildMorphicSwitches

	| instanceSwitch commentSwitch classSwitch panel |


	panel _  TabPanelMorph newInstance.
	panel image: ButtonTheme current tabPanelFormNoBorder.
	
	instanceSwitch _ PluggableTabButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		actWhen: #buttonUp.

	commentSwitch _ PluggableTabButtonMorph
		on: self
		getState: #classCommentIndicated
		action: #plusButtonHit.
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		actWhen: #buttonUp.

	classSwitch _ PluggableTabButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		actWhen: #buttonUp.

	panel addTransparentSpacerOfSize: 2@2.

	" add the tabs to the tab panel. "
	{instanceSwitch. commentSwitch. classSwitch} do: [:m | 
		panel addMorphBack: m. ].

	instanceSwitch state: #on.

 	^ panel.! !

!Browser methodsFor: 'initialize-release' stamp: 'jlb 2/28/2002 11:52'!
openAsMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."
	| window dragNDropFlag hSepFrac switchHeight mySingletonClassList |

	window _ (SystemWindow labelled: 'later') model: self.
	dragNDropFlag _ Preferences browseWithDragNDrop.
	hSepFrac _ 0.3.
	switchHeight _ 25.
	mySingletonClassList _ PluggableListMorph on: self list: #classListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	mySingletonClassList enableDragNDrop: dragNDropFlag.
	window 
		addMorph: mySingletonClassList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@0) 
				offsets: (0@0 corner: 0@switchHeight)
		).
	
	self 
		addMorphicSwitchesTo: window 
		at: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@0) 
				offsets: (0@0 corner: 0@(switchHeight+1))
		).

	window 
		addMorph: self buildMorphicMessageCatList
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 0.5@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	window 
		addMorph: self buildMorphicMessageList
		fullFrame: (
			LayoutFrame 
				fractions: (0.5@0 corner: 1.0@hSepFrac) 
				offsets: (0@switchHeight corner: 0@0)
		).

	self 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window setUpdatablePanesFrom: #(messageCategoryList messageList).
	^ window! !




!FileList class methodsFor: 'instance creation' stamp: 'jlb 2/23/2002 00:07'!
addVolumesAndPatternPanesTo: window at: upperFraction plus: offset forFileList: aFileList 
	| row patternHeight volumeListMorph patternMorph divider dividerDelta |
	row _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 0;
				 layoutPolicy: ProportionalLayout new.
	patternHeight _ 25.
	volumeListMorph _ (PluggableListMorph
				on: aFileList
				list: #volumeList
				selected: #volumeListIndex
				changeSelected: #volumeListIndex:
				menu: #volumeMenu:)
				autoDeselect: false.
	patternMorph _ PluggableTextMorph
				on: aFileList
				text: #pattern
				accept: #pattern:.
	patternMorph acceptOnCR: true.
	patternMorph hideScrollBarIndefinitely.
	divider _ BorderedSubpaneDividerMorph horizontal.
	dividerDelta _ 0.
	Preferences alternativeWindowLook
		ifTrue: [divider extent: 4 @ 4;
				 color: Color transparent;
				 borderColor: #raised;
				 borderWidth: 2.
			volumeListMorph borderColor: Color transparent.
			patternMorph borderColor: Color transparent.
			dividerDelta _ 3].
	row
		addMorph: (volumeListMorph autoDeselect: false)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ patternHeight negated - dividerDelta)).
	row
		addMorph: divider
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ patternHeight negated - dividerDelta corner: 0 @ patternHeight negated)).
	row
		addMorph: patternMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ patternHeight negated corner: 0 @ 0)).
	window
		addMorph: row
		fullFrame: (LayoutFrame
				fractions: upperFraction
				offsets: (0 @ offset corner: 0 @ 0)).
	Preferences alternativeWindowLook
		ifTrue: [row borderWidth: 2] ifFalse: [row borderWidth: 0]! !


!FormCanvas methodsFor: 'private' stamp: 'jlb 4/24/2000 14:59'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule alpha: alpha
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	port colorMap: (aForm colormapIfNeededForDepth: form depth); fillColor: nil.
	port sourceForm: aForm ;
		combinationRule: rule ;
		sourceRect: sourceRect ;
		destOrigin: aPoint +  origin  ;
		copyBitsTranslucent: alpha.
! !


!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 1/20/2002 17:45'!
newMainFlapsPage

	| mainFlapsPage layoutFrame |
	mainFlapsPage _ PasteUpMorph new.
	pages at: #flapsPage put: mainFlapsPage.
	mainFlapsPage beSticky.
	mainFlapsPage	layoutPolicy: ProportionalLayout new.
	layoutFrame _ self pageLayoutFrame copy.
	layoutFrame topOffset: ( layoutFrame topOffset + 1 ) ;
		leftOffset: ( layoutFrame leftOffset + 1 ) ;
		bottomOffset: (layoutFrame bottomOffset - 1) ;
		rightOffset: ( layoutFrame rightOffset - 1 ).
	mainFlapsPage layoutFrame: layoutFrame.
	mainFlapsPage hResizing: #spaceFill;
		 vResizing: #spaceFill ;
		color: Color transparent ;
		borderWidth: 0.
	^ mainFlapsPage.
! !


!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 2/17/2002 00:09'!
buildTabPanel: aModel for: aPasteUpMorph 

	| panel appearanceSwitch settingsSwitch windowSwitch scrollbarSwitch flapsSwitch menuSwitch |
	panel _ InvisibleTabPanelMorph newInstance.
	panel image: ButtonTheme current tabPanelFormNoBorder.

	aModel pasteUpMorph: aPasteUpMorph.
	windowSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #windowMessageIndicated
		action: #selectWindowTab.
	windowSwitch
		label: 'Windows';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildWindowPage: aPasteUpMorph.


	menuSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #menuMessagesIndicated
		action: #selectMenuTab.
	menuSwitch
		label: 'Menus';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildMenuPage: aPasteUpMorph.

	scrollbarSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #scrollMessagesIndicated
		action: #selectScrollbarTab.
	scrollbarSwitch
		label: 'Scrollbars';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildScrollbarPage: aPasteUpMorph.

	appearanceSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #appearanceMessagesIndicated
		action: #selectAppearanceTab.
	appearanceSwitch
		label: 'Appearance';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildAppearancePage: aPasteUpMorph.

	settingsSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #settingsMessagesIndicated
		action: #selectSettingsTab.
	settingsSwitch
		label: 'Settings';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildSettingsPage: aPasteUpMorph.

	flapsSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #flapsMessagesIndicated
		action: #selectFlapsTab.
	flapsSwitch
		label: 'Flaps';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildFlapsPage: aPasteUpMorph.

"	appearanceSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #appearanceMessagesIndicated
		action: #selectAppearanceTab.
	appearanceSwitch
		label: 'Appearance';
		askBeforeChanging: true;
		actWhen: #buttonUp.
	aModel buildAppearancePage: aPasteUpMorph. "

	" add the tabs to the tab panel. "
	panel addTransparentSpacerOfSize: 2@2.
	{windowSwitch. menuSwitch. scrollbarSwitch.  flapsSwitch. appearanceSwitch.  settingsSwitch "  commentSwitch. classSwitch "} do: [:m | 
		panel addMorphBack: m. ].

	aModel selectWindowTab.
	windowSwitch state: #on.

	^ panel
! !

!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 2/25/2002 22:39'!
editProperties
	"open a desktop properties dialog box"
	| aPanel playfield window |
	aPanel _ ScreenPreferencesPanel new initialize.
	playfield _ PasteUpMorph new width: 600.
	playfield dropEnabled: false.
	playfield
		on: #mouseDown
		send: #yourself
		to: #().
	self initializePreferencePanel: aPanel in: playfield.
	window _ (SystemWindow labelled: 'Screen Properties')
				model: aPanel.
	window
		addMorph: playfield
		frame: (0 @ 0 extent: 1 @ 1).
	window updatePaneColors; minimumExtent: 430 @ 600; extent: window minimumExtent;
		on: #keyStroke
		send: #keyStroke:
		to: aPanel.
	window windowFrame addGrowBox.
	self currentWorld addMorphFront: window.
	window center: self currentWorld center;
		 activateAndForceLabelToShow! !

!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 2/23/2002 17:19'!
initializePreferencePanel: aPanel in: aPasteUpMorph 
	| aColor tabbedPalette paneRect aButton |
	aPasteUpMorph removeAllMorphs.
	aColor _ aPanel defaultBackgroundColor.
	aPasteUpMorph color: aColor.
	paneRect _ RectangleMorph new.
	paneRect name: #paneRectangle.
	paneRect borderWidth: 1.
	paneRect color: Color white.
	paneRect borderColor: Color gray.
	aPanel
		pageLayoutFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (8 @ 33 corner: -8 @ -39)).
	aPasteUpMorph addMorph: paneRect fullFrame: aPanel pageLayoutFrame.
	paneRect lock.
	tabbedPalette _ self buildTabPanel: aPanel for: aPasteUpMorph.
	tabbedPalette beSticky.
	aPasteUpMorph layoutPolicy: ProportionalLayout new.
	aPasteUpMorph
		addMorph: tabbedPalette
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (8 @ 7 corner: 0 @ 34)).
	aButton _ OSButtonMorph newInstance target: aPanel;
				 actionSelector: #cancelPanel;
				 label: 'Cancel'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-92 @ -31 corner: -17 @ -8)).
	aButton _ OSButtonMorph newInstance target: aPanel;
				 actionSelector: #closePanel;
				 label: 'OK'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-175 @ -31 corner: -100 @ -8)).
	aButton makeDefault! !


!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 2/23/2002 00:36'!
minimumHorizontalScrollBarWidth
	" include the arrows and the thumb "
	| width |
	width _ (self arrowExtent x * 2) + 
			" Scroller>>sliderThickness " 10.
	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton) 
		ifTrue: [ ^ width ]
		ifFalse: [ ^ width + ( (lookDictionary at: #menuButtonForm) width ) ].
	! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 2/23/2002 00:32'!
minimumVerticalScrollBarHeight
	" include the arrows and the thumb "
	" This isn't quite right ; Scroller>>sliderThickness is 7 ; this should be on a theme basis "
	| height |
	height _  (self arrowExtent y * 2) + 
			" Scroller>>sliderThickness " 10.
	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton) 
		ifTrue: [ ^ height ]
		ifFalse: [ ^ height + ( (lookDictionary at: #menuButtonForm) height / 4 ) ].! !


!Slider methodsFor: 'other events' stamp: 'jlb 2/20/2002 19:50'!
mouseDownInSlider: event 
	slider color: self sliderColor lighter.
	sliderShadow color: self sliderColor darker.
	sliderShadow cornerStyle: slider cornerStyle.
	sliderShadow bounds: slider bounds.
	ScrollBarTheme current
		ifNotNil: [sliderShadow image: slider imageForm].
	sliderShadow show! !


!ScrollBar methodsFor: 'initialize' stamp: 'jlb 2/20/2002 18:50'!
themeInitializeSlider
	slider _ 
	bounds isWide ifTrue: [ ScrollBarTheme current newHorizontalSlider ]
		ifFalse: [ ScrollBarTheme current newVerticalSlider].
	slider bounds: ( self totalSliderArea ).
	sliderShadow _ TranslucentImageMorph new.
	sliderShadow alpha: 64.
	sliderShadow bounds: self totalSliderArea.
	sliderShadow image: slider image.
	slider on: #mouseMove send: #scrollAbsolute: to: self ;
		on: #mouseDown send: #mouseDownInSlider: to: self ;
		on: #mouseUp send: #mouseUpInSlider: to: self.
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider ;
		computeSlider.
! !


!SystemWindow methodsFor: 'label' stamp: 'jlb 2/21/2002 21:40'!
getRawLabel
	^ self windowFrame label firstSubmorph! !

!SystemWindow methodsFor: 'submorphs-add/remove' stamp: 'jlb 2/16/2002 23:57'!
addMorphFront: aMorph
	self addMorphInLayer: aMorph.
! !


!TabButtonMorph methodsFor: 'geometry' stamp: 'jlb 1/9/2002 22:02'!
nominalExtent
	| labelString |
	labelString _ self submorphNamed: #label.
	labelString
		ifNil: [^ 28 @ 24].
	^ labelString measureContents x + 16 @ 24! !

!TabButtonMorph methodsFor: 'event handling' stamp: 'jlb 2/20/2002 19:51'!
mouseDown: evt 
	disabled
		ifTrue: [^ self].
	"get rid of the inherited hesitation; don't call super mouseDown: 
	evt "
	" don't change state of a selected state "
	self state = #on
		ifFalse: [self state: #pressed].
	active
		ifFalse: [^ self].
	actWhen == #buttonDown
		ifTrue: [self doButtonAction]
		ifFalse: ["Morph>>mouseDown: ; this is useful if you need to get a 
			hold of the event"
			self eventHandler
				ifNotNil: [self eventHandler mouseDown: evt fromMorph: self]].
	self mouseStillDown: evt! !


!TabPanelMorph methodsFor: 'initialization' stamp: 'jlb 3/16/2002 20:23'!
initialize
	super initialize.
	pages _ Dictionary new.
	currentPage _ nil.
	self layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		wrapDirection: #none ;
		wrapCentering: #bottomRight ;
		setProperty: #wantsActivate toValue: true.
	self on: #mouseDown send: #mouseDown: to: self. 
! !

!TabPanelMorph methodsFor: 'events-processing' stamp: 'jlb 2/20/2002 12:55'!
mouseDown: anEvent
	" I don't respond to the mouse "! !


!TranslucentImageMorph methodsFor: 'initialization' stamp: 'jlb 2/20/2002 18:42'!
initialize
	super initialize.
	alpha _ 128.! !

!TranslucentImageMorph methodsFor: 'drawing' stamp: 'jlb 2/20/2002 18:43'!
drawOn: aCanvas 
	aCanvas
		image: image
		at: bounds origin
		sourceRect: image boundingBox
		rule: Form blendAlpha
		alpha: alpha! !

!TranslucentImageMorph methodsFor: 'accessing' stamp: 'jlb 2/20/2002 18:42'!
alpha
	^ alpha! !

!TranslucentImageMorph methodsFor: 'accessing' stamp: 'jlb 2/20/2002 18:42'!
alpha: anInteger
	" alpha is an integer between 0-255 "
	alpha _ anInteger! !


!UpdatingRadioButtonMorph methodsFor: 'as yet unclassified' stamp: 'jlb 1/20/2002 15:19'!
step
	| newBoolean |
	" check the selector and update the button accordingly "
	super step.
	state == #pressed
		ifTrue: [^ self].
	newBoolean _ target perform: getSelector.
	newBoolean = value
		ifFalse: [self value: newBoolean]! !


!WindowBorderCornerMorph methodsFor: 'initialization' stamp: 'jlb 2/8/2002 00:31'!
initialize
	super initialize.
	cursorName _ #normal.
	" the resize edges are not obvious (visible) "
	obvious _ false.
	" This is a resizer part of the window frame "
	self setProperty: #resizer toValue: true ;
		on: #mouseEnter send: #mouseEnter: to: self ;
		on: #mouseLeave send: #mouseLeave: to: self ;
		on: #mouseDown send: #mouseDown: to: self ;
		on: #mouseUp send: #mouseUp: to: self.
	self setProperty: #morphicLayerNumber toValue: 20.
	! !

!WindowBorderCornerMorph methodsFor: 'WiW support' stamp: 'jlb 2/7/2002 10:54'!
morphicLayerNumber
	^ self valueOfProperty: #morphicLayerNumber ifAbsent: [100]! !


!WindowBorderMorph methodsFor: 'initialization' stamp: 'jlb 2/8/2002 00:31'!
initialize
	super initialize.
	cursorName _ #normal.
	" the resize edges are not obvious (visible) "
	obvious _ false.
	self setProperty: #resizer toValue: true ;
		on: #mouseEnter send: #mouseEnter: to: self ;
		on: #mouseLeave send: #mouseLeave: to: self ;
		on: #mouseDown send: #mouseDown: to: self ;
		on: #mouseUp send: #mouseUp: to: self.
	self setProperty: #morphicLayerNumber toValue: 20.
	! !

!WindowBorderMorph methodsFor: 'WiW support' stamp: 'jlb 2/7/2002 10:54'!
morphicLayerNumber
	^ self valueOfProperty: #morphicLayerNumber ifAbsent: [100]! !


!WindowFrameMorph methodsFor: 'initialization' stamp: 'jlb 2/7/2002 15:44'!
initialize
	super initialize.
	self extent: ( self minimumExtent ).
	self borderWidth: 4.
	drawBlock _ nil.
	labelFontColor _ Color white.
	" Allow us to resize everything proportionally "
	self layoutPolicy: ProportionalLayout new.
	" grow extent is the size of the corners reframe sides "
	growExtent _ 16@16.
	self color: Color transparent.
	self borderColor: Color transparent.
	topLeftInset _ 8@32.
	bottomRightInset _ 8@8.
	^ self
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:56'!
addBottomFrame: aFrame 
	| xOffset |

	xOffset _ growExtent x - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (xOffset @ 0 corner: xOffset negated @ borderWidth))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:56'!
addBottomLeftFrame: aFrame 

	| xOffset yOffset frameExtent |
	xOffset _ borderWidth+1.
	yOffset _ borderWidth.
	frameExtent _ aFrame bounds extent.

	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 0 @ 1)
				offsets: (xOffset negated @ (frameExtent y - yOffset) negated 
							corner: frameExtent x - xOffset @ yOffset ))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addBottomRightFrame: aFrame 

	| xOffset yOffset |
	xOffset _ self borderWidth.
	yOffset _ self borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: ( (aFrame bounds extent - (xOffset@yOffset)) negated 	
					corner:  (xOffset@yOffset) ))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addLeftFrame: aFrame 
	| yOffset |

	yOffset _ growExtent y - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (borderWidth negated @ yOffset corner: 0 @ yOffset negated))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:58'!
addMorphInLayer: aMorph fullFrame: aLayoutFrame 

	aMorph layoutFrame: aLayoutFrame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.
	self addMorphInLayer: aMorph.
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addRightFrame: aFrame 
	| yOffset |

	yOffset _ growExtent y - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 1)
				offsets: (0 @ yOffset corner: borderWidth @ yOffset negated))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopFrame: aFrame 

	| xOffset |

	xOffset _ growExtent x - borderWidth.
	self addMorphInLayer: aFrame
		fullFrame: (
			LayoutFrame
				fractions: ( 0 @ 0 corner: (1 @ 0) )
				offsets: ( xOffset @ ( borderWidth negated )  corner: ((xOffset negated) @ 0) )).
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopLeftFrame: aFrame 

	| xOffset yOffset |
	xOffset _ self borderWidth + 1.
	yOffset _ self borderWidth + 1.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0)
				offsets: (xOffset negated @ yOffset negated corner: ( aFrame bounds extent) - (xOffset@yOffset)))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopRightFrame: aFrame 

	| aRect xOffset yOffset |
	aRect _ aFrame bounds.
	xOffset _ self borderWidth.
	yOffset _ self borderWidth + 1.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 0)
				offsets: ( aRect width negated + xOffset @ ( yOffset negated )
							corner: ( xOffset  @ ( aRect height - yOffset ))))

			! !

!WindowFrameMorph methodsFor: 'geometry testing' stamp: 'jlb 2/8/2002 00:10'!
containsPoint: aPoint 
	| inset box |
	inset _ self paneInset.
	box _ self bounds insetBy: inset.
	^ (self bounds containsPoint: aPoint)
		and: [(box	containsPoint: aPoint) not]! !


!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 3/1/2002 22:40'!
addGrowBox
	theme ifNil: [ ^ self ].
	self addGrowBox: theme.! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 2/28/2002 20:02'!
fromTheme: aTheme 

	" add surround frame "
	self addLeftFromTheme: aTheme.
	self addRightFromTheme: aTheme.
	self addTopFromTheme: aTheme.
	self addBottomFromTheme: aTheme.

	topLeftInset := aTheme paneInset origin.
	bottomRightInset := aTheme paneInset corner.

	" close box "
	self addCloseBox: aTheme.
	" min box "
	self addMinBox: aTheme.
	"add a maximize button"
	self addMaxBox: aTheme.

	self labelWidgetAllowance: ( aTheme labelWidgetAllowance ).! !

!WindowFrameImagedMorph methodsFor: 'window frame' stamp: 'jlb 2/7/2002 10:57'!
setLabel: aLabelString 
	| label |
	label _ self submorphNamed: #label.
	label
		ifNotNil: [label delete].
	label _ WindowTitleMorph newInstance: aLabelString.
	self addMorphInLayer: label
		fullFrame: ( label layoutFrame ).
	self active ifTrue: [ label activate ]
				ifFalse: [ label passivate ].! !

!WindowFrameImagedMorph methodsFor: 'initialization' stamp: 'jlb 8/21/2001 08:00'!
initialize
	super initialize.
	borderWidth _ 4.
	self showResizeEdges.
! !


!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/21/2002 21:51'!
labelWidgetAllowance
  ^ lookDictionary at: #labelWidgetAllowance ifAbsent: [ 100 ]! !


!WindowTitleMorph methodsFor: 'initialization' stamp: 'jlb 2/7/2002 10:58'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight;
		 clipSubmorphs: true ;
		 cellPositioning: #center;
		 wrapCentering: #center;		" The title is placed in the center of the title "
		 listCentering: #topLeft.		" determines the justification style ; left right center"
	self setProperty: #wantsActivate toValue: true.
	self setProperty: #morphicLayerNumber toValue: 80.
! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 2/7/2002 10:56'!
addMorphInLayer: aMorph fullFrame: aLayoutFrame 

	aMorph layoutFrame: aLayoutFrame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.
	self addMorphInLayer: aMorph.
! !

!WindowTitleMorph methodsFor: 'WiW support' stamp: 'jlb 2/7/2002 10:59'!
morphicLayerNumber
	^ self valueOfProperty: #morphicLayerNumber ifAbsent: [100]! !

