'From Squeak3.2gamma of 15 January 2002 [latest update: #4857] on 8 June 2002 at 12:04:53 pm'!

!IconInfo methodsFor: 'accessing' stamp: 'jlb 5/25/2002 23:03'!
index
	" index of position in MorphDock "
	^ index max: 2! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 5/25/2002 23:02'!
index: anInteger
	" index of position in MorphDock "
	" the first index position is reserved ; therefore start at 2 "
	index _ anInteger max: 2.! !


!MorphDock methodsFor: 'initialization' stamp: 'jlb 6/8/2002 11:57'!
addSpacer
 	" Insert a little spacer here so we can enter the first icon"
	| spacer |
	spacer _ self transparentSpacerOfSize: 16 @ ( ZurglePreferences dockHeight ).
	spacer name: #spacer.
	self addMorphBack: spacer.

	spacer lock.
! !

!MorphDock methodsFor: 'initialization' stamp: 'jlb 5/25/2002 22:44'!
initialize

	super initialize.
	borderWidth _ 1.
	borderColor _ #raised.
	self extent: ( (ZurglePreferences dockWidth )@ (ZurglePreferences dockHeight ) ).
	self addSpacer.
	self enableDragNDrop.
	self color: Color transparent.
	self setToAdhereToEdge: AdhereEdge.
	Current _ self.
	self setProperty: #morphDock toValue: true.! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 5/25/2002 23:04'!
originOfElementNumber: aNumber 
	"return the x y origin of the element number"
	self submorphs size = 0
		ifTrue: [self addSpacer].
	^ aNumber <= submorphs size
		ifTrue: [(self submorphs
				at: (1 max: aNumber - 1)) bounds topRight]
		ifFalse: [self submorphs last bounds topRight]! !

!MorphDock methodsFor: 'event handling' stamp: 'jlb 6/8/2002 12:02'!
mouseDownEvent: event 
	submorphs
		do: [:m | (m containsPoint: event cursorPoint)
				ifTrue: [m isLocked
						ifFalse: [^ self grabMorph: m event: event]]]! !


!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/25/2002 22:38'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state"

	isCollapsed
		ifTrue: 
			["Expand -- restore panes to morphics structure"
			isCollapsed _ false.
			( ZurglePreferences collapseToTitleBar and: [Preferences collapseWindowsInPlace] )
				ifTrue: 
					[fullFrame := fullFrame align: fullFrame topLeft with: self getBoundsWithFlex topLeft]
				ifFalse:
					[collapsedFrame _ self getBoundsWithFlex].
			self collapseBox ifNotNilDo: [ :m | m setBalloonText: 'collapse this window'].
			"First save latest collapsedFrame"
			self setBoundsWithFlex: fullFrame.
			self unlock.
			paneMorphs
				reverseDo: 
					[:m | 
					self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m].
			windowFrame expand.
			self activate "-- mainly for findWindow"]
		ifFalse: 
			[ 
				ZurglePreferences collapseToTitleBar ifTrue: [ self collapseToTitleBar ]
					ifFalse: [self collapseToThumbnail] ].
	self layoutChanged! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/25/2002 22:29'!
getCollapsedFrame

	| tmp |
	^Preferences collapseWindowsInPlace 
		ifTrue:
			[tmp := self getBoundsWithFlex.
			tmp origin extent: (tmp width @ (self labelHeight))]
		ifFalse:
			[RealEstateAgent assignCollapseFrameFor: self]! !

