'From Squeak3.2gamma of 15 January 2002 [latest update: #4827] on 10 May 2002 at 9:34:39 pm'!
ThemeBase subclass: #FontTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!
FancyCheckBoxMorph subclass: #FancyRadioButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
Morph subclass: #ModalEnforcerMorph
	instanceVariableNames: 'done suspended modalMorphs '
	classVariableNames: 'ActiveModalEnforcers '
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ModalEnforcerMorph commentStamp: '<historical>' prior: 0!
With ModalEnforcerMorph, one can make any set of Morphs in a world be modal. Once ModalEnforcerMorph>>startBeingModal is called, the only morphs that will recieve events are the one's that have been added using ModalEnforcerMorph>>addModalMorph: (their submorphs will also receive events). Any click outside the morphs in the modalMorphs collection will be ignored (although the #clickOutside event will be triggered at that time, if special behavior is required for a click outside).  The ModalEnorcerMorph is no longer modal when #stopBeingModal is called (or #stopBeingModalOnError, which should only be called by code that is opening a Debugger). If a Debugger is opened during a modal state, then ModalEnforcerMorph stops being modal. In most cases, you will probably just want to subclass ModalDialog, or follow it's example, to create a modal window. However, for more complex cases, look at SPSComboBoxMorph and it's use of ModalEnforcerMorph, which shows that any Morphs anywhere in a world can collectively be modal.

Examples:
	Do it:
		ModalEnforcerMorph infoDialog

	Print it:
		ModalEnforcerMorph confirmDialog
		ModalEnforcerMorph yesNoCancelDialog


Events triggered: 
	#startBeingModal	Triggered as ModalEnforcer becomes modal
	#stopBeingModal	Triggered as ModalEnforcer releases modality, before cleanup.
	#finished			Triggered when ModalEnforcer is completely finished,
						including cleanUp.
	#error				Triggered when modal enforcer stops being modal due to
						an error.
	#clickOutside		Triggered when user clicks outside of all modal morphs

It is possible for a ModalEnforcerMorph to never send the #stopBeingModal and #finished events due to some exception conditions, because nested ensure blocks might override the ensure block within #startBeingModal. Please listen for the #error event and do appropriate cleanup if needed.

Structure

	done 					Boolean. Whether the ModalEnforcerMorph is finished being modal.
	suspended 				Boolean. Whether the ModalEnforcerMorph is currently modal.
	modalMorphs			OrderedCollection of morphs that are collectively modal when 
							startBeingModal is called.
	ActiveModalEnforcers	ModalEnforcers that are currently active in the world. 

NOTE: A ModalEnforcerMorph may be active, but not running. Example: a modal file dialog opens a confirm box before overwriting a file -- the confirm box is modal to a window that is modal to the rest of the world. In this case, while the confirm box is open, both ModalEnforcerMorphs are in the ActiveModalEnforcers collection, but only the confirm box's ModalEnforcerMorph is running (not suspended).
	!

ModalEnforcerMorph subclass: #ComboBoxModalEnforcer
	instanceVariableNames: 'textEdit '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ComboBoxModalEnforcer commentStamp: '<historical>' prior: 0!
Override the ModalEnforcerMorph so that keyboard events are intercepted and handled in a way that is appropriate for a combo box. Also, mouse events are directed depending on where they occurred. The method SPSComboBoxModalEnforcer>>handleListenEvent: is the heart of this class.

!

ModalEnforcerMorph class
	instanceVariableNames: ''!
ComboBoxModalEnforcer class
	instanceVariableNames: ''!
CheckBoxControlMorph subclass: #RadioButtonControlMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
Model subclass: #ScreenPreferencesPanel
	instanceVariableNames: 'searchString pages currentPage pageLayoutFrame pasteUpMorph sharedFlap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Preferences'!

!TranslucentImageMorph commentStamp: '<historical>' prior: 0!
I represent an translucent image. The opacity of the image displayed is controlled by my ivar 'alpha'.!

UpdatingFancyCheckBoxMorph subclass: #UpdatingFancyRadioButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 3/10/2002 21:19'!
fancyRadioButtonForm
	^ lookDictionary at: #fancyRadioButtonForm ifAbsent: [ ^ nil ].! !


!FontTheme methodsFor: 'set system fonts' stamp: 'jlb 3/11/2002 21:01'!
setSystemFonts
	" set the system fonts to my representation "
	Preferences setSystemFontTo: self systemFont ;
		setCodeFontTo: self codeFont ;
		setButtonFontTo: self buttonFont ;
		setListFontTo: self listFont ;
		setFlapsFontTo: self flapFont ;
		setMenuFontTo: self menuFont.
		! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
buttonFont
  ^ lookDictionary at: #buttonFont ifAbsent: [ nil ]! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
codeFont
  ^ lookDictionary at: #codeFont ifAbsent: [ nil ]! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
flapFont
  ^ lookDictionary at: #flapFont ifAbsent: [ nil ]! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
listFont
  ^ lookDictionary at: #listFont ifAbsent: [ nil ]! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
menuFont
  ^ lookDictionary at: #menuFont ifAbsent: [ nil ]! !

!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/11/2002 20:56'!
systemFont
  ^ lookDictionary at: #systemFont ifAbsent: [ nil ]! !


!FontTheme class methodsFor: 'accessing' stamp: 'jlb 3/11/2002 21:10'!
current: aFontTheme
	aFontTheme ifNil: [ ^ self ].
	current _ aFontTheme.
	current setSystemFonts.! !


!Morph methodsFor: 'layout-properties' stamp: 'jlb 3/4/2002 15:13'!
alignmentLayout
	" set the layout properties to mimic an alignment morph "
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapCentering: #topLeft.
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.
	self layoutInset: 2.
	self rubberBandCells: true.! !


!ComboBoxListMorph methodsFor: 'filter' stamp: 'jlb 3/16/2002 20:29'!
updateListBody

	| toMatch allMatching matchingAtStart index listToSearch priorityDelta startTime |

	true ifTrue: [ ^ self list: self defaultList ].

	toMatch _ textMorph text asString withBlanksTrimmed.
"Debug dShow: toMatch."
	(toMatch isEmpty) ifTrue: [
		lastSearchKey _ nil.
		self defaultList isEmpty 
			ifTrue:[^nil]
			ifFalse:[^self list: self defaultList].
	].

	toMatch = lastSearchKey ifTrue:[^nil]. "If we just did this search, don't do it again"

	"If the user just added a character or 2 to the last search key,
	cull this search from the last results"
	(lastSearchKey notNil and: [toMatch findString: lastSearchKey]) == 1
		ifTrue:[ listToSearch _ filteredList]
		ifFalse:[ listToSearch _ fullList ].

	allMatching _ OrderedCollection new: fullList size.
	matchingAtStart _ SortedCollection sortBlock: [ :a :b | a size < b size].
	priorityDelta _ -1.
	startTime _ Time millisecondClockValue.
	listToSearch do: [ :s |
		(allMatching size > maxListSize) ifFalse:[
			index _ s findString: toMatch startingAt: 1 caseSensitive: false.
			index > 0 ifTrue:[
				index == 1 
					ifTrue:[ matchingAtStart add: s ]
					ifFalse:[allMatching add: s].
			].

			"This makes sure the search process does not get stuck in the background."
			(Time millisecondClockValue - startTime > 500) ifTrue:[
				priorityDelta _ priorityDelta negated.
				updateListProcess priority: (updateListProcess priority + priorityDelta).
				startTime _ Time millisecondClockValue.
			].
		].
	].

	allMatching size > maxListSize ifTrue:[
			lastSearchKey _ nil. "Don't use the currently filtered list as the basis for
									the next list"
			(matchingAtStart _ OrderedCollection new)
				add: '*********************';
				add: '** Too many';
				add: '** matches found.';
				add: '** Please type';
				add: '** more characters';
				add: '** too narrow';
				add: '** the search.';
				add: '*********************'.
			allMatching _ OrderedCollection new.
	] ifFalse:[
		lastSearchKey _ toMatch.
	].

WorldState addDeferredUIMessage: [
	self filteredList: (matchingAtStart asOrderedCollection, allMatching).
]. ! !


!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 3/16/2002 20:02'!
popupChoices

	choiceList ifNotNil: [ ^ self ].
	choiceList _ ComboBoxListMorph on: self.
	modalEnforcer _ ComboBoxModalEnforcer on: self.
	modalEnforcer 
		when: #finished send: #popupChoicesCleanUp to: self;
		when: #error send: #popupChoicesCleanUp to: self.

 	Cursor wait showWhile: [
		(model isNil or: [ prepListSelector isNil]) ifFalse:[
			model perform: prepListSelector with: choiceList.
		].
		choiceList fullList isEmpty ifTrue:[ self flash. ^self].
 	].

	"Let her rip"
	choiceButton value: true.
	choiceList popUp.
	WorldState addDeferredUIMessage: [self selectAtEnd.].
	modalEnforcer start.

! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 3/16/2002 20:56'!
initialize
	| defaultFont |
	super initialize.
	forms _ Dictionary new.
	active _ true.
	disabled _ false.
	self setProperty: #wantsActivate toValue: true .
	self initializeImageMorph.

	(defaultFont _ Preferences standardButtonFont) 
					emphasized: 0. 

	self
		setText:''; "init the textMorph"
		vResizing: #rigid;
		hResizing: #spaceFill;
		height: (defaultFont height * 1.4) asInteger;
		borderWidth: 1;
		font: defaultFont;
		acceptOnCR: true;
		alwaysDiscardEdits: true.

	self setProperty: #alwaysAccept toValue: true.
	self hideScrollBarIndefinitely.

	allowChoices _ false.
	(choiceButton _ ComboButtonMorph newInstance)
		target: self;
		actionSelector: #popupChoices.
! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 3/16/2002 20:48'!
initializeImageMorph

	imageMorph _ EdgeImageMorph new.
	self addMorphBack: imageMorph.

! !

!ComboBoxMorph methodsFor: 'layout' stamp: 'jlb 3/16/2002 20:50'!
doLayoutIn: layoutBounds
"layout has changed. update scroll deltas or whatever else"

	| inset |

	textMorph width: (self width - choiceButton width - 1 ). 
	scroller width: textMorph width.

	"Don't permit layout of button during modal popup"
	inset _ (self borderWidth - 1) max: 0.
	modalEnforcer isNil ifTrue:[ 
		choiceButton bounds:(
			self right - (choiceButton width + inset) @ (self top + inset )
				corner: (self right@ (self bottom - inset ))).
	].

	imageMorph ifNotNil: [ imageMorph bounds: ( self topLeft corner: ( choiceButton bottomLeft )) ]. 

	
	super doLayoutIn: layoutBounds.


! !


!FancyCheckBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 3/10/2002 12:29'!
newInstance
	| theme |
	" return a new instance of a check box morph from the current theme settings "
	theme _ ButtonTheme current.
	theme ifNil: [ ^ nil ].
	^ self new fromImages: theme fancyCheckBoxForm;
		 setEdges: theme checkBoxEdges.
! !


!FancyRadioButtonMorph methodsFor: 'initialization' stamp: 'jlb 3/10/2002 21:23'!
fromImages: buttonImages 
	self fromImages: buttonImages symbols: 
		#(#uncheckedNormal #uncheckedMouseOver #uncheckedPressed #uncheckedDisabled 		           #checkedNormal  #checkedMouseOver #checkedPressed #checkedDisabled ).
	self state: #off! !

!FancyRadioButtonMorph methodsFor: 'initialization' stamp: 'jlb 3/10/2002 21:28'!
state: aStateSymbol 
	"Change the image and invalidate the rect."
	| symbol prefix |
	state _ aStateSymbol.
	symbol _ #Normal.
	state == #on
		ifTrue: [value _ true].
	prefix _ value
				ifTrue: [#checked]
				ifFalse: [#unchecked].
	symbol _ (disabled
					or: [active not])
				ifTrue: [#Disabled]
				ifFalse: [state caseOf: {
						[#off] -> [#Normal].
						[#pressed] -> [#Pressed].
						[#mouseOver] -> [#MouseOver].
						[#on] -> [#Normal]}].
	symbol _ (prefix , symbol) asSymbol.
	self
		image: (forms at: symbol)! !


!FancyRadioButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 3/10/2002 21:22'!
newInstance
	| theme |
	" return a new instance of a check box morph from the current theme settings "
	theme _ ButtonTheme current.
	theme ifNil: [ ^ nil ].
	^ self new fromImages: theme fancyRadioButtonForm;
		 setEdges: theme checkBoxEdges.
! !


!ModalEnforcerMorph methodsFor: 'control'!
cleanUp: aWorld

	aWorld currentHand 
		removeEventListener: self;
		newMouseFocus: nil;
		newKeyboardFocus: nil.
	self delete.
	! !

!ModalEnforcerMorph methodsFor: 'control'!
isDone
	^done ~= false! !

!ModalEnforcerMorph methodsFor: 'control'!
resume
"Allow this modal enforcer to receive and dispatch events"

	suspended _ false.! !

!ModalEnforcerMorph methodsFor: 'control'!
startBeingModal

	^self startBeingModal: Project current world.! !

!ModalEnforcerMorph methodsFor: 'control'!
startBeingModal: w
"Make the morphs in the modalMorphs collection be modal to the rest of the world w"

	| aWorld |
[
	aWorld _ w outermostWorldMorph. "containing world"
	done _ false.

	aWorld addMorph: self.
	aWorld currentHand newKeyboardFocus: nil.
	aWorld currentHand newMouseFocus: nil.
	aWorld currentHand addEventListener: self.

	self class makeModalEnforcerActive: self.
	Sensor flushKeyboard.
	self trigger: #startBeingModal.

	[done not] whileTrue: [
		[aWorld doOneSubCycle] 
			on: Exception 
			do: [:ex | 
				self stopBeingModalOnError.
				ex signal.
"Debug dShow: 'exception'."
			].
	].
	
] ensure: [
	self trigger: #finished.
	self cleanUp: aWorld.
	self class removeFromActive: self.
	self class resumeLastActiveModalEnforcer.
].	! !

!ModalEnforcerMorph methodsFor: 'control'!
stopBeingModal
"Called to stop being modal"

	self trigger: #stopBeingModal.
	done _ true.
"Debug dShow: 'Stop being modal'."

! !

!ModalEnforcerMorph methodsFor: 'control'!
stopBeingModalOnError
"Called to stop being modal on an error. Most callers should use stopBeingModal instead"

	done _ true.
	self class removeFromActive: self.

	"The following are forked so as not to interfere with critical exception handling 
	mechanisms (If the trigger: #error itself triggers an Exception, a recursive condition
	could occur)"
	[self trigger: #error.] fork.
	[self cleanUp: self world ] fork.
"Debug dShow: 'Stop being modal on error'."
! !

!ModalEnforcerMorph methodsFor: 'control'!
suspend
"Stop this modal enforcer from receiving events. Typically, ModalEnforerMorphs are only suspended because another ModalEnforcerMorph needs to run"

	suspended _ true.! !

!ModalEnforcerMorph methodsFor: 'accessing'!
addModalMorph: aMorph
	(modalMorphs includes: aMorph)
		ifFalse:[ modalMorphs add: aMorph].! !

!ModalEnforcerMorph methodsFor: 'accessing'!
addMorph: aMorph
"Stubbed. This done to make a firm distinction between the idea of a submorph and a modal morph"

	self error: 'This message is not appropriate for this object. For ModalEnforcers, please use #addModalMorph instead'! !

!ModalEnforcerMorph methodsFor: 'accessing'!
modalMorphContainingPoint: aPoint

	^modalMorphs detect: [ :m | m containsPoint: aPoint ] ifNone: [nil]! !

!ModalEnforcerMorph methodsFor: 'accessing'!
modalMorphs
	^modalMorphs! !

!ModalEnforcerMorph methodsFor: 'accessing'!
removeMorph: aMorph
	(modalMorphs includes: aMorph)
		ifTrue:[ modalMorphs remove: aMorph].! !

!ModalEnforcerMorph methodsFor: 'initialization'!
initialize
	super initialize.
	done _ true.
	suspended _ true.
	modalMorphs _ OrderedCollection new.! !

!ModalEnforcerMorph methodsFor: 'events'!
clickOutsideMorphs
"Called when the user clicks outside of the modalMorphs. Default is to do nothing"

	self trigger: #clickOutside.! !

!ModalEnforcerMorph methodsFor: 'events'!
ensureFocusOnModalMorphOrSelf: aHand


	| mousefocus |

	mousefocus _ aHand mouseFocus.
	(modalMorphs 
		detect: [:mm | (mm allMorphs detect:[:morph | morph == mousefocus ] ifNone:[nil]) notNil ]
		ifNone: [ nil ]) isNil
			ifTrue:[aHand newMouseFocus: self].
! !

!ModalEnforcerMorph methodsFor: 'events'!
handleListenEvent: evt

	done ifTrue:[
		"This is redundant with the removeListener in cleanUp:, but if cleanUp: is overridden
		or itself has a bug, it's possible the listener would not be removed, which would
		not be good"
		evt hand removeEventListener: self.

		^self
	].

	suspended ifTrue:[ ^self ].

	(evt isMouse) ifTrue:[
		evt isMouseDown ifTrue:[
			"See if it is within the bounds of any of my modalMorphs.
			If not, tell all my modalMorphs, and give up the focus"
			(self modalMorphContainingPoint: evt position) isNil ifTrue:[
				evt hand mouseFocus: self. "Makes it so hand does not send mouse down to anyone else"
				^self clickOutsideMorphs.
			].
		].
		evt isMouseMove ifTrue:[
			(self modalMorphContainingPoint: evt position) isNil ifTrue:[
				"If the mouse is not contained by any of my modalMorphs,
				then make sure the focus is still on one of them, or else set it to
				self"
				self ensureFocusOnModalMorphOrSelf: evt hand.

			] ifFalse:[
				"If the mouse is contained by one of my modalMorphs, make sure
				I'm not hogging the mouse focus"
				evt hand mouseFocus == self 
					ifTrue:[ evt hand newMouseFocus: nil ].
			].
		].
	].
! !

!ModalEnforcerMorph methodsFor: 'events'!
mouseDown: evt
"stubbed -- all event handling in handleListenEvent."

! !

!ModalEnforcerMorph methodsFor: 'events'!
mouseEnter: evt
"stubbed -- all event handling in handleListenEvent."
! !

!ModalEnforcerMorph methodsFor: 'events'!
mouseLeave: evt
"stubbed -- all event handling in handleListenEvent."

! !

!ModalEnforcerMorph methodsFor: 'events'!
mouseUp: evt
"stubbed -- all event handling in handleListenEvent."

! !

!ModalEnforcerMorph methodsFor: 'drawing'!
drawOn: aCanvas
"stubbed. This morph is invisible"! !


!ComboBoxModalEnforcer methodsFor: 'control'!
start

	"self choiceList popUp.
	self choiceButton updateStateAndDisplay: #down."

	"startBeingModal sets newKeyboardFocus: nil, so delay this"
"	WorldState addDeferredUIMessage: [self textEdit selectAtEnd]."

	self startBeingModal: Project currentWorld.! !

!ComboBoxModalEnforcer methodsFor: 'accessing'!
choiceButton
	^textEdit choiceButton! !

!ComboBoxModalEnforcer methodsFor: 'accessing'!
choiceList
	^textEdit choiceList! !

!ComboBoxModalEnforcer methodsFor: 'accessing'!
textEdit
	^textEdit! !

!ComboBoxModalEnforcer methodsFor: 'accessing'!
textEdit: aComboBoxMorph
	textEdit _ aComboBoxMorph.
	self 
		addModalMorph: textEdit;
		addModalMorph: textEdit choiceList;
		addModalMorph: textEdit choiceButton.! !

!ComboBoxModalEnforcer methodsFor: 'events'!
cancel
	self stopBeingModal.! !

!ComboBoxModalEnforcer methodsFor: 'events'!
clickOutsideMorphs
"Called when the user clicks outside of the modalMorphs. Default is to do nothing"
	self cancel! !

!ComboBoxModalEnforcer methodsFor: 'events'!
handleListenEvent: evt

	|  keyCharacter asciiValue choiceList choiceButton |

	super handleListenEvent: evt.
	(self isDone) 
		ifTrue:[ ^self].

	choiceList _ self choiceList.
	choiceButton _ self choiceButton.

	evt isMouse ifTrue:[
		(evt isMouseUp) ifTrue:[
			(choiceList innerBounds containsPoint: evt position) ifTrue:[	
				choiceList mouseUp: evt. 
				self ok.
			].
			^self
		].
		(evt isMouseDown) ifTrue:[
			(choiceButton bounds containsPoint: evt position) ifTrue:[	
Transcript show: 'stop being modal' ; cr.
				self cancel.
			].
			^self
		].
		evt isMouseMove ifTrue:[
			(choiceList bounds containsPoint: evt position) ifTrue:[	
				choiceList mouseOver: evt.
			].
			^self
		].

		^self
	].
	(evt isKeyboard) ifTrue:[

		keyCharacter _ evt keyCharacter.
		asciiValue _ keyCharacter asciiValue.

		(keyCharacter == Character cr ) ifTrue:[
			^self ok.
		].
		(keyCharacter == Character escape ) ifTrue:[
			^self cancel.
		].

		"If it's not a special key, put the key focus back on the text"

"Keys key: 1=home, 4=end, 11=page up, 12=page down, 30=up, 31=down, "
"Debug dShow: asciiValue."

		(#(11 12 13 30 31) includes: asciiValue) ifTrue:[
			self putKeyFocusOnListMorph: evt hand.
		] ifFalse:[
			self putKeyFocusOnTextMorph: evt hand.
		].

		(evt isKeystroke) ifTrue:[
			(#(11 12 30 31) includes: asciiValue)	ifTrue: [
				"choiceList specialKeyPressed: asciiValue"
			].
			^self
		].

		"If any key besides navigation keys was pressed, update the list"
		(#(1 4 11 12 30 31) includes: asciiValue) 
			ifFalse:[ choiceList updateList ].
	].! !

!ComboBoxModalEnforcer methodsFor: 'events'!
ok

	| result |

	self stopBeingModal.

	result _ self choiceList selection.
	result ifNotNil: [
		self textEdit setText: result withBlanksTrimmed.
		self textEdit hasUnacceptedEdits: true.
		[WorldState addDeferredUIMessage: [self textEdit trigger: #selectionMade]] fork.
	].

! !

!ComboBoxModalEnforcer methodsFor: 'events'!
putKeyFocusOnListMorph: aHand
"If listMorph does not have the keyboard focus, take it "

	| keyfocus list |

	(list _ self choiceList) isNil
		ifTrue:[^self ].
	keyfocus _ aHand keyboardFocus.
	(list allMorphs detect: [:m | m == keyfocus ] ifNone: [nil]) ifNil: [
			aHand newKeyboardFocus: list.
	].
! !

!ComboBoxModalEnforcer methodsFor: 'events'!
putKeyFocusOnTextMorph: aHand
"If textMorph does not have the keyboard focus, take it back"

	| keyfocus |

	keyfocus _ aHand keyboardFocus.
	(textEdit allMorphs detect: [:m | m == keyfocus ] ifNone: [nil]) ifNil: [
			aHand newKeyboardFocus: textEdit.
			textEdit setSelection: textEdit selectionInterval.
	].
! !


!ModalEnforcerMorph class methodsFor: 'error handling'!
releaseAllModal
"Called during exception conditions. Tell all known instances of ModalEnforcerMorphs to stop being modal."

	| allModalEnforcers |

	allModalEnforcers _ OrderedCollection new: 25.
	(ModalEnforcerMorph allSubclasses add: ModalEnforcerMorph; yourself) do: [ :cls | 
		allModalEnforcers addAll: cls allInstances.
	].

	allModalEnforcers do: [ :modalEnforcer |
		modalEnforcer stopBeingModalOnError.
	].! !

!ModalEnforcerMorph class methodsFor: 'control'!
activeModalEnforcers
"Return all the currently active modal enforcers"

"
ModalEnforcerMorph activeModalEnforcers.
"
	ActiveModalEnforcers ifNil: [ ActiveModalEnforcers _ OrderedCollection new ].

	^ActiveModalEnforcers! !

!ModalEnforcerMorph class methodsFor: 'control'!
clearActiveModalEnforcers
"
ModalEnforcerMorph clearActiveModalEnforcers.
"
	self activeModalEnforcers do: [ :enforcer |
		enforcer stopBeingModal.
	].
	ActiveModalEnforcers _ OrderedCollection new.
	! !

!ModalEnforcerMorph class methodsFor: 'control'!
makeModalEnforcerActive: aModalEnforcer
"Add aModalEnforcer to the list of active modal enforcers, and then resume it to get it running"

	"Suspend any active one's first"
	self suspendActiveModalEnforcers.

	(self activeModalEnforcers includes: aModalEnforcer) 
		ifFalse:[ self activeModalEnforcers add: aModalEnforcer ].

	aModalEnforcer resume.! !

!ModalEnforcerMorph class methodsFor: 'control'!
removeFromActive: aModalEnforcer

	(self activeModalEnforcers includes: aModalEnforcer) 
		ifTrue:[ self activeModalEnforcers remove: aModalEnforcer ].
! !

!ModalEnforcerMorph class methodsFor: 'control'!
resumeLastActiveModalEnforcer
"Resume the last active modal enforcer"

	self activeModalEnforcers notEmpty ifTrue:[
		self activeModalEnforcers last resume.
	].! !

!ModalEnforcerMorph class methodsFor: 'control'!
suspendActiveModalEnforcers
"Suspend any modal enforcers that are not suspended already."

	self activeModalEnforcers do: [ :modalEnforcer |
		modalEnforcer suspend.
	].! !


!ComboBoxModalEnforcer class methodsFor: 'instance creation'!
on: aComboBoxMorph

	| newInst |
	(newInst _ self new)
		textEdit: aComboBoxMorph.

	^newInst! !


!RadioButtonControlMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/10/2002 12:17'!
initialize
	| aButton |
	super initialize.
	aButton _ ThreePhaseButtonMorph radioButton.
	aButton name: #checkBox .
	self replaceSubmorph: self checkBox by: aButton.! !

!RadioButtonControlMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/10/2002 21:49'!
makeUpdateable
	" remove the old check box "
	| aButton |
	(self submorphNamed: #checkBox)
		ifNotNilDo: [:checkBox | checkBox delete].
	" add an updateable check box "
	self addMorph: (aButton _ UpdatingThreePhaseButtonMorph radioButton).
	aButton name: #checkBox.
	
	! !


!ScreenPreferencesPanel methodsFor: 'page selection' stamp: 'jlb 3/11/2002 23:02'!
selectPage: aSymbol 
	currentPage
		ifNotNil: [currentPage delete].
	currentPage _ pages at: aSymbol.
	pasteUpMorph
		ifNotNil: [aSymbol == #appearancePage
				ifTrue: [pasteUpMorph
						addMorph: currentPage
						fullFrame: (LayoutFrame
								fractions: (0 @ 0 corner: 1 @ 1)
								offsets: (9 @ 34 corner: -9 @ -40))]
				ifFalse: [pasteUpMorph addMorph: currentPage]].
	currentPage position: pasteUpMorph topLeft + self paneRectOrigin.
	pasteUpMorph changed! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 5/10/2002 21:34'!
buildWindowPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the window option 
	checkboxes "
	| windowPage aPref biggerFont smallFont |
	windowPage _ AlignmentMorph new.
	windowPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #windowPage put: windowPage.
	windowPage
		on: #mouseDown
		send: #yourself
		to: #().
	windowPage dropEnabled: false.
	windowPage color: Color transparent;
		 layoutInset: 16.
	windowPage position: self paneRectOrigin.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	windowPage addMorphBack: ( DialogTextMorph contents: 'Window Preference Settings' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogTextMorph contents: 'Define how windows look and behave    ' font: smallFont emphasis: 1) ;
		addMorphBack: ( windowPage transparentSpacerOfSize: (0@8)).
		
	"find the alternative window browse it"
	aPref _ (Preferences preferenceObjectsInCategory: #browsing)
				detect: [:pref | pref name == #alternativeWindowLook] ifNone: [nil].
	aPref
		ifNotNil: [windowPage
				addMorphBack: (self representativeButtonFromPreference: aPref)].
	(Preferences preferenceObjectsInCategory: #windows)
		do: [:aPreference | windowPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'keyboard' stamp: 'jlb 3/2/2002 13:34'!
keyStroke: evt 
	| char |
	char _ evt keyCharacter.
	
	char = Character tab
		ifTrue: [ "select the next tab "
			" This needs to be more elaborate "
			^ true].
	char = Character cr
		ifTrue: [ "default button pressed"
			self closePanel.
			^ true].
	char = Character escape
		ifTrue: [ "Cancel struck"
			self cancelPanel.
			^ true].
	^ false! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/24/2002 20:10'!
buildAppearancePage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| appearancePage  smallFont biggerFont stringMorph leftMargin lineBase frameComboBox fontComboBox |

	leftMargin _ 16.
	appearancePage _ PasteUpMorph new.
	pages at: #appearancePage put: appearancePage.
	appearancePage
		on: #mouseDown
		send: #yourself
		to: #().
	appearancePage color: Color lightBlue ;
		setProperty: #wantsActivate toValue: true ;
	 	layoutInset: 16 ;
		extent: 600@600 ;
		borderWidth: 0 ;
		color: Color white.

	appearancePage dropEnabled: false.


	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	stringMorph _ ( DialogTextMorph contents: 'Appearance Preferences' font: biggerFont). 
	appearancePage addMorph: stringMorph.
	lineBase _ biggerFont height.
	stringMorph position: leftMargin @ lineBase.
	lineBase _ lineBase + (biggerFont height * 2 ).

	stringMorph _ DialogTextMorph contents: 'Frame Style: ' font: smallFont.
	appearancePage addMorph: stringMorph.
	stringMorph position: leftMargin + 8 @ lineBase.
	frameComboBox _ self buildFrameComboBox.
	appearancePage addMorph: frameComboBox.
	frameComboBox position: 140 @ lineBase.
	lineBase _ lineBase + frameComboBox height.
	lineBase _ lineBase + smallFont height + 16.

	stringMorph _ DialogTextMorph contents: 'Font Style: ' font: smallFont.
	appearancePage addMorph: stringMorph.
	stringMorph position: leftMargin + 8 @ lineBase.
	fontComboBox _ self buildFontComboBox.
	appearancePage addMorph: fontComboBox.
	fontComboBox position: 140@lineBase.

"	groupBox _ self buildFontSizeGroupBox.
	appearancePage addMorph: groupBox.
	groupBox position: leftMargin + 32 @ lineBase.
"

"
	| appearancePage biggerFont smallFont frameComboBox |

	appearancePage _ AlignmentMorph new.
	appearancePage listDirection: #topToBottom;
		 beSticky;
		 extent: 2 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #appearancePage put: appearancePage.
	appearancePage
		on: #mouseDown
		send: #yourself
		to: #().
	appearancePage dropEnabled: false.
	appearancePage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	appearancePage addMorphBack: ( DialogTextMorph contents: 'Appearance Preferences' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont).

	frameComboBox _ self buildFrameComboBox.
	appearancePage addMorphBack: frameComboBox.
"
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:36'!
buildFontComboBox
| comboBox |
"Build combobox to be used to set the current font."
	(comboBox _ ComboBoxMorph on: self)
		name: #fontComboBox;
		prepChoiceListSelector: #prepFontComboBox:;
		when: #enter send: #fontComboBoxEnter: to: self with: comboBox;
		when: #selectionMade send: #fontComboBoxEnter: to: self with: comboBox;
		allowChoices: true ;
		setText: FontTheme current themeName.

	self addDependent: comboBox.

	^comboBox! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/24/2002 20:10'!
buildFontSizeGroupBox
	| groupBox smallFont biggerFont outerButton |

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 18
				emphasized: 1.
	groupBox _ GroupBoxMorph newInstance.
	groupBox listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	groupBox
		addMorphBack: (DialogTextMorph contents: ' System Font Sizes ' font: biggerFont emphasis: 1) ;
		addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #toggleFontSize;
		getSelector: #isSmallFonts.
	outerButton label: 'Small'.
	outerButton setBalloonText: 'Select small system fonts'.
	groupBox addMorphBack: outerButton.

	groupBox addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #toggleFontSize;
		getSelector: #isLargeFonts.
	outerButton label: 'Large'.
	outerButton setBalloonText: 'Select large system fonts'.
	groupBox addMorphBack: outerButton.




	^ groupBox.
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:35'!
buildFrameComboBox
| comboBox |
	"Build combobox to be used to set the current frame style."
	(comboBox _ ComboBoxMorph on: self)
		name: #classComboBox;
		prepChoiceListSelector: #prepFrameComboBox:;
		when: #enter send: #frameComboBoxEnter: to: self with: comboBox;
		when: #selectionMade send: #frameComboBoxEnter: to: self with: comboBox;
		allowChoices: true ;
		setText: WindowTheme current themeName.

	self addDependent: comboBox.

	^comboBox! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:10'!
fontComboBoxEnter: comboBox
"User hit enter in the class combobox"
			
	| theClass newTheme |
	self okToChange ifFalse:[^ self].
	newTheme _ FontTheme themeNamed: ( comboBox text ).
	newTheme ifNil: [ ^ self ].
	FontTheme current: newTheme.
	" comboBox text explore. "
	true ifTrue: [ ^ self ].
	(theClass _ Smalltalk at: comboBox text asString asSymbol ifAbsent: [nil]) isNil ifTrue:[
		comboBox choiceList isNil ifTrue:[
			"Wait for user to release the enter key, then popup the choices list"
			Sensor keyboardPressed 
				ifTrue: [ ^WorldState addDeferredUIMessage: [self classComboBoxEnter: comboBox]].
			comboBox popupChoices
		].
	] ifFalse:[
		Cursor wait showWhile: [
			self setClass: theClass selector: nil. 
		].
	].
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:08'!
frameComboBoxEnter: comboBox
"User hit enter in the class combobox"
			
	| theClass newTheme |
	self okToChange ifFalse:[^ self].
	newTheme _ WindowTheme themeNamed: ( comboBox text ).
	newTheme ifNil: [ ^ self ].
	WindowTheme current: newTheme.
	" comboBox text explore. "
	true ifTrue: [ ^ self ].
	(theClass _ Smalltalk at: comboBox text asString asSymbol ifAbsent: [nil]) isNil ifTrue:[
		comboBox choiceList isNil ifTrue:[
			"Wait for user to release the enter key, then popup the choices list"
			Sensor keyboardPressed 
				ifTrue: [ ^WorldState addDeferredUIMessage: [self classComboBoxEnter: comboBox]].
			comboBox popupChoices
		].
	] ifFalse:[
		Cursor wait showWhile: [
			self setClass: theClass selector: nil. 
		].
	].
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/10/2002 22:01'!
isLargeFonts
	^ false! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/10/2002 21:59'!
isSmallFonts
	^ true! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/11/2002 22:40'!
passivateAppearances: appearancePageMorph
	self beep.! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:33'!
prepFontComboBox: choiceList

	choiceList 
			fullList: FontTheme themes keys asOrderedCollection;
			searchFor: FontTheme current themeName ;
			defaultList: FontTheme themes keys asOrderedCollection;
			maxListSize: 500.

	^true
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/16/2002 20:34'!
prepFrameComboBox: choiceList

	choiceList 
			fullList: WindowTheme themes keys asOrderedCollection;
			searchFor: WindowTheme current themeName ;
			defaultList: WindowTheme themes keys asOrderedCollection;
			maxListSize: 500.

	^true
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/10/2002 22:02'!
toggleFontSize! !


!TabPanelMorph methodsFor: 'initialization' stamp: 'jlb 3/17/2002 07:53'!
initialize
	super initialize.
	pages _ Dictionary new.
	currentPage _ nil.
	self layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		wrapDirection: #none ;
		wrapCentering: #bottomRight ;
		setProperty: #wantsActivate toValue: true ;
		clipSubmorphs: true.
	self on: #mouseDown send: #mouseDown: to: self. 
! !

!TabPanelMorph methodsFor: 'drawing' stamp: 'jlb 3/17/2002 07:55'!
clippingBounds
	"Return the bounds to which any submorphs should be clipped if the property is set"
	^self bounds! !


!ThreePhaseButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 3/10/2002 12:27'!
checkBox
	"Answer a button pre-initialized with checkbox images."
	| f |
true ifTrue: [ ^ FancyCheckBoxMorph newInstance ].
	^self new
		onImage: (f _ ScriptingSystem formAtKey: 'CheckBoxOn');
		pressedImage: (ScriptingSystem formAtKey: 'CheckBoxPressed');
		offImage: (ScriptingSystem formAtKey: 'CheckBoxOff');
		extent: f extent + (2@0);
		yourself
! !

!ThreePhaseButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 3/10/2002 21:33'!
radioButton
	"Answer a button pre-initialized with radiobutton images."
	| f |
	true ifTrue: [ ^ FancyRadioButtonMorph newInstance ].
	^self new
		onImage: (f _ ScriptingSystem formAtKey: 'RadioButtonOn');
		pressedImage: (ScriptingSystem formAtKey: 'RadioButtonPressed');
		offImage: (ScriptingSystem formAtKey: 'RadioButtonOff');
		extent: f extent + (2@0);
		yourself
! !


!UpdatingFancyRadioButtonMorph methodsFor: 'initialization' stamp: 'jlb 3/10/2002 21:48'!
fromImages: buttonImages 
	self fromImages: buttonImages symbols: 
		#(#uncheckedNormal #uncheckedMouseOver #uncheckedPressed #uncheckedDisabled 		           #checkedNormal  #checkedMouseOver #checkedPressed #checkedDisabled ).
	self state: #off! !

!UpdatingFancyRadioButtonMorph methodsFor: 'initialization' stamp: 'jlb 3/10/2002 21:48'!
state: aStateSymbol 
	"Change the image and invalidate the rect."
	| symbol prefix |
	state _ aStateSymbol.
	symbol _ #Normal.
	state == #on
		ifTrue: [value _ true].
	prefix _ value
				ifTrue: [#checked]
				ifFalse: [#unchecked].
	symbol _ (disabled
					or: [active not])
				ifTrue: [#Disabled]
				ifFalse: [state caseOf: {
						[#off] -> [#Normal].
						[#pressed] -> [#Pressed].
						[#mouseOver] -> [#MouseOver].
						[#on] -> [#Normal]}].
	symbol _ (prefix , symbol) asSymbol.
	self
		image: (forms at: symbol)! !


!UpdatingFancyRadioButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 3/10/2002 21:48'!
newInstance
	| theme |
	" return a new instance of a check box morph from the current theme settings "
	theme _ ButtonTheme current.
	theme ifNil: [ ^ nil ].
	^ self new fromImages: theme fancyRadioButtonForm;
		 setEdges: theme checkBoxEdges.
! !

