'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 20 February 2002 at 8:33:39 pm'!
"Change Set:		Remember
Date:			18 October 2001
Author:			Jim Benson

When selected from the window menu, makes the current window size the default window size for the associated tool. As an example, open a System Browser, resize it, and select 'Remember this size' from the window menu. When you open your next SystemBrowser, it will be the same size as your current browser. Useful for larger displays.

Includes changes by Mark Schwenk:

Change Set:		fixSelectorBrowserAndTranscriptSizeRemembering-mas

Adds Zurgle default window size remembering for Transcripts and SelectorBrowsers.

Part of the Zurgle desktop project"!

Model class
	instanceVariableNames: 'preferredExtent '!
TranscriptStream class
	instanceVariableNames: 'preferredExtent '!

!Model methodsFor: 'user interface' stamp: 'jlb 10/3/2001 16:16'!
initialExtent
	self class preferredExtent ifNotNilDo: [ :aPoint | ^ aPoint ].
	^ super initialExtent.! !


!Model class methodsFor: 'accessing' stamp: 'jlb 10/3/2001 16:14'!
preferredExtent
	^ preferredExtent! !

!Model class methodsFor: 'accessing' stamp: 'jlb 10/3/2001 16:14'!
preferredExtent: aPoint
	preferredExtent _ aPoint! !


!SelectorBrowser methodsFor: 'as yet unclassified' stamp: 'mas 2/20/2002 00:00'!
initialExtent
	self class preferredExtent ifNotNilDo: [ :aPoint | ^ aPoint ].
	^ 350@250
! !


!SystemWindow methodsFor: 'menu' stamp: 'jlb 10/3/2001 16:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
"template..."
	aCustomMenu addLine.
	aCustomMenu add: 'edit label...' action: #relabel.
	aCustomMenu add: 'remember this size' action: #rememberSize.
! !

!SystemWindow methodsFor: 'menu' stamp: 'jlb 10/3/2001 16:29'!
buildWindowMenu
	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu add: 'change title...' action: #relabel.
	aMenu addLine.
	aMenu add: 'send to back' action: #sendToBack.
	aMenu add: 'make next-to-topmost' action: #makeSecondTopmost.
	aMenu addLine.
	self mustNotClose
		ifTrue: [aMenu add: 'make closable' action: #makeClosable]
		ifFalse: [aMenu add: 'make unclosable' action: #makeUnclosable].
	aMenu
		add: (self isSticky
				ifTrue: ['make draggable']
				ifFalse: ['make undraggable'])
		action: #toggleStickiness.
	aMenu addLine.
	aMenu add: 'full screen' action: #fullScreen.
	self isCollapsed
		ifFalse: [aMenu add: 'window color...' action: #setWindowColor.
			aMenu add: 'remember this size' action: #rememberSize].
	^ aMenu! !

!SystemWindow methodsFor: 'menu' stamp: 'jlb 10/3/2001 16:28'!
rememberSize
	self model
		ifNotNil: [model class preferredExtent: self extent]! !


!TranscriptStream methodsFor: 'user interface' stamp: 'mas 2/19/2002 23:39'!
initialExtent
	self class preferredExtent ifNotNilDo: [ :aPoint | ^ aPoint ].
	^ super initialExtent.! !


!TranscriptStream class methodsFor: 'accessing' stamp: 'mas 2/19/2002 23:24'!
preferredExtent
	^ preferredExtent! !

!TranscriptStream class methodsFor: 'accessing' stamp: 'mas 2/19/2002 23:24'!
preferredExtent: aPoint
	preferredExtent _ aPoint! !

