'From Squeak3.2alpha of 4 October 2001 [latest update: #4418] on 10 October 2001 at 10:43:17 pm'!
StringMorph subclass: #DialogTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Dialog'!
Model subclass: #ScreenPreferencesPanel
	instanceVariableNames: 'searchString pages currentPage pageLayoutFrame pasteUpMorph sharedFlap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Preferences'!
Object subclass: #ScreenProperties
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!

!DialogTextMorph methodsFor: 'initialization' stamp: 'jlb 10/10/2001 11:01'!
initialize
	super initialize.
	self setProperty: #wantsActivate toValue: true .

	! !

!DialogTextMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/9/2001 20:14'!
activate
	self color:  ( ButtonTheme current enabledTextColor ).! !

!DialogTextMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/10/2001 11:07'!
passivate
	self color: ( ButtonTheme current disabledTextColor ).! !


!DialogTextMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 10/10/2001 11:07'!
contents: aString font: aFont
	^ self contents: aString font: aFont emphasis: 0.! !

!DialogTextMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 10/10/2001 11:07'!
contents: aString font: aFont emphasis: emphasisCode 
	| toReturn |
	toReturn _  self basicNew
		initWithContents: aString
		font: aFont
		emphasis: emphasisCode.
	toReturn setProperty: #wantsActivate toValue: true.
	^ toReturn! !


!FlapTab methodsFor: 'globalness' stamp: 'jlb 10/10/2001 00:41'!
isProjectEnabled
	" Answer whether this flap is enabled in the current project "
	| disabledFlapIDs  |
	disabledFlapIDs _ Project current parameterAt: #disabledGlobalFlapIDs ifAbsent: [^ true].
	^ (disabledFlapIDs includes: self flapID) not! !

!FlapTab methodsFor: 'globalness' stamp: 'jlb 10/10/2001 00:23'!
toggleGlobalFlap
	"Toggle the enable/disable status of the given global flap"

	Flaps enableDisableGlobalFlapWithID: self flapID.
		! !


!PasteUpMorph methodsFor: 'initialization' stamp: 'jlb 10/8/2001 15:42'!
initialize
	owner _ nil.
	submorphs _ EmptyArray.
	borderWidth _ 1.
	borderColor _ Color r: 0.861 g: 1.0 b: 0.722.
	color _ Color r: 0.8 g: 1.0 b: 0.6.
	bounds _ 0@0 corner: 50@40.
	cursor _ 1.
	padding _ 3.
	self enableDragNDrop.
	self isWorldMorph ifTrue: [self setProperty: #automaticPhraseExpansion toValue: true].
	self clipSubmorphs: true.
	self setProperty: #wantsActivate toValue: true .
! !

!PasteUpMorph methodsFor: 'activate/passivate' stamp: 'jlb 10/8/2001 15:41'!
activate
	" This is used for alignment morphs in SystemWindows ;
	  propogates activate message to submorphs which may be controls "
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m activate]]! !

!PasteUpMorph methodsFor: 'activate/passivate' stamp: 'jlb 10/8/2001 15:42'!
passivate
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m passivate]]! !


!Preference methodsFor: 'value' stamp: 'jlb 10/10/2001 01:31'!
toggleSpecialPreferenceValue: aCheckBoxMorph
	"Toggle whether the value of the preference"

	value _ value not.
	self notifyInformeeOfChange.
	( aCheckBoxMorph valueOfProperty: #dpModel ) ifNotNilDo: [ :mod | mod sharedFlapsSettingsChanged ].! !


!Preferences class methodsFor: 'personalization' stamp: 'jlb 10/10/2001 15:56'!
personalizeUserMenu: aMenu
	"The user has clicked on the morphic desktop with the yellow mouse button (option+click on the Mac); a menu is being constructed to present to the user in response; its default target is the current world.  In this method, you are invited to add items to the menu as per personal preferences.
	The default implementation, for illustrative purposes, sets the menu title to 'personal', and adds items for go-to-previous-project, show/hide flaps, and load code updates"
	
	aMenu addTitle: 'personal'.  "Remove or modify this as per personal choice"

	aMenu addStayUpItem.
	aMenu add: 'previous project' action: #goBack.
	aMenu add: 'load latest code updates' target: Utilities action: #updateFromServer.
	aMenu add: 'about this system...' target: Smalltalk action: #aboutThisSystem.
				
	aMenu addUpdating: #suppressFlapsString target: CurrentProjectRefactoring action: #currentToggleFlapsSuppressed.
	aMenu balloonTextForLastItem: 'Whether prevailing flaps should be shown in the project right now or not.'.
	aMenu addLine.
	aMenu add: 'Preferences...' target: ScreenProperties action: #editProperties.! !


!ScreenPreferencesPanel methodsFor: 'initialization' stamp: 'jlb 10/7/2001 18:01'!
initialize
	pages _ Dictionary new.
	currentPage _ nil.	
	pasteUpMorph _ nil.! !

!ScreenPreferencesPanel methodsFor: 'color' stamp: 'jlb 10/6/2001 15:20'!
defaultBackgroundColor
	 ^Color r: 233 g: 233 b: 214 range: 255
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 22:40'!
buildAppearancePage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| appearancePage biggerFont smallFont |
	appearancePage _ AlignmentMorph new.
	appearancePage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #appearancePage put: appearancePage.
	appearancePage
		on: #mouseDown
		send: #yourself
		to: #().
	appearancePage dropEnabled: false.
	appearancePage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	appearancePage addMorphBack: ( DialogTextMorph contents: 'It doesn''t mean much now, it''s built for the future.' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont).
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 19:25'!
buildMenuPage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| menuPage biggerFont smallFont |
	menuPage _ AlignmentMorph new.
	menuPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #menuPage put: menuPage.
	menuPage
		on: #mouseDown
		send: #yourself
		to: #().
	menuPage dropEnabled: false.
	menuPage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	menuPage addMorphBack: ( DialogTextMorph contents: 'Menu Preference Settings' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogTextMorph contents: 'Define how menus look and behave   ' font: smallFont emphasis: 1) ;
		addMorphBack: ( menuPage transparentSpacerOfSize: (0@16)).

	(Preferences preferenceObjectsInCategory: #menus)
		do: [:aPreference | menuPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 19:21'!
buildScrollbarPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the scrollbar option  
	checkboxes"
	| scrollbarPage biggerFont smallerFont |
	scrollbarPage _ AlignmentMorph new.
	scrollbarPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #scrollbarPage put: scrollbarPage.
	scrollbarPage
		on: #mouseDown
		send: #yourself
		to: #().
	scrollbarPage dropEnabled: false.
	scrollbarPage color: Color transparent;
		 layoutInset: 16.
	smallerFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallerFont familyName
				size: 21
				emphasized: 1.
	scrollbarPage
		addMorphBack: (DialogTextMorph contents: 'Scrollbar Preference Settings' font: biggerFont);
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogTextMorph contents: 'Define how scrollbars appear in windows' font: smallerFont);
		addMorphBack: (scrollbarPage transparentSpacerOfSize: 0 @ 16).

	(Preferences preferenceObjectsInCategory: #scrolling)
		do: [:aPreference | scrollbarPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 22:39'!
buildSettingsPage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| settingsPage biggerFont smallFont |
	settingsPage _ AlignmentMorph new.
	settingsPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #settingsPage put: settingsPage.
	settingsPage
		on: #mouseDown
		send: #yourself
		to: #().
	settingsPage dropEnabled: false.
	settingsPage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	settingsPage addMorphBack: ( DialogTextMorph contents: 'It doesn''t mean much now, it''s built for the future.' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont).
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 19:24'!
buildWindowPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the window option 
	checkboxes "
	| windowPage aPref biggerFont smallFont |
	windowPage _ AlignmentMorph new.
	windowPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #windowPage put: windowPage.
	windowPage
		on: #mouseDown
		send: #yourself
		to: #().
	windowPage dropEnabled: false.
	windowPage color: Color transparent;
		 layoutInset: 16.
	windowPage position: self paneRectOrigin.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	windowPage addMorphBack: ( DialogTextMorph contents: 'Window Preference Settings' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogTextMorph contents: 'Define how windows look and behave    ' font: smallFont emphasis: 1) ;
		addMorphBack: ( windowPage transparentSpacerOfSize: (0@8)).
		
	"find the alternative window browse it"
	aPref _ (Preferences preferenceObjectsInCategory: #browsing)
				detect: [:pref | pref name == #alternativeWindowLook] ifNone: [nil].
	aPref
		ifNotNil: [windowPage
				addMorphBack: (self representativeButtonFromPreference: aPref)].
	(Preferences preferenceObjectsInCategory: #windows)
		do: [:aPreference | windowPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 01:07'!
representativeButtonFromPreference: aPreference
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton label |
	
	outerButton _ CheckBoxControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: aPreference;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue.
	label _ WriteStream on: ( aPreference name asString).
	aPreference name do: [ :aChar |
		aChar isUppercase ifTrue: [
			label space ;
				  nextPut: ( aChar asLowercase) ]
				ifFalse: [ label nextPut: aChar ]].
	" upper case the first letter "
	label _ label contents.
	label at: 1 put: (label at: 1) asUppercase.
	outerButton label: label.
	outerButton setBalloonText: aPreference helpString.
	^ outerButton 
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 22:32'!
selectAppearanceTab
	self selectPage: #appearancePage.
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 15:59'!
selectMenuTab
	self selectPage: #menuPage.
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/9/2001 15:55'!
selectScrollbarTab
	self selectPage: #scrollbarPage.
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/10/2001 22:32'!
selectSettingsTab
	self selectPage: #settingsPage.
! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 10/9/2001 13:21'!
selectWindowTab
	self selectPage: #windowPage.
! !

!ScreenPreferencesPanel methodsFor: 'accessors' stamp: 'jlb 10/7/2001 17:52'!
pageLayoutFrame
	^ pageLayoutFrame! !

!ScreenPreferencesPanel methodsFor: 'accessors' stamp: 'jlb 10/7/2001 17:52'!
pageLayoutFrame: aLayoutFrame
	pageLayoutFrame _ aLayoutFrame! !

!ScreenPreferencesPanel methodsFor: 'accessors' stamp: 'jlb 10/9/2001 13:24'!
paneRectOrigin
	^ 9@34! !

!ScreenPreferencesPanel methodsFor: 'accessors' stamp: 'jlb 10/7/2001 18:02'!
pasteUpMorph
	^ pasteUpMorph! !

!ScreenPreferencesPanel methodsFor: 'accessors' stamp: 'jlb 10/7/2001 18:02'!
pasteUpMorph: aPasteUpMorph
	pasteUpMorph _ aPasteUpMorph! !

!ScreenPreferencesPanel methodsFor: 'page selection' stamp: 'jlb 10/10/2001 14:22'!
selectPage: aSymbol 
	currentPage
		ifNotNil: [
			currentPage delete].
	currentPage _ (pages at: aSymbol).
	pasteUpMorph
		ifNotNil: [pasteUpMorph addMorph: currentPage].
	currentPage position: ( pasteUpMorph topLeft + ( self paneRectOrigin )).
	pasteUpMorph changed.! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 15:15'!
buildAboutButton: aPanel
	
	| aButton |

	aButton _ OSButtonMorph newInstance target: Flaps;
				 actionSelector: #explainFlaps;
				 label: 'About Flaps...'.
	^ aButton.
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 15:13'!
buildFlapsPage: aPasteUpMorph 
	| flapsPage smallFont biggerFont aPref sharedFlapControl groupBox mainFlapsPage aboutButton aBounds |

	mainFlapsPage _ self newMainFlapsPage.

	flapsPage _ AlignmentMorph new.
	flapsPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	"pages at: #flapsPage put: flapsPage."
	flapsPage
		on: #mouseDown
		send: #yourself
		to: #().
	flapsPage dropEnabled: false.
	flapsPage color: Color transparent;
		 layoutInset: 16.
	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 21
				emphasized: 1.
	flapsPage
		addMorphBack: (DialogTextMorph contents: 'Flaps Preference Settings ' font: biggerFont);
		
		addMorphBack: (DialogTextMorph contents: '' font: biggerFont);
		
		addMorphBack: (DialogTextMorph
				contents: 'Define how flaps appear on the screen    '
				font: smallFont
				emphasis: 1);
		
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4).
	(Preferences preferenceObjectsInCategory: #flaps)
		do: [:aFlap | aFlap name == #showSharedFlaps
				ifTrue: [sharedFlap _ aFlap]
				ifFalse: [flapsPage
						addMorphBack: (self representativeButtonFromPreference: aFlap)]].
	flapsPage
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 16);
		
		addMorphBack: (DialogTextMorph
				contents: 'Define which flaps to show on the screen'
				font: smallFont
				emphasis: 1);
		
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4).
	aPref _ Preferences preferenceAt: #showProjectNavigator.
	flapsPage
		addMorphBack: (self representativeButtonFromPreference: aPref) ;
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 8).

	sharedFlapControl _ self representativeSpecialButtonFromPreference: sharedFlap.
	sharedFlapControl name: #sharedFlap.
	flapsPage addMorphBack: sharedFlapControl.
	sharedFlapControl addDependent: self.
	groupBox _ self buildSharedFlapsGroupBox.
	flapsPage
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4);
		 addMorphBack: groupBox.

	mainFlapsPage addMorph: flapsPage.
	aboutButton _ self buildAboutButton: self.

	aBounds _ aboutButton bounds.
	aboutButton layoutFrame: ( LayoutFrame 
			fractions: ( 1@1 corner: (1@1))
			offsets: ( aBounds corner negated -16 corner: ( -16@-16))). 
	mainFlapsPage addMorph: aboutButton! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 19:17'!
buildSharedFlapsGroupBox 
	| groupBox namedFlap smallFont biggerFont |

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 18
				emphasized: 1.
	groupBox _ GroupBoxMorph newInstance.
	groupBox name: #sharedGroupBox.
	groupBox listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	groupBox
		addMorphBack: (DialogTextMorph contents: '  Current Shared Flaps ' font: biggerFont emphasis: 1) ;
		addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).
	Flaps globalFlapTabsIfAny
		do: [:aFlapTab | 
			namedFlap _ self representativeButtonFromFlap: aFlapTab.
			namedFlap disabled: sharedFlap preferenceValue not;
				 setProperty: #wantsShareInfo toValue: true.
			groupBox addMorphBack: namedFlap].
	^ groupBox.
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 00:41'!
isFlapProjectEnabled: aFlap

	" figure out if we should be visible "

	^ aFlap isProjectEnabled.

! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 15:50'!
newMainFlapsPage

	| mainFlapsPage layoutFrame |
	mainFlapsPage _ PasteUpMorph new.
	pages at: #flapsPage put: mainFlapsPage.
	mainFlapsPage beSticky.
	mainFlapsPage	layoutPolicy: ProportionalLayout new.
	layoutFrame _ self pageLayoutFrame copy.
	layoutFrame topOffset: ( layoutFrame topOffset + 1 ) ;
		leftOffset: ( layoutFrame leftOffset + 1 ) ;
		bottomOffset: (layoutFrame bottomOffset - 1) ;
		rightOffset: ( layoutFrame rightOffset - 1 ).
	mainFlapsPage layoutFrame: layoutFrame.
	mainFlapsPage hResizing: #spaceFill;
		 vResizing: #spaceFill ;
		color: Color transparent.
	^ mainFlapsPage.
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 14:04'!
representativeButtonFromFlap: aFlap
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton label |
	
	outerButton _ CheckBoxControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: aFlap ;
		actionSelector: #toggleGlobalFlap;
		getSelector: #isProjectEnabled.
	label _ aFlap flapID.
	outerButton label: label.
	outerButton setBalloonText: aFlap balloonTextForFlapsMenu.
	^ outerButton 
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 01:25'!
representativeSpecialButtonFromPreference: aPreference
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton label |
	
	outerButton _ CheckBoxControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: aPreference;
		actionSelector: #toggleSpecialPreferenceValue:;
		getSelector: #preferenceValue ;
		arguments: { outerButton }.
	label _ WriteStream on: ( aPreference name asString).
	aPreference name do: [ :aChar |
		aChar isUppercase ifTrue: [
			label space ;
				  nextPut: ( aChar asLowercase) ]
				ifFalse: [ label nextPut: aChar ]].
	" upper case the first letter "
	label _ label contents.
	label at: 1 put: (label at: 1) asUppercase.
	outerButton label: label.
	outerButton setBalloonText: aPreference helpString.
	^ outerButton 
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/9/2001 20:35'!
selectFlapsTab
	self selectPage: #flapsPage.
! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 14:49'!
sharedFlapsSettingsChanged
	"tell everyone that's interested the shared flap has changed"
	( currentPage submorphNamed: #sharedGroupBox )
		submorphsDo: [:control | (control hasProperty: #wantsShareInfo)
				ifTrue: [control disabled: sharedFlap preferenceValue not]]! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 10/10/2001 11:19'!
update: aSymbol 
	"are we on the flaps page?"
	currentPage
			== (pages at: #flapsPage)
		ifTrue: ["we've received an update event from the shared flaps 
			value "
			self sharedFlapsSettingsChanged]! !

!ScreenPreferencesPanel methodsFor: 'as yet unclassified' stamp: 'jlb 10/9/2001 14:02'!
cancelPanel
	pasteUpMorph owner delete.! !

!ScreenPreferencesPanel methodsFor: 'as yet unclassified' stamp: 'jlb 10/9/2001 14:02'!
closePanel
	pasteUpMorph owner delete.! !

!ScreenPreferencesPanel methodsFor: 'as yet unclassified' stamp: 'jlb 10/6/2001 22:03'!
dummy
	self halt.! !


!ScreenProperties methodsFor: 'as yet unclassified' stamp: 'jlb 10/6/2001 18:37'!
dummy! !


!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 10/10/2001 22:41'!
buildTabPanel: aModel for: aPasteUpMorph 

	| panel appearanceSwitch settingsSwitch windowSwitch scrollbarSwitch flapsSwitch menuSwitch |
	panel _ InvisibleTabPanelMorph newInstance.
	panel image: ButtonTheme current tabPanelFormNoBorder.

	aModel pasteUpMorph: aPasteUpMorph.
	windowSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #windowMessageIndicated
		action: #selectWindowTab.
	windowSwitch
		label: 'Windows';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildWindowPage: aPasteUpMorph.


	menuSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #menuMessagesIndicated
		action: #selectMenuTab.
	menuSwitch
		label: 'Menus';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildMenuPage: aPasteUpMorph.

	scrollbarSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #instanceMessagesIndicated
		action: #selectScrollbarTab.
	scrollbarSwitch
		label: 'Scrollbars';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildScrollbarPage: aPasteUpMorph.

	appearanceSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #instanceMessagesIndicated
		action: #selectAppearanceTab.
	appearanceSwitch
		label: 'Appearance';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildAppearancePage: aPasteUpMorph.

	settingsSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #instanceMessagesIndicated
		action: #selectSettingsTab.
	settingsSwitch
		label: 'Settings';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildSettingsPage: aPasteUpMorph.

	flapsSwitch _ PluggableTabButtonMorph
		on: aModel
		getState: #instanceMessagesIndicated
		action: #selectFlapsTab.
	flapsSwitch
		label: 'Flaps';
		askBeforeChanging: true;
		borderWidth: 0 ;
		actWhen: #buttonUp.
	aModel buildFlapsPage: aPasteUpMorph.

	" add the tabs to the tab panel. "
	{windowSwitch. menuSwitch. scrollbarSwitch.  flapsSwitch. appearanceSwitch.  settingsSwitch "  commentSwitch. classSwitch "} do: [:m | 
		panel addMorphBack: m. ].

	aModel selectWindowTab.
	windowSwitch state: #on.

	^ panel
! !

!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 10/6/2001 18:37'!
dummy! !

!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 10/10/2001 19:29'!
editProperties
	" open a desktop properties dialog box "

	| aPanel playfield window |
	aPanel _ ScreenPreferencesPanel new initialize.
	playfield _ PasteUpMorph new width: 600.
	playfield dropEnabled: false.
	playfield
		on: #mouseDown
		send: #yourself
		to: #().
	self initializePreferencePanel: aPanel in: playfield.
	window _ (SystemWindow labelled: 'Screen Properties') model: aPanel.
	window on: #keyStroke send: #keyStroke: to: aPanel.
	window
		addMorph: playfield
		frame: ( 0@0 extent: 1@1).
	window updatePaneColors.
	window minimumExtent: 430@500.
	window extent: ( window minimumExtent ).
	self currentWorld addMorphFront: window.
	window center: self currentWorld center.
	window activateAndForceLabelToShow! !

!ScreenProperties class methodsFor: 'as yet unclassified' stamp: 'jlb 10/10/2001 15:51'!
initializePreferencePanel: aPanel in: aPasteUpMorph 
	| aColor tabbedPalette paneRect aButton |
	aPasteUpMorph removeAllMorphs.
	aColor _ aPanel defaultBackgroundColor.
	aPasteUpMorph color: aColor.
	paneRect _ RectangleMorph new.
	paneRect name: #paneRectangle.
	paneRect borderWidth: 1.
	paneRect color: Color white.
	paneRect borderColor: Color gray.
	aPanel
		pageLayoutFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (8 @ 33 corner: -8 @ -39)).
	aPasteUpMorph addMorph: paneRect fullFrame: aPanel pageLayoutFrame.
	paneRect lock.
	tabbedPalette _ self buildTabPanel: aPanel for: aPasteUpMorph.
	tabbedPalette beSticky.
	aPasteUpMorph layoutPolicy: ProportionalLayout new.
	aPasteUpMorph
		addMorph: tabbedPalette
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (8 @ 8 corner: 0 @ 36)).
	aButton _ OSButtonMorph newInstance target: aPanel;
				 actionSelector: #cancelPanel;
				 label: 'Cancel'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-83 @ -31 corner: -8 @ -8)).
	aButton _ OSButtonMorph newInstance target: aPanel;
				 actionSelector: #closePanel;
				 label: 'OK'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-166 @ -31 corner: -91 @ -8)).
	aButton makeDefault! !


!ScreenPreferencesPanel reorganize!
('initialization' initialize)
('color' defaultBackgroundColor)
('tab controls' buildAppearancePage: buildMenuPage: buildScrollbarPage: buildSettingsPage: buildWindowPage: representativeButtonFromPreference: selectAppearanceTab selectMenuTab selectScrollbarTab selectSettingsTab selectWindowTab)
('accessors' pageLayoutFrame pageLayoutFrame: paneRectOrigin pasteUpMorph pasteUpMorph:)
('page selection' selectPage:)
('flaps' buildAboutButton: buildFlapsPage: buildSharedFlapsGroupBox isFlapProjectEnabled: newMainFlapsPage representativeButtonFromFlap: representativeSpecialButtonFromPreference: selectFlapsTab sharedFlapsSettingsChanged update:)
('as yet unclassified' cancelPanel closePanel dummy)
!

