'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 1 March 2002 at 7:57:37 pm'!
PluggableListMorph subclass: #ComboBoxListMorph
	instanceVariableNames: 'maxListSize fullList filteredList defaultList textMorph lastSearchKey updateListProcess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ComboBoxListMorph commentStamp: '<historical>' prior: 0!
For use with the ComboBoxMorph, this is the list that popup up when the down-arrow button is clicked. Before popping up the list, the textEdit calls the prepChoiceListSelector on the prepChoiceListTarget, passing itself (the textEdit) and the PopupChoicesListMorph (this object) it will be displaying. The developer can do the following in preparation for displaying the list:

		a. Set the fullList:, the full list of items to search through (using the contents
			of this text edit as the searchkey).

		b. Set the defaultList:, the list that appears initially and also when the textEdit 
		is empty. Eg. For a list of Classes, the default list is the Browser>>RecentClasses, but the
		full list is all of the classes in the system.

		c. Call #searchFor: aString to initialize the list with a given searchKey. A 
		typical call would be "popupList searchFor: popupList textMorph getText asString."	

		d. Set the maxListSize. Example: the fullList is all the selectors in the image -- say
		about 35000 give or take. The user must type enough into the textedit so that only
		maxListSize number of items match the search key, otherwise a message will appear
		in the list asking the user to type a more helpful searchkey.
		
Structure:

fullList			OrderedCollection 	The complete list from which filtered results are colled
filteredList		OrderedCollection	The list that appears in the list box. The contents 
									depend on what is currently the search key (the contents
									of the textMorph).
defaultList		OrderedCollection	Optional -- the list to display when the the search key
									is an empty string

maxListSize	int					This limits the number of items that can match during an
									updateList search.
									When there is a very large fullList, performance can bog down.
									Set this value to 1000-2000 and there shouldn't be appreciable
									performance problems on a desktop computer..
!

ComboBoxListMorph class
	instanceVariableNames: ''!
PluggableTextMorph subclass: #ComboBoxMorph
	instanceVariableNames: 'state active disabled forms imageMorph allowChoices modalEnforcer choiceButton choiceList prepListSelector alwaysDiscardEdits '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
TwoModeButtonMorph subclass: #ComboButtonMorph
	instanceVariableNames: 'value glyphForms glyphImage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/26/2001 11:41'!
comboBoxEdges
	^ lookDictionary at: #comboBoxEdges ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/26/2001 11:41'!
comboBoxForm
	^ lookDictionary at: #comboBoxForm ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/26/2001 18:25'!
comboButtonEdges
	^ lookDictionary at: #comboButtonEdges ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/26/2001 11:43'!
comboButtonForm
	^ lookDictionary at: #comboButtonForm ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/26/2001 11:42'!
comboButtonGlyphsForm
	^ lookDictionary at: #comboButtonGlyphsForm ifAbsent: [ ^ nil ].! !


!ComboBoxListMorph methodsFor: 'events' stamp: 'sps 8/26/2001 21:47'!
mouseDown: evt

	| morph colorSave |
	morph _ self selectMorphAtPoint: evt position.
	morph notNil ifTrue:[
		colorSave _ morph color.
		morph color: Color black.
	].


! !

!ComboBoxListMorph methodsFor: 'events' stamp: 'sps 8/18/2001 19:42'!
mouseOver: evt

	self selectMorphAtPoint: evt position.

	
! !

!ComboBoxListMorph methodsFor: 'events' stamp: 'sps 8/26/2001 21:22'!
mouseStillDown: evt
	self selectMorphAtPoint: evt position! !

!ComboBoxListMorph methodsFor: 'events' stamp: 'sps 8/26/2001 21:21'!
mouseUp: evt

	self selectMorphAtPoint: evt position.



! !

!ComboBoxListMorph methodsFor: 'initialization' stamp: 'jlb 10/12/2001 23:10'!
initialize
	| listTheme |
	super initialize.
	maxListSize _ 1000.
	borderWidth _ 0.
	fullList _ OrderedCollection new.
	filteredList _ OrderedCollection new.
	defaultList _ OrderedCollection new.
	list _ OrderedCollection new.
	listTheme _ ListTheme current.
	listTheme
		ifNil: [self color: Color white.
			self borderWidth: 1.
			self borderColor: Color gray]
		ifNotNil: [self color: listTheme backgroundColor.
			self borderWidth: 1.
			self borderColor: listTheme borderColor].
! !

!ComboBoxListMorph methodsFor: 'initialization' stamp: 'jlb 10/12/2001 23:17'!
list: listOfStrings 
	"Set the receiver's list as specified"

	| morphList h loc index converter item aSelector |
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty ifTrue: [self setScrollDeltas.  ^ self selectedMorph: nil].
	"NOTE: we will want a quick StringMorph init message, possibly even
		combined with event install and positioning"
	font ifNil: [font _ Preferences standardListFont].
	converter _ self valueOfProperty: #itemConversionMethod.
	converter ifNil: [converter _ #asStringOrText].
	morphList _ list collect: [:each |
		item _ each.
		item _ item perform: converter.
		item isText
			ifTrue: [StringMorph contents: item font: font emphasis: (item emphasisAt: 1)]
			ifFalse: [StringMorph contents: item font: font]].
	(aSelector _ self valueOfProperty: #balloonTextSelectorForSubMorphs)
		ifNotNil:
			[morphList do: [:m | m balloonTextSelector: aSelector]].

	self highlightSelector ifNotNil:
		[model perform: self highlightSelector with: list with: morphList].

	"Lay items out vertically and install them in the scroller"
	h _ morphList first height "self listItemHeight".
	loc _ self leftMargin.
	morphList do: [:m | m bounds: (loc extent: 9999@h).  loc _ loc + (0@h)].
	scroller addAllMorphs: morphList.

	index _ self getCurrentSelectionIndex.
	self selectedMorph: ((index = 0 or: [index > morphList size]) ifTrue: [nil] ifFalse: [morphList at: index]).
	self setScrollDeltas.
	scrollBar setValue: 0.0! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/17/2001 18:09'!
defaultList

	^ defaultList ! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/17/2001 18:09'!
defaultList: aListOfStrings 

	^ defaultList _ aListOfStrings! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 17:32'!
filteredList
	^ filteredList ! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/17/2001 19:38'!
filteredList: aListOfStrings 
	
	self list: aListOfStrings.
	^ filteredList _ aListOfStrings! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 17:31'!
fullList
	^fullList! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 17:31'!
fullList: aListOfStrings
	^fullList _ aListOfStrings! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 23:35'!
lastSearchKey
	^lastSearchKey
! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 23:35'!
lastSearchKey: aString
	lastSearchKey _ aString.
! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/18/2001 18:25'!
maxListSize
	^maxListSize! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/18/2001 18:25'!
maxListSize: anInt
	^maxListSize _ anInt! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'sps 8/16/2001 17:33'!
textMorph
	^textMorph! !

!ComboBoxListMorph methodsFor: 'accessing' stamp: 'jlb 10/12/2001 21:19'!
textMorph: aPluggableTextMorph
	textMorph _ aPluggableTextMorph.
	self width: textMorph width.
! !

!ComboBoxListMorph methodsFor: 'filter' stamp: 'sps 9/5/2001 21:42'!
searchFor: aString
	lastSearchKey _ nil.

	(self textMorph text asString = aString) ifFalse:[
		self textMorph setText: aString withBlanksTrimmed.
	].

	self updateList.! !

!ComboBoxListMorph methodsFor: 'filter' stamp: 'sps 9/5/2001 21:42'!
updateList

	"Putting the search in another process makes it easier to filter really huge lists -- the user can keep
	typing during an updateListBody -- if we reenter this method before the updateListBody has finished,
	it means the user typed (or erased) a character before the entire filteredList was calculated. So just
	terminate that process and start with the new search key"

	(
		lastSearchKey notNil and: [
		lastSearchKey = textMorph text asString withBlanksTrimmed]
	)
	ifTrue: [^self].

	updateListProcess ifNotNil:[updateListProcess terminate. ].
	updateListProcess _ [self updateListBody.  ] newProcess.

	"The updateListBody method will jack up the priority by one if the list process
	gets stuck in the background for more than .5 secs."
	updateListProcess priority: (updateListProcess priority - 1).
"Debug tShow: textMorph text asString withBlanksTrimmed."
	updateListProcess resume.
! !

!ComboBoxListMorph methodsFor: 'filter' stamp: 'sps 9/5/2001 18:50'!
updateListBody

	| toMatch allMatching matchingAtStart index listToSearch priorityDelta startTime |

	toMatch _ textMorph text asString withBlanksTrimmed.
"Debug dShow: toMatch."
	(toMatch isEmpty) ifTrue: [
		lastSearchKey _ nil.
		self defaultList isEmpty 
			ifTrue:[^nil]
			ifFalse:[^self list: self defaultList].
	].

	toMatch = lastSearchKey ifTrue:[^nil]. "If we just did this search, don't do it again"

	"If the user just added a character or 2 to the last search key,
	cull this search from the last results"
	(lastSearchKey notNil and: [toMatch findString: lastSearchKey]) == 1
		ifTrue:[ listToSearch _ filteredList]
		ifFalse:[ listToSearch _ fullList ].

	allMatching _ OrderedCollection new: fullList size.
	matchingAtStart _ SortedCollection sortBlock: [ :a :b | a size < b size].
	priorityDelta _ -1.
	startTime _ Time millisecondClockValue.
	listToSearch do: [ :s |
		(allMatching size > maxListSize) ifFalse:[
			index _ s findString: toMatch startingAt: 1 caseSensitive: false.
			index > 0 ifTrue:[
				index == 1 
					ifTrue:[ matchingAtStart add: s ]
					ifFalse:[allMatching add: s].
			].

			"This makes sure the search process does not get stuck in the background."
			(Time millisecondClockValue - startTime > 500) ifTrue:[
				priorityDelta _ priorityDelta negated.
				updateListProcess priority: (updateListProcess priority + priorityDelta).
				startTime _ Time millisecondClockValue.
			].
		].
	].

	allMatching size > maxListSize ifTrue:[
			lastSearchKey _ nil. "Don't use the currently filtered list as the basis for
									the next list"
			(matchingAtStart _ OrderedCollection new)
				add: '*********************';
				add: '** Too many';
				add: '** matches found.';
				add: '** Please type';
				add: '** more characters';
				add: '** too narrow';
				add: '** the search.';
				add: '*********************'.
			allMatching _ OrderedCollection new.
	] ifFalse:[
		lastSearchKey _ toMatch.
	].

WorldState addDeferredUIMessage: [
	self filteredList: (matchingAtStart asOrderedCollection, allMatching).
]. ! !

!ComboBoxListMorph methodsFor: 'control' stamp: 'sps 8/26/2001 18:36'!
popUp
	^self 
		popUpAt: (textMorph bounds bottomLeft - (0@1)) 
		forHand: textMorph world currentHand
		in: textMorph world 
! !

!ComboBoxListMorph methodsFor: 'control' stamp: 'sps 9/6/2001 12:43'!
popUpAt: aPoint forHand: hand in: aWorld
	"Present this widget at the given point under control of the given hand."


	(
		"textMorph text asString withBlanksTrimmed isEmpty or: [ 
		self filteredList isEmpty"
		updateListProcess isNil
	)
		ifTrue:[self list: self defaultList].

	self fullBounds. "force layout"
	self position: aPoint.
	aWorld addMorphFront: self; startSteppingSubmorphsOf: self.

	"Aquire focus for valid pop up behavior"
	self changed.
	hand newMouseFocus: self.
! !

!ComboBoxListMorph methodsFor: 'overrides' stamp: 'sps 8/16/2001 22:43'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."
	super selectionIndex: anInteger.! !

!ComboBoxListMorph methodsFor: 'overrides' stamp: 'sps 8/16/2001 23:05'!
getCurrentSelectionIndex
	"Answer the index of the current selection."

	selection isNil ifTrue:[^0].

	scroller submorphs inject: 1 into: [ :index :item |
		(item contents = selection) ifTrue:[ ^index ].
		index + 1.
	].

	^0! !

!ComboBoxListMorph methodsFor: 'overrides' stamp: 'sps 8/16/2001 17:41'!
getList

	^filteredList
! !

!ComboBoxListMorph methodsFor: 'overrides' stamp: 'sps 8/26/2001 21:28'!
selectMorphAtPoint: aPoint
"Return the list item morph under aPoint, or null"

	| aMorph |

	aMorph _ self itemFromPoint: aPoint.
	(aMorph == selectedMorph) ifTrue:[^aMorph].
	aMorph ifNotNil:[
		self selectedMorph: aMorph.
		aMorph 
			invalidRect: aMorph outerBounds;
			refreshWorld.
		^aMorph
	].

	^nil! !

!ComboBoxListMorph methodsFor: 'overrides' stamp: 'sps 8/16/2001 20:52'!
specialKeyPressed: asciiValue 
	| oldSelection nextSelection max howManyItemsShowing |
	max _ self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection _ oldSelection _ self getCurrentSelectionIndex.
	asciiValue == 31
		ifTrue: 
			[" down arrow"
			nextSelection _ oldSelection + 1.
			nextSelection > max ifTrue: [nextSelection _ 1]].
	asciiValue == 30
		ifTrue: 
			[" up arrow"
			nextSelection _ oldSelection - 1.
			nextSelection < 1 ifTrue: [nextSelection _ max]].
	asciiValue == 1 ifTrue: [" home"
		nextSelection _ 1].
	asciiValue == 4 ifTrue: [" end"
		nextSelection _ max].
	howManyItemsShowing _ self numSelectionsInView.
	asciiValue == 11 ifTrue: [" page up"
		nextSelection _ 1 max: oldSelection - howManyItemsShowing].
	asciiValue == 12 ifTrue: [" page down"
		nextSelection _ oldSelection + howManyItemsShowing min: max].
	model okToChange ifFalse: [^ self].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ false].
	self changeModelSelection: nextSelection.
	^true! !

!ComboBoxListMorph methodsFor: 'scroll bar events' stamp: 'jlb 9/28/2001 07:48'!
scrollBarValue: scrollValue
	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: 0 @ (self leftoverScrollRange * scrollValue)! !

!ComboBoxListMorph methodsFor: 'drawing' stamp: 'jlb 10/12/2001 23:17'!
drawOn: aCanvas 
	| colorToFillWith areaToFill next |
	super superDrawOn: aCanvas.
	selectedMorph
		ifNil: [^ self].
	colorToFillWith _ color.
	next _ self.
	ListTheme current
		ifNil: [[colorToFillWith isTransparent
				and: [(next _ next owner) notNil]]
				whileTrue: [colorToFillWith _ next color].
			colorToFillWith _ colorToFillWith luminance < 0.5
						ifTrue: [colorToFillWith muchLighter]
						ifFalse: [colorToFillWith darker]]
		ifNotNil: [colorToFillWith _ self highlightBackgroundColor].
	areaToFill _ ((scroller transformFrom: self)
				localBoundsToGlobal: selectedMorph bounds)
				intersect: scroller bounds.
	areaToFill _ areaToFill expandBy: self leftMargin.
	aCanvas fillRectangle: areaToFill color: colorToFillWith! !

!ComboBoxListMorph methodsFor: 'drawing' stamp: 'jlb 10/12/2001 23:09'!
highlightSelection
	| aColor |
	aColor _ ListTheme current
				ifNil: [Color red]
				ifNotNil: [ListTheme current hilightTextColor].
	selectedMorph
		ifNotNil: [selectedMorph color: aColor.
				  self changed]! !

!ComboBoxListMorph methodsFor: 'drawing' stamp: 'jlb 10/12/2001 23:17'!
leftMargin
	^ 4@0.! !


!ComboBoxListMorph class methodsFor: 'instance creation' stamp: 'sps 8/31/2001 18:40'!
on: aComboBoxMorph 

	^self on: aComboBoxMorph list: OrderedCollection new.

	
	

! !

!ComboBoxListMorph class methodsFor: 'instance creation' stamp: 'sps 8/31/2001 18:40'!
on: aComboBoxMorph 
list: aList

	| newInst |
	(newInst _ self new)
		textMorph: aComboBoxMorph;
		fullList: aList.

	^newInst

	
	

! !


!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
alwaysDiscardEdits
	^alwaysDiscardEdits! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
alwaysDiscardEdits: aBool
	^alwaysDiscardEdits _ aBool! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
borderColor: aColor

	choiceButton ifNotNil: [ choiceButton outlineColor: aColor ].
	^super borderColor: aColor! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
choiceButton
	^choiceButton! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
choiceList
	^choiceList! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:46'!
imageMorph
	^ imageMorph! !

!ComboBoxMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 13:18'!
setText: aText

	super setText: aText.
"	textMorph wrapFlag: false." "This needs work on the horz scrolling"
	textMorph on: #keyStroke send: #checkForSpecialKeystroke: to: self.! !

!ComboBoxMorph methodsFor: 'activate/passivate' stamp: 'jlb 9/26/2001 13:31'!
activate
	" This is used for alignment morphs in SystemWindows ;
	  propogates activate message to submorphs which may be controls "
	self active: true.
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m activate]]! !

!ComboBoxMorph methodsFor: 'activate/passivate' stamp: 'jlb 9/26/2001 13:32'!
active: aBoolean
	active _ aBoolean.
	self state: state.
	self changed! !

!ComboBoxMorph methodsFor: 'activate/passivate' stamp: 'jlb 9/26/2001 13:31'!
passivate
	self active: false.
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m passivate]]! !

!ComboBoxMorph methodsFor: 'behavior override' stamp: 'jlb 9/26/2001 13:17'!
accept
"This class overrided normal accept behavior. See class comment."

	self trigger: #enter.! !

!ComboBoxMorph methodsFor: 'behavior override' stamp: 'jlb 9/26/2001 13:17'!
acceptOnCR: trueOrFalse
"This class overrided normal accept behavior. See class comment."
	textMorph acceptOnCR: true! !

!ComboBoxMorph methodsFor: 'behavior override' stamp: 'jlb 9/26/2001 13:17'!
canDiscardEdits
	"Return true if this view either has no text changes or does not care."

	alwaysDiscardEdits 
		ifTrue:[ ^true ]
		ifFalse:[ ^super canDiscardEdits ].


! !

!ComboBoxMorph methodsFor: 'behavior override' stamp: 'jlb 9/26/2001 13:17'!
hasUnacceptedEdits 

	alwaysDiscardEdits 
		ifTrue:[ ^false ]
		ifFalse:[ ^super hasUnacceptedEdits ].


! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 9/26/2001 13:20'!
allowChoices: aBool

	allowChoices _ aBool.

	aBool ifTrue:[
		choiceButton visible: true.
		self addMorphBack: choiceButton.
	] ifFalse:[
		self  removeAllMorphsIn: (OrderedCollection with: choiceButton).
		choiceButton visible: false.
	].! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 9/26/2001 13:20'!
choicesButtonBalloonText: aString

	choiceButton setBalloonText: aString.! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 10/1/2001 20:33'!
popupChoices

	choiceList ifNotNil: [ ^ self ].
	choiceList _ ComboBoxListMorph on: self.
	modalEnforcer _ SPSComboBoxModalEnforcer on: self.
	modalEnforcer 
		when: #finished send: #popupChoicesCleanUp to: self;
		when: #error send: #popupChoicesCleanUp to: self.

 	Cursor wait showWhile: [
		(model isNil or: [ prepListSelector isNil]) ifFalse:[
			model perform: prepListSelector with: choiceList.
		].
		choiceList fullList isEmpty ifTrue:[ self flash. ^self].
 	].

	"Let her rip"
	choiceButton value: true.
	choiceList popUp.
	WorldState addDeferredUIMessage: [self selectAtEnd.].
	modalEnforcer start.

! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 9/26/2001 13:20'!
popupChoicesCleanUp
"Called when the modalEnforcer closes "

"Debug dShow: 'clean up'."

	modalEnforcer _ nil.
	choiceList ifNotNil: [ choiceList delete. choiceList _ nil ].
	choiceButton value: false.

	WorldState addDeferredUIMessage: [
		self selectAtEnd.
		Project current currentHand newKeyboardFocus: textMorph.
	].



! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 9/26/2001 13:20'!
prepChoiceListSelector

	^prepListSelector
! !

!ComboBoxMorph methodsFor: 'choice list' stamp: 'jlb 9/26/2001 13:20'!
prepChoiceListSelector: selector

	prepListSelector _ selector.
! !

!ComboBoxMorph methodsFor: 'drawing' stamp: 'jlb 9/26/2001 13:20'!
selectAll
	super selectAll.
	self 
			invalidRect: self outerBounds;
			refreshWorld.
	textMorph selectionChanged.
! !

!ComboBoxMorph methodsFor: 'drawing' stamp: 'jlb 9/26/2001 13:20'!
selectAtEnd
		self 
			selectFrom: (self text asString size + 1) 
			to: (self text asString size).
		self 
			invalidRect: self outerBounds;
			refreshWorld.
		textMorph selectionChanged.
! !

!ComboBoxMorph methodsFor: 'drawing' stamp: 'jlb 9/26/2001 13:20'!
wantsFrameAdornments
	^false! !

!ComboBoxMorph methodsFor: 'event handling' stamp: 'jlb 9/26/2001 13:21'!
checkForSpecialKeystroke: evt

	(choiceList isNil and: [ allowChoices]) ifTrue:[
		(evt keyCharacter asciiValue == 31) ifTrue:[
			^self popupChoices.
		].
	].

	choiceList isNil ifTrue:[
		(evt keyCharacter == Character cr) ifTrue:[
				^self trigger: #enter.
		].
	].

! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 11:57'!
fromImages: buttonImages 

	self fromImages: buttonImages symbols: #( #off #pressed #disabled #mouseOver ).
	self state: #off.! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 13:11'!
fromImages: buttonImages symbols: anArrayOfSymbols
	"assume that there are (anArrayOfSymbols size) buttons vertically stacked"
	" button images contains the form image"

	| formExtent height aForm buttonExtent noImages |

	noImages _ anArrayOfSymbols size.
	formExtent _ buttonImages extent.
	height _ formExtent y / noImages.
	buttonExtent _ formExtent x @ height.

	0 to: (noImages-1)
		do: [:i | 
			aForm _ buttonImages
						contentsOfArea: (0 @ (i * height) extent: buttonExtent).
			forms at: ( anArrayOfSymbols at: ( i+1)) put: aForm.
		 ].
! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 10/12/2001 21:50'!
initialize
	| defaultFont |
	super initialize.
	forms _ Dictionary new.
	active _ true.
	disabled _ false.
	self setProperty: #wantsActivate toValue: true .
	self initializeImageMorph.

	(defaultFont _ Preferences standardButtonFont) 
					emphasized: 0. 

	self
		setText:''; "init the textMorph"
		vResizing: #rigid;
		hResizing: #spaceFill;
		height: (defaultFont height * 1.3) asInteger;
		borderWidth: 0;
		font: defaultFont;
		acceptOnCR: true;
		alwaysDiscardEdits: true.

	self setProperty: #alwaysAccept toValue: true.
	self hideScrollBarIndefinitely.

	allowChoices _ false.
	(choiceButton _ ComboButtonMorph newInstance)
		target: self;
		actionSelector: #popupChoices.
! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 17:10'!
initializeImageMorph

	imageMorph _ EdgeImageMorph new.
	self addMorphBack: imageMorph.

! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 13:18'!
on: anObject 

	^super on: anObject text: nil accept: nil readSelection: nil menu: nil
! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 13:18'!
on: anObject text: getTextSel readSelection: getSelectionSel menu: getMenuSel

	^super on: anObject text: getTextSel accept: nil readSelection: getSelectionSel menu: getMenuSel
! !

!ComboBoxMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 17:09'!
setEdges: aRectangle
	imageMorph setEdges: aRectangle.! !

!ComboBoxMorph methodsFor: 'layout' stamp: 'jlb 9/26/2001 17:13'!
doLayoutIn: layoutBounds
"layout has changed. update scroll deltas or whatever else"

	| inset |

	textMorph width: (self width - choiceButton width - 1 ). 
	scroller width: textMorph width.

	"Don't permit layout of button during modal popup"
	inset _ (self borderWidth - 1) max: 0.
	modalEnforcer isNil ifTrue:[ 
		choiceButton bounds:(
			self right - (choiceButton width + inset) @ (self top + inset )
				corner: (self right@ (self bottom - inset ))).
	].

	imageMorph ifNotNil: [ imageMorph bounds: ( self topLeft corner: ( choiceButton bottomLeft )) ]. 

	
	super doLayoutIn: layoutBounds.


! !

!ComboBoxMorph methodsFor: 'state' stamp: 'jlb 9/26/2001 22:26'!
state: aStateSymbol 
	"Change the image and invalidate the rect."
	| symbol |
	state _ aStateSymbol.
	symbol _ #off.

	(disabled or: [ active not ])
		ifTrue: [symbol _ #disabled]
		ifFalse: [state == #on
				ifTrue: [symbol _ #pressed]
				ifFalse: [symbol  _ state]].

	imageMorph image: ( forms at: symbol ).
	" self
		image: (forms at: symbol) "! !


!ComboBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 9/26/2001 11:46'!
newInstance
	| toReturn |
	toReturn _ self new.
	toReturn fromImages: ButtonTheme current comboBoxForm.
	ButtonTheme current comboBoxEdges
		ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	^ toReturn! !

!ComboBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 9/26/2001 13:26'!
on: anObject 
	^ self on: anObject
		text: nil
		accept: nil
		readSelection: nil
		menu: nil! !

!ComboBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 9/26/2001 13:26'!
on: anObject allowChoices: allowChoices prepChoiceListSelector: prepListSelector

	| newInst |
	newInst _ self on: anObject
		text: nil
		accept: nil
		readSelection: nil
		menu: nil.

	newInst 
		allowChoices: allowChoices;
		prepChoiceListSelector: prepListSelector.

	^newInst! !

!ComboBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 9/26/2001 13:27'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel

	^ self newInstance on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !


!ComboButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/26/2001 12:56'!
value
	^ value! !

!ComboButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/28/2001 11:56'!
value: aBoolean
	value _ aBoolean.
	value ifFalse: [ 
		" take care of the case where we hit the button again to collapse the list"
	state _ 
		( self containsPoint: ( self world currentHand cursorPoint))
			ifTrue: [ #mouseOver ]
			ifFalse: [ #off  ]]. 
	self state: ( self state ).! !

!ComboButtonMorph methodsFor: 'drawing' stamp: 'jlb 9/26/2001 19:05'!
drawOn: aCanvas
	| glyphOrigin |
	super drawOn: aCanvas.
	" draw the buttons glyph "
	glyphOrigin _  bounds center - (1@0) - ((glyphImage extent // 2) asIntegerPoint).
	aCanvas paintImage: glyphImage at: glyphOrigin.
	! !

!ComboButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/26/2001 12:07'!
mouseEnterEvent: evt for: aMorph 
	self state: #mouseOver! !

!ComboButtonMorph methodsFor: 'event handling' stamp: 'jlb 10/1/2001 20:20'!
mouseLeave: event 
	super mouseLeave: event.
	self state: #off! !

!ComboButtonMorph methodsFor: 'event handling' stamp: 'jlb 10/1/2001 20:27'!
mouseLeaveDraggingEvent: evt for: aMorph 
	self mouseUp: evt.
! !

!ComboButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 18:20'!
fromGlyphImages: buttonImages symbols: anArrayOfSymbols
	"assume that there are (anArrayOfSymbols size) buttons vertically stacked"
	" button images contains the form image"

	| formExtent height aForm buttonExtent noImages |

	noImages _ anArrayOfSymbols size.
	formExtent _ buttonImages extent.
	height _ formExtent y / noImages.
	buttonExtent _ formExtent x @ height.

	0 to: (noImages-1)
		do: [:i | 
			aForm _ buttonImages
						contentsOfArea: (0 @ (i * height) extent: buttonExtent).
			glyphForms at: ( anArrayOfSymbols at: ( i+1)) put: aForm.
		 ].
! !

!ComboButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/26/2001 18:50'!
fromImages: buttonImages 

	self fromImages: buttonImages symbols: #( #off #pressed #disabled #mouseOver ).
! !

!ComboButtonMorph methodsFor: 'initialization' stamp: 'jlb 10/1/2001 20:26'!
initialize
	super initialize.
	actWhen _ #buttonDown. 
	value _ false.
	glyphForms _ Dictionary new.
	self on: #mouseEnter send: #mouseEnterEvent:for: to: self.
	self on: #mouseLeaveDragging send: #mouseLeaveDraggingEvent:for: to: self.
! !

!ComboButtonMorph methodsFor: 'state' stamp: 'jlb 9/28/2001 15:32'!
state: aStateSymbol 
	"Change the image and invalidate the rect."
	| symbol |
	state _ aStateSymbol.
	symbol _ #off.
	(disabled or: [ active not ])
		ifTrue: [symbol _ #disabled]
		ifFalse: [
			symbol _ state.
			" value ifTrue: [ symbol _ #pressed ]
				ifFalse: [ symbol _ state ] " ].
	self
		image: (forms at: symbol).
	glyphImage _ glyphForms at: symbol.! !


!ComboButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 9/26/2001 18:49'!
newInstance
	| toReturn buttonTheme |
	toReturn _ self new.
	buttonTheme _ ButtonTheme current.
	buttonTheme ifNil: [ ^ toReturn ].
	toReturn fromImages: buttonTheme comboButtonForm.
	buttonTheme comboButtonEdges
		ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	" place the glyph forms in a dictionary "
	toReturn fromGlyphImages: buttonTheme comboButtonGlyphsForm symbols: #( #off #pressed #disabled #mouseOver ).
	toReturn state: #off.
	^ toReturn! !


!ComboButtonMorph reorganize!
('accessing' value value:)
('drawing' drawOn:)
('event handling' mouseEnterEvent:for: mouseLeave: mouseLeaveDraggingEvent:for:)
('initialization' fromGlyphImages:symbols: fromImages: initialize)
('state' state:)
!


!ComboBoxMorph class reorganize!
('instance creation' newInstance on: on:allowChoices:prepChoiceListSelector: on:text:accept:readSelection:menu:)
!


!ComboBoxMorph reorganize!
('accessing' alwaysDiscardEdits alwaysDiscardEdits: borderColor: choiceButton choiceList imageMorph setText:)
('activate/passivate' activate active: passivate)
('behavior override' accept acceptOnCR: canDiscardEdits hasUnacceptedEdits)
('choice list' allowChoices: choicesButtonBalloonText: popupChoices popupChoicesCleanUp prepChoiceListSelector prepChoiceListSelector:)
('drawing' selectAll selectAtEnd wantsFrameAdornments)
('event handling' checkForSpecialKeystroke:)
('initialization' fromImages: fromImages:symbols: initialize initializeImageMorph on: on:text:readSelection:menu: setEdges:)
('layout' doLayoutIn:)
('state' state:)
!

