'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 1 March 2002 at 7:57:31 pm'!
ThemeBase subclass: #ListTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:17'!
backgroundColor
  ^ lookDictionary at: #backgroundColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:17'!
borderColor
  ^ lookDictionary at: #borderColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:18'!
disabledTextColor
  ^ lookDictionary at: #disabledTextColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:17'!
enabledTextColor
  ^ lookDictionary at: #enabledTextColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:17'!
hilightBackgroundColor
  ^ lookDictionary at: #hilightBackgroundColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 09:12'!
hilightBackgroundDisabledColor
  ^ lookDictionary at: #hilightBackgroundDisabledColor ifAbsent: [ nil ]! !

!ListTheme methodsFor: 'accessors' stamp: 'jlb 10/4/2001 20:17'!
hilightTextColor
  ^ lookDictionary at: #hilightTextColor ifAbsent: [ nil ]! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'jlb 10/5/2001 12:54'!
initialize
	super initialize.
	ListTheme current ifNotNil: [
		self highlightBackgroundColor: ( ListTheme current  hilightBackgroundColor )].
! !

!PluggableListMorph methodsFor: 'drawing' stamp: 'jlb 10/4/2001 20:38'!
highlightSelection
	| aColor |
	aColor _ ListTheme current
				ifNil: [Color red]
				ifNotNil: [ListTheme current hilightTextColor].
	selectedMorph
		ifNotNil: [selectedMorph color: aColor;
				 changed]! !

!PluggableListMorph methodsFor: 'drawing' stamp: 'jlb 10/5/2001 12:51'!
unhighlightSelection
	selectedMorph
		ifNotNil: [selectedMorph color: self enabledTextColor;
				 changed]! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'jlb 10/5/2001 09:19'!
drawOn: aCanvas 
	| colorToFillWith areaToFill next |
	super drawOn: aCanvas.
	selectedMorph
		ifNil: [^ self].
	colorToFillWith _ color.
	next _ self.
	ListTheme current
		ifNotNil: [colorToFillWith _ self highlightBackgroundColor]
		ifNil: [[colorToFillWith isTransparent
				and: [(next _ next owner) notNil]]
				whileTrue: [colorToFillWith _ next color].
			colorToFillWith _ colorToFillWith luminance < 0.5
						ifTrue: [colorToFillWith muchLighter]
						ifFalse: [colorToFillWith darker]].
	areaToFill _ ((scroller transformFrom: self)
				localBoundsToGlobal: selectedMorph bounds)
				intersect: scroller bounds.
	aCanvas fillRectangle: areaToFill color: colorToFillWith! !

!PluggableListMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/5/2001 09:24'!
activate
	| enabledTextColor theme |

	super activate.
	theme _ ListTheme current.
	theme
		ifNil: [^ self].
	enabledTextColor _ theme enabledTextColor.
	scroller
		submorphsDo: [:m | (m isKindOf: StringMorph)
				ifTrue: [m color: enabledTextColor]].
	selectedMorph
		ifNotNil: [selectedMorph color: theme hilightTextColor].
	self highlightBackgroundColor: ( theme hilightBackgroundColor ).! !

!PluggableListMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/5/2001 09:24'!
passivate
	| disabledTextColor theme |

	super passivate.
	theme _ ListTheme current.
	theme ifNil: [ ^ self ].
	disabledTextColor _ theme disabledTextColor.
	scroller submorphsDo: [ :m |
		( m isKindOf: StringMorph ) ifTrue: [ 
				m color: disabledTextColor
			]].
	self highlightBackgroundColor: ( theme hilightBackgroundDisabledColor ).! !

!PluggableListMorph methodsFor: 'color' stamp: 'jlb 10/5/2001 12:50'!
enabledTextColor
	^ ListTheme current
				ifNil: [Color black]
				ifNotNil: [ListTheme current enabledTextColor].
! !

!PluggableListMorph methodsFor: 'color' stamp: 'jlb 10/5/2001 09:05'!
highlightBackgroundColor
	
	| val |
	^ (val _ self valueOfProperty: #highlightBackgroundColor)
		ifNotNil:
			[val ifNil: [Color gray]]
		ifNil:
			[Color gray]! !

!PluggableListMorph methodsFor: 'color' stamp: 'jlb 10/5/2001 09:03'!
highlightBackgroundColor: aColor
	self setProperty: #highlightBackgroundColor toValue: aColor! !


!PluggableListMorphOfMany methodsFor: 'drawing' stamp: 'jlb 10/5/2001 11:46'!
drawOn: aCanvas 
	| onMorph backColor |
	super drawOn: aCanvas.
	backColor _ ListTheme current
				ifNil: [color darker]
				ifNotNil: [self highlightBackgroundColor].
	1
		to: list size
		do: [:index | "NOTE: should be optimized to only visible morphs"
			(model listSelectionAt: index)
				ifTrue: [onMorph _ scroller submorphs at: index.
					onMorph color: ( self highlightColor ). 
					aCanvas
						fillRectangle: (((scroller transformFrom: self)
								localBoundsToGlobal: onMorph bounds)
								intersect: scroller bounds)
						color: backColor]]! !

!PluggableListMorphOfMany methodsFor: 'event handling' stamp: 'jlb 10/5/2001 12:42'!
mouseDown: event
	| index oldIndex oldVal aMorph |
	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].
	aMorph _ self itemFromPoint: event position.
	aMorph ifNil:[^super mouseDown: event].

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].

	"Set meaning for subsequent dragging of selection"
	dragOnOrOff _ (model listSelectionAt: index) not.
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ model listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self setSelectedMorph: aMorph]
		ifFalse: [self setSelectedMorph: nil].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [model listSelectionAt: oldIndex put: oldVal].
	model listSelectionAt: index put: dragOnOrOff.
	event hand releaseMouseFocus: aMorph.
	dragOnOrOff ifFalse: [ aMorph color: self enabledTextColor ].
	aMorph changed! !

!PluggableListMorphOfMany methodsFor: 'event handling' stamp: 'jlb 10/5/2001 12:43'!
mouseMove: event
	"The mouse has moved, as characterized by the event provided.  Adjust the scrollbar, and alter the selection as appropriate"

	| index oldIndex oldVal aMorph |
	event position y < self top
		ifTrue:
			[scrollBar scrollUp: 1.
			aMorph _ self itemFromPoint: scroller topLeft + (1@1)]
		ifFalse:
			[event position y > self bottom
				ifTrue:
					[scrollBar scrollDown: 1.
					aMorph _ self itemFromPoint: scroller bottomLeft + (1@-1)]
				ifFalse:
					[aMorph _ self itemFromPoint: event position]].
	aMorph ifNil: [^ super mouseDown: event].

	model okToChange ifFalse: [^ self].  "No change if model is locked"

	index _ scroller submorphs indexOf: aMorph.
	index = 0 ifTrue: [^ self  "minimize chance of selecting with a pane border drag"].
	dragOnOrOff ifNil:  "Was not set at mouse down, which means the mouse must have gone down in an area where there was no list item"
		[dragOnOrOff _ (model listSelectionAt: index) not].

	"Set meaning for subsequent dragging of selection"
	oldIndex _ self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal _ model listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff
		ifTrue: [self setSelectedMorph: aMorph]
		ifFalse: [self setSelectedMorph: nil].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [model listSelectionAt: oldIndex put: oldVal].
	model listSelectionAt: index put: (dragOnOrOff == true).
	dragOnOrOff ifFalse: [ aMorph color: self enabledTextColor ].
	aMorph changed! !

!PluggableListMorphOfMany methodsFor: 'activate/passivate' stamp: 'jlb 10/5/2001 12:47'!
activate
	| onMorph theme |

	super activate.
	theme _ ListTheme current.
	" set the text hilight color to use when selected "
	self highlightColor: (theme
				ifNil: [Color red]
				ifNotNil: [theme hilightTextColor]).
	1
		to: list size
		do: [:index | "NOTE: should be optimized to only visible morphs"
			(model listSelectionAt: index)
				ifTrue: [onMorph _ scroller submorphs at: index.
					onMorph color: (self highlightColor)]]! !

!PluggableListMorphOfMany methodsFor: 'activate/passivate' stamp: 'jlb 10/5/2001 12:48'!
passivate
	| theme |
	super passivate.
	theme _ ListTheme current.
	" set the text hilight color selected items show; in this case the disabled color"
	self highlightColor: (theme
				ifNil: [Color red]
				ifNotNil: [theme disabledTextColor]).
! !

