'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 1 March 2002 at 7:57:28 pm'!
"Change Set:		Menu Bar
Date:			20 June 2001
Author:			Jim Benson

This changeset provides a simple menu bar facility.

For a demo, execute:

MenuBarMorph example

Version 0.3   7/24/2001 
removed 

self setToAdhereToEdge: #topLeft

from MenuBarMorph>>initialize so that menu bars act correctly when placed in other morphs.

Fixed niggle in MenuBarItemMorph>>isEnabled:

"!

TwoModeButtonMorph subclass: #MenuBarButtonMorph
	instanceVariableNames: 'menu expanded enableFlag savedEnables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menu Bar'!

!MenuBarButtonMorph commentStamp: '<historical>' prior: 0!
I represent an item in a menu bar. I consist of a label that appears in the menu bar, and a pull down menu. I may be disabled, so that I may not be selected.

My images are keyed as five different states:

	 #normal #pressed #mouseOver #notUsed #disabled 
!

RectangleMorph subclass: #MenuBarItemMorph
	instanceVariableNames: 'menu expanded string isEnabled title isExpanded savedEnables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menu Bar'!

!MenuBarItemMorph commentStamp: '<historical>' prior: 0!
I represent an item in a menu bar. I consist of a label that appears in the menu bar, and a pull down menu. I may be disabled, so that I may not be selected.!

AlignmentMorph subclass: #MenuBarMorph
	instanceVariableNames: 'menuBarHeight '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menu Bar'!

!MenuBarMorph commentStamp: '<historical>' prior: 0!
I represent a menu bar .

Sometimes my menus ( PulldownMenuMorphs ) turn on listeners for my menu bar buttons. I facilitate that in the category listen.!

Object subclass: #MenuBarProperties
	instanceVariableNames: ''
	classVariableNames: 'MenuBarColor MenuBarDisabledColor MenuBarEnabledColor MenuBarFont MenuBarFontSize MenuBarFrameColor MenuBarHeight MenuBarShowDropShadow '
	poolDictionaries: ''
	category: 'Zurgle-Menu Bar'!

!MenuBarProperties commentStamp: '<historical>' prior: 0!
I contain information about a menu bars appearance such as the color of the menu bar.!

ThemeBase subclass: #MenuTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!
MenuMorph subclass: #PulldownMenuMorph
	instanceVariableNames: 'cover '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menu Bar'!

!PulldownMenuMorph commentStamp: '<historical>' prior: 0!
I represent a pull down menu from a menu bar.

There is one 'trick' hack that I do. When I am displayed and the mouse leaves me, I turn on listeners to all the members of the menu bar that I belong to. I still retain the mouse focus, so that I can be dismissed if the desktop is clicked. However, the listeners provide a hook for interaction with the menu system, and are handled by instances of MenuBarItemMorphs.!


!MenuBarButtonMorph methodsFor: 'initialization' stamp: 'jlb 10/3/2001 10:12'!
fromImages: buttonImages 

	self fromImages: buttonImages symbols: #( #normal #pressed #mouseOver #normalInactive #pressedInactive #mouseOverInactive ).
	self state: #off.! !

!MenuBarButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/24/2001 21:30'!
initialize
	super initialize.
	expanded _ false.
	enableFlag _ true.
	self layoutPolicy: ProportionalLayout new.
	self clipLayoutCells.
	self extent: ( 70 @ 24 ).
	self minimumExtent: 24@20.
	self setProperty: #hasMenu toValue: true.

    self on: #mouseEnterDragging send: #mouseEnterDragging:for: to: self.
	self on: #mouseDown send: #mouseDownEvent: to: self.
	self on: #mouseLeaveDragging send: #mouseLeaveDragging:for: to: self.
	self on: #mouseEnter send: #mouseEnterEvent:for: to: self.


! !

!MenuBarButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/23/2001 08:17'!
reset
	self isExpanded: false.
	self state: ( self state ).
! !

!MenuBarButtonMorph methodsFor: 'state' stamp: 'jlb 9/24/2001 21:36'!
disable
	self isEnabled: false.
	self state: ( self state ).! !

!MenuBarButtonMorph methodsFor: 'state' stamp: 'jlb 9/24/2001 21:36'!
enable
	self isEnabled: true.
	self state: ( self state ).! !

!MenuBarButtonMorph methodsFor: 'state' stamp: 'jlb 9/24/2001 21:36'!
isEnabled: aBoolean 
	enableFlag = aBoolean ifTrue:[^self].
	enableFlag _ aBoolean.
	enableFlag
		ifTrue: 
			["restore the enable state of the menu items"
			savedEnables ifNotNil: [savedEnables do: [:mli | (mli at: 1)
						isEnabled: (mli at: 2)]].
			savedEnables _ nil]
		ifFalse: 
			[ "save the enable state of the menu line items "
			savedEnables _ Set new.
			menu submorphs do: [:m | (m isKindOf: MenuItemMorph)
					ifTrue: 
						[savedEnables add: (Array with: m with: m isEnabled).
						m isEnabled: false]].
			]! !

!MenuBarButtonMorph methodsFor: 'state' stamp: 'jlb 10/3/2001 11:07'!
state: newState 
	| symbol pSymbol |
	state _ newState.
	" Change the image to correspond to the new state"
	pSymbol _ state.
	pSymbol == #off
		ifTrue: [pSymbol _ self isExpanded
						ifTrue: [#pressed]
						ifFalse: [#normal]].
	enableFlag
		ifTrue: [active
				ifTrue: [symbol _ pSymbol]
				ifFalse: [symbol _ (pSymbol , 'Inactive') asSymbol]]
		ifFalse: [symbol _ #normalInactive].
	self
		image: (forms at: symbol).
	self setFontColor! !

!MenuBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/22/2001 09:20'!
isExpanded
	^ expanded! !

!MenuBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/22/2001 09:21'!
isExpanded: aBoolean
	expanded _ aBoolean.! !

!MenuBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/22/2001 09:18'!
menu
	^ menu! !

!MenuBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/24/2001 21:46'!
menu: aMenuMorph 
	"convert a MenuMorph to become a proper pull down menu"
	| titleMorph |
	menu _ aMenuMorph.
	menu
		ifNotNil: 
			["get rid of the title string of the menu in the new world 
			order "
			titleMorph _ menu firstSubmorph.
			(titleMorph isKindOf: AlignmentMorph)
				ifTrue: [titleMorph delete].
			"get rid of any stayup stuff"
			menu items do: [:item | item selector = #toggleStayUp: ifTrue: [item delete]].
			menu stayUp: false.
			"and try not to line up as a line for the first entry"
			titleMorph _ menu firstSubmorph.
			(titleMorph isKindOf: MenuLineMorph)
				ifTrue: [titleMorph delete].
			menu useSquareCorners.
			self menuFontColor.]! !

!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 9/22/2001 19:10'!
closeMenu
	menu deleteIfPopUp.
	self isExpanded: false.
	self state: #off.
! !

!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 9/22/2001 21:56'!
closeOpenMenus
	" close all of the open menus in the owning menu bar "
	owner closeOpenMenus.! !

!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 9/22/2001 10:34'!
deletedMenu
	" Somebody deleted my menu ; reset me "
	self reset.
	( self containsPoint: ( self cursorPoint ) )
	ifTrue: [ " the user pressed mouse down inside of the menu header "
		self changed.
		].! !

!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 9/24/2001 21:45'!
menuFontColor

	| menuFontColor |
	menuFontColor _ MenuTheme current menuFontColor.
	menuFontColor ifNil: [ ^ self ].
	menu submorphs do: [ :m |
			( m isKindOf: MenuItemMorph )
				ifTrue: [ m color: menuFontColor ]].
! !

!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 9/24/2001 21:13'!
openMenu: hand 
	"open my menu under control of the given hand."
	menu ifNil: [ ^ self ].

	menu user: self.
	"Make sure that nothing is currently selected in the menu"
	menu submorphs
		do: [:m | (m isKindOf: MenuItemMorph)
				ifTrue: [m isSelected: false]].
	"menu pullDownAtPoint: bounds bottomLeft forHand: hand."
	self isExpanded: true.
	self state: #off.
	menu
		popUpAt: bounds bottomLeft
		forHand: hand
		in: self world.
! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/22/2001 23:36'!
handleListenEvent: anEvent 
	" a menu that belongs to the menu bar turned on a listener ;
	  handle it if we can "
	(self containsPoint: anEvent cursorPoint)
		ifTrue: [self mouseEnterEvent: anEvent for: self].
! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/24/2001 21:39'!
mouseDownEvent: evt 

	self isExpanded
		ifFalse: [self openMenu: evt hand]! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/24/2001 16:00'!
mouseEnterDragging: evt for: aMorph

	" Mouse entered us already down "
	self mouseEnterEvent: evt for: aMorph. ! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/24/2001 16:00'!
mouseEnterEvent: evt for: aMorph 
	"am I in a menu bar?"
	| openMenu |

	(self containsPoint: evt cursorPoint)
		ifFalse: [^ self].
	( evt hand submorphs isEmpty ) ifFalse: [ ^ self ].
	(owner isKindOf: MenuBarMorph)
		ifTrue: [self isExpanded
				ifFalse: ["we may have another open menu in the menu  
					bar ;  
					if so close that one and open ours"
					openMenu _ owner closeOpenMenus.
					openMenu
						ifTrue: [self openMenu: evt hand.
							self state: #off]
						ifFalse: [self state: #mouseOver]]]
		ifFalse: [self state: #mouseOver]! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/22/2001 23:35'!
mouseLeave: event 
	super mouseLeave: event.
	self isExpanded
		ifTrue: [event hand newMouseFocus: menu.
			self owner allEars: event]
		ifFalse: [self state: #off]! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 9/24/2001 21:40'!
mouseLeaveDragging: anEvent for: aMorph 

	self mouseLeave: anEvent.
! !

!MenuBarButtonMorph methodsFor: 'label' stamp: 'jlb 9/22/2001 09:01'!
label
	^ self submorphNamed: #label.! !

!MenuBarButtonMorph methodsFor: 'label' stamp: 'jlb 10/10/2001 22:51'!
label: aString 
	"get rid of the old label"
	| font label |
	(self submorphNamed: #label)
		ifNotNilDo: [:lab | 
			lab delete.
			self changed].
	"start making a new one"
	aString
		ifNil: [bounds _ bounds origin extent: self minimumExtent]
		ifNotNil: ["setup the font for a menu bar entry"
			font _ Preferences standardMenuFont.
			label _ StringMorph contents: aString font: font.
			label
				layoutFrame: (LayoutFrame
						fractions: (0.5 @ 0.5 corner: 0.5 @ 0.5)
						offsets: (0 @ 0 corner: 0 @ 0)).
			label name: #label.
			self addMorph: label.
			label lock.
			self extent: self nominalExtent]! !

!MenuBarButtonMorph methodsFor: 'label' stamp: 'jlb 10/3/2001 10:36'!
setFontColor
	"set the font color for the menu bar button from the current state"
	| menuTheme aColor |
	menuTheme _ MenuTheme current.
	menuTheme
		ifNil: [^ self].

	aColor _ (enableFlag not
					or: [active not])
				ifTrue: [menuTheme passiveLabelColor]
				ifFalse: [state == #off
						ifTrue: [expanded
								ifTrue: [menuTheme selectedLabelColor]
								ifFalse: [menuTheme activeLabelColor]]
						ifFalse: [state == #pressed
								ifTrue: [menuTheme selectedLabelColor]
								ifFalse: [menuTheme mouseOverLabelColor]]].
	self setLabelColor: aColor.
! !

!MenuBarButtonMorph methodsFor: 'label' stamp: 'jlb 10/3/2001 10:25'!
setLabelColor: aColor
	"set the color for the label string "
	| aLabel |
	aLabel _ self label.
	(aLabel notNil
			and: [aColor notNil])
		ifTrue: [aLabel color ~= aColor
				ifTrue: [aLabel color: aColor]]! !

!MenuBarButtonMorph methodsFor: 'geometry' stamp: 'jlb 9/22/2001 09:09'!
nominalExtent
	| labelString |
	labelString _ self submorphNamed: #label.
	labelString ifNil: [ ^ 28 @ 24].
	^ labelString width + 16 @ 24.
! !


!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/24/2001 21:46'!
fromMenuMorph:  aMenuMorph
	| newMorph |

	newMorph _ aMenuMorph as: PulldownMenuMorph.
	aMenuMorph become: newMorph.
	aMenuMorph setColors.
	aMenuMorph color: Color transparent.
	aMenuMorph borderWidth: 0.
	aMenuMorph initializeCover.
	aMenuMorph extent: ( aMenuMorph extent ).
	^ self label: ( aMenuMorph getTitleString ) 
		menu: aMenuMorph.! !

!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/22/2001 09:29'!
label: aString menu: aMenuMorph
	| toReturn |
	toReturn _ self newInstance.
	toReturn label: aString ;
		menu: aMenuMorph.
	^ toReturn! !

!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/24/2001 14:26'!
newInstance
	| toReturn |
	toReturn _ self new.
	toReturn fromImages:  (MenuTheme current menuBarButtonForm).
	^ toReturn.! !

!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/22/2001 10:17'!
test
	"MenuBarButtonMorph test "
    | worldMenu aMenu mi |
	worldMenu _ TheWorldMenu new.
	aMenu _ (worldMenu
		world: World
		project: ( Project current )     
		hand: ActiveHand) buildWorldMenu.

	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'World'.
	mi openInWorld.
! !


!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/28/2000 11:14'!
isEnabled
	^isEnabled! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 7/24/2001 17:07'!
isEnabled: aBoolean 
	isEnabled = aBoolean ifTrue:[^self].
	isEnabled _ aBoolean.
	title color: (isEnabled
			ifTrue: [MenuBarProperties menuBarEnabledColor]
			ifFalse: [MenuBarProperties menuBarDisabledColor]).
	self changed.
	isEnabled
		ifTrue: 
			["restore the enable state of the menu items"
			savedEnables ifNotNil: [savedEnables do: [:mli | (mli at: 1)
						isEnabled: (mli at: 2)]].
			savedEnables _ nil]
		ifFalse: 
			[ "save the enable state of the menu line items "
			savedEnables _ Set new.
			menu submorphs do: [:m | (m isKindOf: MenuItemMorph)
					ifTrue: 
						[savedEnables add: (Array with: m with: m isEnabled).
						m isEnabled: false]].
			]! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/28/2000 19:39'!
isExpanded
	^ isExpanded! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/28/2000 19:36'!
isExpanded: aBoolean
	isExpanded _ aBoolean.! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 9/23/2001 09:51'!
label
	^ title.! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 9/23/2001 09:51'!
label: aString 
	| maxWidth font |
	title ifNotNil: ["get rid of the current title"
		title delete.
		self changed.].
	aString
		ifNil: 
			[bounds _ bounds origin extent: ( self minimumExtent).
			title _ nil]
		ifNotNil: 
			["setup the font for a menu bar entry"
			font _ StrikeFont
						familyName: MenuBarProperties menuBarFont
						size: MenuBarProperties menuBarFontSize
						emphasized: 0.
			title _ StringMorph
						contents: aString
						font: font
						emphasis: 1.
			self addMorph: title.
			maxWidth _ font maxWidth.
			bounds _ bounds origin extent: title width + maxWidth @ MenuBarProperties menuBarHeight.
			self layoutChanged.
			self changed.]! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/24/2000 21:59'!
menu
	^ menu! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/20/2001 07:31'!
menu: aMenuMorph 
	"convert a MenuMorph to become a proper pull down menu"
	| titleMorph |
	menu _ aMenuMorph.
	menu
		ifNotNil: 
			["get rid of the title string of the menu in the new world 
			order "
			titleMorph _ menu firstSubmorph.
			(titleMorph isKindOf: AlignmentMorph)
				ifTrue: [titleMorph delete].
			"get rid of any stayup stuff"
			menu items do: [:item | item selector = #toggleStayUp: ifTrue: [item delete]].
			menu stayUp: false.
			"and try not to line up as a line for the first entry"
			titleMorph _ menu firstSubmorph.
			(titleMorph isKindOf: MenuLineMorph)
				ifTrue: [titleMorph delete].
			menu useSquareCorners.]! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/26/2000 19:37'!
title
	^ title.! !

!MenuBarItemMorph methodsFor: 'accessing' stamp: 'jlb 6/28/2000 19:47'!
title: aString 
	| maxWidth font |
	title ifNotNil: ["get rid of the current title"
		title delete.
		self changed.].
	aString
		ifNil: 
			[bounds _ bounds origin extent: ( self minimumExtent).
			title _ nil]
		ifNotNil: 
			["setup the font for a menu bar entry"
			font _ StrikeFont
						familyName: MenuBarProperties menuBarFont
						size: MenuBarProperties menuBarFontSize
						emphasized: 0.
			title _ StringMorph
						contents: aString
						font: font
						emphasis: 1.
			self addMorph: title.
			maxWidth _ font maxWidth.
			bounds _ bounds origin extent: title width + maxWidth @ MenuBarProperties menuBarHeight.
			self layoutChanged.
			self changed.]! !

!MenuBarItemMorph methodsFor: 'initialize' stamp: 'jlb 9/22/2001 22:11'!
initialize
	super initialize.
	borderWidth _ 2.
	color _ MenuBarProperties menuBarColor.
	borderColor _ Color transparent.
	isExpanded _ false.
	isEnabled _ true.
	savedEnables _ nil.
	self setProperty: #hasMenu toValue: true.
! !

!MenuBarItemMorph methodsFor: 'initialize' stamp: 'jlb 6/28/2000 19:48'!
minimumExtent
	^ 16 @ 16.! !

!MenuBarItemMorph methodsFor: 'initialize' stamp: 'jlb 6/28/2000 20:21'!
reset
	borderColor _ Color transparent.
	self changed.
	self refreshWorld.
	self isExpanded: false.
	! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/18/2001 20:50'!
closeMenu
	menu deleteIfPopUp.
	isExpanded _ false.
! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/25/2000 00:16'!
deletedMenu
	" Somebody deleted my menu ; reset me "
	self reset.
	( self containsPoint: ( self cursorPoint ) )
	ifTrue: [ " the user pressed mouse down inside of the menu header "
		borderColor _ #inset.
		self changed.
		].! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 23:48'!
handleMouseDown: anEvent
	"System level event handling."
	(self containsPoint: anEvent cursorPoint) ifFalse: [ ^ self ].
	super handleMouseDown: anEvent
! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/20/2001 00:20'!
handleMouseMove: anEvent
	"System level event handling."
	" in case a pull down menu attached a listener to us "
	(self containsPoint: anEvent cursorPoint)
		ifFalse: [ ^ self. ].
	" WARNING -- assumes that a transparent border color means we aren't the current menu "
	borderColor == Color transparent ifTrue: [ 
			anEvent wasHandled: true.
			owner noEars: anEvent.
			^ self mouseEnter: anEvent ].
	super handleMouseMove: anEvent
	

! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 22:45'!
handlesMouseDown: evt
	^ true.! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 22:16'!
handlesMouseOver: evt

	^ true
! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 22:16'!
handlesMouseOverDragging: evt

	^ true
! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 23:17'!
mouseDown: evt 

	
(self containsPoint: evt cursorPoint)
	ifFalse: [ ^ self ].
	isEnabled
		ifTrue: 
			[borderColor _ #inset.
			self changed.
			"make sure we show the border change immediately"
			self refreshWorld].
	self openMenu: evt hand! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 19:52'!
mouseEnter: evt 
	| openMenu |

	(owner isKindOf: MenuBarMorph)
		ifTrue: [isExpanded
				ifFalse: 
					["we may have another open menu in the menu  
					bar ;  
					if so close that one and open ours"
					openMenu _ false.
					owner submorphs do: [:m | (m isKindOf: self class)
							ifTrue: [m isExpanded
									ifTrue: 
										[m closeMenu.
										m mouseLeave: evt.
										openMenu _ true]]].
					openMenu ifTrue: [self openMenu: evt hand]]].
	isExpanded
		ifTrue: [borderColor _ #inset]
		ifFalse: [borderColor _ #raised].
	self changed.
	self refreshWorld! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 22:17'!
mouseEnterDragging: evt 
	" Mouse entered us already down "
	isEnabled ifTrue: [self borderColor: #inset].
	^ self mouseEnter: evt! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/20/2001 08:10'!
mouseLeave: evt 
	isExpanded
		ifFalse: [borderColor _ Color transparent.
			self changed.
			self refreshWorld.
			evt hand newMouseFocus: nil]
		ifTrue: [
			evt hand newMouseFocus: menu ]! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 20:29'!
mouseLeaveDragging: evt 
	" Mouse entered us already down "
	^ self mouseLeave: evt! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/19/2001 22:48'!
mouseMove: evt
	super mouseMove: evt.
	evt hand newMouseFocus: nil! !

!MenuBarItemMorph methodsFor: 'event handling' stamp: 'jlb 6/18/2001 21:21'!
openMenu: hand 
	"open my menu under control of the given hand."
	menu ifNil: [ ^ self ].
	MenuBarProperties menuBarShowDropShadow
		ifTrue: [menu addDropShadow.
				menu shadowColor == Color black ifTrue: [
			menu
				shadowColor: (menu shadowColor alpha: 0.5)]]
		ifFalse: [menu hasDropShadow
				ifTrue: [menu removeDropShadow]].
	menu user: self.
	"Make sure that nothing is currently selected in the menu"
	menu submorphs
		do: [:m | (m isKindOf: MenuItemMorph)
				ifTrue: [m isSelected: false]].
	"menu pullDownAtPoint: bounds bottomLeft forHand: hand."
	isExpanded _ true.
	menu
		popUpAt: bounds bottomLeft
		forHand: hand
		in: self world.
! !

!MenuBarItemMorph methodsFor: 'geometry' stamp: 'jlb 6/20/2001 07:58'!
drawOn: aCanvas
	super drawOn: aCanvas! !

!MenuBarItemMorph methodsFor: 'geometry' stamp: 'jlb 6/24/2000 23:58'!
layoutChanged
	| sm |
	super layoutChanged.
	( sm _ self findA: StringMorph )
		ifNotNil: [ 	sm position: self center - (sm extent // 2). ].
! !


!MenuBarItemMorph class methodsFor: 'instance creation' stamp: 'jlb 6/20/2001 07:26'!
fromMenuMorph:  aMenuMorph
	| newMorph |

	newMorph _ aMenuMorph as: PulldownMenuMorph.
	aMenuMorph become: newMorph.
	aMenuMorph setColors.
	^ self fromString: ( aMenuMorph getTitleString ) 
		menu: aMenuMorph.! !

!MenuBarItemMorph class methodsFor: 'instance creation' stamp: 'jlb 6/26/2000 19:23'!
fromString: aString
	| toReturn |
	toReturn _ self new.
	toReturn title: aString.
	^ toReturn! !

!MenuBarItemMorph class methodsFor: 'instance creation' stamp: 'jlb 6/26/2000 19:23'!
fromString: aString menu: aMenuMorph
	| toReturn |
	toReturn _ self new.
	toReturn title: aString.
	toReturn menu: aMenuMorph.
	^ toReturn! !


!MenuBarMorph methodsFor: 'geometry' stamp: 'jlb 6/7/2000 19:36'!
ownerChanged
	super ownerChanged.
	self extent: ( (owner bounds width ) @ menuBarHeight ).

! !

!MenuBarMorph methodsFor: 'adding / removing' stamp: 'jlb 6/28/2000 22:26'!
append: aMenuBarItemMorph
	self addMorphBack: aMenuBarItemMorph! !

!MenuBarMorph methodsFor: 'adding / removing' stamp: 'jlb 6/26/2000 09:53'!
clear
	" delete all of the menu bar items "
	self removeAllMorphs.! !

!MenuBarMorph methodsFor: 'adding / removing' stamp: 'jlb 6/26/2000 09:53'!
delete: aMenuBarItemMorph
	aMenuBarItemMorph delete.! !

!MenuBarMorph methodsFor: 'adding / removing' stamp: 'jlb 6/26/2000 19:07'!
insert: aMenuBarItemMorph before: anItemMorph
	" Insert a menu before anItem in the menu bar "
	self addMorph: aMenuBarItemMorph inFrontOf: anItemMorph.! !

!MenuBarMorph methodsFor: 'drawing' stamp: 'jlb 9/21/2001 20:53'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	self fillStyle isColor ifFalse: [ ^ self ].
	"draw a seperator line at the bottom of the morph"
	aCanvas
		line: bounds bottomLeft - (0 @ 1)
		to: bounds bottomRight - (0 @ 1)
		width: 1
		color: ( MenuBarProperties menuBarFrameColor ).! !

!MenuBarMorph methodsFor: 'listen' stamp: 'jlb 9/23/2001 08:10'!
allEars: evt
	self menuBarButtons do: [ :m |
		 evt hand addMouseListener: m.
	].

	! !

!MenuBarMorph methodsFor: 'listen' stamp: 'jlb 9/23/2001 08:10'!
noEars: evt
	self menuBarButtons do: [ :m |
		 evt hand removeMouseListener: m.
	].

	! !

!MenuBarMorph methodsFor: 'listen' stamp: 'jlb 9/23/2001 08:10'!
removeEars
	self menuBarButtons do: [ :m |
		 World activeHand removeMouseListener: m.
	].

	! !

!MenuBarMorph methodsFor: 'menus' stamp: 'jlb 9/22/2001 22:08'!
closeOpenMenus
	"close all of the open menus ; return true if one of the menu 
	items was open"
	| openItem |
	openItem _ false.
	self
		submorphsDo: [:menuButton | (menuButton hasProperty: #hasMenu)
				ifTrue: [menuButton isExpanded
						ifTrue: [openItem _ true.
							menuButton closeMenu]]].
	^ openItem! !

!MenuBarMorph methodsFor: 'menus' stamp: 'jlb 6/29/2000 00:38'!
collapse
	" Don't collapse menu bars "! !

!MenuBarMorph methodsFor: 'menus' stamp: 'jlb 9/23/2001 08:10'!
menuBarButtons
	^ self
		submorphsSatisfying: [:m | m hasProperty: #hasMenu]! !

!MenuBarMorph methodsFor: 'initialize' stamp: 'jlb 7/24/2001 17:06'!
initialize
	super initialize.
	self color: MenuBarProperties menuBarColor.
	menuBarHeight _ MenuBarProperties menuBarHeight.
	borderWidth _ 0.
	self beSticky.
	self layoutInset: -1.
! !

!MenuBarMorph methodsFor: 'initialize' stamp: 'jlb 9/23/2001 08:18'!
reset
	" reset the menu buttons ; make everybody happy "
	submorphs
		do: [:m | m reset]! !


!MenuBarMorph class methodsFor: 'example' stamp: 'jlb 9/24/2001 21:22'!
example
	"MenuBarMorph example"
	| mb hand aMenu mi worldMenu |
	mb _ self newInstance.
	"get a little away from the edge; you should put Squeak icon 
	here "
	mb
		addTransparentSpacerOfSize: (MenuTheme current
				ifNil: [0 @ 8]
				ifNotNil: [0 @ MenuTheme current leftSpacer]).
	hand _ self currentWorld activeHand.
	worldMenu _ TheWorldMenu new.
	"world menu"
	aMenu _ (worldMenu
				world: World
				project: Project current
				hand: hand) buildWorldMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'World'.
	mb append: mi.
	"Changes menu"
	aMenu _ worldMenu changesMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'Changes'.
	mb append: mi.
	"Appearance menu"
	aMenu _ worldMenu appearanceMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'Appearance'.
	mb append: mi.
	"Debug menu"
	aMenu _ worldMenu debugMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'Debug'.
	mb append: mi.
	"Disable for fanciness"
	"mi isEnabled: false."
	"Windows menu"
	aMenu _ worldMenu windowsMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'Windows'.
	mb append: mi.
	"Help menu"
	aMenu _ worldMenu helpMenu.
	mi _ MenuBarItemMorph fromMenuMorph: aMenu.
	mi label: 'Help'.
	mb append: mi.
	"Act like a menu bar and hang out in the upper left hand corner"
	mb setToAdhereToEdge: #topLeft.
	mb openInWorld! !

!MenuBarMorph class methodsFor: 'example' stamp: 'jlb 10/4/2001 17:07'!
newExample
	| mb hand aMenu mi worldMenu |
	" MenuBarMorph example "
	mb _ self newInstance.

	" get a little away from the edge; you should put Squeak icon here "
	mb addTransparentSpacerOfSize: 
		( MenuTheme current ifNil: [ 8@0 ]
				ifNotNil: [ MenuTheme current leftSpacer @ 0 ]).
	hand _ self currentWorld activeHand.
	worldMenu _ TheWorldMenu new.
	" world menu "
	aMenu _ (worldMenu
		world: World
		project: ( Project current )     
		hand: hand) buildWorldMenu.

	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'World'.
	mb append: mi.


	" Changes menu "
	aMenu _ worldMenu changesMenu.
	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'Changes'.
	mb append: mi. 

	" Appearance menu "
	aMenu _ worldMenu appearanceMenu.
	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'Appearance'. 
	mb append: mi.

	" Open menu "
	aMenu _ worldMenu openMenu.
	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'Tools'.
	mb append: mi.
	" Disable for fanciness "
	" mi disable. "

	" Windows menu "
	aMenu _ worldMenu windowsMenu.
	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'Windows'.
	mb append: mi.

	" Help menu "
	aMenu _ worldMenu helpMenu.
	mi _ MenuBarButtonMorph fromMenuMorph: aMenu.
	mi label: 'Help'.
	mb append: mi.
	" Act like a menu bar and hang out in the upper left hand corner "
	mb setToAdhereToEdge: #topLeft.   
	mb openInWorld.! !

!MenuBarMorph class methodsFor: 'example' stamp: 'jlb 9/21/2001 20:51'!
newInstance

	| toReturn fill |
	toReturn _ self new.
	MenuTheme current ifNotNilDo: [ :mt |
			fill _ BitmapFillStyle fromForm: (mt menuBarForm).
			fill origin: toReturn bounds origin.
			toReturn fillStyle: fill.
		].
	^ toReturn.! !


!MenuBarProperties methodsFor: 'look in class' stamp: 'jlb 6/26/2000 19:45'!
seeClassSide
	"All the code for MenuBarProperties is on the class side"! !


!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 19:59'!
menuBarColor
	" the color of the menu bar "
	^ MenuBarColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 19:59'!
menuBarColor: aColor
	" Set the color of the menu bar property "
	MenuBarColor _ aColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:03'!
menuBarDisabledColor
	" The color of a disabled item in the menu bar "
	^ MenuBarDisabledColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:03'!
menuBarDisabledColor: aColor
	" set the color of a disabled item in the menu bar "
	MenuBarDisabledColor _ aColor.! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:03'!
menuBarEnabledColor
	" the color of a enabled item in the menu bar "
	^ 	MenuBarEnabledColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:04'!
menuBarEnabledColor: aColor
	" set the color of a enabled item in the menu bar "
	MenuBarEnabledColor _ aColor.! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:23'!
menuBarFont
	" return the name of the menuBar font family "
	^ MenuBarFont.! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:23'!
menuBarFont: aFontFamilyName
	" set the name of the menuBar font family "
	MenuBarFont _ aFontFamilyName.! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 19:59'!
menuBarFontSize
	" the size of the font for strings in the menu bar "
	^ MenuBarFontSize! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 19:59'!
menuBarFontSize: anInteger
	" set the size of the font for strings in the menu bar "
	MenuBarFontSize _ anInteger! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/20/2001 07:20'!
menuBarFrameColor
	" the color of the menu bar frame "
	^ MenuBarFrameColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/20/2001 07:20'!
menuBarFrameColor: aColor
	" Set the color of the menu bar frame color property "
	MenuBarFrameColor _ aColor! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:00'!
menuBarHeight
	" the height of the menu bar in pixels "
	^ MenuBarHeight.! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:00'!
menuBarHeight: anInteger
	" set the height of the menu bar in pixels "
	MenuBarHeight _ anInteger! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:31'!
menuBarShowDropShadow
	" show the drop shadow when menus are pulled down "
	^ MenuBarShowDropShadow! !

!MenuBarProperties class methodsFor: 'properties' stamp: 'jlb 6/26/2000 20:32'!
menuBarShowDropShadow: aBoolean
	" show the drop shadow when menus are pulled down "
	MenuBarShowDropShadow _ aBoolean! !

!MenuBarProperties class methodsFor: 'class initialization' stamp: 'jlb 6/20/2001 08:17'!
initialize
	" MenuBarProperties initialize "
	self menuBarHeight: 24.
	" adjust this color for the menu bar color -- light gray here "
	self menuBarColor: (Color r: 0.80 g: 0.80 b: 0.80).
	self menuBarFrameColor: Color black.
	self menuBarEnabledColor: Color black.
	self menuBarDisabledColor: Color gray.
	self menuBarFont: #NewYork.
	self menuBarFontSize: 20.
	self menuBarShowDropShadow: true.! !


!MenuLineMorph methodsFor: 'drawing' stamp: 'jlb 9/24/2001 22:02'!
drawOn: aCanvas
	| pref |
	aCanvas
		line: (bounds leftCenter) 
		to: (bounds rightCenter) 
		width: 1 
		color: ((pref _ Preferences menuColorFromWorld)
					ifTrue:
						[owner color darker]
					ifFalse:
						[Preferences menuLineUpperColor]).
	aCanvas
		line: (bounds leftCenter + ( 0@1)) 
		to: (bounds rightCenter + (0@1)) 
		width: 1 
		color: (pref
					ifTrue:
						[owner color lighter]
					ifFalse:
						[Preferences menuLineLowerColor])! !

!MenuLineMorph methodsFor: 'layout' stamp: 'jlb 9/24/2001 21:58'!
minHeight

	^ Preferences standardMenuFont height
! !


!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
activeLabelColor
  ^ lookDictionary at: #activeLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
leftSpacer
  ^ lookDictionary at: #leftSpacer ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuBarButtonForm
  ^ lookDictionary at: #menuBarButtonForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuBarForm
  ^ lookDictionary at: #menuBarForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuFontColor
  ^ lookDictionary at: #menuFontColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuFrameEdges
  ^ lookDictionary at: #menuFrameEdges ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuFrameForm
  ^ lookDictionary at: #menuFrameForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuFrameOffset
  ^ lookDictionary at: #menuFrameOffset ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuItemEdges
  ^ lookDictionary at: #menuItemEdges ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuItemForm
  ^ lookDictionary at: #menuItemForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
menuTextOffset
  ^ lookDictionary at: #menuTextOffset ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
mouseOverLabelColor
  ^ lookDictionary at: #mouseOverLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
passiveLabelColor
  ^ lookDictionary at: #passiveLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 10/3/2001 10:53'!
selectedLabelColor
  ^ lookDictionary at: #selectedLabelColor ifAbsent: [ nil ]! !


!PulldownMenuMorph methodsFor: 'accessing' stamp: 'jlb 6/29/2000 14:59'!
getTitleString
	
	| aMorph nameMorph |
	aMorph _ self submorphs first.
	(aMorph isKindOf: AlignmentMorph)
		ifTrue: [  nameMorph _ aMorph submorphs first.
					(nameMorph isKindOf: StringMorph)
					ifTrue: [ ^ nameMorph contents ]].
	^ 'Untitled'.
					! !

!PulldownMenuMorph methodsFor: 'accessing' stamp: 'jlb 6/29/2000 14:59'!
user
	|  user |
	"This returns the an interested party to the menu"
	(user _ self valueOfProperty: #user)
		ifNotNil:
			[^ user].
	^ nil! !

!PulldownMenuMorph methodsFor: 'accessing' stamp: 'jlb 6/29/2000 14:59'!
user: aMorph
	"This sets the interested party to the menu to be a Morph"
	self setProperty: #user toValue: aMorph.

	! !

!PulldownMenuMorph methodsFor: 'control' stamp: 'jlb 9/27/2001 00:07'!
popUpAt: aPoint forHand: hand in: aWorld 
	"Present this menu at the given point under control of the given 
	hand. "
	self items isEmpty
		ifTrue: [^ self].
	self
		positionAt: aPoint
		relativeTo: (selectedItem
				ifNil: [self items first])
		inWorld: aWorld.
	cover
		ifNotNil: [aWorld addMorphFront: cover].
	aWorld addMorphFront: self;
		 startSteppingSubmorphsOf: self.
	"Aquire focus for valid pop up behavior"
	self changed! !

!PulldownMenuMorph methodsFor: 'control' stamp: 'jlb 6/18/2001 21:30'!
positionAt: aPoint relativeTo: aMenuItem inWorld: aWorld
	"Note: items may not be laid out yet (I found them all to be at 0@0),  
	so we have to add up heights of items above the selected item."
	
	" This positions the menu at the given point with no offset ; slight changed from MenuMorph version "

	| i yOffset sub |
	self fullBounds. "force layout"
	i _ 0.
	yOffset _ 0.
	[(sub _ self submorphs at: (i _ i + 1)) == aMenuItem]
		whileFalse: [yOffset _ yOffset + sub height].

	self position: aPoint.

! !

!PulldownMenuMorph methodsFor: 'control' stamp: 'jlb 7/11/2001 20:13'!
pullDownAtPoint: aPoint forHand: hand 

	self popUpAt: aPoint forHand: hand in: self currentWorld.
! !

!PulldownMenuMorph methodsFor: 'private' stamp: 'jlb 9/23/2001 01:20'!
deleteIfPopUp
	"Remove this menu from the screen if stayUp is not true. If it is a submenu, also remove its owning menu."
	
	stayUp ifFalse: [self topRendererOrSelf delete. 
		self user ifNotNil: [ self user deletedMenu ]].
	(popUpOwner notNil and: [popUpOwner isKindOf: MenuItemMorph]) ifTrue: [
		popUpOwner isSelected: false.
		(popUpOwner owner isKindOf: MenuMorph)
			ifTrue: [popUpOwner owner deleteIfPopUp]].
! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 6/19/2001 16:06'!
handlesMouseOver: evt
	^ true! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 6/19/2001 22:53'!
handlesMouseOverDragging: evt

	^ true
! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 6/20/2001 00:11'!
mouseEnter: evt

	super mouseEnter: evt.
	evt hand newMouseFocus: self.
! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 6/20/2001 00:12'!
mouseEnterDragging: evt 
	" Mouse entered us already down "
	^ self mouseEnter: evt! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 9/22/2001 19:32'!
mouseLeave: evt
	super mouseLeave: evt.
	self user owner allEars: evt. 
! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 9/22/2001 19:09'!
mouseLeaveDragging: evt 
	super mouseLeave: evt.
	self user owner allEars: evt.

! !

!PulldownMenuMorph methodsFor: 'events' stamp: 'jlb 6/20/2001 00:25'!
mouseUp: evt

	evt hand newMouseFocus: self.
! !

!PulldownMenuMorph methodsFor: 'initialization' stamp: 'jlb 9/27/2001 00:06'!
initializeCover
	| aMorph |
	MenuTheme current
		ifNotNilDo: [:theme | 
			aMorph _ EdgeImageMorph new.
			aMorph image: theme menuFrameForm.
			theme menuFrameEdges
				ifNotNilDo: [:edgeRectangle | aMorph setEdges: edgeRectangle].
			cover _ aMorph.
			fullBounds _ nil.]! !

!PulldownMenuMorph methodsFor: 'initialization' stamp: 'jlb 6/20/2001 07:36'!
setColors

	self setColor: MenuBarProperties menuBarColor
					borderWidth: 1
					borderColor: MenuBarProperties menuBarFrameColor.
! !

!PulldownMenuMorph methodsFor: 'layout' stamp: 'jlb 9/26/2001 23:48'!
doLayoutIn: aRect
	super doLayoutIn: aRect.
	cover ifNotNil: [ self setCoverBounds: ( self bounds ) ].
! !

!PulldownMenuMorph methodsFor: 'layout' stamp: 'jlb 9/27/2001 07:53'!
setCoverBounds: aRect 
	"adjust the rectangle based on the theme"
	| aBoundsRect menuTheme expandExtent |
	menuTheme _ MenuTheme current.
	menuTheme
		ifNil: [^ self].
	expandExtent _ (menuTheme menuTextOffset @ 0) abs + menuTheme menuFrameOffset abs.
	aBoundsRect _ aRect extendBy: expandExtent.
	aBoundsRect _ cover topLeft extent: aBoundsRect extent.
	cover bounds: aBoundsRect! !

!PulldownMenuMorph methodsFor: 'geometry' stamp: 'jlb 9/27/2001 01:22'!
position: aPoint 
	| workPoint menuTheme |
	menuTheme _ MenuTheme current.
	menuTheme
		ifNil: [^ super position: aPoint]
		ifNotNil: [workPoint _ aPoint translateBy: menuTheme menuTextOffset @ 0.
			super position: workPoint].
	cover
		ifNotNil: [workPoint _ aPoint translateBy: menuTheme menuFrameOffset.
			cover position: workPoint]! !

!PulldownMenuMorph methodsFor: 'submorphs-add/remove' stamp: 'jlb 9/23/2001 09:53'!
delete
	" take me off of the display and tell my user I'm through "
	self user owner removeEars.
	super delete.
	cover ifNotNil: [ cover delete.].
	self user ifNotNil: [ self user reset].! !


!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'jlb 9/25/2001 08:26'!
screenTopSetback
	" Don't overwrite menu bars up top "
	Smalltalk isMorphic
		ifTrue: [^ 16]
		ifFalse: [^ 18]! !

MenuBarProperties initialize!

!MenuBarProperties class reorganize!
('properties' menuBarColor menuBarColor: menuBarDisabledColor menuBarDisabledColor: menuBarEnabledColor menuBarEnabledColor: menuBarFont menuBarFont: menuBarFontSize menuBarFontSize: menuBarFrameColor menuBarFrameColor: menuBarHeight menuBarHeight: menuBarShowDropShadow menuBarShowDropShadow:)
('class initialization' initialize)
!


!MenuBarProperties reorganize!
('look in class' seeClassSide)
!


!MenuBarMorph class reorganize!
('example' example newExample newInstance)
!

"Postscript:
Initialize class"

MenuBarProperties initialize.!

