'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 1 March 2002 at 7:57:20 pm'!
"Change Set:		Luna Scrollbars
Date:			9 September 2001
Author:			Jim Benson

Adds for scroll bar styles

EXPERIMENTAL --

Squeak 3.1a-4332"!

ThemeBase subclass: #ButtonTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!
ThemeBase subclass: #ScrollBarTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!

!AlignmentMorph methodsFor: 'initialization' stamp: 'jlb 9/10/2001 14:38'!
initialize

	super initialize.
	borderWidth _ 0.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapCentering: #topLeft.
	self hResizing: #spaceFill.
	self vResizing: #spaceFill.
	self layoutInset: 2.
	color _ Color r: 0.8 g: 1.0 b: 0.8.
	self rubberBandCells: true. "default"
	self setProperty: #wantsActivate toValue: true .
! !

!AlignmentMorph methodsFor: 'activate / passivate' stamp: 'jlb 9/10/2001 14:54'!
activate
	" This is used for alignment morphs in SystemWindows ;
	  propogates activate message to submorphs which may be controls "
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m activate]]! !

!AlignmentMorph methodsFor: 'activate / passivate' stamp: 'jlb 9/10/2001 14:38'!
passivate
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m passivate]]! !


!Form class methodsFor: 'BMP file reading' stamp: 'jlb 8/26/2001 12:21'!
convertHorizontalBMPFileNamed: fileName noImages: noImages
" convert a horizontal bitmap to a vertical bitmap and send to file "
| form  fh fw copyRect newForm fName |
form _ Form fromFileNamed: fileName.
fh _ form height.
fw _ form width.
copyRect _ 0 @ 0 extent: ( fw / noImages @ fh ).

newForm _ Form extent: ( fw / noImages @ ( fh * noImages )) depth: ( form depth ).

0 to: noImages do: [ :i |
	newForm copy: (copyRect translateBy: (fw*i/noImages@0)) from: form to: (0@(i*fh)) rule: (Form over).
 ].

" Now prompt the user and write out the file "
	fName _ FillInTheBlank request:'Please enter converted file name' initialAnswer: self externalName,'.bmp'.
	fName isEmpty ifTrue:[^self].
	newForm writeBMPfileNamed: fName.
! !


!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/10/2001 14:19'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self setProperty: #wantsActivate toValue: true .
! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/9/2001 14:38'!
initializeDownButton
	ScrollBarTheme current
	ifNotNil: [ 
			downButton _
				bounds isWide ifTrue: [ ScrollBarTheme current newRightArrowButton ]
								ifFalse: [ ScrollBarTheme current newDownArrowButton. ].
			downButton bounds:	(self innerBounds bottomRight - self buttonExtent extent: self buttonExtent).
			downButton actWhen: #buttonDown ;
				target: self ;
				actionSelector: #scrollDownInit.
		]
	ifNil: [
	downButton := RectangleMorph
		newBounds: (self innerBounds bottomRight - self buttonExtent extent: self buttonExtent)
		color: Color lightGray.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	downButton addMorphCentered: (ImageMorph new image: 
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['right'] ifFalse: ['down']) 
			ifAbsentPut: [
				self upArrow8Bit
					rotateBy: (bounds isWide ifTrue: [#right] ifFalse: [#pi])
					centerAt: 0@0
			]
		)
	).
	downButton setBorderWidth: 1 borderColor: #raised.
	 ].
	self addMorph: downButton.! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/9/2001 21:38'!
initializeMenuButton
	"Preferences disable: #scrollBarsWithoutMenuButton"
	"Preferences enable: #scrollBarsWithoutMenuButton"
	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton)
		ifTrue: [^ self].
	ScrollBarTheme current
		ifNil: [menuButton _ RectangleMorph
						newBounds: (self innerBounds topLeft extent: self buttonExtent)
						color: Color lightGray.
			menuButton
				on: #mouseEnter
				send: #menuButtonMouseEnter:
				to: self.
			menuButton
				on: #mouseLeave
				send: #menuButtonMouseLeave:
				to: self.
			menuButton
				addMorphCentered: (RectangleMorph
						newBounds: (0 @ 0 extent: 4 @ 2)
						color: Color black).
			menuButton setBorderWidth: 1 borderColor: #raised]
		ifNotNil: [menuButton _ ScrollBarTheme current newMenuButton.
			menuButton
				bounds: (self innerBounds topLeft extent: self buttonExtent)].
	menuButton
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	self addMorph: menuButton! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/8/2001 01:23'!
initializePagingArea
	ScrollBarTheme current ifNotNil: [
		pagingArea _ ScrollBarTheme current newVerticalShaft.
		pagingArea bounds: ( self totalSliderArea ).
		pagingArea on: #mouseDown send: #scrollPageInit: to: self.
		pagingArea on: #mouseUp send: #finishedScrolling to: self.
		self addMorph: pagingArea.
	  ]
	ifNil: [
	pagingArea := RectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea ].! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/9/2001 13:13'!
initializeSlider
	self initializeMenuButton; initializeUpButton; initializeDownButton; initializePagingArea.
	ScrollBarTheme current
		ifNil: [super initializeSlider]
		ifNotNil: [self themeInitializeSlider]! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 9/9/2001 14:39'!
initializeUpButton
	ScrollBarTheme current
	ifNotNil: [ 
			upButton _ 
				bounds isWide ifTrue: [ ScrollBarTheme current newLeftArrowButton ]
								ifFalse: [ ScrollBarTheme current newUpArrowButton. ].
			upButton bounds: ((menuButton ifNil: [self innerBounds topLeft]
				ifNotNil: [bounds isWide ifTrue: [menuButton bounds topRight]
									ifFalse: [menuButton bounds bottomLeft]])
					extent: self buttonExtent).
			upButton actWhen: #buttonDown ;
				target: self ;
				actionSelector: #scrollUpInit.
			" upButton on: #mouseDown send: #scrollUpInit to: self.
			upButton on: #mouseUp send: #finishedScrolling to: self. "
		]
    ifNil: [
	upButton := RectangleMorph 
		newBounds: ((menuButton ifNil: [self innerBounds topLeft]
				ifNotNil: [bounds isWide ifTrue: [menuButton bounds topRight]
									ifFalse: [menuButton bounds bottomLeft]])
					extent: self buttonExtent)
		color: Color lightGray.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	upButton addMorphCentered: (ImageMorph new image:
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['left'] ifFalse: ['up'])
			ifAbsentPut: [
				bounds isWide ifTrue: [
					self upArrow8Bit rotateBy: #left centerAt: 0@0
				] ifFalse: [
					self upArrow8Bit
				]
			]
		)
	).
	upButton setBorderWidth: 1 borderColor: #raised. 
	].
	self addMorph: upButton
! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 2/20/2002 18:50'!
themeInitializeSlider
	slider _ 
	bounds isWide ifTrue: [ ScrollBarTheme current newHorizontalSlider ]
		ifFalse: [ ScrollBarTheme current newVerticalSlider].
	slider bounds: ( self totalSliderArea ).
	sliderShadow _ TranslucentImageMorph new.
	sliderShadow alpha: 64.
	sliderShadow bounds: self totalSliderArea.
	sliderShadow image: slider image.
	slider on: #mouseMove send: #scrollAbsolute: to: self ;
		on: #mouseDown send: #mouseDownInSlider: to: self ;
		on: #mouseUp send: #mouseUpInSlider: to: self.
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider ;
		computeSlider.
! !

!ScrollBar methodsFor: 'geometry' stamp: 'jlb 9/8/2001 07:12'!
buttonExtent
	ScrollBarTheme current ifNotNil: [
	^ ScrollBarTheme current arrowExtent ].

	^ bounds isWide
		ifTrue: [11 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 11]
! !

!ScrollBar methodsFor: 'geometry' stamp: 'jlb 9/8/2001 08:42'!
computeSlider
	| r grip sliderExtent gripExtent |
	r _ self roomToMove.
	self descending
		ifFalse:
			[slider position: (bounds isWide
				ifTrue: [r topLeft + ((r width * value) asInteger @ 0)]
				ifFalse: [r topLeft + (0 @ (r height * value)  asInteger)])]
		ifTrue:
			[slider position: (bounds isWide
				ifTrue:	[r bottomRight - ((r width * value) asInteger @ 0)]
				ifFalse:	[r bottomRight - ((0 @ (r height * value) asInteger))])].
	slider extent: self sliderExtent.
	" and reposition the grip if available "
	grip _ slider submorphNamed: #gripMorph 
		ifNone: [ ^self ].
	" reposition the grip moprh for the thumb "
	grip center: ( slider center ).
	" if the grip is larger than the thumb, don't show it "
	sliderExtent _ slider extent.
	gripExtent _ grip extent.
	( sliderExtent x > gripExtent x or: [sliderExtent y > gripExtent y] )
		ifTrue: [ grip show ]
		ifFalse: [ grip hide ].
	! !

!ScrollBar methodsFor: 'geometry' stamp: 'jlb 9/8/2001 23:56'!
scrollBarHeight "Includes border"
	ScrollBarTheme current ifNotNil: [ ^ ScrollBarTheme current arrowExtent y + 2].
	(Preferences valueOfFlag: #scrollBarsNarrow)
		ifTrue: [^ 12]
		ifFalse: [^ 16]! !

!ScrollBar methodsFor: 'geometry' stamp: 'jlb 9/8/2001 07:18'!
scrollBarWidth "Includes border"
	ScrollBarTheme current ifNotNil: [ ^ ScrollBarTheme current arrowExtent x + 2].
	(Preferences valueOfFlag: #scrollBarsNarrow)
		ifTrue: [^ 12]
		ifFalse: [^ 16]! !

!ScrollBar methodsFor: 'scrolling' stamp: 'jlb 9/8/2001 15:27'!
doScrollDown

	( downButton isKindOf: TwoModeButtonMorph )
	ifTrue: [
		" only scroll down when the button is in a pressed state "
		downButton isPressed ifFalse: [ ^ self ].
	 ].
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!ScrollBar methodsFor: 'scrolling' stamp: 'jlb 9/8/2001 15:26'!
doScrollUp
	( upButton isKindOf: TwoModeButtonMorph )
	ifTrue: [
		" only scroll down when the button is in a pressed state "
		upButton isPressed ifFalse: [ ^ self ].
	 ].
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!ScrollBar methodsFor: 'scrolling' stamp: 'jlb 9/8/2001 11:20'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	" reset the mouse button "
	(downButton isKindOf: TwoModeButtonMorph)
		ifTrue: ["set the action of the button to be mouseDown"
			downButton actWhen: #buttonDown;
				 target: self;
				 actionSelector: #scrollDownInit.
			upButton actWhen: #buttonDown;
				 target: self;
				 actionSelector: #scrollUpInit]
		ifFalse: [downButton borderRaised.
			upButton borderRaised]! !

!ScrollBar methodsFor: 'scrolling' stamp: 'jlb 9/9/2001 14:46'!
scrollDownInit
	(downButton isKindOf: TwoModeButtonMorph)
		ifTrue: ["set the action of the button to be mouseUp"
			downButton actWhen: #buttonUp;
				 target: self;
				 actionSelector: #finishedScrolling]
		ifFalse: [downButton borderInset].
	self scrollBarAction: #doScrollDown.
	self resetTimer.
	self startStepping! !

!ScrollBar methodsFor: 'scrolling' stamp: 'jlb 9/8/2001 11:23'!
scrollUpInit
	(upButton isKindOf: TwoModeButtonMorph)
		ifTrue: ["set the action of the button to be mouseUp"
			upButton actWhen: #buttonUp;
				 target: self;
				 actionSelector: #finishedScrolling]
		ifFalse: [upButton borderInset].
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 9/9/2001 21:25'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event].
	(menuButton isKindOf: ModeButtonMorph) ifTrue: [
		menuButton mouseUp: event.
	].! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 9/8/2001 16:38'!
mouseDownInSlider: event 
	(slider isKindOf: EdgeImageMorph)
		ifTrue: [slider
				valueOfProperty: #pressedImage
				ifPresentDo: [:pressedImage | slider image: pressedImage]].
	interval = 1.0
		ifTrue: ["make the entire scrollable area visible if a full scrollbar 
			is clicked on"
			self setValue: 0.
			self model hideOrShowScrollBar].
	super mouseDownInSlider: event! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 9/8/2001 15:19'!
mouseUpBalk: evt
	" the user released the mouse, but wasn't in the button that they started the mouse down in "
	self finishedScrolling.! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 9/8/2001 16:37'!
mouseUpInSlider: event
	( slider isKindOf: EdgeImageMorph ) ifTrue: [
		slider
			valueOfProperty: #normalImage
			ifPresentDo: [:normalImage | slider image: normalImage].
	 ].
	super mouseUpInSlider: event! !

!ScrollBar methodsFor: 'activate/passivate' stamp: 'jlb 9/10/2001 14:43'!
activate
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m activate]].
	slider show.! !

!ScrollBar methodsFor: 'activate/passivate' stamp: 'jlb 9/10/2001 14:43'!
passivate
	self
		submorphsDo: [:m | (m hasProperty: #wantsActivate)
				ifTrue: [m passivate]].
	slider hide.! !


!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:17'!
arrowExtent
	^ lookDictionary at: #arrowExtent! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:23'!
newDownArrowButton
	^ 	TwoModeButtonMorph new from4Images: (lookDictionary at: #downArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:18'!
newHorizontalSlider
	| toReturn copyRect thumbHeight hScrollGripMorph horizontalForm hScrollThumb hScrollGrip |

	hScrollThumb _ lookDictionary at: #hScrollThumb.
	hScrollGrip _ lookDictionary at: #hScrollGrip.

	hScrollThumb ifNil: [ ^ RectangleMorph new ].
	thumbHeight _ hScrollThumb height / 3.
	toReturn _ EdgeImageMorph new.

	copyRect _ 0@0 extent:  ( hScrollThumb width @ thumbHeight).
	horizontalForm _ hScrollThumb contentsOfArea: copyRect.
	toReturn image: horizontalForm.
	toReturn setProperty: #normalImage toValue: horizontalForm.
	" get the pressed image ; second image "
	copyRect _ 0@thumbHeight extent: ( hScrollThumb width @ thumbHeight).
	horizontalForm _ hScrollThumb contentsOfArea: copyRect.
	toReturn setProperty: #pressedImage toValue: horizontalForm.
	" the third image is the mouse over image  ; not used yet "
	copyRect _ 0@(thumbHeight*2) extent: ( hScrollThumb width @ thumbHeight).
	horizontalForm _ hScrollThumb contentsOfArea: copyRect.
	toReturn setProperty: #mouseOverImage toValue: horizontalForm.


	" now add the grip if applicable "
	hScrollGrip ifNotNil: [
		hScrollGripMorph _ ImageMorph new.
		hScrollGripMorph name: #gripMorph.
		hScrollGripMorph image: ( hScrollGrip contentsOfArea: ( 0 @ 0 extent: (self arrowExtent))). 
		toReturn addMorphCentered: hScrollGripMorph.
	 ].
	^ toReturn.! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:19'!
newLeftArrowButton
	^ 	TwoModeButtonMorph new from4Images: (lookDictionary at: #leftArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:19'!
newMenuButton
	
	^ TwoModeButtonMorph new from4Images: (lookDictionary at: #menuButtonForm).
	
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:19'!
newRightArrowButton
	^ 	TwoModeButtonMorph new from4Images: (lookDictionary at: #rightArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:20'!
newUpArrowButton
	^ 	TwoModeButtonMorph new from4Images: (lookDictionary at: #upArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/14/2001 20:57'!
newVerticalShaft
	| toReturn copyRect verticalForm vScrollShaft |

	vScrollShaft _ lookDictionary at: #vScrollShaft.

	toReturn _ EdgeImageMorph new.
	copyRect _ 0@0 extent: ( vScrollShaft width @ ( vScrollShaft height / 4 )).
	" copyRect _ copyRect translateBy: ( 0 @ ( (vScrollShaft height / 4 ) * 3 )).
	copyRect _ 0 @ 51 extent: ( 17 @ 17 ). "
	verticalForm _ vScrollShaft contentsOfArea: copyRect.
	toReturn image: verticalForm.
	^ toReturn.! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 12:16'!
newVerticalSlider
	| toReturn copyRect verticalForm vScrollGripMorph thumbHeight vScrollThumb  vScrollGrip |

	vScrollThumb _ lookDictionary at: #vScrollThumb.
	vScrollGrip _ lookDictionary at: #vScrollGrip.

	vScrollThumb ifNil: [ ^ RectangleMorph new ].
	thumbHeight _ vScrollThumb height / 3.
	toReturn _ EdgeImageMorph new.

	copyRect _ 0@0 extent: ( vScrollThumb width @ thumbHeight).
	verticalForm _ vScrollThumb contentsOfArea: copyRect.
	toReturn image: verticalForm.
	toReturn setProperty: #normalImage toValue: verticalForm.
	" get the pressed image ; second image "
	copyRect _ 0@thumbHeight extent: ( vScrollThumb width @ thumbHeight).
	verticalForm _ vScrollThumb contentsOfArea: copyRect.
	toReturn setProperty: #pressedImage toValue: verticalForm.
	" the third image is the mouse over image  ; not used yet "
	copyRect _ 0@(thumbHeight*2) extent: ( vScrollThumb width @ thumbHeight).
	verticalForm _ vScrollThumb contentsOfArea: copyRect.
	toReturn setProperty: #mouseOverImage toValue: verticalForm.


	" now add the grip if applicable "
	vScrollGrip ifNotNil: [
		vScrollGripMorph _ ImageMorph new.
		vScrollGripMorph name: #gripMorph.
		vScrollGripMorph image: ( vScrollGrip contentsOfArea: ( 0 @ 0 extent: (self arrowExtent))). 
		toReturn addMorphCentered: vScrollGripMorph.
	 ].
	^ toReturn.! !


!ScrollPane methodsFor: 'initialization' stamp: 'jlb 10/2/2001 14:47'!
initialize
	retractableScrollBar _ (Preferences valueOfFlag: #inboardScrollbars) not.
	scrollBarOnLeft _ (Preferences valueOfFlag: #scrollBarsOnRight) not.
	super initialize.
	hasFocus _ false.
	borderWidth _ 2.
	borderColor _ Color black.

	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar borderWidth: 1; borderColor: Color black.

	scroller := TransformMorph new color: Color transparent.
	scroller offset: -3@0.
	self addMorph: scroller.

	retractableScrollBar ifFalse: [self addMorph: scrollBar].

	self extent: 150@120.

	self setProperty: #wantsActivate toValue: true .
! !

!ScrollPane methodsFor: 'geometry' stamp: 'jlb 9/8/2001 11:04'!
scrollbarWidth  
	scrollBar ifNotNil: [ ^ scrollBar scrollBarWidth ].
	self inform: 'scrollBarWidth incorrectly called'.
	^ self.
! !

!ScrollPane methodsFor: 'activate / passivate' stamp: 'jlb 9/10/2001 14:26'!
activate
	scrollBar activate! !

!ScrollPane methodsFor: 'activate / passivate' stamp: 'jlb 9/10/2001 14:26'!
passivate
	scrollBar passivate! !


!SystemWindow methodsFor: 'top window' stamp: 'jlb 9/10/2001 14:31'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"

	| oldTop outerMorph sketchEditor pal |
	outerMorph _ self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock.
			" send activate to window frame and controls "
			(m hasProperty: #wantsActivate)
				ifTrue: [m activate]].
	" windowFrame ifNotNil: [ windowFrame activate ]. "
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		self labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor _ self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal _ self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 9/10/2001 14:30'!
passivate
	"Make me unable to respond to mouse and keyboard"
	model modelSleep.
	"Nothing responds to the keyboard or mouse"
	" send passivate to controls and window frame "
	self
		submorphsDo: [:m | m lock.
			(m hasProperty: #wantsActivate)
				ifTrue: [m passivate]].
	self world
		ifNotNil: ["clean damage now, so dont merge this rect with new top 
			window "
			self world == World
				ifTrue: [self world displayWorld]]! !


!TwoWayScrollPane methodsFor: 'geometry' stamp: 'jlb 9/8/2001 23:58'!
resizeScrollBar
	"used to handle left vs right scrollbar"
	yScrollBar bounds: (bounds topLeft extent: (self scrollbarWidth: yScrollBar) @ (bounds height - (self scrollbarHeight: xScrollBar))).
	xScrollBar bounds: ((bounds left + (self scrollbarWidth: yScrollBar)) @ (bounds bottom - (self scrollbarHeight: xScrollBar))  extent: (bounds width - (self scrollbarWidth: yScrollBar)) @ (self scrollbarHeight: xScrollBar)).
! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'jlb 9/8/2001 23:55'!
scrollbarHeight: aScrollBar 
	aScrollBar ifNotNil: [ ^ aScrollBar scrollBarHeight ].
	self inform: 'scrollBarWidth incorrectly called'.
	^ self.
! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'jlb 9/8/2001 23:55'!
scrollbarWidth: aScrollBar 
	aScrollBar ifNotNil: [ ^ aScrollBar scrollBarWidth ].
	self inform: 'scrollBarWidth incorrectly called'.
	^ self.
! !


!ScrollBarTheme reorganize!
('as yet unclassified' arrowExtent newDownArrowButton newHorizontalSlider newLeftArrowButton newMenuButton newRightArrowButton newUpArrowButton newVerticalShaft newVerticalSlider)
!

"Postscript:
Set a Luna style scroll bar as the current scroll bar style"
!

