'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 1 March 2002 at 7:53:57 pm'!
TwoModeButtonMorph subclass: #TabButtonMorph
	instanceVariableNames: 'value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
TabButtonMorph subclass: #PluggableTabButtonMorph
	instanceVariableNames: 'model label getStateSelector getLabelSelector getMenuSelector shortcutCharacter askBeforeChanging showSelectionFeedback '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
EdgeImageMorph subclass: #TabPanelMorph
	instanceVariableNames: 'pages currentPage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!
TabPanelMorph subclass: #InvisibleTabPanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!Browser methodsFor: 'initialize-release' stamp: 'jlb 2/17/2002 00:04'!
addAListPane: aListPane to: window at: nominalFractions plus: verticalOffset

	| row switchHeight divider |

	row _ AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		layoutPolicy: ProportionalLayout new.
	switchHeight _ 24.

	row 
		addMorph: aListPane
		fullFrame: (
			LayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@0 corner: 0@switchHeight negated)
		).	
	divider _ BorderedSubpaneDividerMorph forTopEdge.
	Preferences alternativeWindowLook ifTrue:[
		divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	].
	row 
		addMorph: divider
		fullFrame: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@switchHeight negated corner: 0@(1-switchHeight))
		).	

	self 
		addMorphicSwitchesTo: row 
		at: (
			LayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (-1@(1-switchHeight-2)  corner: 1@2)
		).

	window 
		addMorph: row
		fullFrame: (
			LayoutFrame 
				fractions: nominalFractions 
				offsets: (0@verticalOffset corner: 0@0)
		).	
	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.

! !

!Browser methodsFor: 'initialize-release' stamp: 'jlb 2/17/2002 00:06'!
buildMorphicSwitches

	| instanceSwitch commentSwitch classSwitch panel |


	panel _  TabPanelMorph newInstance.
	panel image: ButtonTheme current tabPanelFormNoBorder.
	
	instanceSwitch _ PluggableTabButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		actWhen: #buttonUp.

	commentSwitch _ PluggableTabButtonMorph
		on: self
		getState: #classCommentIndicated
		action: #plusButtonHit.
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		actWhen: #buttonUp.

	classSwitch _ PluggableTabButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		actWhen: #buttonUp.

	panel addTransparentSpacerOfSize: 2@2.

	" add the tabs to the tab panel. "
	{instanceSwitch. commentSwitch. classSwitch} do: [:m | 
		panel addMorphBack: m. ].

	instanceSwitch state: #on.

 	^ panel.! !


!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/16/2001 18:12'!
tabEdges
	^ lookDictionary at: #tabEdges ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/16/2001 18:11'!
tabForm
	^ lookDictionary at: #tabForm ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/16/2001 18:56'!
tabPanelEdges
	^ lookDictionary at: #tabPanelEdges ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/16/2001 18:56'!
tabPanelForm
	^ lookDictionary at: #tabPanelForm ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/21/2001 08:21'!
tabPanelFormNoBorder
	^ lookDictionary at: #tabPanelFormNoBorder ifAbsent: [ ^ nil ].! !

!ButtonTheme methodsFor: 'accessors' stamp: 'jlb 9/18/2001 21:54'!
tabPanelLayoutInset
	^ lookDictionary at: #tabPanelLayoutInset ifAbsent: [ ^ nil ].! !


!TabButtonMorph methodsFor: 'events-processing' stamp: 'jlb 9/18/2001 21:29'!
adjustState: evt
	"while pressed, only show the pressed image while the hand is still over the button"

	| desiredState |
     desiredState _ (self containsPoint: evt cursorPoint)
		ifTrue: [ #pressed ]
		ifFalse: [ self value ifTrue: [ #on ] ifFalse: [#off] ].

     (self state ~= desiredState) ifTrue: [ self state: desiredState. self changed ].! !

!TabButtonMorph methodsFor: 'events-processing' stamp: 'jlb 10/3/2001 11:39'!
mouseEnterEvent: evt for: aMorph 
	value
		ifTrue: [^ self].
	self state: #mouseOver! !

!TabButtonMorph methodsFor: 'events-processing' stamp: 'jlb 10/3/2001 11:39'!
mouseLeave: evt 
	super mouseLeave: evt.
	value
		ifTrue: [^ self].
	self state: #off! !

!TabButtonMorph methodsFor: 'events-processing' stamp: 'jlb 9/18/2001 21:30'!
mouseUp: event

	disabled ifTrue: [ ^ self ].
	active ifFalse: [^ self].
	(self containsPoint: event cursorPoint)
		ifTrue: ["Allow on:send:to: to set the response to events 
					other  
					than actWhen"
			self value ifTrue: [ self state: #on. ]
				ifFalse: [ self value: true.
				self state: #on.
			actWhen == #buttonUp
				ifTrue: [ self doButtonAction: event]
				ifFalse: [ " Morph>>mouseDown: ; this is useful if you need to get a hold of the event "
								  super mouseUp: event]]]
		ifFalse: [
				self value ifTrue: [ self state: #on ]
						  ifFalse: [ self state: #off ].
				target
					ifNotNil: [target mouseUpBalk: event].
					self cursorReset]! !

!TabButtonMorph methodsFor: 'events-processing' stamp: 'jlb 10/11/2001 23:37'!
state: aStateSymbol 
	"Change the image and invalidate the rect."

	| symbol |
	state := aStateSymbol.
	symbol _ nil.
	(disabled or: [active not]) 
		ifTrue: [symbol := value ifTrue: [#disabledSelected] ifFalse: [#disabled]]
		ifFalse: 
			[state caseOf: { 
						[#pressed] -> [symbol := #pressed].
						[#off] -> 
								[value := false.
								symbol := value ifTrue: [#selected] ifFalse: [#normal]].
						[#on] -> 
								[value := true.
								symbol := #selected.
								(self owner isKindOf: TabPanelMorph) ifTrue: [self owner select: self]].
						[#mouseOver] -> [symbol := #disabledSelected]}].
	self image: (forms at: symbol)! !

!TabButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/24/2001 13:14'!
fromImages: buttonImages 
	"assume that there are 5 buttons vertically stacked"

	self fromImages: buttonImages symbols: #( #normal #selected #pressed #disabled #disabledSelected ).
	self state: #off.! !

!TabButtonMorph methodsFor: 'initialization' stamp: 'jlb 10/7/2001 23:52'!
initialize
	super initialize.
	value _ false.
	self layoutPolicy: ProportionalLayout new.
	self clipLayoutCells.
	self extent: ( 70 @ 24 ).
	self minimumExtent: 24@20.
	self on: #mouseEnter send: #mouseEnterEvent:for: to: self.
	self clipSubmorphs: true.
! !

!TabButtonMorph methodsFor: 'geometry' stamp: 'jlb 1/9/2002 22:02'!
nominalExtent
	| labelString |
	labelString _ self submorphNamed: #label.
	labelString
		ifNil: [^ 28 @ 24].
	^ labelString measureContents x + 16 @ 24! !

!TabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/16/2001 18:03'!
value
	^ value! !

!TabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/18/2001 21:18'!
value: aBoolean
	value _ aBoolean.
! !

!TabButtonMorph methodsFor: 'label' stamp: 'jlb 10/8/2001 00:06'!
label
	" return the contents of the label StringMorph "
	(self submorphNamed: #label)
		ifNotNilDo: [:m | ^ m contents]! !

!TabButtonMorph methodsFor: 'label' stamp: 'jlb 10/8/2001 00:06'!
label: aString 
	" reset the label; nil means use the standard fonts "
	self label: aString font: nil.
! !

!TabButtonMorph methodsFor: 'label' stamp: 'jlb 10/11/2001 23:36'!
label: aString font: aFontOrNil 
	" Get rid of the old label "

	| label font theme |
	(self submorphNamed: #label) ifNotNilDo: [:oldLabel | oldLabel delete].
	" figure out the correct font "
	font _ aFontOrNil.
	font ifNil: 
			[theme := ButtonTheme current.
			font := theme ifNil: [Preferences standardButtonFont]
						ifNotNil: [theme systemFont]].
	" create the label string "
	label := StringMorph contents: aString font: font.
	label name: #label.
	label layoutFrame: (LayoutFrame fractions: (0.5 @ 0.5 corner: 0.5 @ 0.5)
				offsets: (0 @ 0 corner: 0 @ 0)).
	self addMorph: label.
	label lock.
	self extent: self nominalExtent! !

!TabButtonMorph methodsFor: 'label' stamp: 'jlb 10/8/2001 00:06'!
setLabel
	| newLabel |
	newLabel _ FillInTheBlank request: 'Enter a new label for this button' initialAnswer: self label.
	newLabel isEmpty
		ifFalse: [self label: newLabel font: nil]! !

!TabButtonMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/8/2001 15:57'!
activate
	super activate.	
	( self submorphNamed: #label ) color: ( ButtonTheme current enabledTextColor ).! !

!TabButtonMorph methodsFor: 'activate / passivate' stamp: 'jlb 10/8/2001 15:57'!
passivate
	super passivate.
	( self submorphNamed: #label ) color: ( ButtonTheme current disabledTextColor ).! !

!TabButtonMorph methodsFor: 'rotate' stamp: 'jlb 9/17/2001 20:22'!
rotateBy: deg 
	| symbols |
	symbols _ #(#normal #selected #pressed #disabled #disabledSelected ).
	symbols
		do: [:aSymbol | forms
				at: aSymbol
				put: ((forms at: aSymbol)
						rotateBy: deg)].
	image _ nil.
	self state: ( self state ).
	self extent: self nominalExtent.
! !


!PluggableTabButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/21/2001 11:20'!
initialize

 	super initialize.
	model _ nil.
	label _ nil.
	getStateSelector _ nil.
	actionSelector _ nil.
	getLabelSelector _ nil.
	getMenuSelector _ nil.
	shortcutCharacter _ nil.
	askBeforeChanging _ false.
! !

!PluggableTabButtonMorph methodsFor: 'initialization' stamp: 'jlb 9/21/2001 11:51'!
on: anObject getState: getStateSel action: actionSel label: labelSel menu: menuSel

	self model: anObject.
	getStateSelector _ getStateSel.
	actionSelector _ actionSel.
	getLabelSelector _ labelSel.
	getMenuSelector _ menuSel.
	self update: labelSel.
! !

!PluggableTabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/21/2001 11:21'!
askBeforeChanging

	^ askBeforeChanging
! !

!PluggableTabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/21/2001 11:21'!
askBeforeChanging: aBoolean
	"If this preference is turned on, then give the model an opportunity to ask the user before accepting a change that might cause unaccepted edits to be lost."

	askBeforeChanging _ aBoolean.
! !

!PluggableTabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/21/2001 12:09'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model _ anObject.
	target _ anObject.
! !

!PluggableTabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/21/2001 11:22'!
shortcutCharacter
	"Return the Character to be used as a shortcut to turn on this switch, or nil if this switch doesn't have a keyboard shortcut."

	^ shortcutCharacter
! !

!PluggableTabButtonMorph methodsFor: 'accessing' stamp: 'jlb 9/21/2001 11:22'!
shortcutCharacter: aCharacter 
	"Set the character to be used as a keyboard shortcut for turning on this switch."

	shortcutCharacter _ aCharacter.
! !

!PluggableTabButtonMorph methodsFor: 'private' stamp: 'jlb 10/12/2001 00:58'!
getModelState
	"Answer the result of sending the receiver's model the getStateSelector message."

	getStateSelector ifNotNil: [^model perform: getStateSelector].
	^ false.! !


!TabButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 9/24/2001 13:13'!
newInstance
	| toReturn |
	toReturn _ self new.
	toReturn fromImages:  (ButtonTheme current tabForm).
	toReturn setEdges: ( ButtonTheme current tabEdges ). 
	^ toReturn.! !


!PluggableTabButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/21/2001 11:29'!
on: anObject

	^ self on: anObject getState: #isOn action: #switch
! !

!PluggableTabButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 9/21/2001 11:29'!
on: anObject getState: getStateSel action: actionSel

	^ self newInstance
		on: anObject
		getState: getStateSel
		action: actionSel
		label: nil
		menu: nil
! !

!PluggableTabButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 9/21/2001 11:29'!
on: anObject getState: getStateSel action: actionSel label: labelSel

	^ self newInstance
		on: anObject
		getState: getStateSel
		action: actionSel
		label: labelSel
		menu: nil
! !

!PluggableTabButtonMorph class methodsFor: 'instance creation' stamp: 'jlb 9/21/2001 11:29'!
on: anObject getState: getStateSel action: actionSel label: labelSel menu: menuSel

	^ self newInstance
		on: anObject
		getState: getStateSel
		action: actionSel
		label: labelSel
		menu: menuSel
! !


!TabPanelMorph methodsFor: 'tab selection' stamp: 'jlb 9/18/2001 21:20'!
select: aTabMorph 

	self
		submorphsDo: [:tab |
			( tab isKindOf: TabButtonMorph )
				ifTrue: [tab ~= aTabMorph
						ifTrue: [tab state: #off]]] ! !

!TabPanelMorph methodsFor: 'accessing' stamp: 'jlb 10/6/2001 19:29'!
currentPage
	^ currentPage! !

!TabPanelMorph methodsFor: 'accessing' stamp: 'jlb 10/6/2001 19:29'!
pages
	^ pages! !

!TabPanelMorph methodsFor: 'initialization' stamp: 'jlb 9/21/2001 08:36'!
activate
	self
		submorphsDo: [:m | 
				m unlock.
				(m
					valueOfProperty: #wantsActivate
					ifAbsent: [false])
				ifTrue: [m activate]]! !

!TabPanelMorph methodsFor: 'initialization' stamp: 'jlb 2/20/2002 14:54'!
initialize
	super initialize.
	pages _ Dictionary new.
	currentPage _ nil.
	self layoutPolicy: TableLayout new ;
		listDirection: #leftToRight ;
		wrapDirection: #none ;
		wrapCentering: #bottomRight ;
		setProperty: #wantsActivate toValue: true.
	self on: #mouseDown send: #mouseDown: to: self. 
! !

!TabPanelMorph methodsFor: 'initialization' stamp: 'jlb 9/21/2001 08:36'!
passivate

	self submorphsDo: [ :m |
			( m valueOfProperty: #wantsActivate ifAbsent: [ false ] )
			ifTrue: [ m passivate ].
		].
	" self lockInactivePortions. "! !


!InvisibleTabPanelMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/6/2001 15:50'!
drawOn: aCanvas! !


!TabPanelMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/18/2001 21:55'!
newInstance
	| toReturn |
	toReturn _ self new.
	toReturn image:  (ButtonTheme current tabPanelForm).
	toReturn setEdges: ( ButtonTheme current tabPanelEdges ).
	ButtonTheme current tabPanelLayoutInset ifNotNilDo: [ :layoutInset | toReturn layoutInset: layoutInset ].
	^ toReturn.! !


!TabPanelMorph reorganize!
('tab selection' select:)
('accessing' currentPage pages)
('initialization' activate initialize passivate)
('events-processing' mouseDown:)
!


!TabButtonMorph class reorganize!
('instance creation' newInstance)
!


!PluggableTabButtonMorph reorganize!
('initialization' initialize on:getState:action:label:menu:)
('accessing' askBeforeChanging askBeforeChanging: model: shortcutCharacter shortcutCharacter:)
('private' getModelState)
('updating' update:)
!


!TabButtonMorph reorganize!
('events-processing' adjustState: mouseEnterEvent:for: mouseLeave: mouseUp: state:)
('initialization' fromImages: initialize)
('geometry' nominalExtent)
('accessing' value value:)
('label' label label: label:font: setLabel)
('activate / passivate' activate passivate)
('rotate' rotateBy:)
('event handling' mouseDown:)
!

