'From Squeak3.2gamma[BC] of 15 January 2002 [latest update: #4743] on 1 March 2002 at 8:23:15 am'!
"Change Set:		WindowFrames
Date:			20 April 2002
Author:			Jim Benson

Adds custom shaped window surrounds and resizing frames to SystemWindows


File in changeset.
Preferences:
Window corner rounding should be off.
Looks better with inboard scroll bars.

Squeak 3.2g - 4743
"!

RectangleMorph subclass: #DefaultFrameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!
EdgeImageMorph subclass: #FrameEdgeImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!
Object subclass: #ThemeBase
	instanceVariableNames: 'themeName lookDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!

!ThemeBase commentStamp: 'jlb 2/23/2002 09:04' prior: 0!
This class is a helper class for generating accessors of theme based dictionaries!

ThemeBase class
	instanceVariableNames: 'current themes '!
PolygonMorph subclass: #WindowBorderCornerMorph
	instanceVariableNames: 'cursorName obvious '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!

!WindowBorderCornerMorph commentStamp: '<historical>' prior: 0!
I represent the edge or corner of a window frame.

When the mouse enter me, I have a cursor associated shape that I change the cursor to.

When the user clicks and drags on me, I resize my owner appropriately.
!

BorderedMorph subclass: #WindowBorderMorph
	instanceVariableNames: 'cursorName obvious '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!

!WindowBorderMorph commentStamp: '<historical>' prior: 0!
I represent the edge or corner of a window frame.

When the mouse enter me, I have a cursor associated shape that I change the cursor to.

When the user clicks and drags on me, I resize my owner appropriately.
!

AbstractWindowFrame subclass: #WindowFrameMorph
	instanceVariableNames: 'labelString labelFontColor growExtent drawBlock topLeftInset bottomRightInset frameColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!

!WindowFrameMorph commentStamp: '<historical>' prior: 0!
WindowFrameMorph is a testbed for some window frame ideas

The WindowFrameMorph is initialized with 8 WindowBorderMorphs which represent the 4 corners and 4 sides of the frame. t

Instance variables:

	growExtent		-- A Point that represents the extent of each corner; 
						note that these need not be the same size!

WindowFrameMorph subclass: #WindowFrameImagedMorph
	instanceVariableNames: 'theme '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!
WindowFrameMorph class
	instanceVariableNames: ''!
ThemeBase subclass: #WindowTheme
	instanceVariableNames: 'leftWidth topHeight rightWidth bottomHeight '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!

!WindowTheme commentStamp: 'jlb 2/23/2002 09:05' prior: 0!
I represent the elements of a window theme, which includes all of the different images and layout settings of window decorations!

WindowTheme class
	instanceVariableNames: ''!
Morph subclass: #WindowTitleMorph
	instanceVariableNames: 'title '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!

!DefaultFrameMorph methodsFor: 'drawing' stamp: 'jlb 8/19/2001 16:23'!
drawOn: aCanvas 
	"solid color border"
	"fillStyle doesn't do what I want here ; draw the label and the rest of  
	the border"
	| aPaneRect myBounds aFrameRectangle aBorder aFrameColor |
	aFrameColor _ owner frameColor.
	aPaneRect _ owner paneInset.
	aFrameColor _ owner frameColor.
	myBounds _ self bounds.
	aFrameRectangle _ Rectangle origin: myBounds origin + (0 @ aPaneRect top) corner: myBounds corner.
	myBounds _ myBounds bottom: myBounds top + aPaneRect top + 2.
	owner window isCollapsed ifFalse: [
	aCanvas
		fillRectangle: (myBounds insetBy: borderWidth)
		fillStyle: self fillStyle.
	"left border"
	aBorder _ Rectangle origin: aFrameRectangle origin extent: aPaneRect left + 1 @ aFrameRectangle height.
	aCanvas fillRectangle: aBorder color: aFrameColor.
	( owner active and: [ Preferences alternativeWindowLook not ] )
		ifTrue: [aCanvas
				line: aBorder topRight - (1 @ -1)
				to: aBorder bottomRight - (1 @ 1)
				color: aFrameColor dansDarker]. 
	"right border"
	aBorder _ Rectangle origin: aFrameRectangle topRight - (aPaneRect right + 1 @ 0) corner: aFrameRectangle corner.
	aCanvas fillRectangle: aBorder color: aFrameColor.
	( owner active and: [ Preferences alternativeWindowLook not ] )
		ifTrue: [aCanvas
				line: aBorder origin + (0 @ 1)
				to: aBorder bottomLeft - ( 0 @ 1 )
				color: aFrameColor twiceLighter]. 
	"bottom border"
	aBorder _ Rectangle origin: aFrameRectangle bottomLeft - (0 @ (aPaneRect bottom + 1)) corner: aFrameRectangle corner.
	aCanvas fillRectangle: aBorder color: aFrameColor.
	( owner active and: [ Preferences alternativeWindowLook not ] )
		ifTrue: [aCanvas
				line: aBorder origin + (aPaneRect left + 1 @ 0)
				to: aBorder topRight - (aPaneRect right + 1 @ 0)
				color: aFrameColor twiceLighter]]
	ifTrue: [ 
			aCanvas
		fillRectangle: (bounds insetBy: borderWidth)
		fillStyle: self fillStyle.
]. 
	aCanvas
		frameAndFillRectangle: bounds
		fillColor: Color transparent
		borderWidth: borderWidth
		borderColor: borderColor! !

!DefaultFrameMorph methodsFor: 'rounding' stamp: 'jlb 8/5/2001 13:07'!
roundedCorners
	"Return a list of those corners to round"
	^#(1  4) "top corners"! !

!DefaultFrameMorph methodsFor: 'initialize' stamp: 'jlb 8/5/2001 14:47'!
initialize
	super initialize.
	self toggleCornerRounding. 
	self borderWidth: 1.
	self borderColor: Color black.
! !

!DefaultFrameMorph methodsFor: 'top window' stamp: 'jlb 8/5/2001 21:11'!
activate

	| aFrameColor fill |
	aFrameColor _ owner frameColor.
	self color: aFrameColor.
	fill _ GradientFillStyle ramp: {0.0 -> aFrameColor twiceLighter. 1.0 -> aFrameColor}.
	fill origin: self topLeft.
	fill direction: 0 @ 5.
	fill radial: false.
	self fillStyle: fill.
! !

!DefaultFrameMorph methodsFor: 'top window' stamp: 'jlb 8/5/2001 14:00'!
passivate
	self color: owner frameColor.! !


!FrameEdgeImageMorph methodsFor: 'activate/passivate' stamp: 'jlb 8/7/2001 21:16'!
activate
	self
		valueOfProperty: #activeImage
		ifPresentDo: [:activeImage | self image: activeImage].
! !

!FrameEdgeImageMorph methodsFor: 'activate/passivate' stamp: 'jlb 8/7/2001 21:16'!
passivate
	self
		valueOfProperty: #inactiveImage
		ifPresentDo: [:inactiveImage | self image: inactiveImage].
! !

!FrameEdgeImageMorph methodsFor: 'initialization' stamp: 'jlb 8/7/2001 21:19'!
initialize
	super initialize.
	self setProperty: #wantsActivate toValue: true .
! !


!SystemWindow methodsFor: 'initialization' stamp: 'jlb 9/13/2001 20:40'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	| oldStyle |
	super initialize.
	allowReframeHandles _ true.
	labelString
		ifNil: [labelString _ 'Untitled Window'].
	isCollapsed _ false.
	activeOnlyOnTop _ true.
	paneMorphs _ Array new.
	Preferences alternativeWindowLook ifFalse:[
		borderColor _ Color black.
		borderWidth _ 1.
		color _ Color black.
	] ifTrue:[
		borderColor _ #raised.
		borderWidth _ 2.
		color _ Color white.
	].
	self layoutPolicy: ProportionalLayout new.
	self
		layoutInset: (0 @ 16 corner: 0 @ 0).
	oldStyle _ false. 
	windowFrame _ oldStyle
				ifTrue: [SqueakWindowFrame defaultWindowFrame: self]
				ifFalse: [WindowFrameImagedMorph defaultWindowFrame: self].
	self extent: 300 @ 200.
	mustNotClose _ false.
	updatablePanes _ Array new! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 2/21/2002 21:40'!
getRawLabel
	^ self windowFrame label firstSubmorph! !


!ThemeBase methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:01'!
buildAccessors
	lookDictionary keys do: [ :aKey | 
	Transcript show: '!!'; show: ( self class printString ) .
	Transcript show: ' methodsFor: #accessors stamp: ' ;
		show: Utilities changeStamp printString ; show: '!!' ; cr.
		Transcript show: ( aKey asString  ) ; cr ;
			show: '  ^ ' ; show: 'lookDictionary at: ' ; show: ( aKey printString) ; 
			show: ' ifAbsent: [ nil ]' ; show: '!! !!' ; cr ; cr ].
! !

!ThemeBase methodsFor: 'accessors' stamp: 'jlb 9/12/2001 20:24'!
lookDictionary
	^ lookDictionary! !

!ThemeBase methodsFor: 'accessors' stamp: 'jlb 9/12/2001 20:25'!
lookDictionary: aDictionary
	lookDictionary _ aDictionary! !

!ThemeBase methodsFor: 'accessors' stamp: 'jlb 2/25/2002 11:13'!
name: aString
	" this is a synonym for themeName: ; seperated out in case of a conflict with the more generic name ivar "
	self themeName: aString.! !

!ThemeBase methodsFor: 'accessors' stamp: 'jlb 2/25/2002 11:09'!
themeName
	^ themeName! !

!ThemeBase methodsFor: 'accessors' stamp: 'jlb 2/25/2002 11:08'!
themeName: aString
	themeName _ aString.! !

!ThemeBase methodsFor: 'initialization' stamp: 'jlb 9/12/2001 20:36'!
initialize
	lookDictionary _ Dictionary new.! !


!ThemeBase class methodsFor: 'themes' stamp: 'jlb 2/25/2002 11:09'!
addTheme: aTheme 
	| currentName |
	current
		ifNotNil: [currentName _ current name].
	self themes at: aTheme themeName put: aTheme.
	currentName
		ifNil: [^ self].
	aTheme name = currentName
		ifTrue: [self current: aTheme]! !

!ThemeBase class methodsFor: 'themes' stamp: 'jlb 2/25/2002 11:01'!
deleteTheme: aTheme 
	self themes removeKey: aTheme name! !

!ThemeBase class methodsFor: 'themes' stamp: 'jlb 2/25/2002 11:04'!
themeNamed: aString
	^ self themes at: aString ifAbsent: [ nil ].! !

!ThemeBase class methodsFor: 'themes' stamp: 'jlb 2/25/2002 10:57'!
themes
	themes ifNil: [ themes _ Dictionary new ].
	^ themes.! !

!ThemeBase class methodsFor: 'themes' stamp: 'jlb 2/25/2002 10:58'!
themes: aDictionary
	themes _ aDictionary! !

!ThemeBase class methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 15:38'!
current
	^ current! !

!ThemeBase class methodsFor: 'as yet unclassified' stamp: 'jlb 9/13/2001 15:38'!
current: aTheme
	current _ aTheme.! !

!ThemeBase class methodsFor: 'as yet unclassified' stamp: 'jlb 9/15/2001 20:16'!
readFormAndFix: aFileNameString replaceColor: aColor 
	"read a Form from a file and replace aColor with Color transparent"
	| aForm |
	aForm _ Form fromFileNamed: aFileNameString.
	aForm depth < 16
		ifTrue: [aForm _ aForm asFormOfDepth: 32].
	aForm replaceColor: aColor withColor: Color transparent.
	^ aForm! !

!ThemeBase class methodsFor: 'as yet unclassified' stamp: 'jlb 9/15/2001 20:22'!
readFormXlateMagenta: aFileName
	^ self readFormAndFix: aFileName replaceColor: Color magenta! !


!WindowBorderCornerMorph methodsFor: 'geometry' stamp: 'jlb 10/13/2001 13:36'!
calculateOffset: aPoint 
	"return the offset from aPoint to the edge of the owners  
	bounding rectangle"
	"The result is keyed by the name of the edge, which is also the  
	known name of this morph"

	| nameArray offsetPt symbolName |
	nameArray _ #(#topLeft #topRight #bottomLeft #bottomRight ).
	"place the handle centered at the cursor hotspot"
	offsetPt _ 0 @ 0.
	"calculate the offset in x and y coordinates from the cursor point 
	to the  
	realignment edge"
	symbolName _ self knownName asSymbol.
	(nameArray includes: symbolName)
		ifTrue: ["calculate the offset to the corner"
			offsetPt _ (owner bounds perform: symbolName)
						- aPoint]
		ifFalse: ["one of the real edges"
			offsetPt _ (#(#left #right ) includes: symbolName)
						ifTrue: [(owner bounds perform: symbolName)
								@ aPoint y]
						ifFalse: ["assume here the edge is either #bottom  
							and #top"
							aPoint x
								@ (owner bounds perform: symbolName)].
			offsetPt _ offsetPt - aPoint].
	^ offsetPt! !

!WindowBorderCornerMorph methodsFor: 'geometry' stamp: 'jlb 2/24/2002 11:11'!
doFastWindowReframe: ptName offset: offsetPt

	| newBounds |
	"For fast display, only higlight the rectangle during loop"
	newBounds _ owner bounds newRectButtonPressedDo: [:f | 
		f 
			withSideOrCorner: ptName
			setToPoint: (self pointFromWorld: (Sensor cursorPoint+offsetPt))
			minExtent: owner windowMinimumExtent].
	owner setWindowBounds: newBounds.
	self mouseLeave: nil.
! !

!WindowBorderCornerMorph methodsFor: 'geometry' stamp: 'jlb 7/17/2001 15:20'!
fastFramingOn

	^ Preferences fastDragWindowForMorphic ! !

!WindowBorderCornerMorph methodsFor: 'access' stamp: 'jlb 7/17/2001 13:29'!
cursorName
	^ cursorName
! !

!WindowBorderCornerMorph methodsFor: 'access' stamp: 'jlb 7/17/2001 13:30'!
cursorName: aSymbol
	cursorName _ aSymbol
! !

!WindowBorderCornerMorph methodsFor: 'access' stamp: 'jlb 7/17/2001 21:07'!
obvious
	" This ivar controls display of the morph "
	^ obvious! !

!WindowBorderCornerMorph methodsFor: 'access' stamp: 'jlb 7/17/2001 21:07'!
obvious: aBoolean
	" This ivar controls display of the morph "
	obvious _ aBoolean.
! !

!WindowBorderCornerMorph methodsFor: 'drawing' stamp: 'jlb 7/17/2001 21:08'!
drawOn: aCanvas
	obvious ifTrue: [ super drawOn: aCanvas ].! !

!WindowBorderCornerMorph methodsFor: 'event handling' stamp: 'jlb 4/20/2002 21:06'!
mouseDown: event 
	"calculate the offset from the cursor point to the edge of the 
	owner bounds"
	| resizer localPt newBounds symbolName offsetPt |
	symbolName _ self knownName.
	offsetPt _ self calculateOffset: event cursorPoint.
	self fastFramingOn
		ifTrue: [^ self doFastWindowReframe: symbolName offset: offsetPt].
	resizer _ NewHandleMorph new.
	resizer color: Color transparent;
		 borderWidth: 0.
	resizer position: event cursorPoint - (resizer extent / 2).
	"set up the follow block"
	resizer
		followHand: event hand
		forEachPointDo: [:p | 
			localPt _ self pointFromWorld: p.
			newBounds _ owner bounds
						withSideOrCorner: symbolName
						setToPoint: localPt + offsetPt
						minExtent: owner windowMinimumExtent.
			newBounds = owner bounds
				ifFalse: [owner setWindowBounds: newBounds]]
		lastPointDo: [:p | "check to make sure that we're still in the frame border"
			(self containsPoint: p)
				ifFalse: [self mouseLeave: nil].
				self stop].
	"place the resizer into the worlds top layer"
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!WindowBorderCornerMorph methodsFor: 'event handling' stamp: 'jlb 7/17/2001 13:35'!
mouseEnter: event
	cursorName
		ifNotNil: [(Cursor perform: cursorName) beCursor]! !

!WindowBorderCornerMorph methodsFor: 'event handling' stamp: 'jlb 7/16/2001 22:23'!
mouseLeave: event
	
	Cursor normal beCursor.
! !

!WindowBorderCornerMorph methodsFor: 'event handling' stamp: 'jlb 7/16/2001 22:24'!
mouseUp: event! !

!WindowBorderCornerMorph methodsFor: 'initialization' stamp: 'jlb 2/8/2002 00:31'!
initialize
	super initialize.
	cursorName _ #normal.
	" the resize edges are not obvious (visible) "
	obvious _ false.
	" This is a resizer part of the window frame "
	self setProperty: #resizer toValue: true ;
		on: #mouseEnter send: #mouseEnter: to: self ;
		on: #mouseLeave send: #mouseLeave: to: self ;
		on: #mouseDown send: #mouseDown: to: self ;
		on: #mouseUp send: #mouseUp: to: self.
	self setProperty: #morphicLayerNumber toValue: 20.
	! !

!WindowBorderCornerMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/20/2002 21:18'!
wantsSteps
	^ false.! !

!WindowBorderMorph methodsFor: 'event handling' stamp: 'jlb 2/24/2002 10:39'!
mouseDown: event 
	| resizer localPt newBounds symbolName offsetPt |

	"calculate the offset from the cursor point to the edge of the owner bounds"
	symbolName _ self knownName.
	offsetPt _ self calculateOffset: event cursorPoint.
	self fastFramingOn 
			ifTrue:
				[ ^ self doFastWindowReframe: symbolName offset: offsetPt].
	resizer _ NewHandleMorph new.
	resizer color: Color transparent ;  
	borderWidth: 0. 
	resizer position: event cursorPoint - (resizer extent / 2).
     " set up the follow block "
	resizer
		followHand: event hand
		forEachPointDo: [:p | 
			localPt _ self pointFromWorld: p.
			newBounds _ owner bounds
						withSideOrCorner: symbolName
						setToPoint: localPt + offsetPt
						minExtent: owner windowMinimumExtent.
				newBounds = owner bounds
					ifFalse: [owner setWindowBounds: newBounds]]
		lastPointDo: [:p | " check to make sure that we're still in the frame border "
						( self containsPoint: p ) ifFalse: [ self mouseLeave: nil ].
			self stop ].
	" place the resizer into the worlds top layer "
	event hand world addMorphInLayer: resizer.
	resizer startStepping.! !

!WindowBorderMorph methodsFor: 'event handling' stamp: 'jlb 7/17/2001 13:35'!
mouseEnter: event 
	cursorName
		ifNotNil: [(Cursor perform: cursorName) beCursor]! !

!WindowBorderMorph methodsFor: 'event handling' stamp: 'jlb 7/14/2001 20:57'!
mouseLeave: event
	
	Cursor normal beCursor.
! !

!WindowBorderMorph methodsFor: 'event handling' stamp: 'jlb 2/23/2002 22:42'!
mouseUp: event
! !

!WindowBorderMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 13:33'!
cursorName
	^ cursorName
! !

!WindowBorderMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 13:33'!
cursorName: aSymbol
	cursorName _ aSymbol
! !

!WindowBorderMorph methodsFor: 'accessing' stamp: 'jlb 2/24/2002 11:04'!
doFastWindowReframe: ptName offset: offsetPt

	| newBounds |
	"For fast display, only higlight the rectangle during loop"
	newBounds _ owner bounds newRectButtonPressedDo: [:f | 
		f 
			withSideOrCorner: ptName
			setToPoint: (self pointFromWorld: (Sensor cursorPoint+offsetPt))
			minExtent: owner windowMinimumExtent].
	owner setWindowBounds: newBounds.
	self mouseLeave: nil.


! !

!WindowBorderMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 21:06'!
obvious
	" This ivar controls display of the morph "
	^ obvious! !

!WindowBorderMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 21:06'!
obvious: aBoolean
	" This ivar controls display of the morph "
	obvious _ aBoolean.
! !

!WindowBorderMorph methodsFor: 'initialization' stamp: 'jlb 2/8/2002 00:31'!
initialize
	super initialize.
	cursorName _ #normal.
	" the resize edges are not obvious (visible) "
	obvious _ false.
	self setProperty: #resizer toValue: true ;
		on: #mouseEnter send: #mouseEnter: to: self ;
		on: #mouseLeave send: #mouseLeave: to: self ;
		on: #mouseDown send: #mouseDown: to: self ;
		on: #mouseUp send: #mouseUp: to: self.
	self setProperty: #morphicLayerNumber toValue: 20.
	! !

!WindowBorderMorph methodsFor: 'geometry' stamp: 'jlb 10/13/2001 13:36'!
calculateOffset: aPoint 
	"return the offset from aPoint to the edge of the owners bounding rectangle"
	"The result is keyed by the name of the edge, which is also the known name of 
	this morph"

	| nameArray offsetPt symbolName |
	nameArray _ #(#topLeft #topRight #bottomLeft #bottomRight ).
	"place the handle centered at the cursor hotspot"
	offsetPt _ 0 @ 0.
	"calculate the offset in x and y coordinates from the cursor point to the 
	realignment edge"
	symbolName _ self knownName asSymbol.
	(nameArray includes: symbolName)
		ifTrue: ["calculate the offset to the corner"
			offsetPt _ (owner bounds perform: symbolName)
						- aPoint]
		ifFalse: ["one of the real edges"
			offsetPt _ ( #( #left #right ) includes: symbolName )
						ifTrue: [(owner bounds perform: symbolName)
								@ aPoint y]
						ifFalse: ["assume here the edge is either #bottom and #top"
							aPoint x
								@ (owner bounds perform: symbolName)].
			offsetPt _ offsetPt - aPoint].
	^ offsetPt! !

!WindowBorderMorph methodsFor: 'geometry' stamp: 'jlb 7/17/2001 15:14'!
fastFramingOn

	^ Preferences fastDragWindowForMorphic ! !

!WindowBorderMorph methodsFor: 'drawing' stamp: 'jlb 7/17/2001 21:08'!
drawOn: aCanvas
	obvious ifTrue: [ super drawOn: aCanvas ].! !

!WindowBorderMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/20/2002 21:12'!
wantsSteps
	^ false.! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/21/2001 21:15'!
bottomRightInset
	^ bottomRightInset! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/21/2001 21:15'!
bottomRightInset: aPoint
	bottomRightInset _ aPoint.! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 22:34'!
drawBlock
	" render code is the block to execute when called to draw the part "
	^ drawBlock! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 22:35'!
drawBlock: aBlock
	" aBlock should expect two arguments; theMorph and theCanvas "
	" For example: [ :morph :canvas | canvas fillRectangle: morph bounds fillStyle: morph fillStyle ] "
	
	aBlock ifNil: [ drawBlock _ nil. ]
		ifNotNil: [ drawBlock _ aBlock copy].! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 8/5/2001 13:59'!
frameColor
	^ frameColor! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 8/5/2001 14:00'!
frameColor: aColor
	frameColor _ aColor! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 21:41'!
growExtent
	" The size of the reframe corners "
	^ growExtent! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/17/2001 21:41'!
growExtent: aPoint
	" The size of the reframe corners "
	growExtent _ aPoint! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/28/2001 23:24'!
labelArea
	^ nil.! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/18/2001 11:53'!
labelFontColor
	^ labelFontColor! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/18/2001 11:53'!
labelFontColor: aColor
	 labelFontColor _ aColor! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/21/2001 21:15'!
topLeftInset
	^ topLeftInset! !

!WindowFrameMorph methodsFor: 'accessing' stamp: 'jlb 7/21/2001 21:15'!
topLeftInset: aPoint
	topLeftInset _ aPoint! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 10/12/2001 00:00'!
addCloseBox
	" add a close button "

	" This needs to be changed in a themed environment "

	| form button |
	self closeBox ifNotNil: [^self].
	form := self class squareClose.
	button := (TwoModeButtonMorph new)
				fromImages: form;
				target: self;
				actionSelector: #closeBoxHit;
				setBalloonText: 'close this window';
				setProperty: #wantsActivate toValue: true;
				name: #closeBox ; yourself.
	self addMorph: button.
	button position: self bounds origin + (7 @ 5)! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 20:14'!
closeBox
	^ self submorphNamed: #closeBox.! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 20:22'!
collapseBox
	^ self submorphNamed: #collapseBox.! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 21:22'!
deleteCloseBox
	self closeBox ifNotNil: [ self closeBox delete ].! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 20:21'!
expandBox
	^ self submorphNamed: #expandBox.! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 20:32'!
label
	^ self submorphNamed: #label! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 7/31/2001 20:22'!
menuBox
	^ self submorphNamed: #menuBox.! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 8/16/2001 20:37'!
removeMenuBox
	self menuBox
		ifNotNilDo: [:m | m delete]! !

!WindowFrameMorph methodsFor: 'initialization' stamp: 'jlb 10/12/2001 00:18'!
addDefaultFrame: aWindow 
	| title form button lwa |
	self window: aWindow.
	frameColor := Color white.
	title := DefaultFrameMorph new.
	title
		borderWidth: 1;
		borderColor: Color black;
		color: frameColor;
		name: #title;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)
					offsets: ((borderWidth @ borderWidth) negated 
							corner: borderWidth @ borderWidth));
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setProperty: #wantsActivate toValue: true.
	self addMorphBack: title.
	title setProperty: #wantsPaneColor toValue: true.

	"add a close button"
	form := self class squareClose.
	button := (TwoModeButtonMorph new)
				fromImages: form;
				target: self;
				actionSelector: #closeBoxHit;
				setBalloonText: 'close this window';
				setProperty: #wantsActivate toValue: true;
				name: #closeBox ; yourself.
	self addMorph: button.
	button position: 7 @ 5.
	"add a collapse button"
	form := self class minButtonForm.
	button := (TwoModeButtonMorph new)
				fromImages: form;
				target: self;
				actionSelector: #collapseOrExpand;
				setBalloonText: 'collapse/expand window';
				name: #collapseBox ; yourself.
	button layoutFrame: (LayoutFrame fractions: (1 @ 0 corner: 1 @ 0)
				offsets: ((button extent x + 2) negated @ 0 extent: button extent)).
	button
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button setProperty: #wantsActivate toValue: true.
	self addMorph: button.
	"add a maximize button"
	form := self class maxButtonForm.
	button := (TwoModeButtonMorph new)
				fromImages: form;
				target: self;
				actionSelector: #expandBoxHit;
				setBalloonText: 'expand to full screen';
				name: #expandBox;
				yourself.
	button layoutFrame: (LayoutFrame fractions: (1 @ 0 corner: 1 @ 0)
				offsets: ((button extent x * 2 + 4) negated @ 0 extent: button extent)).
	button
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button setProperty: #wantsActivate toValue: true.
	self addMorph: button.
	"add a menu button"
	button := (IconicButton new)
				borderWidth: 0;
				labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu');
				color: Color transparent;
				actWhen: #buttonDown;
				actionSelector: #offerWindowMenu;
				target: self;
				name: #menuBox;
				setBalloonText: 'window menu';
				yourself.
	button position: 26 @ 7.
	self addMorph: button.
	self topLeftInset: 3 @ 23.
	self bottomRightInset: 3 @ 3.
	"figure out how much room for widgets with a little room to breathe"
	lwa := 24.
	self closeBox ifNotNil: [lwa := lwa + self closeBox width].
	self collapseBox ifNotNil: [lwa := lwa + self collapseBox width].
	self expandBox ifNotNil: [lwa := lwa + self expandBox width].
	self menuBox ifNotNil: [lwa := lwa + self menuBox width].
	self labelWidgetAllowance: lwa.
	"add the frame to the window"
	aWindow
		addMorph: self;
		borderColor: Color transparent;
		borderWidth: 1! !

!WindowFrameMorph methodsFor: 'initialization' stamp: 'jlb 7/21/2001 11:29'!
addFrame: frameWidth growExtent: aPoint

	" add the four corners and four edges to the window frame "

	self borderWidth: frameWidth.
	self growExtent: aPoint.
	self addFrame.
! !

!WindowFrameMorph methodsFor: 'initialization' stamp: 'jlb 2/7/2002 15:44'!
initialize
	super initialize.
	self extent: ( self minimumExtent ).
	self borderWidth: 4.
	drawBlock _ nil.
	labelFontColor _ Color white.
	" Allow us to resize everything proportionally "
	self layoutPolicy: ProportionalLayout new.
	" grow extent is the size of the corners reframe sides "
	growExtent _ 16@16.
	self color: Color transparent.
	self borderColor: Color transparent.
	topLeftInset _ 8@32.
	bottomRightInset _ 8@8.
	^ self
! !

!WindowFrameMorph methodsFor: 'geometry' stamp: 'jlb 7/21/2001 16:08'!
setWindowBounds: aRect
	owner bounds: aRect! !

!WindowFrameMorph methodsFor: 'label' stamp: 'jlb 10/30/2001 23:28'!
labelHeight
	| theme |
	theme _ WindowTheme current.
	theme ifNil: [ ^ 22 ]
		ifNotNil: [ ^ theme labelHeight ].
! !

!WindowFrameMorph methodsFor: 'label' stamp: 'jlb 10/12/2001 00:02'!
setLabel: aLabelString 
	| frame label |
	label := self submorphNamed: #label.
	label ifNotNil: [label delete].
	labelString := aLabelString.
	label := (StringMorph new)
				contents: labelString;
				font: Preferences windowTitleFont emphasis: 1 ;
				yourself.
	label name: #label.
	frame := LayoutFrame new.
	frame
		leftFraction: 0.5;
		topFraction: 0;
		leftOffset: label width negated // 2.
	" ; topOffset: 2. "
	label layoutFrame: frame.
	self addMorph: label! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:56'!
addBottomFrame: aFrame 
	| xOffset |

	xOffset _ growExtent x - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (xOffset @ 0 corner: xOffset negated @ borderWidth))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 8/18/2001 20:01'!
addBottomLeftFrame

		| aFrame xGrow yGrow bw |
	xGrow _ growExtent x.
	yGrow _ growExtent y.
	bw _ self borderWidth - 1.
	aFrame _ WindowBorderCornerMorph new.
	aFrame 	vertices: {  0@0. 0@yGrow. xGrow@yGrow. xGrow@(yGrow-bw). bw@(yGrow-bw). bw@0 }
				color: Color yellow
				borderWidth: 1
				borderColor: Color black ;
			name: #bottomLeft ;
			cursorName: #resizeBottomLeft.
		" send a message to ourselves to add the named part; e.g. self addTopFrame: aFrame "
		self addBottomLeftFrame: aFrame.
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:56'!
addBottomLeftFrame: aFrame 

	| xOffset yOffset frameExtent |
	xOffset _ borderWidth+1.
	yOffset _ borderWidth.
	frameExtent _ aFrame bounds extent.

	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 0 @ 1)
				offsets: (xOffset negated @ (frameExtent y - yOffset) negated 
							corner: frameExtent x - xOffset @ yOffset ))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 8/18/2001 20:01'!
addBottomRightFrame

		| aFrame xGrow yGrow bw |
	xGrow _ growExtent x.
	yGrow _ growExtent y.
	bw _ self borderWidth - 1.
	aFrame _ WindowBorderCornerMorph new.
	aFrame 	vertices: { 0@yGrow. xGrow@yGrow. xGrow@0. xGrow-bw@0. xGrow-bw@(yGrow-bw). 0@(yGrow-bw) }
				color: Color yellow
				borderWidth: 1
				borderColor: Color black ;
			name: #bottomRight ;
			cursorName: #resizeBottomRight.
		" send a message to ourselves to add the named part; e.g. self addTopFrame: aFrame "
		self addBottomRightFrame: aFrame.
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addBottomRightFrame: aFrame 

	| xOffset yOffset |
	xOffset _ self borderWidth.
	yOffset _ self borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: ( (aFrame bounds extent - (xOffset@yOffset)) negated 	
					corner:  (xOffset@yOffset) ))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 10/12/2001 00:01'!
addFrame
	" add the resizing frame to the window frame ;
       this resizing area is usually transparent, the actual window decorations
	  are seperate. The resizing edges provide the interaction between the user
	  and the window "

	" Resize edges are colored in the case that you want to debug "

	" add the four corners and four edges to the window frame "

	" the following array represents the name and cursor associated with a WindowBorderMorph"

	| aFrame |
	#(#(#top #resizeTop) #(#left #resizeLeft) #(#bottom #resizeBottom) #(#right #resizeRight)) 
		do: 
			[:spec | 
			aFrame := (WindowBorderMorph new)
						name: spec first;
						extent: 0 @ 0;
						color: Color blue;
						borderWidth: 1;
						borderColor: Color black;
						cursorName: spec second ;	" so you can take a look for debugging "
						yourself.
			" send a message to ourselves to add the named part; e.g. self addTopFrame: aFrame "
			self perform: ('add' , aFrame knownName capitalized , 'Frame:') asSymbol
				with: aFrame].
	self addTopRightFrame.
	self addTopLeftFrame.
	self addBottomRightFrame.
	self addBottomLeftFrame.
	self changed! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addLeftFrame: aFrame 
	| yOffset |

	yOffset _ growExtent y - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (borderWidth negated @ yOffset corner: 0 @ yOffset negated))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addRightFrame: aFrame 
	| yOffset |

	yOffset _ growExtent y - borderWidth.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 1)
				offsets: (0 @ yOffset corner: borderWidth @ yOffset negated))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopFrame: aFrame 

	| xOffset |

	xOffset _ growExtent x - borderWidth.
	self addMorphInLayer: aFrame
		fullFrame: (
			LayoutFrame
				fractions: ( 0 @ 0 corner: (1 @ 0) )
				offsets: ( xOffset @ ( borderWidth negated )  corner: ((xOffset negated) @ 0) )).
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 8/18/2001 20:01'!
addTopLeftFrame

		| aFrame xGrow yGrow bw |

	xGrow _ growExtent x.
	yGrow _ growExtent y.
	bw _ self borderWidth - 1.

	aFrame _ WindowBorderCornerMorph new.
	aFrame 	vertices: {  0@0. xGrow@0. xGrow@bw. bw@bw. bw@yGrow. 0@yGrow }
				color: Color yellow
				borderWidth: 1
				borderColor: Color black ;
			name: #topLeft ;
			cursorName: #resizeTopLeft.
		" send a message to ourselves to add the named part; e.g. self addTopFrame: aFrame "
		self addTopLeftFrame: aFrame.
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopLeftFrame: aFrame 

	| xOffset yOffset |
	xOffset _ self borderWidth + 1.
	yOffset _ self borderWidth + 1.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0)
				offsets: (xOffset negated @ yOffset negated corner: ( aFrame bounds extent) - (xOffset@yOffset)))! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 8/18/2001 20:00'!
addTopRightFrame

		| aFrame xGrow yGrow bw |
	xGrow _ growExtent x.
	yGrow _ growExtent y.
	bw _ self borderWidth - 1.
	aFrame _ WindowBorderCornerMorph new.
	aFrame 	vertices: { 0@0. xGrow@0. xGrow@yGrow. xGrow-bw@yGrow. xGrow-bw@bw. 0@bw }
				color: Color yellow
				borderWidth: 1
				borderColor: Color black ;
			name: #topRight ;
			cursorName: #resizeTopRight.
		" send a message to ourselves to add the named part; e.g. self addTopFrame: aFrame "
		self addTopRightFrame: aFrame.
! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 2/7/2002 09:57'!
addTopRightFrame: aFrame 

	| aRect xOffset yOffset |
	aRect _ aFrame bounds.
	xOffset _ self borderWidth.
	yOffset _ self borderWidth + 1.
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 0)
				offsets: ( aRect width negated + xOffset @ ( yOffset negated )
							corner: ( xOffset  @ ( aRect height - yOffset ))))

			! !

!WindowFrameMorph methodsFor: 'frame geometry' stamp: 'jlb 7/23/2001 20:00'!
windowMinimumExtent
	^ owner minimumExtent! !

!WindowFrameMorph methodsFor: 'message handling' stamp: 'jlb 7/22/2001 21:18'!
closeBoxHit
	owner closeBoxHit.
	! !

!WindowFrameMorph methodsFor: 'message handling' stamp: 'jlb 7/22/2001 21:25'!
collapseOrExpand
	owner collapseOrExpand.! !

!WindowFrameMorph methodsFor: 'message handling' stamp: 'jlb 7/22/2001 21:19'!
expandBoxHit
	owner expandBoxHit! !

!WindowFrameMorph methodsFor: 'message handling' stamp: 'jlb 7/23/2001 22:06'!
offerWindowMenu
	owner offerWindowMenu.! !

!WindowFrameMorph methodsFor: 'color' stamp: 'jlb 8/5/2001 13:51'!
buildFillStyle: aMorph color: aColor
	| aFrameColor fill |

	aFrameColor _ aColor.
	fill _ GradientFillStyle ramp: {0.0 -> aFrameColor muchLighter. 1.0 -> aFrameColor}.
	fill origin: aMorph bounds topLeft.
	fill direction: 0 @ (borderWidth+1).
	fill radial: false.
	^ fill! !

!WindowFrameMorph methodsFor: 'color' stamp: 'jlb 8/18/2001 23:24'!
paneColor: aColor 
	"the pane is being set to this color"
	| wantsColor |
	self
		submorphsDo: [:m | 
			wantsColor _ m
						valueOfProperty: #wantsPaneColor
						ifAbsent: [false].
			wantsColor
				ifTrue: [frameColor _ Preferences alternativeWindowLook
								ifTrue: [aColor  ]
								ifFalse: [aColor darker darker].
					m color: frameColor]]! !

!WindowFrameMorph methodsFor: 'color' stamp: 'jlb 8/5/2001 21:43'!
setStripeColorsFrom: paneColor
	self paneColor: paneColor.! !

!WindowFrameMorph methodsFor: 'top window' stamp: 'jlb 9/9/2001 09:33'!
activate
	"hilite the window frame"
	super activate.
	self
		submorphsDo: [:m | 
			window isCollapsed ifFalse: [ m unlock ].
			(m
					valueOfProperty: #wantsActivate
					ifAbsent: [false])
				ifTrue: [m activate]]! !

!WindowFrameMorph methodsFor: 'top window' stamp: 'jlb 8/6/2001 15:55'!
lockInactivePortions
	self submorphs
		do: [:m | (m == self closeBox
					or: [m == self collapseBox
							or: [m == self expandBox]])
				ifFalse: [m lock]]! !

!WindowFrameMorph methodsFor: 'top window' stamp: 'jlb 8/6/2001 15:56'!
passivate

	" unhilite the window frame "	
	super passivate.
	self submorphsDo: [ :m |
			( m valueOfProperty: #wantsActivate ifAbsent: [ false ] )
			ifTrue: [ m passivate ].
		].
	self lockInactivePortions.! !

!WindowFrameMorph methodsFor: 'resize edges' stamp: 'jlb 8/18/2001 13:53'!
hideResizeEdges
	"hide the morphs that are responsible for resizing the window"
	self
		submorphsDo: [:m | (m hasProperty: #resizer)
				ifTrue: [m obvious: false]].
	self changed! !

!WindowFrameMorph methodsFor: 'resize edges' stamp: 'jlb 8/18/2001 13:53'!
showResizeEdges
	"show the morphs that are responsible for resizing the window"
	self
		submorphsDo: [:m | (m hasProperty: #resizer)
				ifTrue: [m obvious: true]].
	self changed! !

!WindowFrameMorph methodsFor: 'layout' stamp: 'jlb 7/31/2001 12:20'!
paneInset
	" return the inset rectangle for the pane area of the window "
	^ topLeftInset corner: bottomRightInset! !

!WindowFrameMorph methodsFor: 'layout' stamp: 'jlb 7/21/2001 21:18'!
windowBoundsInset
	^ topLeftInset corner: bottomRightInset! !

!WindowFrameMorph methodsFor: 'drawing' stamp: 'jlb 7/17/2001 22:34'!
drawOn: aCanvas
	drawBlock ifNotNil: [ ^ drawBlock value: self value: aCanvas ].
	super drawOn: aCanvas.! !

!WindowFrameMorph methodsFor: 'drawing' stamp: 'jlb 7/17/2001 22:37'!
superDrawOn: aCanvas
	" This is for access from a draw block "
	super drawOn: aCanvas.! !

!WindowFrameMorph methodsFor: 'collpase / exapnd' stamp: 'jlb 2/25/2002 00:22'!
collapse
	" The window is being collapsed ; don't let the resizers be active "
	self
		submorphsDo: [:m | (m hasProperty: #resizer)
				ifTrue: [m lock].
				(m hasProperty: #growBox)
				ifTrue: [m hide]].
	self changed! !

!WindowFrameMorph methodsFor: 'collpase / exapnd' stamp: 'jlb 2/25/2002 00:22'!
expand
	" The window is being expanded ; let the resizers be free to roam the open plains "
	self
		submorphsDo: [:m | (m hasProperty: #resizer)
				ifTrue: [m unlock].
				(m hasProperty: #growBox)
				ifTrue: [m show]].
	self changed! !


!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 8/21/2001 08:21'!
addBottomFromTheme: aTheme 
	| bottom |
	bottom _ FrameEdgeImageMorph new.
	bottom
		edgeLeft: aTheme bottomEdge x
		right: aTheme bottomEdge y
		top: 0
		bottom: 0.
	bottom image: aTheme bottomActive.
	bottom setProperty: #activeImage toValue: aTheme bottomActive.
	bottom setProperty: #inactiveImage toValue: aTheme bottomInactive.
	bottom name: #bottomBorder.
	self
		addMorph: bottom
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (aTheme leftWidth - borderWidth @ (aTheme bottomHeight - borderWidth) negated corner: (aTheme rightWidth - borderWidth) negated @ (borderWidth)))! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 3/1/2002 08:12'!
addCloseBox: aTheme

	" close box "
	| button buttonExtent buttonClass |

	aTheme closeBoxButtonClass ifNil: [ buttonClass _ TwoModeButtonMorph ]
		ifNotNil: [ buttonClass _ Smalltalk classNamed: aTheme closeBoxButtonClass ].
	button := (buttonClass perform: #new)
				fromImages: aTheme closeBoxImages;
				target: self;
				actionSelector: #closeBoxHit;
				setBalloonText: 'close this window';
				setProperty: #wantsActivate toValue: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				name: #closeBox ; yourself.
	buttonExtent _ aTheme closeBoxExtent.
	buttonExtent ifNil: [ buttonExtent _ button extent ].
	button layoutFrame: (LayoutFrame 
				fractions: (aTheme closeBoxFractions ifNil: [0 @ 0 corner: 0 @ 0]
						ifNotNil: [aTheme closeBoxFractions])
				offsets: (aTheme closeBoxLayout extent: buttonExtent)).
	self addMorph: button.
! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 2/28/2002 20:12'!
addGrowBox

	theme ifNotNil: [ ^ self ].
	self addGrowBox: theme.! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 2/28/2002 14:25'!
addGrowBox: aTheme 
	| button aForm aFrame |

	aForm _ aTheme growBoxForm.
	aForm ifNil: [ ^ self ].
	button _ EdgeImageMorph new.
	button image: aForm.
	button
		layoutFrame: (LayoutFrame
				fractions: (aTheme growBoxFractions
						ifNil: [1 @ 1 corner: 1 @ 1]
						ifNotNil: [aTheme growBoxFractions])
				offsets: (aTheme growBoxLayout extent: button extent)).
	button setProperty: #growBox toValue: true.
	self addMorph: button.
	"and add a resize area for it."
	aFrame _ WindowBorderMorph new name: #bottomRight;
				 extent: 0 @ 0;
				 color: Color blue;
				 borderWidth: 1;
				 borderColor: Color black;
				 cursorName: #resizeBottomRight;
				 yourself.
	"so you can take a look for debugging"
	self
		addMorphInLayer: aFrame
		fullFrame: (LayoutFrame
				fractions: (aTheme growBoxFractions
						ifNil: [1 @ 1 corner: 1 @ 1]
						ifNotNil: [aTheme growBoxFractions])
				offsets: (aTheme growBoxLayout extent: button extent))! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 8/21/2001 08:01'!
addLeftFromTheme: aTheme 
	| left |
	left _ FrameEdgeImageMorph new.
	left image: aTheme leftActive.
	left
		edgeLeft: 0
		right: 0
		top: aTheme leftEdge x
		bottom: aTheme leftEdge y.
	left setProperty: #activeImage toValue: aTheme leftActive.
	left setProperty: #inactiveImage toValue: aTheme leftInactive.
	left name: #leftBorder.
	self
		addMorph: left
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: ((borderWidth @ borderWidth) negated corner: aTheme leftWidth - borderWidth @ borderWidth))! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 3/1/2002 08:19'!
addMaxBox: aTheme

	| button buttonExtent buttonClass |
	aTheme maxBoxButtonClass ifNil: [ buttonClass _ TwoModeButtonMorph ]
		ifNotNil: [ buttonClass _ Smalltalk classNamed: aTheme maxBoxButtonClass ].
	button := (buttonClass perform: #new)
				fromImages: aTheme maxBoxImages;
				target: self;
				actionSelector: #expandBoxHit;
				setBalloonText: 'expand to full screen';
				setProperty: #wantsActivate toValue: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				name: #expandBox;
				yourself.
	buttonExtent _ aTheme maxBoxExtent.
	buttonExtent ifNil: [ buttonExtent _ button extent ].
	button layoutFrame: (LayoutFrame 
				fractions: (aTheme maxBoxFractions ifNil: [1 @ 0 corner: 1 @ 0]
						ifNotNil: [aTheme maxBoxFractions])
				offsets: (aTheme maxBoxLayout extent: buttonExtent)).
	button
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button setProperty: #wantsActivate toValue: true.
	self addMorph: button.! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 3/1/2002 08:19'!
addMinBox: aTheme

	| button buttonExtent buttonClass |
	aTheme minBoxButtonClass ifNil: [ buttonClass _ TwoModeButtonMorph ]
		ifNotNil: [ buttonClass _ Smalltalk classNamed: aTheme minBoxButtonClass ].
	button := (buttonClass perform: #new)
				fromImages: aTheme minBoxImages;
				target: self;
				actionSelector: #collapseOrExpand;
				setBalloonText: 'collapse/expand window';
				setProperty: #wantsActivate toValue: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				name: #collapseBox;
				yourself.
	buttonExtent _ aTheme maxBoxExtent.
	buttonExtent ifNil: [ buttonExtent _ button extent ].
	button layoutFrame: (LayoutFrame 
				fractions: (aTheme minBoxFractions ifNil: [1 @ 0 corner: 1 @ 0]
						ifNotNil: [aTheme minBoxFractions])
				offsets: (aTheme minBoxLayout extent: buttonExtent)).
	self addMorph: button.
! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 8/21/2001 08:08'!
addRightFromTheme: aTheme 
	| right |
	right _ FrameEdgeImageMorph new.
	right image: aTheme rightActive.
	right
		edgeLeft: 0
		right: 0
		top: aTheme rightEdge x
		bottom: aTheme rightEdge y.
	right setProperty: #activeImage toValue: aTheme rightActive.
	right setProperty: #inactiveImage toValue: aTheme rightInactive.
	right name: #rightBorder.
	self
		addMorph: right
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 1)
				offsets: ((aTheme rightWidth - borderWidth) negated @ borderWidth negated corner: (borderWidth @ borderWidth) ))! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 8/21/2001 08:15'!
addTopFromTheme: aTheme 
	| top |
	top _ FrameEdgeImageMorph new.
	top image: aTheme topActive.
	top
		edgeLeft: aTheme topEdge x
		right: aTheme topEdge y
		top: 0
		bottom: 0.
	top setProperty: #activeImage toValue: aTheme topActive.
	top setProperty: #inactiveImage toValue: aTheme topInactive.
	top name: #topBorder.
	self
		addMorph: top
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (aTheme leftWidth - borderWidth @ (borderWidth negated) corner: (aTheme rightWidth - borderWidth) negated @ (aTheme topHeight - borderWidth)))! !

!WindowFrameImagedMorph methodsFor: 'theme support' stamp: 'jlb 2/28/2002 20:02'!
fromTheme: aTheme 

	" add surround frame "
	self addLeftFromTheme: aTheme.
	self addRightFromTheme: aTheme.
	self addTopFromTheme: aTheme.
	self addBottomFromTheme: aTheme.

	topLeftInset := aTheme paneInset origin.
	bottomRightInset := aTheme paneInset corner.

	" close box "
	self addCloseBox: aTheme.
	" min box "
	self addMinBox: aTheme.
	"add a maximize button"
	self addMaxBox: aTheme.

	self labelWidgetAllowance: ( aTheme labelWidgetAllowance ).! !

!WindowFrameImagedMorph methodsFor: 'window frame' stamp: 'jlb 2/28/2002 20:12'!
addDefaultFrame: aWindow 
	window _ aWindow.
	theme _ WindowTheme current.
	self fromTheme: theme.
	self addFrame.
	" self showResizeEdges. "
	aWindow addMorph: self;
		borderColor: Color transparent ;
		borderWidth: 0.
! !

!WindowFrameImagedMorph methodsFor: 'window frame' stamp: 'jlb 2/28/2002 20:13'!
labelHeight

	theme ifNil: [ ^ 22 ]
		ifNotNil: [ ^ theme labelHeight ].
! !

!WindowFrameImagedMorph methodsFor: 'window frame' stamp: 'jlb 2/28/2002 20:28'!
setLabel: aLabelString 
	| label |
	label _ self submorphNamed: #label.
	label
		ifNotNil: [label delete].
	label _ WindowTitleMorph newInstance: aLabelString theme: theme.
	self addMorphInLayer: label
		fullFrame: ( label layoutFrame ).
	self active ifTrue: [ label activate ]
				ifFalse: [ label passivate ].! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 2/28/2002 20:15'!
theme
	^ theme! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 2/28/2002 20:15'!
theme: aWindowTheme
	theme _ aWindowTheme! !

!WindowFrameImagedMorph methodsFor: 'initialization' stamp: 'jlb 2/28/2002 20:04'!
initialize
	super initialize.
	borderWidth _ 4.
	self showResizeEdges.
	theme _ nil.
! !


!WindowFrameMorph class methodsFor: 'demo forms' stamp: 'jlb 7/19/2001 00:20'!
bigX
^ (Form
	extent: 18@108
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278219751 4278219751 4278219742 4278217686 0 0 0 0 0 0 4278217694 4278217694 4278217694 4278217694 0 0 0 0 4278219751 4278219759 4278219759 4278219751 4278215630 0 0 0 0 4278217686 4278219751 4278219759 4278217694 4278217686 0 0 0 0 4278217694 4278219751 4278219759 4278221815 4278217694 4278215622 0 0 4278217678 4278219742 4278219759 4278219759 4278217686 4278215622 0 0 0 0 0 4278217686 4278219742 4278219759 4278219759 4278217694 4278215630 4278215622 4278217686 4278219751 4278219759 4278217686 4278213309 0 0 0 0 0 0 0 4278215630 4278217694 4278219751 4278219751 4278217694 4278217694 4278217694 4278217694 4278215622 4278211245 0 0 0 0 0 0 0 0 0 4278215622 4278217686 4278219751 4278221815 4278219759 4278217694 4278213309 4278211237 0 0 0 0 0 0 0 0 0 0 0 4278215630 4278219751 4278221823 4278221823 4278217694 4278211245 0 0 0 0 0 0 0 0 0 0 0 4278215630 4278217686 4278219751 4278219759 4278219759 4278217686 4278213301 4278211237 0 0 0 0 0 0 0 0 0 4278217686 4278217694 4278217694 4278217686 4278215630 4278215622 4278217686 4278217686 4278215622 4278213301 0 0 0 0 0 0 0 4278217694 4278219751 4278219759 4278219751 4278213309 4278211237 4278209180 4278213309 4278217694 4278219751 4278217686 4278215622 0 0 0 0 0 4278219742 4278219751 4278219759 4278219751 4278215630 4278211237 0 0 4278211245 4278215630 4278219751 4278219751 4278217686 4278215630 0 0 0 0 4278219751 4278219751 4278219751 4278217686 4278213301 0 0 0 0 4278213309 4278217686 4278217694 4278217694 4278217686 0 0 0 0 4278219751 4278217694 4278217686 4278215622 0 0 0 0 0 0 4278215622 4278215630 4278217686 4278217694 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281443798 4281443798 4281441486 4280913085 0 0 0 0 0 0 4281439430 4281441478 4281439430 4281439430 0 0 0 0 4281441486 4281443806 4281445854 4281441486 4280911021 0 0 0 0 4281439430 4281441486 4281443806 4281441486 4280913077 0 0 0 0 4281439430 4281441486 4281970151 4281972199 4281441486 4280908709 0 0 4281437365 4281441486 4281445863 4281445854 4280913077 4280908709 0 0 0 0 0 4280913077 4281441486 4281445863 4281445854 4281439430 4280911021 4280911013 4280913085 4281443798 4281443806 4280913077 4280380308 0 0 0 0 0 0 0 4280911021 4281439430 4281443798 4281443798 4281441478 4281439430 4281439430 4280915142 4280908709 4279788411 0 0 0 0 0 0 0 0 0 4280908709 4281439421 4281443798 4281972199 4281445863 4281439430 4280382356 4279784043 0 0 0 0 0 0 0 0 0 0 0 4280911021 4281443798 4281974263 4281974263 4280915133 4279786107 0 0 0 0 0 0 0 0 0 0 0 4280911021 4280913077 4281441486 4281445863 4281445854 4280913085 4280380300 4279784043 0 0 0 0 0 0 0 0 0 4281439421 4281439430 4281441486 4280915133 4280908709 4280908709 4280911029 4280913077 4280384421 4280380300 0 0 0 0 0 0 0 4281439430 4281441486 4281445854 4281441486 4280382356 4279784043 4279784043 4280382356 4281439430 4281443798 4280913077 4280384412 0 0 0 0 0 4281441486 4281441486 4281445854 4281443798 4280911021 4279786099 0 0 4279786099 4280911021 4281443798 4281443798 4280913077 4280911021 0 0 0 0 4281441486 4281441486 4281441486 4280911029 4280378244 0 0 0 0 4280380300 4280911029 4281439430 4280915133 4280913085 0 0 0 0 4281441486 4281439430 4280913077 4280382364 0 0 0 0 0 0 4280384412 4280911021 4280913077 4280915142 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280915142 4280913077 4280911021 4280384412 0 0 0 0 0 0 4280382364 4280913077 4281439430 4281441486 0 0 0 0 4280913085 4280915133 4281439430 4280911029 4280380300 0 0 0 0 4280378244 4280911029 4281441486 4281441486 4281441486 0 0 0 0 4280911021 4280913077 4281443798 4281443798 4280911021 4279786099 0 0 4279786099 4280911021 4281443798 4281445854 4281441486 4281441486 0 0 0 0 0 4280384412 4280913077 4281443798 4281439430 4280382356 4279784043 4279784043 4280382356 4281441486 4281445854 4281441486 4281439430 0 0 0 0 0 0 0 4280380300 4280384421 4280913077 4280911029 4280908709 4280908709 4280915133 4281441486 4281439430 4281439421 0 0 0 0 0 0 0 0 0 4279784043 4280380300 4280913085 4281445854 4281445863 4281441486 4280913077 4280911021 0 0 0 0 0 0 0 0 0 0 0 4279786107 4280915133 4281974263 4281974263 4281443798 4280911021 0 0 0 0 0 0 0 0 0 0 0 4279784043 4280382356 4281439430 4281445863 4281972199 4281443798 4281439421 4280908709 0 0 0 0 0 0 0 0 0 4279788411 4280908709 4280915142 4281439430 4281439430 4281441478 4281443798 4281443798 4281439430 4280911021 0 0 0 0 0 0 0 4280380308 4280913077 4281443806 4281443798 4280913085 4280911013 4280911021 4281439430 4281445854 4281445863 4281441486 4280913077 0 0 0 0 0 4280908709 4280913077 4281445854 4281445863 4281441486 4281437365 0 0 4280908709 4281441486 4281972199 4281970151 4281441486 4281439430 0 0 0 0 4280913077 4281441486 4281443806 4281441486 4281439430 0 0 0 0 4280911021 4281441486 4281445854 4281443806 4281441486 0 0 0 0 4281439430 4281439430 4281441478 4281439430 0 0 0 0 0 0 4280913085 4281441486 4281443798 4281443798 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!WindowFrameMorph class methodsFor: 'demo forms' stamp: 'jlb 7/22/2001 21:12'!
helpForm
^(Form
	extent: 17@102
	depth: 32
	fromArray: #( 0 0 0 0 4282547166 4283600094 4285242599 4285769199 4286885351 4285769199 4285242599 4283600094 4282547166 0 0 0 0 0 0 0 4283600094 4285766887 4284716254 4283073758 4281957342 4281430998 4281957342 4283073758 4284716254 4285769199 4283600094 0 0 0 0 0 4283600094 4284716263 4282547166 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4282547166 4284716263 4283600094 0 0 0 4283600094 4284716263 4281430998 4281430998 4281430998 4282547166 4284716263 4285242599 4283600094 4281430998 4281430998 4281430998 4281430998 4284716263 4283600094 0 4282547166 4285766887 4282547166 4281430998 4281430998 4281430998 4291221239 4294967295 4294967295 4294967295 4289580783 4281957334 4281430998 4281430998 4282547166 4285766887 4282547166 4283600094 4284716254 4281430998 4281430998 4281430998 4281430998 4294967295 4289580783 4288462311 4294967295 4294967295 4285769199 4281430998 4281430998 4281430998 4284716254 4283600094 4285242599 4283073758 4281430998 4281430998 4281430998 4281430998 4284716263 4281430998 4281430998 4285769199 4294967295 4287411695 4281430998 4281430998 4281430998 4283073758 4285242599 4285769199 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4289580783 4294967295 4285769199 4281430998 4281430998 4281430998 4281957342 4285769199 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4287411695 4294967295 4294967295 4281957334 4281430998 4281430998 4281430998 4281430998 4286885351 4285769199 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4283600094 4294967295 4294967295 4282547166 4281430998 4281430998 4281430998 4281430998 4281957342 4285769199 4285242599 4283073758 4281430998 4281430998 4281430998 4281430998 4281430998 4283600094 4288462311 4285766887 4281430998 4281430998 4281430998 4281430998 4281430998 4283073758 4285242599 4283600094 4284716254 4281430998 4281430998 4281430998 4281430998 4281430998 4281955286 4285242599 4282547166 4281430998 4281430998 4281430998 4281430998 4281430998 4284716254 4283600094 4282547166 4285769199 4282547166 4281430998 4281430998 4281430998 4281430998 4284716263 4294967295 4287411695 4281430998 4281430998 4281430998 4281430998 4282547166 4285769199 4282547166 0 4283600094 4284716263 4281430998 4281430998 4281430998 4281430998 4281957342 4286885351 4282547166 4281430998 4281430998 4281430998 4281430998 4284716263 4283600094 0 0 0 4283600094 4284716263 4282547166 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4282547166 4284716263 4283600094 0 0 0 0 0 4283600094 4285766887 4284716254 4283073758 4281957342 4281430998 4281957342 4283073758 4284716254 4285769199 4283600094 0 0 0 0 0 0 0 4282547166 4283600094 4285242599 4285769199 4286885351 4285769199 4285242599 4283600094 4282547166 0 0 0 0 0 0 0 0 4282547166 4285244903 4285771247 4286295535 4286887407 4286295535 4285771247 4285244903 4282547166 0 0 0 0 0 0 0 4285244903 4286295535 4285769191 4284718311 4284128487 4284126439 4284128487 4284718311 4285769191 4286295535 4285244903 0 0 0 0 0 4285244903 4285769199 4284718311 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284718311 4285769199 4283600094 0 0 0 4285244903 4285769199 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4285769199 4285244903 0 4282547166 4286295535 4284718311 4284126439 4284126439 4284126439 4284126439 4284718311 4285769199 4285771247 4285244903 4284126439 4284126439 4284126439 4284718311 4286295535 4284718311 4285244903 4285769191 4284126439 4284126439 4284126439 4284126439 4284126439 4289054455 4291747575 4291747575 4291747575 4287938031 4284128487 4284126439 4284126439 4285769191 4285244903 4285771247 4284718311 4284126439 4284126439 4284126439 4284126439 4284126439 4291747575 4288464623 4287413743 4289054455 4291747575 4286295535 4284126439 4284126439 4284718311 4285771247 4286295535 4284128487 4284126439 4284126439 4284126439 4284126439 4284126439 4285769199 4284126439 4284126439 4286295535 4291747575 4287411695 4284126439 4284126439 4284128487 4286295535 4286887407 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4287938031 4291747575 4286295535 4284126439 4284126439 4284126439 4286887407 4286295535 4284128487 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4287411695 4291747575 4288464631 4284128487 4284126439 4284126439 4284128487 4286295535 4285771247 4284718311 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4285244903 4291747575 4289054455 4284718311 4284126439 4284126439 4284126439 4284718311 4285771247 4283600094 4285769191 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4285244903 4287413743 4286295535 4284126439 4284126439 4284126439 4284126439 4285769191 4285244903 4282547166 4286295535 4284718311 4284126439 4284126439 4284126439 4284126439 4284126439 4284126439 4285771247 4284718311 4284126439 4284126439 4284126439 4284718311 4286295535 4284718311 0 4283600094 4285769199 4284126439 4284126439 4284126439 4284126439 4284126439 4285769199 4291747575 4287411695 4284126439 4284126439 4284126439 4285769199 4285244903 0 0 0 4283600094 4285769199 4284718311 4284126439 4284126439 4284126439 4284128487 4286887407 4284718311 4284126439 4284126439 4285769199 4285244903 0 0 0 0 0 4283600094 4286295535 4285769191 4284718311 4284128487 4284126439 4284128487 4284718311 4285769191 4286295535 4285244903 0 0 0 0 0 0 0 4282547166 4283600094 4285771247 4286295535 4286887407 4286295535 4285771247 4285244903 4282547166 0 0 0 0 0 0 0 0 4282547166 4283600094 4285242599 4285769199 4286885351 4285769199 4285242599 4283600094 4282547166 0 0 0 0 0 0 0 4283600094 4285766887 4284716254 4283073758 4281957342 4281430998 4281957342 4283073758 4284716254 4285769199 4283600094 0 0 0 0 0 4283600094 4284716263 4282547166 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4282547166 4284716263 4283600094 0 0 0 4283600094 4284716263 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4284716263 4283600094 0 4282547166 4285766887 4282547166 4281430998 4281430998 4281430998 4281430998 4282547166 4284716263 4285242599 4283600094 4281430998 4281430998 4281430998 4282547166 4285766887 4282547166 4285244903 4284716254 4281430998 4281430998 4281430998 4281430998 4281430998 4291221239 4291747575 4291747575 4291747575 4289580783 4281957334 4281430998 4281430998 4284716254 4283600094 4285771247 4283073758 4281430998 4281430998 4281430998 4281430998 4281430998 4291747575 4289580783 4288462311 4291221239 4291747575 4285769199 4281430998 4281430998 4283073758 4285242599 4286295535 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4284716263 4281430998 4281430998 4285769199 4291747575 4287411695 4281430998 4281430998 4281957342 4285769199 4286887407 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4289580783 4291747575 4285769199 4281430998 4281430998 4281430998 4286885351 4286295535 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4287411695 4291747575 4290105079 4281957334 4281430998 4281430998 4281957342 4285769199 4285771247 4283073758 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4283600094 4291747575 4291221239 4282547166 4281430998 4281430998 4281430998 4283073758 4285242599 4283600094 4284716254 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4283600094 4288462311 4285766887 4281430998 4281430998 4281430998 4281430998 4284716254 4283600094 4282547166 4285769199 4282547166 4281430998 4281430998 4281430998 4281430998 4281430998 4281955286 4285242599 4282547166 4281430998 4281430998 4281430998 4282547166 4285769199 4282547166 0 4283600094 4284716263 4281430998 4281430998 4281430998 4281430998 4281430998 4284716263 4291747575 4287411695 4281430998 4281430998 4281430998 4284716263 4283600094 0 0 0 4283600094 4284716263 4282547166 4281430998 4281430998 4281430998 4281957342 4286885351 4282547166 4281430998 4281430998 4284716263 4283600094 0 0 0 0 0 4283600094 4285766887 4284716254 4283073758 4281957342 4281430998 4281957342 4283073758 4284716254 4285769199 4283600094 0 0 0 0 0 0 0 4282547166 4283600094 4285242599 4285769199 4286885351 4285769199 4285242599 4283600094 4282547166 0 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4283069373 0 0 0 4283069373 4283595718 4280902581 4280902581 4280902581 4281953213 4283595718 4284122310 4283069373 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 4281953213 4284712134 4281953213 4280902581 4280902581 4280902581 4289050070 4289576406 4289576406 4289576406 4287409614 4281426869 4280902581 4280902581 4281953213 4284712134 4281953213 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4289576406 4287933902 4286883270 4289050070 4289576406 4284714182 4280902581 4280902581 4280902581 4283595709 4283069373 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4283595718 4280902581 4280902581 4284714182 4289576406 4286289094 4280902581 4280902581 4280902581 4281955261 4284122310 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4287409614 4289576406 4284714182 4280902581 4280902581 4280902581 4281426877 4284714182 4285238470 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4286289094 4289576406 4288458198 4281426869 4280902581 4280902581 4280902581 4280902581 4285238470 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4289576406 4289050070 4281953213 4280902581 4280902581 4280902581 4280902581 4281426877 4284714182 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4286883270 4284712134 4280902581 4280902581 4280902581 4280902581 4280902581 4281955261 4284122310 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4284122310 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4283069373 4281953213 4284714182 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4289576406 4286289094 4280902581 4280902581 4280902581 4280902581 4281953213 4284714182 4281953213 0 4283069373 4283595718 4280902581 4280902581 4280902581 4280902581 4281426877 4285238470 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4283069373 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4283069373 0 0 0 4283069373 4283595718 4280902581 4280902581 4280902581 4281953213 4283595718 4284122310 4283069373 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 4281953213 4284712134 4281953213 4280902581 4280902581 4280902581 4289050070 4289576406 4289576406 4289576406 4287409614 4281426869 4280902581 4280902581 4281953213 4284712134 4281953213 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4289576406 4287933902 4286883270 4289050070 4289576406 4284714182 4280902581 4280902581 4280902581 4283595709 4283069373 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4283595718 4280902581 4280902581 4284714182 4289576406 4286289094 4280902581 4280902581 4280902581 4281955261 4284122310 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4287409614 4289576406 4284714182 4280902581 4280902581 4280902581 4281426877 4284714182 4285238470 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4286289094 4289576406 4288458198 4281426869 4280902581 4280902581 4280902581 4280902581 4285238470 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4289576406 4289050070 4281953213 4280902581 4280902581 4280902581 4280902581 4281426877 4284714182 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4286883270 4284712134 4280902581 4280902581 4280902581 4280902581 4280902581 4281955261 4284122310 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4284122310 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4283069373 4281953213 4284714182 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4289576406 4286289094 4280902581 4280902581 4280902581 4280902581 4281953213 4284714182 4281953213 0 4283069373 4283595718 4280902581 4280902581 4280902581 4280902581 4281426877 4285238470 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4283069373 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4280902581 0 0 0 4283069373 4283595718 4280902581 4280902581 4280902581 4281953213 4283595718 4284122310 4283069373 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 4281953213 4284712134 4281953213 4280902581 4280902581 4280902581 4289050070 4289576406 4289576406 4289576406 4287409614 4281426869 4280902581 4280902581 4281953213 4284712134 4281953213 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4289576406 4287933902 4286883270 4289050070 4289576406 4284714182 4280902581 4280902581 4280902581 4283595709 4283069373 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4283595718 4280902581 4280902581 4284714182 4289576406 4286289094 4280902581 4280902581 4280902581 4281955261 4284122310 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4287409614 4289576406 4284714182 4280902581 4280902581 4280902581 4281426877 4284714182 4285238470 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4286289094 4289576406 4288458198 4281426869 4280902581 4280902581 4280902581 4280902581 4285238470 4284714182 4281426877 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4289576406 4289050070 4281953213 4280902581 4280902581 4280902581 4280902581 4281426877 4284714182 4284122310 4281955261 4280902581 4280902581 4280902581 4280902581 4280902581 4283069373 4286883270 4284712134 4280902581 4280902581 4280902581 4280902581 4280902581 4281955261 4284122310 4283069373 4283595709 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4284122310 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4283069373 4281953213 4284714182 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4289576406 4286289094 4280902581 4280902581 4280902581 4280902581 4281953213 4284714182 4281953213 0 4283069373 4283595718 4280902581 4280902581 4280902581 4280902581 4281426877 4285238470 4281953213 4280902581 4280902581 4280902581 4280902581 4283595718 4283069373 0 0 0 4283069373 4283595718 4281953213 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281953213 4283595718 4283069373 0 0 0 0 0 4283069373 4284712134 4283595709 4281955261 4281426877 4280902581 4281426877 4281955261 4283595709 4284714182 4283069373 0 0 0 0 0 0 0 4281953213 4283069373 4284122310 4284714182 4285238470 4284714182 4284122310 4283069373 4281953213 0 0 0 0)
	offset: 0@0)! !

!WindowFrameMorph class methodsFor: 'demo forms' stamp: 'jlb 7/22/2001 20:41'!
maxButtonForm
^ (Form
	extent: 17@102
	depth: 32
	fromArray: #( 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 3240406 3240406 3240406 3240406 3240406 3240406 3240406 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 6134251 6134251 6134251 6134251 6134251 6134251 6134251 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 3240406 3240406 3240406 3240406 3240406 3240406 3240406 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 13557495 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 2711989 2711989 2711989 2711989 2711989 2711989 2711989 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934)
	offset: 0@0)! !

!WindowFrameMorph class methodsFor: 'demo forms' stamp: 'jlb 7/22/2001 20:42'!
minButtonForm
^(Form
	extent: 17@102
	depth: 32
	fromArray: #( 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 16777215 16777215 16777215 16777215 16777215 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 16777215 16777215 16777215 16777215 16777215 16777215 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 13557495 13557495 13557495 13557495 13557495 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 13557495 13557495 13557495 13557495 13557495 13557495 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 6134251 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 6134251 6134251 6134251 6134251 6134251 6134251 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 6134251 6134251 6134251 6134251 6134251 6134251 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 3240406 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 8694503 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 8692438 8692438 8692438 8692438 8692438 8692438 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 2711989 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934 7049934)
	offset: 0@0)! !

!WindowFrameMorph class methodsFor: 'demo forms' stamp: 'jlb 7/19/2001 00:23'!
squareClose
^ (Form
	extent: 17@102
	depth: 32
	fromArray: #( 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281957342 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281957342 4290105079 4286885351 4281430998 4281430998 4281430998 4281430998 4284716263 4291221239 4284124382 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4283073758 4294967295 4294967295 4286885351 4281430998 4281430998 4284716263 4294967295 4294967295 4284716263 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4283073758 4294967295 4294967295 4286885351 4284716263 4294967295 4294967295 4284716263 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4283073758 4294967295 4294967295 4294967295 4294967295 4284716263 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4285769199 4294967295 4294967295 4288462319 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4284716263 4294967295 4294967295 4294967295 4294967295 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4284716263 4294967295 4294967295 4284716263 4283073758 4294967295 4294967295 4286885351 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4284124382 4294967295 4294967295 4284716263 4281430998 4281430998 4283073758 4294967295 4294967295 4285769199 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4288462319 4284716263 4281430998 4281430998 4281430998 4281430998 4283073758 4289054463 4281957342 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284718319 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284718319 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284718319 4290105079 4286885351 4284128495 4284128495 4284128495 4284128495 4285771255 4291221239 4285769199 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4285244911 4291221239 4291747575 4286885351 4284128495 4284128495 4285771255 4291747575 4291747575 4285771255 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4285244911 4291221239 4291747575 4286885351 4285771255 4291747575 4291747575 4285771255 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4285244911 4291221239 4291747575 4291747575 4291747575 4285771255 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4285769199 4291747575 4291747575 4288462319 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4285771255 4291747575 4291747575 4291221239 4291747575 4286885351 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4285771255 4291747575 4291747575 4285771255 4285244911 4291221239 4291747575 4286885351 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4285769199 4291747575 4291747575 4285771255 4284128495 4284128495 4285244911 4291221239 4291747575 4285769199 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4288462319 4285771255 4284128495 4284128495 4284128495 4284128495 4285244911 4289054463 4284718319 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4284128495 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281957342 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281957342 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281957342 4290105079 4286885351 4281430998 4281430998 4281430998 4281430998 4284716263 4291221239 4284124382 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4283073758 4291221239 4291747575 4286885351 4281430998 4281430998 4284716263 4291747575 4291747575 4284716263 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4283073758 4291221239 4291747575 4286885351 4284716263 4291747575 4291747575 4284716263 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4283073758 4291221239 4291747575 4291747575 4291747575 4284716263 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4285769199 4291747575 4291747575 4288462319 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4284716263 4291747575 4291747575 4291221239 4291747575 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4284716263 4291747575 4291747575 4284716263 4283073758 4291221239 4291747575 4286885351 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4284124382 4291747575 4291747575 4284716263 4281430998 4281430998 4283073758 4291221239 4291747575 4285769199 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4288462319 4284716263 4281430998 4281430998 4281430998 4281430998 4283073758 4289054463 4281957342 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4281430998 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4286885351 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4285240526 4284122310 4280902581 4280902581 4280902581 4280902581 4283069373 4286291150 4281953222 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4286883286 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4286883286 4286883286 4284714182 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281953222 4286291158 4286291158 4283069373 4280902581 4280902581 4281426869 4286291150 4286883286 4283595709 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4284714182 4283069373 4280902581 4280902581 4280902581 4280902581 4281426869 4285240526 4281426869 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4285240526 4284122310 4280902581 4280902581 4280902581 4280902581 4283069373 4286291150 4281953222 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4286883286 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4286883286 4286883286 4284714182 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281953222 4286291158 4286291158 4283069373 4280902581 4280902581 4281426869 4286291150 4286883286 4283595709 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4284714182 4283069373 4280902581 4280902581 4280902581 4280902581 4281426869 4285240526 4281426869 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4281426869 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4285240526 4284122310 4280902581 4280902581 4280902581 4280902581 4283069373 4286291150 4281953222 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4284122310 4283069373 4286291158 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4281426869 4286291150 4286883286 4286883286 4286291158 4283069373 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4283595709 4286883286 4286883286 4284714182 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4283069373 4286291158 4286291158 4283069373 4281426869 4286291150 4286883286 4284122310 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4281953222 4286291158 4286291158 4283069373 4280902581 4280902581 4281426869 4286291150 4286883286 4283595709 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4284714182 4283069373 4280902581 4280902581 4280902581 4280902581 4281426869 4285240526 4281426869 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4280902581 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526 4285240526)
	offset: 0@0)! !

!WindowFrameMorph class methodsFor: 'instance creation' stamp: 'jlb 8/5/2001 12:26'!
defaultWindowFrame: aWindow
	| toReturn |
	" return a default window frame "

	toReturn _ self new.
	toReturn addFrame: 4 growExtent: 16@16.
 	" toReturn showResizeEdges. "
	toReturn addDefaultFrame: aWindow.
	^ toReturn.! !


!WindowFrameImagedMorph class methodsFor: 'instance creation' stamp: 'jlb 8/11/2001 19:18'!
defaultWindowFrame: aWindow
	| toReturn |
	" return a default window frame "
	toReturn _ self new.
	toReturn addDefaultFrame: aWindow.
	^ toReturn.! !


!WindowTheme methodsFor: 'form handling' stamp: 'jlb 9/13/2001 15:33'!
readFormAndFix: aFileNameString
	
	| form xlatColor |
	form _ Form fromFileNamed: aFileNameString.
	xlatColor _ Color r: 255 g: 0 b: 255 range: 255.
	form replaceColor: xlatColor withColor: Color transparent. 
	^ form.
! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 13:35'!
bottomHeight
	^ bottomHeight! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 12:50'!
frameDimensions
	^ leftWidth @ topHeight corner: ( rightWidth @ bottomHeight ).
! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/11/2001 23:58'!
frameDimensions: aRectangle
	topHeight _ aRectangle top.
	leftWidth _ aRectangle left.
	rightWidth _ aRectangle right.
	bottomHeight _ aRectangle bottom.
	! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 12:53'!
frameInset
	^ leftWidth @ topHeight corner: ( rightWidth @ bottomHeight ).
! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 13:34'!
leftWidth
	^ leftWidth! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 13:34'!
rightWidth
	^ rightWidth! !

!WindowTheme methodsFor: 'frame' stamp: 'jlb 6/12/2001 13:35'!
topHeight
	^ topHeight! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
activeTitleColor
  ^ lookDictionary at: #activeTitleColor ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
bottomActive
  ^ lookDictionary at: #bottomActive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
bottomEdge
  ^ lookDictionary at: #bottomEdge ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
bottomInactive
  ^ lookDictionary at: #bottomInactive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/27/2002 22:48'!
closeBoxButtonClass
  ^ lookDictionary at: #closeBoxButtonClass ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
closeBoxEdges
  ^ lookDictionary at: #closeBoxEdges ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/24/2002 23:56'!
closeBoxExtent
  ^ lookDictionary at: #closeBoxExtent ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
closeBoxFractions
  ^ lookDictionary at: #closeBoxFractions ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
closeBoxImages
  ^ lookDictionary at: #closeBoxImages ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
closeBoxLayout
  ^ lookDictionary at: #closeBoxLayout ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
disabledTitleColor
  ^ lookDictionary at: #disabledTitleColor ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/23/2002 14:41'!
growBoxEdges
  ^ lookDictionary at: #growBoxEdges ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/28/2002 14:22'!
growBoxForm
  ^ lookDictionary at: #growBoxForm ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/23/2002 14:41'!
growBoxFractions
  ^ lookDictionary at: #growBoxFractions ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/23/2002 14:41'!
growBoxLayout
  ^ lookDictionary at: #growBoxLayout ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
helpBoxEdges
  ^ lookDictionary at: #helpBoxEdges ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/25/2002 00:01'!
helpBoxExtent
  ^ lookDictionary at: #helpBoxExtent ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
helpBoxFractions
  ^ lookDictionary at: #helpBoxFractions ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
helpBoxImages
  ^ lookDictionary at: #helpBoxImages ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/30/2001 23:27'!
labelHeight
  ^ lookDictionary at: #labelHeight ifAbsent: [ 22 ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/21/2002 21:51'!
labelWidgetAllowance
  ^ lookDictionary at: #labelWidgetAllowance ifAbsent: [ 100 ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
leftActive
  ^ lookDictionary at: #leftActive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
leftEdge
  ^ lookDictionary at: #leftEdge ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
leftInactive
  ^ lookDictionary at: #leftInactive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/27/2002 23:23'!
maxBoxButtonClass
  ^ lookDictionary at: #maxBoxButtonClass ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
maxBoxEdges
  ^ lookDictionary at: #maxBoxEdges ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/24/2002 23:58'!
maxBoxExtent
  ^ lookDictionary at: #maxBoxExtent ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
maxBoxFractions
  ^ lookDictionary at: #maxBoxFractions ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
maxBoxImages
  ^ lookDictionary at: #maxBoxImages ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
maxBoxLayout
  ^ lookDictionary at: #maxBoxLayout ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/27/2002 23:22'!
minBoxButtonClass
  ^ lookDictionary at: #minBoxButtonClass ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
minBoxEdges
  ^ lookDictionary at: #minBoxEdges ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 2/24/2002 23:59'!
minBoxExtent
  ^ lookDictionary at: #minBoxExtent ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
minBoxFractions
  ^ lookDictionary at: #minBoxFractions ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
minBoxImages
  ^ lookDictionary at: #minBoxImages ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
minBoxLayout
  ^ lookDictionary at: #minBoxLayout ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
paneInset
  ^ lookDictionary at: #paneInset ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
rightActive
  ^ lookDictionary at: #rightActive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
rightEdge
  ^ lookDictionary at: #rightEdge ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
rightInactive
  ^ lookDictionary at: #rightInactive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:23'!
titleLayoutFrame
  ^ lookDictionary at: #titleLayoutFrame ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
topActive
  ^ lookDictionary at: #topActive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
topEdge
  ^ lookDictionary at: #topEdge ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 9/13/2001 21:16'!
topInactive
  ^ lookDictionary at: #topInactive ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
wantsTitleShadow
  ^ lookDictionary at: #wantsTitleShadow ifAbsent: [ false ]! !


!WindowTitleMorph methodsFor: 'activate/passivate' stamp: 'jlb 2/28/2002 20:26'!
activate
	| theme label |
	label _ self firstSubmorph.
	label
		ifNil: [^ self].
	theme _ owner theme.
	theme
		ifNotNil: [theme wantsTitleShadow
				ifTrue: [self addDropShadow].
			label color: theme activeTitleColor]! !

!WindowTitleMorph methodsFor: 'activate/passivate' stamp: 'jlb 2/28/2002 20:26'!
passivate
	| theme label |

	label _ self firstSubmorph.
	label ifNil: [ ^ self ].
	theme _ owner theme.
	theme
		ifNotNil: [theme wantsTitleShadow
				ifTrue: [label removeDropShadow].
			label color: theme disabledTitleColor]! !

!WindowTitleMorph methodsFor: 'drop shadows' stamp: 'jlb 10/23/2001 23:42'!
addDropShadow

	| label |
	label _ self firstSubmorph.
	label ifNil: [ ^ self ].
	label addDropShadow.
	label shadowPoint: 5 @ 5 + label bounds center

! !

!WindowTitleMorph methodsFor: 'initialization' stamp: 'jlb 2/7/2002 10:58'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight;
		 clipSubmorphs: true ;
		 cellPositioning: #center;
		 wrapCentering: #center;		" The title is placed in the center of the title "
		 listCentering: #topLeft.		" determines the justification style ; left right center"
	self setProperty: #wantsActivate toValue: true.
	self setProperty: #morphicLayerNumber toValue: 80.
! !


!WindowTitleMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 2/28/2002 20:27'!
newInstance: aLabelString theme: aTheme

	| labelString label frame toReturn  |
	labelString _ aLabelString.
	toReturn _ self new.
	label _ StringMorph new contents: labelString;
				 font: Preferences windowTitleFont emphasis: 1.
	toReturn name: #label.
	aTheme
		ifNil: [
			label color: Color black.
			frame _ LayoutFrame new.
			frame leftFraction: 0.5;
				 topFraction: 0;
				 leftOffset: label width negated // 2;
				 topOffset: 8]
		ifNotNil: [ 
			label color: aTheme activeTitleColor.
			frame _ aTheme titleLayoutFrame copy.
			aTheme titleJustification ifNotNilDo: [ :justify | toReturn perform: justify ].
			].
	toReturn layoutFrame: frame.
	toReturn addMorph: label.
	^ toReturn.! !

WindowTitleMorph class removeSelector: #newInstance:!

!WindowFrameMorph reorganize!
('accessing' bottomRightInset bottomRightInset: drawBlock drawBlock: frameColor frameColor: growExtent growExtent: labelArea labelFontColor labelFontColor: topLeftInset topLeftInset:)
('buttons' addCloseBox closeBox collapseBox deleteCloseBox expandBox label menuBox removeMenuBox)
('initialization' addDefaultFrame: addFrame:growExtent: initialize)
('geometry' setWindowBounds:)
('label' labelHeight setLabel:)
('frame geometry' addBottomFrame: addBottomLeftFrame addBottomLeftFrame: addBottomRightFrame addBottomRightFrame: addFrame addLeftFrame: addMorphInLayer:fullFrame: addRightFrame: addTopFrame: addTopLeftFrame addTopLeftFrame: addTopRightFrame addTopRightFrame: windowMinimumExtent)
('message handling' closeBoxHit collapseOrExpand expandBoxHit offerWindowMenu)
('color' buildFillStyle:color: paneColor: setStripeColorsFrom:)
('top window' activate lockInactivePortions passivate)
('resize edges' hideResizeEdges showResizeEdges)
('layout' paneInset windowBoundsInset)
('drawing' drawOn: superDrawOn:)
('collpase / exapnd' collapse expand)
('geometry testing' containsPoint:)
!

WindowBorderMorph removeSelector: #position:!

!WindowBorderCornerMorph reorganize!
('geometry' calculateOffset: doFastWindowReframe:offset: fastFramingOn)
('access' cursorName cursorName: obvious obvious:)
('drawing' drawOn:)
('event handling' mouseDown: mouseEnter: mouseLeave: mouseUp:)
('initialization' initialize)
('WiW support' morphicLayerNumber)
!


!DefaultFrameMorph reorganize!
('drawing' drawOn:)
('rounding' roundedCorners)
('initialize' initialize)
('top window' activate passivate)
!

"Postscript: "

Preferences
   setPreference: #inboardScrollbars toValue: true;
   setPreference: #roundedWindowCorners toValue: false.
!

