'From Squeak3.2alpha of 4 October 2001 [latest update: #4441] on 20 January 2002 at 1:59:51 pm'!

!Morph methodsFor: 'initialization' stamp: 'jlb 10/30/2001 23:37'!
openInWindowLabeled: aString inWorld: aWorld

	| window extent |

	window _ (SystemWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent _ self fullBounds extent + 
			(window windowFrame borderWidth@window labelHeight) + window windowFrame borderWidth.
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

!Morph methodsFor: 'e-toy support' stamp: 'jlb 10/30/2001 23:40'!
embedInWindow

	| window worldToUse |

	worldToUse _ self world.		"I'm assuming we are already in a world"
	window _ (SystemWindow labelled: self defaultLabelForInspector) model: nil.
	window bounds: ((self position - ((0@window labelHeight) + window windowFrame borderWidth))
						corner: self bottomRight + window windowFrame borderWidth).
	window addMorph: self frame: (0@0 extent: 1@1).
	window updatePaneColors.
	worldToUse addMorph: window.
	window activate! !

!Morph methodsFor: 'e-toy support' stamp: 'jlb 10/30/2001 23:37'!
wrappedInWindowWithTitle: aTitle
	| aWindow w2 |
	aWindow _ (SystemWindow labelled: aTitle) model: Model new.
	aWindow addMorph: self frame: (0@0 extent: 1@1).
	w2 _ aWindow windowFrame borderWidth * 2.
	w2 _ 3.		"oh, well"
	aWindow extent: self fullBounds extent + (0 @ aWindow labelHeight) + (w2 @ w2).
	^ aWindow! !


!Preferences class methodsFor: 'preferences panel' stamp: 'jlb 10/30/2001 23:35'!
openFactoredPanelWithWidth: aWidth 
	"Open up a preferences panel of the given width"

	"Preferences openFactoredPanelWithWidth: 325"
	| window playfield aPanel |

	aPanel _ PreferencesPanel new.
	playfield _ PasteUpMorph new width: aWidth.
	playfield dropEnabled: false.
	self initializePreferencePanel: aPanel in: playfield.
	self couldOpenInMorphic
		ifTrue: [window _ (SystemWindow labelled: 'Preferences')
						model: aPanel.
			window on: #keyStroke send: #keyStroke: to: aPanel.
			window
				bounds: (100 @ 100 - (0 @ window labelHeight + window windowFrame borderWidth) extent: playfield extent + (2 * window windowFrame borderWidth)).
			window
				addMorph: playfield
				frame: (0 @ 0 extent: 1 @ 1).
			window updatePaneColors.
			window setProperty: #minimumExtent toValue: window extent.
			self currentWorld addMorphFront: window.
			window center: self currentWorld center.
			window activateAndForceLabelToShow]
		ifFalse:
			[(window _ MVCWiWPasteUpMorph newWorldForProject: nil) addMorph: playfield.
			MorphWorldView
				openOn: window
				label: 'Preferences'
				extent: playfield extent]! !

!Preferences class methodsFor: 'preferences panel' stamp: 'jlb 10/30/2001 23:25'!
preferencesControlPanel
	"Answer a Preferences control panel window"

	"Preferences preferencesControlPanel openInHand"
	| window playfield aPanel |

	aPanel _ PreferencesPanel new.
	playfield _ PasteUpMorph new width: 325.
	playfield dropEnabled: false.
	self initializePreferencePanel: aPanel in: playfield.
	window _ (SystemWindow labelled: 'Preferences') model: aPanel.
	window on: #keyStroke send: #keyStroke: to: aPanel.
	window bounds: (100 @ 100 - (0 @ window labelHeight + window windowFrame borderWidth) extent: playfield extent + (2 * window windowFrame borderWidth)).
	window addMorph: playfield frame: (0 @ 0 extent: 1 @ 1).
	window updatePaneColors.
	window setProperty: #minimumExtent toValue: playfield extent + (12@15).
	^ window! !


!WindowFrameMorph methodsFor: 'label' stamp: 'jlb 10/30/2001 23:28'!
labelHeight
	| theme |
	theme _ WindowTheme current.
	theme ifNil: [ ^ 22 ]
		ifNotNil: [ ^ theme labelHeight ].
! !


!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/30/2001 23:27'!
labelHeight
  ^ lookDictionary at: #labelHeight ifAbsent: [ 22 ]! !

