'From Squeak3.2alpha of 4 October 2001 [latest update: #4441] on 24 October 2001 at 10:09:49 am'!
Smalltalk renameClassNamed: #WindowTitleMorphII as: #WindowTitleMorph!
Morph subclass: #WindowTitleMorph
	instanceVariableNames: 'title '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Windows'!

!SystemWindow methodsFor: 'label' stamp: 'jlb 10/5/2001 07:21'!
setLabel: aString
	" set the title of the window to be aString "
	labelString _ aString.
	windowFrame ifNil: [ ^ self ].
	windowFrame setLabel: labelString.
! !


!SystemWindow class methodsFor: 'instance creation' stamp: 'jlb 10/5/2001 07:31'!
labelled: labelString

	^ self new setLabel: labelString.! !


!WindowFrameImagedMorph methodsFor: 'window frame' stamp: 'jlb 10/24/2001 00:10'!
setLabel: aLabelString 
	| label |
	label _ self submorphNamed: #label.
	label
		ifNotNil: [label delete].
	label _ WindowTitleMorph newInstance: aLabelString.
	self addMorph: label
		fullFrame: ( label layoutFrame ).
	self active ifTrue: [ label activate ]
				ifFalse: [ label passivate ].! !


!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
activeTitleColor
  ^ lookDictionary at: #activeTitleColor ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
disabledTitleColor
  ^ lookDictionary at: #disabledTitleColor ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/24/2001 00:14'!
titleJustification
  ^ lookDictionary at: #titleJustification ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:23'!
titleLayoutFrame
  ^ lookDictionary at: #titleLayoutFrame ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 10/5/2001 00:06'!
wantsTitleShadow
  ^ lookDictionary at: #wantsTitleShadow ifAbsent: [ false ]! !


!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:40'!
activate
	| theme label |
	label _ self firstSubmorph.
	label
		ifNil: [^ self].
	theme _ WindowTheme current.
	theme
		ifNotNil: [theme wantsTitleShadow
				ifTrue: [self addDropShadow].
			label color: theme activeTitleColor]! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:42'!
addDropShadow

	| label |
	label _ self firstSubmorph.
	label ifNil: [ ^ self ].
	label addDropShadow.
	label shadowPoint: 5 @ 5 + label bounds center

! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:39'!
centerJustify
	" center the title in the title bar "
	self listCentering: #center! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:26'!
drawOn: aCanvas
! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:29'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight;
		 clipSubmorphs: true ;
		 cellPositioning: #center;
		 wrapCentering: #center;		" The title is placed in the center of the title "
		 listCentering: #topLeft.		" determines the justification style ; left right center"
	self setProperty: #wantsActivate toValue: true.
! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:39'!
leftJustify
	" left justify the title in the title bar "
	self listCentering: #topLeft! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:33'!
passivate
	| theme label |

	label _ self firstSubmorph.
	label ifNil: [ ^ self ].
	theme _ WindowTheme current.
	theme
		ifNotNil: [theme wantsTitleShadow
				ifTrue: [label removeDropShadow].
			label color: theme disabledTitleColor]! !

!WindowTitleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 10/23/2001 23:39'!
rightJustify
	" right justify the title in the title bar "
	self listCentering: #bottomRight! !


!WindowTitleMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 10/24/2001 00:17'!
newInstance: aLabelString

	| labelString label theme frame toReturn |
	labelString _ aLabelString.
	toReturn _ self new.
	label _ StringMorph new contents: labelString;
				 font: Preferences windowTitleFont emphasis: 1.
	toReturn name: #label.
	theme _ WindowTheme current.
	theme
		ifNil: [
			label color: Color black.
			frame _ LayoutFrame new.
			frame leftFraction: 0.5;
				 topFraction: 0;
				 leftOffset: label width negated // 2;
				 topOffset: 8]
		ifNotNil: [ 
			label color: theme activeTitleColor.
			frame _ theme titleLayoutFrame copy.
			theme titleJustification ifNotNilDo: [ :justify | toReturn perform: justify ].
			].
	toReturn layoutFrame: frame.
	toReturn addMorph: label.
	^ toReturn.! !

WindowTitleMorph removeSelector: #justify:!
