'From Squeak3.1alpha of 9 September 2001 [latest update: #4332] on 9 September 2001 at 9:57 am'!
"Change Set:		WindowFrameRefactor
Date:			09 September 2001
Author:			Jim Benson


EXPERIMENTAL --


Converts SystemWindows to use window frames ; eliminates instance variables in class SystemWindow.

File in changeset.
Preferences:
Window corner rounding should be off.
Looks better with inboard scroll bars.

Converts to use Squeak 3.1a - 4332 
"!

BorderedMorph subclass: #AbstractWindowFrame
	instanceVariableNames: 'window active labelWidgetAllowance '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!AbstractWindowFrame commentStamp: '<historical>' prior: 0!
I represent the abstract class that contains the protocols for the window frame. This is part of the refactoring of SystemWindow!

AbstractWindowFrame subclass: #SqueakWindowFrame
	instanceVariableNames: 'stripes label closeBox collapseBox menuBox labelArea expandBox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

MorphicModel subclass: #SystemWindow
	instanceVariableNames: 'labelString stripes label closeBox collapseBox activeOnlyOnTop paneMorphs paneRects collapsedFrame fullFrame isCollapsed menuBox mustNotClose labelWidgetAllowance updatablePanes allowReframeHandles labelArea expandBox windowFrame '
	classVariableNames: 'TopWindow '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!AbstractWindowFrame methodsFor: 'top window' stamp: 'jlb 8/5/2001 20:53'!
activate
	self active: true.! !

!AbstractWindowFrame methodsFor: 'top window' stamp: 'jlb 8/6/2001 14:57'!
lockInactivePortions! !

!AbstractWindowFrame methodsFor: 'top window' stamp: 'jlb 8/5/2001 20:53'!
passivate
	self active: false.! !

!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 19:49'!
addCloseBox
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 19:51'!
addExpandBox
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 19:51'!
addMenuControl
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 8/4/2001 23:40'!
initialize
	super initialize.
	active _ false.
	self setProperty: #wantsActivate toValue: true .! !

!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 8/16/2001 20:34'!
removeMenuBox
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'label' stamp: 'jlb 7/30/2001 22:08'!
relabelEvent: evt
	window relabelEvent: evt.! !

!AbstractWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 19:58'!
closeBoxHit
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 20:11'!
expandBoxHit
	^ self subclassResponsibility! !

!AbstractWindowFrame methodsFor: 'window resizing' stamp: 'jlb 7/31/2001 21:49'!
spawnReframeHandle: ptName event: event! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 8/5/2001 20:53'!
active
	^ active! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 8/5/2001 20:53'!
active: aBoolean
	active _ aBoolean.! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 7/31/2001 20:40'!
labelWidgetAllowance
	^ labelWidgetAllowance! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 7/31/2001 20:41'!
labelWidgetAllowance: aLabelWidgetAllowance
	labelWidgetAllowance _ aLabelWidgetAllowance! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 8/5/2001 21:39'!
stripes
^ nil.! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 8/4/2001 21:44'!
window
	^ window! !

!AbstractWindowFrame methodsFor: 'accessing' stamp: 'jlb 8/4/2001 21:44'!
window: aWindow
	window _ aWindow! !

!AbstractWindowFrame methodsFor: 'color' stamp: 'jlb 8/4/2001 23:12'!
paneColor: aColor! !

!AbstractWindowFrame methodsFor: 'color' stamp: 'jlb 8/4/2001 23:50'!
setStripeColorsFrom: paneColor! !

!AbstractWindowFrame methodsFor: 'collapse/expand' stamp: 'jlb 8/18/2001 13:41'!
collapse
	" Collapse the window frame "! !

!AbstractWindowFrame methodsFor: 'collapse/expand' stamp: 'jlb 8/18/2001 13:41'!
expand
	" expand the window frame "! !


!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:27'!
closeBox
	^ closeBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
closeBox: aCloseBox
	closeBox _ aCloseBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:27'!
collapseBox
	^ collapseBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
collapseBox: aCollapseBox
	collapseBox _ aCollapseBox.! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
expandBox
	^ expandBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:30'!
expandBox: anExpandBox
	expandBox _ anExpandBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:27'!
label	
	^ label! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
label: aLabel
	label _ aLabel! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
labelArea
	^ labelArea! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:29'!
labelArea: aLabelArea
	labelArea _ aLabelArea! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:27'!
menuBox
	^ menuBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:29'!
menuBox: aMenuBox
	menuBox _ aMenuBox! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 8/5/2001 13:00'!
newFrame: aWindow label: labelString

		window _ aWindow.
		self label: ( StringMorph new contents: labelString;
				font: Preferences windowTitleFont emphasis: 1).
		self label on: #mouseDown send: #relabelEvent: to: self.

		self addLabelArea: window.
		self addStripes.
		self addCollapseBox.
		" setLabelWidgetAllowance is implemented incorrectly ;
	       uses lazy initialization, and during conversion to windowFrames
		  uses a circular reference. Eventually, I should fix it "
		window windowFrame: self.
		self labelWidgetAllowance: ( window setLabelWidgetAllowance).
		self addCloseBox.
		self addMenuControl.
		self labelArea addMorph: (self label).
		window wantsExpandBox ifTrue: [self addExpandBox].

		self setFramesForLabelArea: aWindow.
		Preferences noviceMode ifTrue:
			[self closeBox ifNotNil: [self closeBox setBalloonText: 'close window'].
			 self menuBox ifNotNil: [self menuBox setBalloonText: 'window menu'].
			 self collapseBox ifNotNil: [self collapseBox setBalloonText: 'collapse/expand window']].
! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:26'!
stripes
	^ stripes! !

!SqueakWindowFrame methodsFor: 'accessors' stamp: 'jlb 7/24/2001 12:28'!
stripes: aStripe
	stripes _ aStripe! !

!SqueakWindowFrame methodsFor: 'top window' stamp: 'jlb 7/31/2001 19:52'!
activate
	" set the stripes and make sure everything is unlocked "
	super activate.
	self labelArea
		ifNotNil: [self labelArea
				submorphsDo: [:m | m unlock].
			self setStripeColorsFrom: window paneColorToUse]! !

!SqueakWindowFrame methodsFor: 'top window' stamp: 'jlb 8/6/2001 15:01'!
lockInactivePortions

	self labelArea ifNotNil:
		[self labelArea submorphsDo: [:m |
			(m == ( self closeBox ) or: [m == (self collapseBox)]) ifTrue:
				[Preferences noviceMode ifTrue: [m lock] ifFalse: [m lock]]]]! !

!SqueakWindowFrame methodsFor: 'top window' stamp: 'jlb 7/31/2001 19:52'!
passivate
	super passivate.
	window setStripeColorsFrom: window paneColorToUse.
	self labelArea unlock.
	self labelArea
		ifNil: ["i.e. label area is nil, so we're titleless"
			self adjustBorderUponDeactivationWhenLabeless]
		ifNotNil: [self labelArea
				submorphsDo: [:m | (m == self closeBox
							or: [m == self collapseBox])
						ifTrue: [Preferences noviceMode
								ifTrue: [m lock]]
						ifFalse: [m lock]]]! !

!SqueakWindowFrame methodsFor: 'label' stamp: 'jlb 7/28/2001 23:18'!
labelHeight
	window ifNotNil: [ ^ window oldLabelHeight ].
	^ 0.! !

!SqueakWindowFrame methodsFor: 'label' stamp: 'jlb 8/19/2001 15:24'!
setStripeColorsFrom: paneColor
	"Set the stripe color based on the given paneColor"
	labelArea ifNotNil:[
		Preferences alternativeWindowLook 
			ifTrue:[labelArea color: paneColor lighter]
			ifFalse:[labelArea color: Color black]].
	stripes ifNil: [^ window].
	Preferences alternativeWindowLook ifFalse:[
		window isActive
			ifTrue: [stripes second color: paneColor;
						borderColor: stripes second color darker.
					stripes first color: stripes second borderColor darker;
						borderColor: stripes first color darker]
			ifFalse: ["This could be much faster"
					stripes second color: paneColor; borderColor: paneColor.
					stripes first color: paneColor; borderColor: paneColor].
	] ifTrue:[
		window isActive
			ifTrue: [stripes first borderColor: paneColor lighter;
						color: stripes first borderColor.
					stripes second borderColor: stripes first color lighter;
						color: stripes second borderColor]
			ifFalse: ["This could be much faster"
					stripes second color: paneColor; borderColor: paneColor.
					stripes first color: paneColor; borderColor: paneColor].
	].! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 21:13'!
addBalloonTexts
	Preferences noviceMode
		ifTrue: [self closeBox
				ifNotNil: [self closeBox setBalloonText: 'close window'].
			self menuBox
				ifNotNil: [self menuBox setBalloonText: 'window menu'].
			self collapseBox
				ifNotNil: [self collapseBox setBalloonText: 'collapse/expand window']]! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 8/18/2001 20:41'!
addCloseBox
	"If I have a labelArea, add a close box to it"

	| frame |
	self labelArea ifNil: [^ self].
	self closeBox ifNotNil: [ ^ self ].
	closeBox _ SimpleButtonMorph new borderWidth: 0;
			label: 'X' font: Preferences standardButtonFont; color: Color transparent;
			actionSelector: #closeBoxHit; target: self; extent: 14@14;
			setBalloonText: 'close this window'.
	frame _ LayoutFrame new.
	frame leftFraction: 0; leftOffset: 4; topFraction: 0; topOffset: 1.
	closeBox layoutFrame: frame.
	labelArea addMorph: closeBox.! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 20:50'!
addCollapseBox
		| aFont |
	
		"Add collapse box so #labelHeight will work"
		aFont _ Preferences standardButtonFont.
		self collapseBox: ( SimpleButtonMorph new borderWidth: 0;
				label: 'O' font: aFont; color: Color transparent;
				actionSelector: #collapseOrExpand; target: self; extent: 14@14;
				setBalloonText: 'collapse this window').
		self labelArea addMorph: (self collapseBox).

! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 8/18/2001 20:42'!
addExpandBox
	"If I have a labelArea, add a close box to it"

	| frame |
	labelArea ifNil: [^ self].

	expandBox _ IconicButton new borderWidth: 0;
			labelGraphic: (ScriptingSystem formAtKey: 'expandBox'); color: Color transparent; 
			actWhen: #buttonUp;
			actionSelector: #expandBoxHit; target: self;
			setBalloonText: 'expand to full screen'.
	frame _ LayoutFrame new.
	frame leftFraction: 1; leftOffset: -30; topFraction: 0; topOffset: 0.
	expandBox layoutFrame: frame.
	labelArea addMorph: expandBox.! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/28/2001 22:29'!
addLabelArea: aWindow

	
	self labelArea: ( (AlignmentMorph newSpacer: Color transparent) vResizing: #shrinkWrap;
			layoutPolicy: ProportionalLayout new).
	aWindow addMorph: (self labelArea).! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 8/18/2001 20:43'!
addMenuControl
	"If I have a label area, add a menu control to it. "
	| frame |
	labelArea ifNil: [^ self].  "No menu if no label area"
	menuBox ifNotNil: [menuBox delete].
	menuBox _ IconicButton new borderWidth: 0;
			labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu'); color: Color transparent; 
			actWhen: #buttonUp;
			actionSelector: #offerWindowMenu; target: self;
			setBalloonText: 'window menu'.
	frame _ LayoutFrame new.
	frame leftFraction: 0; leftOffset: 17; topFraction: 0; topOffset: 0.
	menuBox layoutFrame: frame.
	labelArea addMorph: menuBox
! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 20:37'!
addStripes

	self stripes: ( Array with: (RectangleMorph newBounds: bounds)  "see extent:"
					with: (RectangleMorph newBounds: bounds)).
	self labelArea addMorph: (self stripes first borderWidth: 1).
	self labelArea addMorph: (self stripes second borderWidth: 2).
! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/24/2001 12:24'!
initialize
	super initialize.! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/25/2001 22:32'!
setFramesForLabelArea: aWindow
	"an aid to converting old instances, but then I found convertAlignment (jesse welton's note)"

	| frame |
	self labelArea ifNil: [^ self].
	frame _ LayoutFrame new.
	frame leftFraction: 0.5; topFraction: 0; leftOffset: self label width negated // 2.
	self label layoutFrame: frame.

	frame _ LayoutFrame new.
	frame rightFraction: 1; topFraction: 0; rightOffset: -1; topOffset: 1.
	self collapseBox ifNotNilDo: [:cb | cb layoutFrame: frame].

	self stripes isEmptyOrNil ifFalse:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
			leftOffset: 1; topOffset: 1; rightOffset: -1.
		self stripes first layoutFrame: frame.
		self stripes first height: aWindow labelHeight - 2.
		self stripes first hResizing: #spaceFill.

		frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				leftOffset: 3; topOffset: 3; rightOffset: -3.
		self stripes last layoutFrame: frame.
		self stripes last height: aWindow labelHeight - 6.
		self stripes last hResizing: #spaceFill].

	self labelArea ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				topOffset: aWindow labelHeight negated.
		self labelArea layoutFrame: frame]

! !

!SqueakWindowFrame methodsFor: 'initialization' stamp: 'jlb 7/30/2001 22:11'!
setLabel: aString 
	| frame |
	self label
		ifNil: [^ self].
	self label contents: aString.
	self labelWidgetAllowance.
	"Sets it if not already"
	window isCollapsed
		ifTrue: [window extent: self label width + self labelWidgetAllowance @ (self labelHeight + 2)]
		ifFalse: [self label fitContents;
				setWidth: (self label width min: window bounds width - self labelWidgetAllowance).
			self label align: self label bounds topCenter with: window bounds topCenter + (0 @ window borderWidth).
			window collapsedFrame
				ifNotNil: [window
						collapsedFrame: (window collapsedFrame withWidth: self label width + self labelWidgetAllowance)]].
	frame _ LayoutFrame new.
	frame leftFraction: 0.5;
		 topFraction: 0;
		 leftOffset: self label width negated // 2.
	self label layoutFrame: frame! !

!SqueakWindowFrame methodsFor: 'geometry' stamp: 'jlb 7/30/2001 22:06'!
extent: newPoint
	self labelArea ifNotNil:
		[window setStripeColorsFrom: window paneColorToUse.
		self label fitContents; setWidth: (self label width min: window bounds width - self labelWidgetAllowance).
		self label layoutFrame leftOffset: self label width negated // 2].! !

!SqueakWindowFrame methodsFor: 'geometry' stamp: 'jlb 8/16/2001 20:36'!
removeMenuBox
	menuBox ifNotNil:
		[menuBox delete.
		menuBox _ nil].
! !

!SqueakWindowFrame methodsFor: 'layout' stamp: 'jlb 7/31/2001 12:20'!
paneInset
	" return the inset rectangle for the pane area of the window "
	^ 0 @ self labelHeight corner: 0 @ 0! !

!SqueakWindowFrame methodsFor: 'layout' stamp: 'jlb 7/29/2001 20:40'!
windowBoundsInset
	^ 0 @ self labelHeight corner: 0 @ 0! !

!SqueakWindowFrame methodsFor: 'menu' stamp: 'jlb 7/31/2001 21:22'!
deleteCloseBox
	self closeBox ifNotNil:
		[self closeBox delete.
		self closeBox: nil]! !

!SqueakWindowFrame methodsFor: 'window resizing' stamp: 'jlb 8/18/2001 19:42'!
spawnReframeHandle: aPtName event: event 
	| pt ptName resizer localPt newBounds cursor |

	ptName _ aPtName.
	pt _ event cursorPoint.
	#(topLeft bottomRight bottomLeft topRight) do:
		[:corner |  "Check for window corner adjust"
		(pt dist: (window bounds perform: corner)) < 20 ifTrue: [ptName _ corner]].

	cursor _ Cursor resizeForEdge: ptName.
	resizer _ NewHandleMorph new
		sensorMode: window fastFramingOn;

		followHand: event hand
		forEachPointDo:
			[:p | localPt _ window pointFromWorld: p.
			newBounds _ window bounds
				withSideOrCorner: ptName
				setToPoint: localPt
				minExtent: window minimumExtent.
			window fastFramingOn 
			ifTrue:
				[Cursor currentCursor == cursor ifFalse:[
					event hand visible: false; refreshWorld; visible: true.
					cursor show].
				window doFastWindowReframe: ptName]
			ifFalse:
				[window bounds: newBounds.
				(Preferences roundedWindowCorners
					and: [#(bottom right bottomRight) includes: ptName])
					ifTrue:
					["Complete kluge: causes rounded corners to get painted correctly,
					in spite of not working with top-down displayWorld."
					ptName = #bottom ifFalse:
						[window invalidRect: (window bounds topRight - (6@0) extent: 7@7)].
					ptName = #right ifFalse:
						[window invalidRect: (window bounds bottomLeft - (0@6) extent: 7@7)].
					window invalidRect: (window bounds bottomRight - (6@6) extent: 7@7)]]]
		lastPointDo:
			[:p | ]
		withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SqueakWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 20:13'!
closeBoxHit
	self labelArea owner closeBoxHit! !

!SqueakWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 20:42'!
collapseOrExpand
	self labelArea owner collapseOrExpand! !

!SqueakWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 20:13'!
expandBoxHit
	self labelArea owner expandBoxHit! !

!SqueakWindowFrame methodsFor: 'window messages' stamp: 'jlb 7/25/2001 20:47'!
offerWindowMenu
	labelArea owner offerWindowMenu! !


!SqueakWindowFrame class methodsFor: 'as yet unclassified' stamp: 'jlb 8/5/2001 13:01'!
defaultWindowFrame: aWindow
	
	| toReturn |
	toReturn _ self new.
	aWindow wantsLabel
	ifTrue: [ toReturn newFrame: aWindow label: (aWindow labelString)].
	aWindow
		on: #mouseEnter
		send: #spawnReframeHandle:
		to: aWindow.
	aWindow
		on: #mouseLeave
		send: #spawnReframeHandle:
		to: aWindow.
	^ toReturn.! !


!SystemWindow methodsFor: 'initialization' stamp: 'jlb 7/24/2001 20:24'!
addLabelArea

	self labelArea: ( (AlignmentMorph newSpacer: Color transparent) vResizing: #shrinkWrap;
			layoutPolicy: ProportionalLayout new).
	self addMorph: (self labelArea).! !

!SystemWindow methodsFor: 'initialization' stamp: 'jlb 9/9/2001 09:51'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	| |
	super initialize.
	allowReframeHandles _ true.
	labelString
		ifNil: [labelString _ 'Untitled Window'].
	isCollapsed _ false.
	activeOnlyOnTop _ true.
	paneMorphs _ Array new.
	Preferences alternativeWindowLook ifFalse:[
		borderColor _ Color black.
		borderWidth _ 1.
		color _ Color black.
	] ifTrue:[
		borderColor _ #raised.
		borderWidth _ 2.
		color _ Color white.
	].
	self layoutPolicy: ProportionalLayout new.
	self
		layoutInset: (0 @ 16 corner: 0 @ 0).
	SqueakWindowFrame defaultWindowFrame: self.
	self extent: 300 @ 200.
	mustNotClose _ false.
	updatablePanes _ Array new! !

!SystemWindow methodsFor: 'initialization' stamp: 'jlb 8/18/2001 20:45'!
model: aModel
	super model: aModel.
	self paneColor: nil.
	" the pane color is determined by the model "
	windowFrame ifNotNil: [
		windowFrame paneColor: ( self paneColor ) ].! !

!SystemWindow methodsFor: 'initialization' stamp: 'jlb 8/18/2001 20:48'!
setFramesForLabelArea
	"an aid to converting old instances, but then I found convertAlignment (jesse welton's note)"

	| frame |
	self labelArea ifNil: [^ self].
	frame _ LayoutFrame new.
	frame leftFraction: 0.5; topFraction: 0; leftOffset: self windowFrame label width negated // 2.
	windowFrame label layoutFrame: frame.

	frame _ LayoutFrame new.
	frame rightFraction: 1; topFraction: 0; rightOffset: -1; topOffset: 1.
	self collapseBox ifNotNilDo: [:cb | cb layoutFrame: frame].

	self stripes isEmptyOrNil ifFalse:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
			leftOffset: 1; topOffset: 1; rightOffset: -1.
		self stripes first layoutFrame: frame.
		self stripes first height: self labelHeight - 2.
		self stripes first hResizing: #spaceFill.

		frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				leftOffset: 3; topOffset: 3; rightOffset: -3.
		self stripes last layoutFrame: frame.
		self stripes last height: self labelHeight - 6.
		self stripes last hResizing: #spaceFill].

	self labelArea ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				topOffset: self labelHeight negated.
		Preferences alternativeWindowLook ifTrue:[
			frame leftOffset: -1;  rightOffset: 1; topOffset: self labelHeight negated - 1;
				bottomFraction: 0; bottomOffset: 1.
		].
		self labelArea layoutFrame: frame]

! !

!SystemWindow methodsFor: 'geometry' stamp: 'jlb 7/28/2001 22:48'!
extent: newExtent 
	"Set the receiver's extent to value provided"
	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	windowFrame
		ifNotNil: [windowFrame extent: newExtent].
	isCollapsed
		ifTrue: [collapsedFrame _ self bounds]
		ifFalse: [fullFrame _ self bounds]! !

!SystemWindow methodsFor: 'geometry' stamp: 'jlb 8/16/2001 20:38'!
removeMenuBox
	self menuBox ifNotNil:
		[ windowFrame removeMenuBox].
! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 8/11/2001 14:06'!
getRawLabel
	^ self windowFrame label! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 7/28/2001 23:18'!
labelHeight
	windowFrame ifNotNil: [ ^ windowFrame labelHeight ].
	^ 0.! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 8/5/2001 12:45'!
labelString
	^ labelString! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 8/19/2001 21:50'!
oldLabelHeight
	"Answer the height for the window label.  The standard behavior is at bottom; a hook is provided so that models can stipulate other heights, in support of various less-window-looking demos."

	| aHeight |
	(model notNil and: [model respondsTo: #desiredWindowLabelHeightIn:]) ifTrue:
		[(aHeight _ model desiredWindowLabelHeightIn: self) ifNotNil: [^ aHeight]].

	^ windowFrame label ifNil: [0] ifNotNil:
		 [(windowFrame label height + 1) max:
			(self collapseBox ifNotNil: [self collapseBox height + 2] ifNil: [10])]! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 7/30/2001 22:11'!
setLabel: aString
	| frame |
	labelString _ aString.
	windowFrame ifNil: [ ^ self ].
	windowFrame setLabel: labelString.
! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 7/24/2001 18:58'!
setLabelWidgetAllowance
	self labelWidgetAllowance: 75.
	^ self labelWidgetAllowance.! !

!SystemWindow methodsFor: 'label' stamp: 'jlb 8/18/2001 18:02'!
setStripeColorsFrom: paneColor
	"Set the stripe color based on the given paneColor"

	windowFrame ifNotNil: [ ^ windowFrame setStripeColorsFrom: paneColor ].
! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 7/28/2001 21:55'!
addExpandBoxIfMissingAndWanted
	"Add an expand box if I don't have one and yet would like one"

	windowFrame expandBox ifNil: [self wantsExpandBox ifTrue: [windowFrame addExpandBox]]! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 8/18/2001 13:41'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state"

	isCollapsed
		ifTrue: 
			["Expand -- restore panes to morphics structure"
			isCollapsed _ false.
			Preferences collapseWindowsInPlace
				ifTrue: 
					[fullFrame := fullFrame align: fullFrame topLeft with: self getBoundsWithFlex topLeft]
				ifFalse:
					[collapsedFrame _ self getBoundsWithFlex].
			self collapseBox ifNotNilDo: [ :m | m setBalloonText: 'collapse this window'].
			"First save latest collapsedFrame"
			self setBoundsWithFlex: fullFrame.
			paneMorphs
				reverseDo: 
					[:m | 
					self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m].
			windowFrame expand.
			self activate "-- mainly for findWindow"]
		ifFalse: 
			["Collapse -- remove panes from morphics structure"
			isCollapsed _ true.
			fullFrame _ self getBoundsWithFlex.
			"First save latest fullFrame"
			paneMorphs do: [:m | m delete; releaseCachedState].
			model modelSleep.
			cf := self getCollapsedFrame.
			(collapsedFrame isNil and: [Preferences collapseWindowsInPlace not]) ifTrue:
				[collapsedFrame _ cf].
			self setBoundsWithFlex: cf.
			windowFrame collapse.
			self collapseBox ifNotNilDo: [ :m | m setBalloonText: 'expand this window'].
			self expandBox ifNotNilDo: [ :m | m setBalloonText: 'expand to full screen']].
	self layoutChanged! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 7/28/2001 22:53'!
collapsedFrame: aCollapseFrame
	collapsedFrame _ aCollapseFrame! !


!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 7/24/2001 18:42'!
expandBoxHit
	"The full screen expand box has been hit"

	isCollapsed
		ifTrue: [self hide.
			self collapseOrExpand.
			self unexpandedFrame ifNil: [ self unexpandedFrame: fullFrame. ].
			self fullScreen.
			self expandBox setBalloonText: 'contract to original size'.
			^ self show].
	self unexpandedFrame
		ifNil: [self unexpandedFrame: fullFrame.
			self fullScreen.
			self expandBox setBalloonText: 'contract to original size']
		ifNotNil: [self bounds: self unexpandedFrame.
			self unexpandedFrame: nil.
			self expandBox setBalloonText: 'expand to full screen' ]! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 8/18/2001 19:26'!
spawnPaneFrameHandle: event
	| resizer localPt side growingPane newBounds adjoiningPanes limit cursor |
	(self world firstSubmorph isKindOf: NewHandleMorph) ifTrue:
		[ ^ self  "Prevent multiple handles"].
	((self innerBounds withHeight: self labelHeight+4) containsPoint: event cursorPoint)
		ifTrue: [^ self "in label or top of top pane"].
	growingPane _ self paneWithLongestSide: [:s | side _ s] near: event cursorPoint.
	growingPane ifNil: [^ self].
	"don't resize pane side coincident with window side - RAA 5 jul 2000"
	(growingPane perform: side) = (self layoutBounds perform: side) ifTrue: [^self].
	(side == #top and: [growingPane top = self panelRect top]) ifTrue: [^self].
	adjoiningPanes _ paneMorphs select: [:pane | pane bounds bordersOn: growingPane bounds along: side].
	limit _ adjoiningPanes isEmpty
		ifFalse: [ (adjoiningPanes collect: [:pane | pane bounds perform: side])
			perform: ((#(top left) includes: side) ifTrue: [#max] ifFalse: [#min])]
		ifTrue: [self bounds perform: side].

	cursor _ Cursor resizeForEdge: side.
	resizer _ NewHandleMorph new
		sensorMode: self fastFramingOn;

		followHand: event hand
		forEachPointDo:
			[:p | localPt _ self pointFromWorld: p.
			newBounds _ growingPane bounds withSideOrCorner: side setToPoint: localPt minExtent: 40@20 limit: limit.
			self fastFramingOn 
			ifTrue:
				["For fast display, only higlight the rectangle during loop"
				Cursor currentCursor == cursor ifFalse:[
					event hand visible: false; refreshWorld; visible: true.
					cursor show].
				newBounds _ growingPane bounds
				  newRectButtonPressedDo:
					[:f | growingPane bounds withSideOrCorner: side
							setToPoint: (self pointFromWorld: Sensor cursorPoint)
							minExtent: 40@20 limit: limit].
					self reframePanesAdjoining: growingPane along: side
						to: newBounds]
			ifFalse:
				[self reframePanesAdjoining: growingPane along: side to: newBounds]]
		lastPointDo: [:p | ]
		withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 7/31/2001 21:53'!
spawnReframeHandle: event
	"The mouse has crossed a pane border.  Spawn a reframe handle."
	| resizer localPt pt ptName newBounds |

	allowReframeHandles ifFalse: [^ self].
	owner ifNil: [^ self  "Spurious mouseLeave due to delete"].
	(self isActive not or: [self isCollapsed]) ifTrue:  [^ self].
	((self world ifNil: [^ self]) firstSubmorph isKindOf: NewHandleMorph) ifTrue:
		[^ self  "Prevent multiple handles"].
	pt _ event cursorPoint.
	self bounds forPoint: pt closestSideDistLen:
		[:side :dist :len |  "Check for window side adjust"
		dist <= 2  ifTrue: [ptName _ side]].
	ptName ifNil:
		["Check for pane border adjust"
		^ self spawnPaneFrameHandle: event].

	" This is placed here as a stub for the old window frame reframing logic "
	windowFrame ifNotNil: [ ^ windowFrame spawnReframeHandle: ptName event: event ].

	#(topLeft bottomRight bottomLeft topRight) do:
		[:corner |  "Check for window corner adjust"
		(pt dist: (self bounds perform: corner)) < 20 ifTrue: [ptName _ corner]].

	resizer _ NewHandleMorph new
		sensorMode: self fastFramingOn;

		followHand: event hand
		forEachPointDo:
			[:p | localPt _ self pointFromWorld: p.
			newBounds _ self bounds
				withSideOrCorner: ptName
				setToPoint: localPt
				minExtent: self minimumExtent.
			self fastFramingOn 
			ifTrue:
				[self doFastWindowReframe: ptName]
			ifFalse:
				[self bounds: newBounds.
				(Preferences roundedWindowCorners
					and: [#(bottom right bottomRight) includes: ptName])
					ifTrue:
					["Complete kluge: causes rounded corners to get painted correctly,
					in spite of not working with top-down displayWorld."
					ptName = #bottom ifFalse:
						[self invalidRect: (self bounds topRight - (6@0) extent: 7@7)].
					ptName = #right ifFalse:
						[self invalidRect: (self bounds bottomLeft - (0@6) extent: 7@7)].
					self invalidRect: (self bounds bottomRight - (6@6) extent: 7@7)]]]
		lastPointDo:
			[:p | ].
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 7/31/2001 15:50'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"

	| oldTop outerMorph sketchEditor pal |
	outerMorph _ self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock].
	windowFrame ifNotNil: [ windowFrame activate ].
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		self labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor _ self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal _ self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 8/6/2001 15:02'!
lockInactivePortions
	"Make me unable to respond to mouse and keyboard.  Control boxes remain active, except in novice mode"

	self submorphsDo:
		[:m | (m == windowFrame) ifFalse: [m lock]].

	windowFrame ifNotNil: [ windowFrame lockInactivePortions ].

! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 7/31/2001 15:44'!
passivate
	"Make me unable to respond to mouse and keyboard"
	model modelSleep.
	"Nothing responds to the keyboard or mouse"
	self
		submorphsDo: [:m | m lock].
	"tell the window frame to get with it"
	windowFrame
		ifNotNil: [windowFrame passivate].
	self world
		ifNotNil: ["clean damage now, so dont merge this rect with new top 
			window "
			self world == World
				ifTrue: [self world displayWorld]]! !

!SystemWindow methodsFor: 'panes' stamp: 'jlb 8/18/2001 20:45'!
existingPaneColor
	"Answer the existing pane color for the window, obtaining it from the first paneMorph if any, and fall back on using the second stripe color if necessary."

	| aColor |
	Preferences alternativeWindowLook ifTrue:[
		aColor _ self valueOfProperty: #paneColor.
		aColor ifNil:[self setProperty: #paneColor toValue: (aColor _ self paneColor)].
		^aColor].
	paneMorphs isEmptyOrNil
		ifFalse:
			[((aColor _ paneMorphs first color) isKindOf: Color)
				ifTrue:
					[^ aColor]].
	^ self stripes
		ifNotNil:
			[self stripes second color]
		ifNil:
			[Color blue lighter]! !

!SystemWindow methodsFor: 'drawing' stamp: 'jlb 8/21/2001 08:35'!
drawOn: aCanvas
	"Draw a rectangle with a solid, inset, or raised border.
	Note: the raised border color is generated from the receiver's own color,
	while the inset border color is generated from the color of its owner.
	This behavior is visually more consistent. Thanks to Hans-Martin Mosner."

	| insetColor |
	borderWidth = 0 ifTrue: [  "no border"
		aCanvas fillRectangle: (self layoutBounds) fillStyle: self fillStyle.
		^ self].

	borderColor == #raised ifTrue: [
		"Use a hack for now"
		aCanvas fillRectangle: self bounds fillStyle: self fillStyle.
		^ aCanvas frameAndFillRectangle: bounds
			fillColor: Color transparent
			borderWidth: borderWidth
			topLeftColor: (borderWidth = 1 ifTrue: [self raisedColor twiceLighter]
										ifFalse: [self raisedColor lighter])
			bottomRightColor: (borderWidth = 1 ifTrue: [self raisedColor twiceDarker]
										ifFalse: [self raisedColor darker])].

	borderColor == #inset ifTrue: [
		insetColor _ owner ifNil: [Color black] ifNotNil: [owner colorForInsets].
		aCanvas fillRectangle: self bounds fillStyle: self fillStyle.
		^ aCanvas frameAndFillRectangle: bounds
			fillColor: Color transparent
			borderWidth: borderWidth
			topLeftColor: (borderWidth = 1 ifTrue: [insetColor twiceDarker]
										ifFalse: [insetColor darker])
			bottomRightColor: (borderWidth = 1 ifTrue: [insetColor twiceLighter]
										ifFalse: [insetColor lighter])].

	"solid color border"
	aCanvas fillRectangle: (self layoutBounds) fillStyle: self fillStyle.
	aCanvas frameAndFillRectangle: bounds
		fillColor: Color transparent
		borderWidth: borderWidth
		borderColor: borderColor.! !

!SystemWindow methodsFor: 'menu' stamp: 'jlb 7/31/2001 21:23'!
deleteCloseBox
	windowFrame ifNotNil: [ windowFrame deleteCloseBox ].! !

!SystemWindow methodsFor: 'menu' stamp: 'jlb 7/28/2001 21:53'!
makeClosable
	mustNotClose _ false.
	windowFrame addCloseBox.
! !

!SystemWindow methodsFor: 'layout' stamp: 'jlb 8/15/2001 15:35'!
convertAlignment
	"Primarily Jesse Welton's code to convert old system windows to ones with modern layout scheme"

	| frame |
	self layoutPolicy: ProportionalLayout new.
	(paneMorphs == nil or: [paneRects == nil or:[paneMorphs size ~= paneRects size]]) ifFalse:[
		self addLabelArea.
		self putLabelItemsInLabelArea.
		self setFramesForLabelArea.
		paneMorphs with: paneRects do:[:m :r|
			frame _ LayoutFrame new.
			frame leftFraction: r left; rightFraction: r right; topFraction: r top; bottomFraction: r bottom.
			m layoutFrame: frame.
			m hResizing: #spaceFill; vResizing: #spaceFill]].
	(self labelArea isNil and: [self wantsLabel]) ifTrue:
		[self addLabelArea.
		self putLabelItemsInLabelArea.
		self setFramesForLabelArea.
		paneMorphs ifNotNil:
			[paneMorphs do: [:m |
				frame := m layoutFrame ifNil: [LayoutFrame new].
				frame topOffset: (frame topOffset ifNil: [0]) - self labelHeight.
				(frame bottomFraction ~= 1.0) ifTrue:
					[ frame bottomOffset: (frame bottomOffset ifNil: [0]) - self labelHeight ]]]].
	self label ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0.5; topFraction: 0; leftOffset: windowFrame label width negated // 2.
		windowFrame label layoutFrame: frame].
	self collapseBox ifNotNil:
		[frame _ LayoutFrame new.
		frame rightFraction: 1; topFraction: 0; rightOffset: -1; topOffset: 1.
		self collapseBox layoutFrame: frame].
	self stripes ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				leftOffset: 1; topOffset: 1; rightOffset: -1.
		self stripes first layoutFrame: frame.
		self stripes first height: self labelHeight - 2.
		self stripes first hResizing: #spaceFill.
		frame _ LayoutFrame new.
		frame leftFraction: 0; topFraction: 0; rightFraction: 1;
				leftOffset: 3; topOffset: 3; rightOffset: -3.
		self stripes last layoutFrame: frame.
		self stripes last height: self labelHeight - 6.
		self stripes last hResizing: #spaceFill].
	self menuBox ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; leftOffset: 19; topFraction: 0; topOffset: 1.
		self menuBox layoutFrame: frame].
	self closeBox ifNotNil:
		[frame _ LayoutFrame new.
		frame leftFraction: 0; leftOffset: 4; topFraction: 0; topOffset: 1.
		self closeBox layoutFrame: frame].
! !

!SystemWindow methodsFor: 'layout' stamp: 'jlb 7/31/2001 12:21'!
layoutBounds
	"Bounds of pane area only."
	| box inset |

	windowFrame ifNil: [ ^ super layoutBounds ].
	inset _ windowFrame paneInset.
	box _ self innerBounds.
	^ box insetBy: inset.
! !

!SystemWindow methodsFor: 'layout' stamp: 'jlb 8/15/2001 15:34'!
putLabelItemsInLabelArea
	"Put label items into the label area, if there is one"

	self labelArea ifNotNil:
		[self stripes ifNotNil: [self stripes do: [:stripe | self labelArea addMorph: stripe]].
		self closeBox ifNotNil: [self labelArea addMorph: ( self closeBox)].
		self menuBox ifNotNil: [self labelArea addMorph: (self menuBox)].
		self collapseBox ifNotNil: [self labelArea addMorph: (self collapseBox)].
		self label ifNotNil: [self labelArea addMorph: windowFrame label]]

! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:09'!
closeBox
	^ windowFrame closeBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:09'!
closeBox: aCloseBox
	windowFrame closeBox: aCloseBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:09'!
collapseBox
	^ windowFrame collapseBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:09'!
collapseBox: aCollapseBox
	windowFrame collapseBox: aCollapseBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
expandBox
	^ windowFrame expandBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
expandBox: anExpandBox
	windowFrame expandBox: anExpandBox! !


!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
label: aLabel
	windowFrame label: aLabel! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
labelArea
	^ windowFrame labelArea! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:11'!
labelArea: aLabelArea
	windowFrame labelArea: aLabelArea! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
labelWidgetAllowance
	^ windowFrame labelWidgetAllowance! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:11'!
labelWidgetAllowance: aLabelWidgetAllowance
	windowFrame labelWidgetAllowance: aLabelWidgetAllowance! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
menuBox
	^ windowFrame menuBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:11'!
menuBox: aMenuBox
	windowFrame menuBox: aMenuBox! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:10'!
stripes
	^ windowFrame stripes! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 7/24/2001 21:11'!
stripes: aStripes
	windowFrame stripes: aStripes! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 8/6/2001 14:58'!
windowFrame
	^ windowFrame! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 8/5/2001 12:53'!
windowFrame: aWindowFrame
	windowFrame _ aWindowFrame.! !

!SystemWindow methodsFor: 'conversion' stamp: 'jlb 7/24/2001 13:08'!
convertLabelToFrame
	windowFrame _ SqueakWindowFrame new.
	windowFrame stripes: stripes ;
		label: label ;
		window: self ;
		closeBox: closeBox ;
		collapseBox: collapseBox ;
		menuBox: menuBox ;
		labelWidgetAllowance: labelWidgetAllowance ;
		labelArea: labelArea ;
		expandBox: expandBox.
	
	
	
	! !

!SystemWindow methodsFor: 'conversion' stamp: 'jlb 8/14/2001 22:01'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	" convert old style window to window frame surrounds "
	windowFrame ifNil: [
		windowFrame _ SqueakWindowFrame new.
		windowFrame window: self.
		varDict at: #stripes ifPresent: [ :m | windowFrame stripes: m ] ;
			at: #label ifPresent: [ :m | windowFrame label: m ] ;
			at: #closeBox ifPresent: [ :m | windowFrame closeBox: m ] ;
			at: #collapseBox ifPresent: [ :m | windowFrame collapseBox: m ] ;
			at: #menuBox ifPresent: [ :m | windowFrame menuBox: m ] ;
			at: #labelWidgetAllowance ifPresent: [ :m | windowFrame labelWidgetAllowance: m ] ;
			at: #labelArea ifPresent: [ :m | windowFrame labelArea: m ] ;
			at: #expandBox ifPresent: [ :m | windowFrame expandBox: m ].
	 ].
	allowReframeHandles ifNil: [allowReframeHandles := true].
	self layoutPolicy ifNil: [self convertAlignment].
	self labelArea ifNil: [self convertAlignment].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !


!NewWorldWindow methodsFor: 'color' stamp: 'jlb 8/13/2001 20:46'!
setStripeColorsFrom: paneColor
	"Since our world may be *any* color, try to avoid really dark colors so title will show"

	| revisedColor |
	self stripes ifNil: [^ self].
	revisedColor _ paneColor atLeastAsLuminentAs: 0.1 .
	windowFrame ifNotNil: [ ^ windowFrame setStripeColorsFrom: revisedColor ].

	self isActive ifTrue:
		[self stripes second 
			color: revisedColor; 
			borderColor: self stripes second color darker.
		self stripes first 
			color: self stripes second borderColor darker;
			borderColor: self stripes first color darker.
		^ self].
	"This could be much faster"
	self stripes second 
		color: revisedColor; 
		borderColor: revisedColor.
	self stripes first 
		color: revisedColor; 
		borderColor: revisedColor! !


!PartsWindow methodsFor: 'as yet unclassified' stamp: 'jlb 7/24/2001 19:00'!
setLabelWidgetAllowance
	self labelWidgetAllowance: 115.
	^ self labelWidgetAllowance.! !


!PreDebugWindow methodsFor: 'as yet unclassified' stamp: 'jlb 7/24/2001 18:38'!
setBalloonTextForCloseBox
	self closeBox ifNotNil:
		[self closeBox setBalloonText: 'abandon this execution by closing this window'].
! !

!PreDebugWindow methodsFor: 'as yet unclassified' stamp: 'jlb 7/24/2001 19:00'!
setLabelWidgetAllowance
	 self labelWidgetAllowance: ((Smalltalk isMorphic | Preferences optionalButtons)
		ifTrue:
			[super setLabelWidgetAllowance]
		ifFalse:
			[180]).
	^ self labelWidgetAllowance.! !


!SystemWindow class methodsFor: 'instance creation' stamp: 'jlb 7/24/2001 21:21'!
labelled: labelString

	^ self new setLabel: labelString.! !


!SystemWindowWithButton methodsFor: 'as yet unclassified' stamp: 'jlb 7/24/2001 19:00'!
setLabelWidgetAllowance
	self labelWidgetAllowance: 115.
	^ self labelWidgetAllowance.! !

SystemWindow removeSelector: #addCloseBox!
SystemWindow removeSelector: #addExpandBox!
SystemWindow removeSelector: #addLabel!
SystemWindow removeSelector: #addMenuControl!

!SqueakWindowFrame reorganize!
('accessors' closeBox closeBox: collapseBox collapseBox: expandBox expandBox: label label: labelArea labelArea: menuBox menuBox: newFrame:label: stripes stripes:)
('top window' activate lockInactivePortions passivate)
('label' labelHeight setStripeColorsFrom:)
('initialization' addBalloonTexts addCloseBox addCollapseBox addExpandBox addLabelArea: addMenuControl addStripes initialize setFramesForLabelArea: setLabel:)
('geometry' extent: removeMenuBox)
('layout' paneInset windowBoundsInset)
('menu' deleteCloseBox)
('window resizing' spawnReframeHandle:event:)
('window messages' closeBoxHit collapseOrExpand expandBoxHit offerWindowMenu)
!


!AbstractWindowFrame reorganize!
('top window' activate lockInactivePortions passivate)
('initialization' addCloseBox addExpandBox addMenuControl initialize removeMenuBox)
('label' relabelEvent:)
('window messages' closeBoxHit expandBoxHit)
('window resizing' spawnReframeHandle:event:)
('accessing' active active: labelWidgetAllowance labelWidgetAllowance: stripes window window:)
('color' paneColor: setStripeColorsFrom:)
('collapse/expand' collapse expand)
!

"Postscript:
Convert over to the new window frames"

SystemWindow allInstances do: [ :m | m convertLabelToFrame ].

" Get rid of conversion routine ; invalid references under new scheme "
 SystemWindow removeSelector: #convertLabelToFrame. 

" Oh no, close your eyes ; get rid of instance variables "

MorphicModel subclass: #SystemWindow
	instanceVariableNames: 'labelString activeOnlyOnTop paneMorphs paneRects collapsedFrame fullFrame isCollapsed mustNotClose updatablePanes allowReframeHandles windowFrame '
	classVariableNames: 'TopWindow '
	poolDictionaries: ''
	category: 'Morphic-Windows'. 

!

