'From Squeak3.4alpha of ''11 November 2002'' [latest update: #5109] on 22 February 2003 at 12:38:14 pm'!
"Change Set:		Zurgle34Changes-nk
Date:			22 February 2003
Author:			Ned Konz

This fixes Zurgle for 3.2 to use the event triggering in 3.4. It does not address any other potential problems.
"!


!ComboBoxMorph methodsFor: 'behavior override' stamp: 'nk 2/22/2003 12:27'!
accept
"This class overrided normal accept behavior. See class comment."

	self triggerEvent: #enter.! !

!ComboBoxMorph methodsFor: 'event handling' stamp: 'nk 2/22/2003 12:27'!
checkForSpecialKeystroke: evt

	(choiceList isNil and: [ allowChoices]) ifTrue:[
		(evt keyCharacter asciiValue == 31) ifTrue:[
			^self popupChoices.
		].
	].

	choiceList isNil ifTrue:[
		(evt keyCharacter == Character cr) ifTrue:[
				^self triggerEvent: #enter.
		].
	].

! !


!ModalEnforcerMorph methodsFor: 'control' stamp: 'nk 2/22/2003 12:27'!
startBeingModal: w
"Make the morphs in the modalMorphs collection be modal to the rest of the world w"

	| aWorld |
[
	aWorld _ w outermostWorldMorph. "containing world"
	done _ false.

	aWorld addMorph: self.
	aWorld currentHand newKeyboardFocus: nil.
	aWorld currentHand newMouseFocus: nil.
	aWorld currentHand addEventListener: self.

	self class makeModalEnforcerActive: self.
	Sensor flushKeyboard.
	self triggerEvent: #startBeingModal.

	[done not] whileTrue: [
		[aWorld doOneSubCycle] 
			on: Exception 
			do: [:ex | 
				self stopBeingModalOnError.
				ex signal.
"Debug dShow: 'exception'."
			].
	].
	
] ensure: [
	self triggerEvent: #finished.
	self cleanUp: aWorld.
	self class removeFromActive: self.
	self class resumeLastActiveModalEnforcer.
].	! !

!ModalEnforcerMorph methodsFor: 'control' stamp: 'nk 2/22/2003 12:27'!
stopBeingModal
"Called to stop being modal"

	self triggerEvent: #stopBeingModal.
	done _ true.
"Debug dShow: 'Stop being modal'."

! !

!ModalEnforcerMorph methodsFor: 'control' stamp: 'nk 2/22/2003 12:27'!
stopBeingModalOnError
"Called to stop being modal on an error. Most callers should use stopBeingModal instead"

	done _ true.
	self class removeFromActive: self.

	"The following are forked so as not to interfere with critical exception handling 
	mechanisms (If the triggerEvent: #error itself triggers an Exception, a recursive condition
	could occur)"
	[self triggerEvent: #error.] fork.
	[self cleanUp: self world ] fork.
"Debug dShow: 'Stop being modal on error'."
! !

!ModalEnforcerMorph methodsFor: 'events' stamp: 'nk 2/22/2003 12:27'!
clickOutsideMorphs
"Called when the user clicks outside of the modalMorphs. Default is to do nothing"

	self triggerEvent: #clickOutside.! !


!ComboBoxModalEnforcer methodsFor: 'events' stamp: 'nk 2/22/2003 12:26'!
ok

	| result |

	self stopBeingModal.

	result _ self choiceList selection.
	result ifNotNil: [
		self textEdit setText: result withBlanksTrimmed.
		self textEdit hasUnacceptedEdits: true.
		[WorldState addDeferredUIMessage: [self textEdit triggerEvent: #selectionMade]] fork.
	].

! !

