'From Squeak3.2gamma of 15 January 2002 [latest update: #4857] on 14 May 2002 at 7:50:54 am'!
"Change Set:		Busy Bee
Date:			10 May 2002
Author:			Jim Benson

This implements many enhancements and bug fixes for the Zurgle project for April/May 2002.

Besides bug fixes, toolbars and status bars have been added to window surrounds. Menus have been skinned"!

ThemeBase subclass: #DialogTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!
Object subclass: #IconInfo
	instanceVariableNames: 'position inDock bounds index ownerDock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!IconInfo commentStamp: '<historical>' prior: 0!
I represent information about a WindowMorphIcon such as the position, bounds and the owner.!

Morph subclass: #AnimationMorph
	instanceVariableNames: 'image frameExtent numberOfFrames currentFrame '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Animation'!

!AnimationMorph commentStamp: '<historical>' prior: 0!
I represent an animation. 

	My ivar image contains the consecutive frames of an animation stored vertically. 
	ivar numberOfFrames indicates the number of frames in the animation.
	frameExtent is the natural size of an animation frame.
	currentFrame indicates the current frame that is being displayed. This index starts at 1.
	I warpBlt each frame to my extent when drawing, so that the animationis scaled to my bounding box.!

Morph subclass: #DeliverMorph
	instanceVariableNames: 'behaviourList currentPosition velocity maxForce maxSpeed mass targetVector target selector arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Boids-Basic'!

!DeliverMorph commentStamp: '<historical>' prior: 0!
DeliverMorph delivers a morph from one place to another place!

Smalltalk renameClassNamed: #DialogTextMorph as: #DialogStringMorph!
MorphThumbnail subclass: #IconMorph
	instanceVariableNames: 'label '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!IconMorph commentStamp: '<historical>' prior: 0!
I represent another morph. I am drawn on the display as a thumbnail of the morph. Also, I can be dragged around on the desktop, and when clicked I turn into the morph that I represent.

	(IconMorph on: RectangleMorph new) openInWorld.!

IconMorph subclass: #DesktopIcon
	instanceVariableNames: 'vehicle originVector targetVector poof formerOwner dropPosition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!DesktopIcon commentStamp: '<historical>' prior: 0!
I represent the abstract class for a desktop icon morph. 

My visual representation is that of a thumbnail of the morph that I represent.

When I am moved about the screen by click dragging, I turn translucent. In addition, a 'ghost' follows me when being dragged to give a better illusion as to how I'm being dragged.

When I am clicked on, I expand into the representative morph, with an optional animation taking place.

For an example:

	(DesktopIcon on: RectangleMorph new) openInWorld.!

Morph subclass: #InvisibleExpandingMorph
	instanceVariableNames: 'stepTime expandExtent synchronized '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Animation'!
Morph subclass: #InvisibleShrinkingMorph
	instanceVariableNames: 'stepTime shrinkExtent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Animation'!
StringMorph subclass: #MenuItemMorph
	instanceVariableNames: 'isEnabled subMenu isSelected target selector arguments cellBounds '
	classVariableNames: 'SubMenuMarker '
	poolDictionaries: ''
	category: 'Morphic-Menus'!
MenuMorph subclass: #FancyMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menus'!
AlignmentMorph subclass: #MenuTitleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Menus'!

!MenuTitleMorph commentStamp: '<historical>' prior: 0!
I represent the menu title bar of a menu!

TwoModeButtonMorph subclass: #ControlButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Controls'!

!ControlButtonMorph commentStamp: '<historical>' prior: 0!
I represent a button used in things like scroll bar arrows and such.

The button states are a little misnamed, being subclassed. For these buttons, there are only four states,

	normal -> #off
	pressed -> #pressed
	hilite	-> #pressedPassive
	disabled -> #disabled
	
	!

DesktopIcon subclass: #ProjectIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!ProjectIcon commentStamp: '<historical>' prior: 0!
I represent a Squeak Project in iconic form.

Some examples:

	( ProjectIcon new morphRepresented: ( ProjectViewMorph on: Project current )) openInWorld

	( ProjectIcon new morphRepresented: ( ProjectViewMorph on: Project allProjects first )) openInWorld
!

RectangleMorph subclass: #ProjectPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!
AlignmentMorph subclass: #SequenceDock
	instanceVariableNames: 'insertIndex indexClip '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!SequenceDock commentStamp: '<historical>' prior: 0!
I represent an AlignmentMorph with animation. When a member is added/deleted to the list, the list is animated to make it look as if the list is being 'arranged' for the new entry/exit.!

SequenceDock subclass: #MorphDock
	instanceVariableNames: ''
	classVariableNames: 'AdhereEdge Current '
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!

!MorphDock commentStamp: '<historical>' prior: 0!
I represent a handy dandy place to store morphs, to keep them dry and safe from harm.

I am transparent, and like to hang out in the lower left hand corner of the display.

The class message #current provides the current MorphDock in the project.

!

Morph subclass: #ShakingMorph
	instanceVariableNames: 'intensity target index origin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Animation'!
ShakingMorph class
	instanceVariableNames: ''!
ImageMorph subclass: #ShrinkingMorph
	instanceVariableNames: 'stepTime shrinkExtent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Animation'!
Object subclass: #SteeringBehaviour
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Boids-Basic'!
SteeringBehaviour class
	instanceVariableNames: ''!
SystemWindow subclass: #DialogWindow
	instanceVariableNames: 'modalAnswer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Dialog'!
TextMorph subclass: #DialogTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Dialog'!
TwoModeButtonMorph subclass: #ToolBarButtonMorph
	instanceVariableNames: 'iconForm icon label '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Toolbar'!
Morph subclass: #ToolBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Toolbar'!

!ToolBarMorph commentStamp: '<historical>' prior: 0!
I represent a toolbar. I contain iconic buttons that represent shortcuts to application specific actions.!

Morph subclass: #ToolBarSeparator
	instanceVariableNames: 'barColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Toolbar'!
ThemeBase subclass: #ToolbarTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Themes'!
IconMorph subclass: #WindowIcon
	instanceVariableNames: 'poof vehicle originVector targetVector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!
RectangleMorph subclass: #WindowIconTitle
	instanceVariableNames: 'label '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zurgle-Desktop'!
Object subclass: #ZurglePreferences
	instanceVariableNames: ''
	classVariableNames: 'AdhereEdge CollapseToMorphDock CollapseToTitleBar DockHeight DockWidth IconFont IconHeight LabelColor LabelTextColor MoveAnimation ShakeAnimation ShowIconTitle '
	poolDictionaries: ''
	category: 'Zurgle-Preferences'!

!ZurglePreferences commentStamp: '<historical>' prior: 0!
I represent a place to keep the MorphDock preferences

DockHeight -- Height of a MorphDock with horizontal orientation
DockWidth  -- Width of a MorphDock with vertical orientation
MoveAnimation -- boolean which indicates if a MorphIcon relocation is animated.
ShakeAnimation -- boolean which indicates if the MorphIcon 'shakes' after an automated move.
IconHeight -- The height of an icon which represents a window.!


!CodeHolder methodsFor: 'construction' stamp: 'jlb 4/29/2002 14:57'!
addLowerPanesTo: window at: nominalFractions with: editString

	| verticalOffset row innerFractions |

	row _ AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		borderColor: Color gray;
		layoutPolicy: ProportionalLayout new.

	verticalOffset _ 0.
	innerFractions _ 0@0 corner: 1@0.
	verticalOffset _ self addOptionalAnnotationsTo: row at: innerFractions plus: verticalOffset.
	verticalOffset _ self addOptionalButtonsTo: row  at: innerFractions plus: verticalOffset.

	row 
		addMorph: ((self buildMorphicCodePaneWith: editString) borderWidth: 0)
		fullFrame: (
			LayoutFrame 
				fractions: (innerFractions withBottom: 1) 
				offsets: (0@verticalOffset corner: 0@0)
		).
	window 
		addMorph: row
		frame: nominalFractions.

	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.! !


!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
criticalEdges
  ^ lookDictionary at: #criticalEdges ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
criticalForm
  ^ lookDictionary at: #criticalForm ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
infoEdges
  ^ lookDictionary at: #infoEdges ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
infoForm
  ^ lookDictionary at: #infoForm ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
warningEdges
  ^ lookDictionary at: #warningEdges ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
warningForm
  ^ lookDictionary at: #warningForm ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
warningFormFractions
  ^ lookDictionary at: #warningFormFractions ifAbsent: [ nil ]! !

!DialogTheme methodsFor: 'accessors' stamp: 'jlb 3/23/2002 20:48'!
warningFormOffsets
  ^ lookDictionary at: #warningFormOffsets ifAbsent: [ nil ]! !


!FontTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 20:04'!
dialogFont
  ^ lookDictionary at: #dialogFont ifAbsent: [ nil ]! !


!FormCanvas methodsFor: 'private' stamp: 'jlb 4/24/2000 14:59'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule alpha: alpha
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	port colorMap: (aForm colormapIfNeededForDepth: form depth); fillColor: nil.
	port sourceForm: aForm ;
		combinationRule: rule ;
		sourceRect: sourceRect ;
		destOrigin: aPoint +  origin  ;
		copyBitsTranslucent: alpha.
! !


!IconInfo methodsFor: 'thumbnail' stamp: 'jlb 4/30/2000 23:03'!
dock: aWindowMorphIcon

	ownerDock addMorph: aWindowMorphIcon asElementNumber: index

! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:05'!
bounds
	^ bounds! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:05'!
bounds: aRect
	bounds _ aRect! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:07'!
inDock
	^ inDock! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:10'!
inDock: aMorphDock
	inDock _ aMorphDock! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/27/2000 23:43'!
index
	" index of position in MorphDock "
	^ index! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/28/2000 00:27'!
index: anInteger
	" index of position in MorphDock "
	index _ anInteger.! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/28/2000 00:21'!
ownerDock
	^ ownerDock! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/28/2000 00:22'!
ownerDock: aMorphDock
 	ownerDock _ aMorphDock.
! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:05'!
position
	^ position! !

!IconInfo methodsFor: 'accessing' stamp: 'jlb 4/21/2000 12:16'!
position: aPoint
	position _ aPoint! !


!MenuBarProperties class methodsFor: 'class initialization' stamp: 'jlb 6/20/2001 08:17'!
initialize
	" MenuBarProperties initialize "
	self menuBarHeight: 24.
	" adjust this color for the menu bar color -- light gray here "
	self menuBarColor: (Color r: 0.80 g: 0.80 b: 0.80).
	self menuBarFrameColor: Color black.
	self menuBarEnabledColor: Color black.
	self menuBarDisabledColor: Color gray.
	self menuBarFont: #NewYork.
	self menuBarFontSize: 20.
	self menuBarShowDropShadow: true.! !


!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
activeLabelColor
  ^ lookDictionary at: #activeLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
backgroundColor
  ^ lookDictionary at: #backgroundColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
borderColor
  ^ lookDictionary at: #borderColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
borderWidth
  ^ lookDictionary at: #borderWidth ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 12:44'!
bottomColor
	" the bottom color for the menu bar "
  ^ lookDictionary at: #bottomColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/29/2002 19:41'!
disabledTextColor
  ^ lookDictionary at: #disabledTextColor ifAbsent: [ Color gray ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/29/2002 19:41'!
enabledTextColor
  ^ lookDictionary at: #enabledTextColor ifAbsent: [ Color black ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
hilightBackgroundColor
  ^ lookDictionary at: #hilightBackgroundColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
hilightTextColor
  ^ lookDictionary at: #hilightTextColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 11:44'!
leftColor
  ^ lookDictionary at: #leftColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
leftSpacer
  ^ lookDictionary at: #leftSpacer ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuBarButtonForm
  ^ lookDictionary at: #menuBarButtonForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuBarForm
  ^ lookDictionary at: #menuBarForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuFontColor
  ^ lookDictionary at: #menuFontColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuFrameEdges
  ^ lookDictionary at: #menuFrameEdges ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuFrameForm
  ^ lookDictionary at: #menuFrameForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuFrameOffset
  ^ lookDictionary at: #menuFrameOffset ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuItemEdges
  ^ lookDictionary at: #menuItemEdges ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuItemForm
  ^ lookDictionary at: #menuItemForm ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuTextOffset
  ^ lookDictionary at: #menuTextOffset ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuTitleBackgroundColor
  ^ lookDictionary at: #menuTitleBackgroundColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
menuTitleTextColor
  ^ lookDictionary at: #menuTitleTextColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
mouseOverLabelColor
  ^ lookDictionary at: #mouseOverLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
passiveLabelColor
  ^ lookDictionary at: #passiveLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 11:44'!
rightColor
  ^ lookDictionary at: #rightColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
selectedLabelColor
  ^ lookDictionary at: #selectedLabelColor ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/24/2002 07:59'!
simple
  ^ lookDictionary at: #simple ifAbsent: [ nil ]! !

!MenuTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 11:44'!
useGradient
  ^ lookDictionary at: #useGradient ifAbsent: [ nil ]! !


!Morph methodsFor: 'zurgle' stamp: 'jlb 4/28/2000 19:07'!
shake
	self shake: 20
! !

!Morph methodsFor: 'zurgle' stamp: 'jlb 4/28/2000 19:07'!
shake: n
	ShakingMorph shake: self intensity: n! !


!AbstractWindowFrame methodsFor: 'initialization' stamp: 'jlb 3/21/2002 20:48'!
addStatusBar
	^ self subclassResponsibility! !


!AnimationMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/15/2002 19:21'!
startStepping
	currentFrame _ 0.
	super startStepping.! !

!AnimationMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/15/2002 19:37'!
step
	currentFrame < numberOfFrames 
		ifTrue: [
			self currentFrame: currentFrame.
			currentFrame _ currentFrame + 1]
		ifFalse: [self stopAnimation]! !

!AnimationMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/15/2002 19:37'!
stepTime
	^ 50! !

!AnimationMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/15/2002 19:24'!
stopAnimation
	"stop stepping "
	self stop.
	self delete.! !

!AnimationMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/15/2002 19:24'!
wantsSteps
	^ false.! !

!AnimationMorph methodsFor: 'initialization' stamp: 'jlb 2/15/2002 19:25'!
initialize
	super initialize.
	currentFrame _ 1.
	self on: #click send: #start to: self.
! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:30'!
currentFrame
	^ currentFrame! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:36'!
currentFrame: anInteger
	" 1 based "
	currentFrame _ anInteger.
	self changed.! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:29'!
frameExtent
	^ frameExtent! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:29'!
frameExtent: aPoint
	frameExtent _ aPoint.! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:25'!
image
	^ image! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:25'!
image: aForm
	image _ aForm.! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:29'!
numberOfFrames
	^ numberOfFrames! !

!AnimationMorph methodsFor: 'accessing' stamp: 'jlb 2/15/2002 19:30'!
numberOfFrames: anInteger
	numberOfFrames _ anInteger! !

!AnimationMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:47'!
collapse
	" Don't do anything ; not collapsible "! !

!AnimationMorph methodsFor: 'drawing' stamp: 'jlb 2/15/2002 19:34'!
drawOn: aCanvas 
	"figure out the extent rectangle"
	| formRect |
	" calculate the bounding rectangle of the animation frame"
	formRect _ 0 @ ((currentFrame-1) * frameExtent y) extent: frameExtent.
	" copy the calculated frame to the canvas " 
	(WarpBlt current toForm: aCanvas form) sourceForm: image;
		 cellSize: 2;
		 combinationRule: Form paint;
		copyQuad: formRect innerCorners
		toRect: (self topLeft extent: self extent)! !


!AnimationMorph class methodsFor: 'demo' stamp: 'jlb 2/15/2002 19:56'!
explode
	
	" return an animation that looks like an explosion "
	" There are five frames in the animation ; the 'natural' size of each frame is 128@128 "

	| toReturn |
	toReturn _ self new.
	toReturn extent: 128@128 ;
		frameExtent: 128@128 ;
		numberOfFrames: 5 ;
		image: self explodeForm .
	^ toReturn.

	" | explode |
	  explode _ AnimationMorph explode.
	  explode openInWorld ; start. "
	! !

!AnimationMorph class methodsFor: 'demo' stamp: 'jlb 2/15/2002 19:57'!
explodeForm
" This is an 'explosion' image sequence "
^ (Form
	extent: 128@640
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285756275 4289572269 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4292269782 4290098613 4285229931 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287927444 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4287927444 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4291743438 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4291743438 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291217094 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287401100 4291743438 4293914607 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4287927444 4281413937 0 0 0 0 4282532418 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291217094 4283585106 0 4281940281 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290098613 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4290624957 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4290624957 4285756275 4278716424 0 0 0 0 4282532418 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4289572269 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4289572269 4280887593 0 4283058762 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4289045925 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286282619 4288453788 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4288453788 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4291743438 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4291217094 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4293914607 4293914607 4293914607 4293388263 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4291743438 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292269782 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4293388263 4292269782 4292269782 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4292269782 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293388263 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293914607 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4292796126 4292269782 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4292796126 4293388263 4292796126 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4292796126 4294440951 4294967295 4294967295 4294440951 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4291743438 4292269782 4292796126 4292269782 4292269782 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292269782 4292269782 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4291743438 4291743438 4292269782 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293388263 4292796126 4292269782 4292269782 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4291743438 4292269782 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4293914607 4293914607 4293388263 4292796126 4292796126 4292269782 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4291743438 4291217094 4291743438 4291743438 4291217094 4291743438 4291743438 4291743438 4291217094 4291217094 4291743438 4291217094 4291217094 4291217094 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293388263 4292796126 4293388263 4292796126 4292796126 4293388263 4293914607 4293914607 4293388263 4293388263 4292269782 4292269782 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4292269782 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4292269782 4291217094 4291217094 4291743438 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293914607 4293388263 4292796126 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4291743438 4293388263 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4290098613 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4291743438 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4291743438 4292269782 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4291743438 4291743438 4292269782 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4292796126 4291743438 4279242768 0 0 0 0 0 0 0 0 0 0 0 4279242768 4289572269 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292796126 4293914607 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291743438 4293388263 4294440951 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4291217094 4278716424 0 0 0 0 0 0 0 0 0 0 0 4280361249 4290624957 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4293914607 4293388263 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4292269782 4291743438 4291743438 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4293914607 4293388263 4293388263 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4293388263 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292269782 4292269782 4292269782 4292269782 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294440951 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 4292269782 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4293914607 4293914607 4293914607 4293914607 4293388263 4290098613 0 0 0 0 0 0 0 0 0 0 0 4279769112 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 4282532418 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4294440951 4293914607 4293388263 4293388263 4293388263 4286874756 0 0 0 0 0 0 0 0 0 0 4284111450 4292269782 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293914607 4293388263 4292796126 4289572269 0 0 0 0 0 0 0 0 0 0 4284111450 4292269782 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4293388263 4294440951 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4291217094 0 0 0 0 0 0 0 0 0 0 4283058762 4292796126 4293388263 4292796126 4293914607 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4293388263 4292796126 4293914607 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4291743438 0 0 0 0 0 0 0 0 0 0 4281940281 4291743438 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292269782 4292269782 4292269782 0 0 0 0 0 0 0 0 0 0 4280361249 4290098613 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293914607 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292269782 4292269782 4291743438 0 0 0 0 0 0 0 0 0 0 4278716424 4287927444 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4293914607 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4292269782 4291743438 4291217094 0 0 0 0 0 0 0 0 0 0 0 4284111450 4292269782 4292269782 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4293388263 4293914607 4294440951 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4291743438 4291743438 4291743438 4290098613 0 0 0 0 0 0 0 0 0 0 0 4280887593 4290098613 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4293388263 4293914607 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292269782 4292269782 4292269782 4291743438 4291217094 4291217094 4288453788 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285756275 4291743438 4292796126 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4289572269 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 4291743438 4291743438 4291217094 4291217094 4290624957 4290098613 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4291743438 4291743438 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4293388263 4292796126 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4292796126 4292269782 4292269782 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293914607 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4290624957 4290624957 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4293388263 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4290624957 4290624957 4290098613 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285756275 4291743438 4292269782 4292269782 4292796126 4292796126 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4290624957 4290624957 4290098613 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4291743438 4292269782 4291743438 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 4291743438 4291743438 4291217094 4291217094 4290624957 4290098613 4290098613 4287927444 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4282532418 4291217094 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 4291743438 4291743438 4291217094 4290624957 4290624957 4290624957 4290098613 4288453788 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4288453788 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4291743438 4291743438 4291743438 4291217094 4290624957 4290624957 4290098613 4289572269 4288453788 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4287927444 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4291743438 4291743438 4291217094 4291217094 4290624957 4290098613 4290098613 4289572269 4286874756 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287401100 4290624957 4292796126 4292796126 4292796126 4292269782 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4292269782 4292269782 4291743438 4291217094 4290624957 4290624957 4290624957 4289572269 4287927444 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4291743438 4291743438 4292269782 4291743438 4291743438 4292269782 4292269782 4292796126 4293388263 4293914607 4293388263 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4293388263 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4290624957 4291217094 4291743438 4291217094 4290624957 4290098613 4288453788 4286282619 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4291217094 4291217094 4291217094 4291743438 4291743438 4291217094 4291743438 4292269782 4292796126 4292796126 4293388263 4293388263 4292796126 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293914607 4294967295 4294440951 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4293388263 4293388263 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4291743438 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4290098613 4291217094 4290624957 4291217094 4291217094 4291217094 4290624957 4291217094 4291743438 4292269782 4292269782 4292796126 4293388263 4293388263 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4292269782 4292269782 4292269782 4292796126 4292796126 4293388263 4293914607 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4293914607 4293914607 4292796126 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4289572269 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290098613 4290624957 4291217094 4291743438 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4292269782 4292269782 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4293914607 4292796126 4292269782 4292269782 4292269782 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4292269782 4292796126 4293388263 4293914607 4293914607 4293388263 4291743438 4291743438 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4292796126 4292269782 4292269782 4292269782 4291743438 4291217094 4289572269 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4290098613 4290098613 4289572269 4290098613 4290098613 4290624957 4290624957 4289572269 4290098613 4290624957 4291217094 4291743438 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4292796126 4292269782 4291743438 4292269782 4292269782 4292796126 4293388263 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294967295 4294440951 4294967295 4294967295 4294440951 4293914607 4292796126 4292269782 4291743438 4292269782 4292269782 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4291743438 4291217094 4291743438 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4292796126 4293388263 4293388263 4292796126 4292796126 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4291743438 4291743438 4291217094 4291217094 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4289572269 4289572269 4289572269 4289572269 4290098613 4289572269 4290098613 4290098613 4289572269 4289572269 4290098613 4290624957 4290624957 4291217094 4291743438 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292269782 4291217094 4291217094 4291743438 4291743438 4291743438 4291743438 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4291743438 4291743438 4291743438 4291217094 4291217094 4290624957 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4289045925 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4290098613 4289572269 4288453788 4289572269 4290098613 4290624957 4290624957 4291743438 4291743438 4291743438 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292269782 4290624957 4290624957 4290624957 4291217094 4291743438 4291217094 4291743438 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4292269782 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4292269782 4291743438 4291217094 4291217094 4291217094 4290624957 4290098613 4290098613 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4288453788 4288453788 4289045925 4288453788 4288453788 4289045925 4289045925 4289045925 4289572269 4289045925 4289045925 4289572269 4290098613 4290098613 4290624957 4291217094 4291743438 4291743438 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4292269782 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291217094 4291743438 4291217094 4291217094 4291217094 4291217094 4291217094 4291743438 4292269782 4291217094 4291217094 4291217094 4290624957 4290098613 4290098613 4289572269 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4287927444 4288453788 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289572269 4288453788 4289045925 4289572269 4289572269 4290098613 4290624957 4290624957 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293388263 4293914607 4293914607 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4291743438 4291217094 4290098613 4290098613 4290098613 4290098613 4290624957 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4291217094 4291217094 4291217094 4290624957 4291217094 4291743438 4291217094 4290624957 4290624957 4290624957 4290098613 4290098613 4289572269 4289572269 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4287401100 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289572269 4288453788 4288453788 4289045925 4289572269 4289572269 4290098613 4290624957 4291217094 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291743438 4291743438 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290624957 4290098613 4290098613 4290624957 4290624957 4290624957 4290098613 4290098613 4290624957 4290624957 4290624957 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4290624957 4290624957 4290098613 4290098613 4289572269 4289572269 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4290098613 4289572269 4289045925 4288453788 4289045925 4289045925 4289572269 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291217094 4291743438 4291217094 4291217094 4290624957 4288453788 4289572269 4289045925 4289572269 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4289572269 4289572269 4290098613 4290098613 4290098613 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290624957 4291217094 4290098613 4290098613 4290098613 4289572269 4289572269 4289045925 4289045925 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4287401100 4286874756 4286874756 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4290098613 4290098613 4290098613 4289572269 4288453788 4289045925 4289045925 4289045925 4289572269 4290098613 4290098613 4290624957 4291217094 4291217094 4291217094 4291217094 4291743438 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291743438 4291743438 4291217094 4291217094 4291217094 4291217094 4290624957 4291217094 4289045925 4289572269 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4289572269 4289045925 4289045925 4289572269 4290624957 4290624957 4290098613 4290098613 4290098613 4289572269 4289572269 4289572269 4289045925 4289045925 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4286282619 4286874756 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287927444 4287927444 4289572269 4290098613 4289572269 4290098613 4290098613 4289572269 4289045925 4289572269 4290098613 4290624957 4290624957 4291217094 4291743438 4291743438 4291217094 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4290624957 4290624957 4287927444 4288453788 4289045925 4288453788 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4288453788 4288453788 4288453788 4289045925 4289572269 4290098613 4290624957 4290098613 4290098613 4290098613 4289572269 4289572269 4289045925 4289045925 4288453788 4288453788 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286282619 4286282619 4286282619 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287927444 4289572269 4289572269 4289045925 4290098613 4289572269 4290098613 4290624957 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291743438 4291217094 4290098613 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290098613 4290098613 4291217094 4289045925 4287927444 4288453788 4288453788 4289045925 4288453788 4287927444 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4289572269 4290624957 4290098613 4290098613 4290098613 4289572269 4289572269 4289045925 4289045925 4288453788 4288453788 4288453788 4287927444 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4286282619 4286282619 4286282619 4286282619 4286282619 4286874756 4286874756 4287401100 4287401100 4288453788 4289572269 4289045925 4289045925 4289045925 4289572269 4289572269 4290098613 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4290624957 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290624957 4290098613 4290624957 4291217094 4291217094 4290624957 4290624957 4290098613 4290624957 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4291217094 4290098613 4288453788 4288453788 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4287401100 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287401100 4287927444 4288453788 4289045925 4290098613 4290098613 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4285756275 4285756275 4285756275 4285756275 4286282619 4286282619 4286874756 4286874756 4286874756 4287927444 4288453788 4288453788 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4290098613 4290624957 4290624957 4290624957 4290624957 4290624957 4291217094 4290624957 4289572269 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290624957 4291217094 4291217094 4291217094 4290624957 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4291217094 4290624957 4289045925 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4289045925 4289045925 4288453788 4287927444 4287401100 4287401100 4287401100 4287401100 4288453788 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4287927444 4287927444 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4285756275 4285756275 4285756275 4285756275 4286282619 4286874756 4286282619 4286874756 4286874756 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290624957 4290624957 4290624957 4290098613 4289045925 4289045925 4289572269 4289572269 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4289572269 4289572269 4289572269 4289572269 4290098613 4290624957 4290624957 4290098613 4290624957 4289572269 4288453788 4287927444 4287927444 4287927444 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4288453788 4287927444 4287927444 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4285756275 4285229931 4285756275 4286282619 4285756275 4286282619 4286874756 4286874756 4287401100 4288453788 4288453788 4287927444 4288453788 4288453788 4289045925 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4290624957 4290624957 4290098613 4290624957 4290098613 4290098613 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 4290098613 4290098613 4290624957 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4287927444 4287927444 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4285756275 4285229931 4285756275 4285756275 4285756275 4286282619 4286282619 4286874756 4287401100 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4289572269 4290098613 4290098613 4290098613 4290098613 4289572269 4289572269 4290098613 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4287927444 4287927444 4287927444 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4285229931 4285229931 4285756275 4285756275 4286282619 4286282619 4286282619 4286874756 4287401100 4287927444 4287927444 4287401100 4287927444 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4289572269 4289572269 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4288453788 4288453788 4288453788 4288453788 4287927444 4288453788 4287927444 4287927444 4287927444 4287927444 4287927444 4287401100 4287927444 4286282619 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283585106 4285756275 4285229931 4285756275 4286282619 4286282619 4285756275 4286874756 4287927444 4287927444 4287927444 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287401100 4287927444 4286874756 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4284111450 4285756275 4285229931 4286282619 4286282619 4286282619 4286874756 4287401100 4287927444 4287927444 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4289045925 4289045925 4288453788 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4284703587 4285756275 4286282619 4286282619 4286282619 4287401100 4287927444 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4288453788 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4287401100 4286282619 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281940281 4284111450 4285229931 4286282619 4286874756 4287927444 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4289045925 4288453788 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4287401100 4285756275 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280361249 4287927444 4287927444 4287927444 4287401100 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287401100 4287927444 4287927444 4287401100 4287401100 4287401100 4287927444 4288453788 4289045925 4288453788 4287927444 4287401100 4287401100 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4279242768 4285229931 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286874756 4286874756 4286282619 4286874756 4286874756 4286874756 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4287401100 4287401100 4287401100 4287927444 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4287927444 4287927444 4287927444 4287401100 4287401100 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4285756275 0 0 4281940281 4285756275 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286282619 4286874756 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286874756 4285229931 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286874756 4286282619 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287401100 4287401100 4286874756 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4287927444 4287401100 4287401100 4287401100 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4282532418 0 0 0 0 4281940281 4284703587 4286874756 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4286282619 4286282619 4286282619 4285756275 4284703587 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4286282619 4286282619 4286282619 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286282619 4285756275 0 0 0 0 0 0 0 4278716424 4281413937 4284703587 4285756275 4286282619 4286282619 4286282619 4285756275 4286282619 4286282619 4285756275 4285229931 4283585106 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4287401100 4286874756 4286282619 4286874756 4286874756 4286282619 4286282619 4286874756 4285756275 4286282619 4286282619 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4285756275 4286282619 4285756275 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286874756 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4285756275 4285756275 4285756275 4285756275 4285756275 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4286282619 4285756275 4285756275 4286282619 4285756275 4286282619 4286282619 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4285229931 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4286282619 4286282619 4286282619 4286282619 4285756275 4285756275 4286282619 4285756275 4285756275 4286282619 4285756275 4286282619 4285229931 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4285229931 4285756275 4285229931 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283058762 4285229931 4285229931 4285229931 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283058762 4284111450 4285229931 4285756275 4285756275 4285229931 4285229931 4285229931 4285756275 4285229931 4285229931 4283058762 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 4281940281 4285756275 4289572269 4293388263 4293914607 4293914607 4294440951 4294440951 4293388263 4291743438 4288453788 4283585106 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4289572269 4293914607 4294440951 4294440951 4294440951 4292269782 4287401100 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4287927444 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045925 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4284111450 4284111450 4281940281 0 0 4285756275 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4285756275 4286282619 4286874756 4285756275 4283585106 4278716424 0 0 4283585106 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290098613 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279242768 4279242768 0 0 0 4280887593 4290098613 4294967295 4294967295 4294967295 4294967295 4289045925 4285756275 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4285229931 4284111450 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287401100 4292796126 4292796126 4293388263 4289572269 4281940281 4281940281 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284111450 4289572269 4290624957 4291217094 4290624957 4290098613 4285229931 4279769112 0 4279242768 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286282619 4287927444 4289045925 4287401100 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286874756 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4281940281 0 4278716424 4278716424 4278716424 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4289572269 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4290098613 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4291217094 4293914607 4294440951 4294440951 4293914607 4290624957 4285229931 4279769112 0 0 0 0 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4291217094 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4284703587 0 0 0 0 0 0 0 0 4281940281 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4286874756 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4286282619 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4283585106 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4291217094 4279242768 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4293914607 4293914607 4293388263 4284111450 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293388263 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4292796126 4289572269 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4294440951 4294967295 4294440951 4294440951 4293914607 4293914607 4294440951 4294440951 4294967295 4294440951 4294967295 4294440951 4293914607 4293914607 4293914607 4293388263 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4292796126 4291743438 0 0 0 0 4279769112 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4291743438 4292796126 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4293388263 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4292796126 4292796126 0 0 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4291217094 4291217094 4291217094 4291217094 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293914607 4293914607 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4293388263 4293388263 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292269782 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4292269782 4292269782 4293914607 4293388263 4290624957 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4293388263 4292796126 4292796126 4292796126 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4294967295 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 0 0 0 4284703587 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292269782 4292796126 4292796126 4293388263 4292796126 4292269782 4291743438 4293388263 4294440951 4293388263 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4291743438 4292269782 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 0 0 4279242768 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292269782 4292269782 4291743438 4291743438 4293388263 4294440951 4294440951 4291743438 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291743438 4291217094 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293388263 4293388263 4292269782 0 0 4284111450 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294440951 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4291743438 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293914607 4293388263 4292796126 4291743438 0 0 4287927444 4293914607 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4291217094 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292269782 4292269782 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4292796126 4293914607 4293914607 4292796126 4290098613 0 0 4289572269 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4294967295 4294967295 4294440951 4293914607 4293388263 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4291743438 4292269782 4293914607 4294440951 4293388263 4292796126 4286282619 0 0 4289572269 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4294440951 4294967295 4294440951 4293914607 4293388263 4292796126 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4292269782 4292796126 4292796126 4293388263 4292796126 4292796126 4292796126 4292269782 4291743438 4292269782 4293388263 4294440951 4293914607 4293914607 4292796126 4280361249 0 0 4287401100 4292796126 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4293388263 4294967295 4294440951 4293914607 4293914607 4292796126 4292269782 4284703587 0 0 0 0 0 0 0 0 0 0 0 4281413937 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292796126 4293914607 4294967295 4294967295 4293914607 4293388263 4286282619 0 0 0 4284111450 4292269782 4292796126 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4293914607 4293914607 4293388263 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292269782 4293388263 4294440951 4294440951 4293914607 4293914607 4292796126 4292796126 4291743438 4283585106 0 0 0 0 0 0 0 0 0 0 0 4287401100 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4292796126 4292269782 4292269782 4293914607 4293914607 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4279769112 0 0 0 4279769112 4290624957 4292269782 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4292796126 4293914607 4294440951 4294440951 4294440951 4293914607 4292796126 4292796126 4291743438 4291217094 4281413937 0 0 0 0 0 0 0 0 0 0 4278716424 4291743438 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293388263 4284703587 0 0 0 0 4284111450 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4293914607 4293388263 4292269782 4291743438 4291217094 4288453788 4279242768 0 0 0 0 0 0 0 0 0 0 4280361249 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4290098613 0 0 0 0 0 4286874756 4292269782 4292796126 4292796126 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292796126 4292269782 4291743438 4291217094 4290098613 4282532418 0 0 0 0 0 0 0 0 0 0 0 4281940281 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4294440951 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4280361249 0 0 0 0 0 4284703587 4291217094 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292796126 4292796126 4292269782 4291217094 4290098613 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4293388263 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4280887593 0 0 0 0 0 0 4279769112 4284703587 4291743438 4292796126 4292796126 4293914607 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4292796126 4292269782 4292796126 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4292796126 4292796126 4291217094 4290624957 4288453788 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4291217094 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293388263 4294440951 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4292796126 4292269782 4280887593 0 0 0 0 0 0 0 4285229931 4291217094 4291743438 4291743438 4292796126 4292796126 4292796126 4292269782 4292796126 4292269782 4293388263 4294440951 4293914607 4292796126 4292269782 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4292269782 4289045925 4279242768 4279769112 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4292269782 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293914607 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4293388263 4293388263 4292796126 4292796126 4292796126 4293914607 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4292796126 4292796126 4292269782 4291743438 4280887593 0 0 0 0 0 0 4281940281 4290098613 4290624957 4290098613 4290624957 4291743438 4292796126 4293388263 4292269782 4292796126 4293388263 4294440951 4294967295 4294967295 4293914607 4292796126 4292269782 4292269782 4292796126 4293914607 4293388263 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4291743438 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4292796126 4292269782 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4293388263 4292796126 4292269782 4292269782 4293388263 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4291743438 4291743438 4291217094 4280361249 0 0 0 0 0 0 4285229931 4289572269 4289572269 4289572269 4289572269 4290624957 4291743438 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4292796126 4291217094 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292269782 4291743438 4291217094 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4289572269 4292269782 4292796126 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4293914607 4294440951 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4292269782 4292269782 4292269782 4290624957 4287927444 4278716424 0 0 0 0 0 0 4285756275 4287927444 4288453788 4289045925 4289045925 4289045925 4290624957 4291217094 4291743438 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293388263 4293388263 4293388263 4292269782 4291743438 4290624957 4290098613 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4291217094 4291217094 4290098613 4287927444 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4293914607 4294440951 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4292269782 4292269782 4291217094 4290624957 4290624957 4283585106 0 0 0 0 0 0 0 4285229931 4287401100 4287927444 4287927444 4289045925 4289045925 4289045925 4290098613 4290624957 4291743438 4291743438 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4290098613 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290624957 4290098613 4289572269 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4291743438 4292269782 4292269782 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4292269782 4291743438 4291217094 4291217094 4290624957 4287401100 4278716424 0 0 0 0 0 0 0 4283585106 4286282619 4286874756 4287401100 4289045925 4290098613 4289572269 4290098613 4290624957 4291217094 4291217094 4290624957 4291217094 4291217094 4291743438 4291217094 4291217094 4291217094 4290624957 4290624957 4290624957 4289572269 4287927444 4288453788 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4290098613 4290098613 4289572269 4289045925 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4290624957 4291743438 4292269782 4292796126 4292269782 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4293914607 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4291743438 4291743438 4290624957 4290098613 4288453788 4280361249 0 0 0 0 0 0 0 0 4280361249 4285756275 4286282619 4286282619 4287401100 4289045925 4289572269 4289572269 4290624957 4290624957 4290624957 4290098613 4289572269 4290098613 4290624957 4291217094 4290098613 4290098613 4290098613 4290624957 4290098613 4288453788 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4289045925 4289572269 4289572269 4289045925 4289045925 4287927444 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286282619 4291217094 4292269782 4292796126 4292796126 4292796126 4293388263 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4292269782 4291743438 4291743438 4290624957 4290624957 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 4281940281 4285229931 4286282619 4286874756 4287927444 4288453788 4289045925 4289572269 4290098613 4290098613 4290098613 4289572269 4290098613 4290624957 4290624957 4290098613 4290098613 4290098613 4290098613 4289045925 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4288453788 4287927444 4286874756 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4282532418 4289572269 4292796126 4292796126 4292269782 4292796126 4293388263 4293388263 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292796126 4292269782 4291743438 4291217094 4290624957 4287927444 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4285756275 4285756275 4286874756 4287927444 4287927444 4288453788 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4287927444 4287927444 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4290098613 4291743438 4291217094 4291743438 4291743438 4292796126 4293388263 4293388263 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4293914607 4292796126 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4291217094 4282532418 4281413937 4280887593 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283585106 4285756275 4286874756 4287927444 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4286874756 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287401100 4287401100 4287401100 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4289572269 4290098613 4290624957 4291217094 4290098613 4291217094 4292269782 4292796126 4293388263 4292796126 4292269782 4292269782 4292269782 4292269782 4292796126 4293388263 4294440951 4294967295 4294967295 4293914607 4292796126 4292269782 4291743438 4291743438 4291743438 4291743438 4292269782 4292796126 4293914607 4293388263 4292269782 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4293388263 4293388263 4292796126 4292269782 4292269782 4291217094 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4283058762 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4287401100 4286874756 4287401100 4285229931 4285756275 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286874756 4286282619 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4290098613 4289572269 4290098613 4290624957 4289572269 4290624957 4291217094 4291743438 4292269782 4293388263 4293388263 4292796126 4293388263 4293388263 4293914607 4294440951 4294967295 4294440951 4294440951 4294967295 4294440951 4293914607 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4291743438 4291743438 4292269782 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4292269782 4292269782 4292269782 4291217094 4291217094 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287401100 4287401100 4286874756 4286874756 4286282619 4280361249 4279769112 4283585106 4285756275 4286282619 4286282619 4286282619 4286282619 4284111450 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4288453788 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4291217094 4291743438 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4292796126 4291217094 4291217094 4291217094 4291217094 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292269782 4291743438 4292269782 4291743438 4291217094 4290624957 4290624957 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4286874756 4286282619 4286874756 4286874756 4286874756 4286874756 4287401100 4286874756 4286282619 4286282619 4284703587 0 0 0 4279242768 4280361249 4279769112 4279769112 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4290098613 4290624957 4291217094 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4291217094 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4291743438 4291217094 4290624957 4290098613 4289572269 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285229931 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4286282619 4285756275 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4287401100 4287401100 4287401100 4287927444 4288453788 4288453788 4289572269 4289045925 4288453788 4289572269 4290098613 4290624957 4291217094 4291743438 4291743438 4292269782 4292796126 4292796126 4292796126 4292796126 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4291217094 4289572269 4289045925 4289045925 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290624957 4290624957 4290098613 4290098613 4289572269 4289045925 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283058762 4284703587 4285756275 4285756275 4285756275 4285756275 4285229931 4282532418 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286874756 4286874756 4287401100 4287401100 4287927444 4287927444 4289572269 4290098613 4289045925 4289045925 4289572269 4289572269 4290624957 4291217094 4291743438 4291743438 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4291217094 4290624957 4290624957 4289045925 4289045925 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4290098613 4290624957 4290098613 4290098613 4289572269 4289045925 4288453788 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4286282619 4286874756 4286874756 4287401100 4287401100 4289045925 4289572269 4289572269 4290098613 4290098613 4290098613 4291217094 4291743438 4291217094 4290624957 4290098613 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4291217094 4291217094 4290624957 4290624957 4290098613 4290624957 4289572269 4287927444 4289045925 4288453788 4287927444 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4289572269 4290098613 4290098613 4289572269 4289045925 4289045925 4288453788 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286282619 4286282619 4286282619 4286874756 4286874756 4287927444 4289045925 4289045925 4289045925 4290098613 4290098613 4290098613 4290624957 4290624957 4290624957 4290098613 4289572269 4289572269 4290098613 4290624957 4291217094 4291217094 4290624957 4290098613 4290098613 4289572269 4289572269 4290098613 4290624957 4290624957 4288453788 4287927444 4287927444 4288453788 4288453788 4288453788 4287927444 4287401100 4287401100 4287927444 4288453788 4289045925 4289572269 4290098613 4290098613 4289572269 4289045925 4289045925 4288453788 4288453788 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4285229931 4285756275 4286282619 4286282619 4286874756 4288453788 4288453788 4288453788 4289045925 4289572269 4289572269 4290098613 4290624957 4290624957 4290098613 4290098613 4289572269 4290098613 4290624957 4290624957 4290624957 4290624957 4290098613 4290098613 4290098613 4290098613 4290624957 4290098613 4289572269 4287927444 4287927444 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289572269 4289045925 4289045925 4289045925 4289045925 4288453788 4288453788 4287927444 4286874756 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283058762 4287927444 4291743438 4294440951 4294440951 4294440951 4293914607 4292796126 4289572269 4284111450 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4285756275 4285229931 4286282619 4285756275 4287401100 4287927444 4287927444 4287927444 4289045925 4289045925 4289045925 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4289572269 4289572269 4289572269 4289572269 4290098613 4290098613 4289572269 4289572269 4289572269 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4287927444 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4286874756 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4284703587 4285756275 4285756275 4286282619 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4289572269 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287401100 4287927444 4287927444 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4284111450 4285756275 4286282619 4286874756 4287927444 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4287401100 4287401100 4287401100 4287401100 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4286874756 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4286282619 4286874756 4286282619 4283585106 4278716424 0 4279769112 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4283058762 4284703587 4285229931 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4286874756 4287401100 4286874756 4286874756 4285756275 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4283585106 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4287401100 4287401100 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4287927444 4287401100 4287401100 4286874756 4286874756 4286874756 4285229931 4278716424 4283058762 4286282619 4286874756 4286282619 4286874756 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4284703587 4280887593 0 0 0 0 0 0 0 0 0 0 4280887593 4286874756 4291217094 4291217094 4291217094 4289045925 4283585106 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286282619 4286874756 4286874756 4287401100 4287401100 4286874756 4287401100 4287401100 4287401100 4287927444 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4281413937 0 0 4279242768 4281413937 4284111450 4285756275 4285756275 4285756275 4285756275 4285756275 4284703587 4282532418 4280361249 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 4288453788 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4281940281 0 4278716424 4278716424 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4285756275 4286282619 4286282619 4286874756 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4285756275 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4291743438 4294440951 4294440951 4294440951 4291217094 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4286282619 4285756275 4285756275 4286282619 4286282619 4285756275 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4285756275 4285756275 4284111450 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4285229931 4285756275 4285229931 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4286282619 4285229931 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281413937 4283585106 4285229931 4285229931 4285229931 4285756275 4285229931 4285229931 4284111450 4281413937 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4290624957 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292269782 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292796126 4290098613 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4289572269 4293388263 4294440951 4294440951 4294440951 4292796126 4287401100 4281940281 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4284111450 4284111450 4281940281 0 0 4285756275 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4292796126 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279242768 4278716424 4278716424 0 0 4280887593 4290624957 4294967295 4294967295 4294967295 4294440951 4289045925 4285756275 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4293914607 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4294440951 4293914607 4292796126 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287401100 4292269782 4293388263 4292796126 4289572269 4281940281 4281940281 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4292269782 4292269782 4292796126 4292269782 4292269782 4292796126 4292269782 4292269782 4291743438 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286282619 4287927444 4289045925 4287927444 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4291743438 4291743438 4291743438 4292269782 4291743438 4291743438 4291743438 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045925 4279769112 0 0 0 0 0 0 0 0 0 0 4283058762 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4291217094 4291217094 4291217094 4291217094 4291217094 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4293388263 4293914607 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4291217094 4279242768 0 0 0 0 0 0 0 0 4283058762 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292269782 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4293388263 4294440951 4292796126 4290098613 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4287401100 0 0 0 0 0 0 0 4281413937 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4291743438 4292269782 4294440951 4293914607 4292796126 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4281940281 0 0 0 0 0 4278716424 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4291743438 4292269782 4293914607 4294440951 4293914607 4293388263 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4287401100 0 0 0 0 0 4283058762 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292269782 4293914607 4294967295 4294440951 4293388263 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4291217094 0 0 0 0 4278716424 4288453788 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293388263 4292796126 4292269782 4293388263 4293914607 4294967295 4294967295 4294440951 4294440951 4293914607 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4292269782 0 0 0 0 4279769112 4291743438 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4286874756 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4293914607 4293388263 4291743438 0 0 0 0 4281413937 4292796126 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293914607 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4291743438 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4291743438 0 0 0 0 4282532418 4292796126 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293914607 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292796126 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4291743438 0 0 0 0 4282532418 4292269782 4293388263 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4294440951 4294967295 4294440951 4294440951 4293914607 4293388263 4293388263 4292796126 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291743438 4291217094 4291217094 4291217094 4291217094 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292269782 0 0 0 0 4281413937 4291743438 4292796126 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293914607 4294440951 4294967295 4294440951 4293914607 4293388263 4293914607 4292269782 4292269782 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4292796126 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4291743438 4294440951 4293914607 4290098613 0 0 0 0 4279242768 4289045925 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292269782 4293388263 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4291743438 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4292796126 4293388263 4292796126 4292796126 4292269782 4291743438 4293388263 4294440951 4293388263 4286874756 0 0 0 0 0 4285756275 4292269782 4292796126 4293388263 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4293388263 4294440951 4294967295 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4292269782 4291217094 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292269782 4292269782 4292269782 4291743438 4291743438 4292796126 4294967295 4294440951 4292269782 4280887593 0 0 0 0 0 4280887593 4290624957 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292796126 4292796126 4292796126 4293388263 4294440951 4294967295 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4292269782 4291217094 4289045925 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4292796126 4293388263 4294440951 4294967295 4294440951 4294440951 4288453788 4278716424 0 0 0 0 0 0 4285229931 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293914607 4294440951 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4292796126 4292269782 4291743438 4291217094 4291217094 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4293914607 4294440951 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4293914607 4291743438 4279769112 0 0 0 0 0 0 4278716424 4287927444 4291743438 4292796126 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292269782 4291743438 4291217094 4290624957 4289572269 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294440951 4293914607 4293388263 4283585106 0 0 0 0 0 0 0 4279769112 4287927444 4291743438 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4292796126 4292269782 4291743438 4291217094 4290624957 4290098613 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4294967295 4294967295 4294440951 4293914607 4293388263 4293388263 4284111450 0 0 0 0 0 0 0 0 4278716424 4284703587 4290624957 4292269782 4292796126 4292796126 4292796126 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292269782 4292796126 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4292796126 4292269782 4291743438 4291743438 4290624957 4290098613 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4292796126 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4293914607 4294440951 4294440951 4293914607 4293914607 4293388263 4291743438 4284703587 0 0 0 0 0 0 0 0 0 0 4279242768 4283058762 4290624957 4292796126 4292269782 4292796126 4293388263 4293388263 4292796126 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4291743438 4291743438 4290624957 4288453788 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4292269782 4292796126 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4293388263 4294967295 4294440951 4294440951 4293388263 4292796126 4292796126 4292269782 4283585106 0 0 0 0 0 0 0 0 0 0 0 4281940281 4291217094 4291217094 4291743438 4291743438 4292796126 4293388263 4292796126 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4293914607 4293914607 4293388263 4292269782 4292796126 4292269782 4292269782 4292269782 4292269782 4292269782 4292796126 4293388263 4292796126 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4287927444 4280887593 4280887593 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4290098613 4292796126 4292796126 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4292269782 4292796126 4293914607 4294967295 4294440951 4294440951 4293388263 4293388263 4292796126 4291743438 4291217094 4281940281 0 0 0 0 0 0 0 0 0 0 4280361249 4289572269 4290624957 4290624957 4290098613 4291217094 4292269782 4292796126 4293388263 4292796126 4291743438 4292269782 4292269782 4292269782 4293388263 4294967295 4294967295 4293914607 4292796126 4292269782 4291743438 4291743438 4291743438 4292269782 4292796126 4293388263 4292796126 4292269782 4292796126 4293388263 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292269782 4292269782 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4291743438 4292796126 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4294967295 4294440951 4294440951 4293914607 4293388263 4292269782 4291743438 4291217094 4287927444 4279242768 0 0 0 0 0 0 0 0 0 0 4284703587 4289572269 4290098613 4290624957 4290098613 4290098613 4291217094 4292269782 4292796126 4293388263 4292796126 4292796126 4293388263 4293914607 4294440951 4294967295 4294440951 4294967295 4294440951 4293914607 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4292269782 4291217094 4291743438 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4292796126 4291743438 4291217094 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4292269782 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292796126 4292269782 4291743438 4291217094 4290624957 4282532418 0 0 0 0 0 0 0 0 0 0 4278716424 4287401100 4289045925 4289045925 4289572269 4289572269 4289572269 4290098613 4291217094 4291743438 4292269782 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4291743438 4291217094 4291217094 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4292269782 4291743438 4291217094 4290624957 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4291743438 4292269782 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4293388263 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4292796126 4291743438 4291217094 4290098613 4285229931 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286874756 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4290098613 4291217094 4291217094 4292269782 4292796126 4292796126 4293388263 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4291743438 4290098613 4289572269 4290624957 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4290098613 4286874756 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284703587 4292269782 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292269782 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4292269782 4291217094 4290624957 4288453788 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4286874756 4287401100 4287927444 4287927444 4288453788 4289572269 4289045925 4289045925 4289572269 4290624957 4291217094 4291217094 4292269782 4292269782 4292796126 4292796126 4292796126 4293388263 4293388263 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4290624957 4289045925 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4291217094 4290624957 4290098613 4289572269 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4291217094 4291217094 4291743438 4293388263 4293388263 4292269782 4292269782 4292796126 4292796126 4292796126 4294440951 4293914607 4292269782 4292269782 4292269782 4291743438 4292269782 4292269782 4293388263 4292796126 4293388263 4293388263 4293914607 4294440951 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4289045925 4279769112 4279769112 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4286282619 4286874756 4286874756 4287927444 4287927444 4289045925 4290098613 4289045925 4289045925 4289572269 4290098613 4291217094 4291743438 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291217094 4291217094 4291217094 4290098613 4288453788 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289572269 4290098613 4290624957 4290098613 4289572269 4289045925 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4290098613 4290098613 4290624957 4290624957 4291743438 4292796126 4292796126 4292269782 4292269782 4292796126 4294440951 4294967295 4294967295 4293914607 4292796126 4292269782 4292269782 4292796126 4293914607 4292796126 4291743438 4292269782 4292796126 4293388263 4292796126 4293388263 4293388263 4293388263 4292796126 4292796126 4292796126 4292269782 4291743438 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4286282619 4286874756 4286874756 4287401100 4288453788 4289572269 4290098613 4290098613 4290098613 4290624957 4291217094 4291217094 4290098613 4290624957 4290624957 4291217094 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4290624957 4290098613 4290624957 4290624957 4289045925 4287927444 4288453788 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4290098613 4290098613 4289572269 4289572269 4289045925 4288453788 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4289572269 4289572269 4289572269 4289572269 4290098613 4291743438 4292796126 4293388263 4293388263 4293914607 4294440951 4293914607 4294440951 4294967295 4294440951 4294440951 4293914607 4293914607 4293914607 4292269782 4291217094 4291217094 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291217094 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286282619 4285756275 4286874756 4286874756 4287927444 4289045925 4289045925 4289572269 4290098613 4290098613 4290624957 4291217094 4290624957 4289572269 4289572269 4289572269 4290098613 4291217094 4291217094 4290624957 4290098613 4289572269 4290098613 4290098613 4290624957 4290098613 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4287401100 4287927444 4288453788 4289045925 4289572269 4289572269 4289572269 4289045925 4289045925 4288453788 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4287927444 4288453788 4289045925 4289045925 4289572269 4290098613 4291217094 4291743438 4292796126 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4292796126 4292269782 4292269782 4290624957 4289572269 4290098613 4290624957 4291217094 4291217094 4291217094 4291217094 4290624957 4290624957 4291217094 4291217094 4290098613 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4285756275 4285756275 4286282619 4286874756 4288453788 4288453788 4288453788 4289572269 4289572269 4289572269 4290098613 4290098613 4290098613 4289572269 4290098613 4290624957 4290624957 4290624957 4290624957 4290098613 4290098613 4290098613 4290098613 4290624957 4289045925 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4288453788 4288453788 4287927444 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4287401100 4287927444 4288453788 4289045925 4289045925 4289045925 4290098613 4290624957 4291743438 4291743438 4292269782 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4292269782 4291743438 4291743438 4290098613 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4290098613 4290624957 4290098613 4289572269 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4285756275 4285756275 4286282619 4286874756 4288453788 4287927444 4287927444 4289045925 4289045925 4289572269 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4290098613 4289572269 4290098613 4289045925 4287401100 4287401100 4287927444 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4288453788 4287927444 4287927444 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4286282619 4286874756 4287401100 4289045925 4289572269 4289572269 4290098613 4290624957 4291217094 4290624957 4290624957 4291217094 4291217094 4291743438 4291217094 4291217094 4291217094 4290624957 4290624957 4290624957 4289045925 4288453788 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4290098613 4290098613 4289572269 4289045925 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283058762 4285229931 4285756275 4286282619 4287401100 4287927444 4287927444 4287927444 4288453788 4289045925 4289045925 4289045925 4289045925 4289572269 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4289045925 4287927444 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4287401100 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285756275 4286282619 4286874756 4287927444 4289045925 4289045925 4290098613 4290624957 4291217094 4290624957 4290098613 4289572269 4290098613 4291217094 4291217094 4290098613 4289572269 4289572269 4290624957 4290098613 4287927444 4287927444 4288453788 4287927444 4287927444 4287401100 4288453788 4289045925 4289572269 4289572269 4289045925 4289045925 4288453788 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283585106 4285756275 4286282619 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4289045925 4288453788 4287927444 4287401100 4287401100 4286874756 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4285229931 4285756275 4286874756 4287927444 4288453788 4289045925 4289572269 4289572269 4290098613 4290098613 4290098613 4290098613 4290624957 4290624957 4290098613 4290098613 4290098613 4290098613 4289045925 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4289045925 4289045925 4289045925 4288453788 4288453788 4287927444 4286282619 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4283058762 4284703587 4286874756 4287401100 4286874756 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4286874756 4287401100 4286874756 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4285756275 4285756275 4286874756 4287927444 4287927444 4288453788 4289045925 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4287927444 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4288453788 4287927444 4287927444 4287927444 4287401100 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287401100 4287401100 4287927444 4287401100 4287401100 4286874756 4287401100 4287927444 4288453788 4288453788 4287927444 4287401100 4286874756 4287401100 4286874756 4286874756 4281413937 4280887593 4286282619 4286874756 4286874756 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4282532418 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4285756275 4287401100 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 4286874756 4287401100 4286874756 4287401100 4287401100 4287401100 4287927444 4286874756 4287927444 4287401100 4287401100 4286874756 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4286874756 4286874756 4287401100 4286874756 4286874756 4287401100 4287927444 4287401100 4287401100 4287401100 4286874756 4286874756 4286282619 4286282619 4285229931 4279242768 0 4278716424 4281940281 4284111450 4285756275 4285756275 4285756275 4285756275 4284703587 4281940281 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4283585106 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4288453788 4287927444 4286874756 4286874756 4285756275 4285756275 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286874756 4283058762 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4286282619 4286282619 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286282619 4286282619 4286874756 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4287927444 4287927444 4286874756 4286874756 4286874756 4286874756 4280361249 4279769112 4284111450 4285756275 4286874756 4286282619 4286282619 4286282619 4284111450 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4285756275 4285756275 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4286282619 4286282619 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4286282619 4286874756 4286874756 4286874756 4287401100 4286874756 4286874756 4286874756 4286874756 4286282619 4284111450 0 0 0 4279242768 4279769112 4279769112 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4285229931 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285756275 4285229931 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285229931 4285756275 4286282619 4286282619 4286282619 4286282619 4286282619 4285756275 4285756275 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4282532418 4284703587 4285229931 4285229931 4285756275 4285756275 4284703587 4282532418 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283058762 4285229931 4285756275 4285756275 4285756275 4285756275 4285229931 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283058762 4281940281 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 4287927444 4292269782 4294440951 4286874756 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4285229931 4286874756 4294440951 4294967295 4294967295 4293914607 4287401100 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4289572269 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4291217094 4280887593 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4291743438 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291217094 4286282619 4282532418 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4291743438 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284111450 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4294440951 4294967295 4294967295 4294967295 4291743438 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4291217094 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4294440951 4294967295 4294967295 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4290624957 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4293914607 4293388263 4293388263 4294967295 4294967295 4294440951 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286874756 4290624957 4292796126 4293914607 4293388263 4293388263 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4289045925 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4288453788 4291217094 4293388263 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4294440951 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286874756 4289045925 4290624957 4291743438 4292269782 4294440951 4294967295 4294440951 4293914607 4293388263 4292796126 4294440951 4294440951 4291743438 4281940281 4279769112 4282532418 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283058762 4285229931 4287401100 4288453788 4289045925 4292796126 4294967295 4294440951 4293388263 4293914607 4293388263 4293388263 4291743438 4284703587 4281940281 4287401100 4292796126 4287927444 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4287927444 4293388263 4293388263 4286282619 4281940281 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283058762 4286282619 4288453788 4290624957 4293388263 4294440951 4294440951 4293914607 4294440951 4289572269 4287401100 4287401100 4288453788 4293914607 4294967295 4294440951 4288453788 4281413937 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4294967295 4294967295 4294967295 4294967295 4293914607 4290624957 4285756275 4283585106 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4287401100 4288453788 4290624957 4290098613 4289572269 4290098613 4290098613 4282532418 4285756275 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4287401100 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4289045925 4286282619 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281940281 4284703587 4283585106 4281940281 4279769112 4282532418 4280361249 4278716424 4283585106 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279242768 4278716424 0 0 0 0 4279769112 4287401100 4293914607 4294967295 4294967295 4294967295 4293914607 4292796126 4294440951 4294967295 4290624957 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4290624957 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281413937 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283058762 4283585106 4278716424 0 0 0 4282532418 4289572269 4293388263 4294440951 4294440951 4294967295 4294440951 4293914607 4294440951 4294967295 4292269782 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4292269782 4293914607 4294440951 4294967295 4294967295 4294967295 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4287927444 4293914607 4293388263 4285756275 4281940281 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4288453788 4292796126 4293914607 4286282619 4280361249 0 0 4281940281 4289045925 4292796126 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4294967295 4292269782 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294967295 4294967295 4294967295 4294967295 4293914607 4290624957 4285756275 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4282532418 4287401100 4294440951 4294967295 4294967295 4293914607 4289045925 4281413937 4278716424 4280361249 4286874756 4290624957 4291743438 4292796126 4294440951 4294440951 4294440951 4293388263 4290624957 4284703587 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4294967295 4294440951 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4289045925 4285756275 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287927444 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4284703587 4282532418 4284111450 4286282619 4288453788 4290098613 4293388263 4294967295 4292796126 4292269782 4283585106 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4291743438 4293914607 4293914607 4294440951 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4292269782 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4283058762 4280887593 4284703587 4287927444 4290098613 4289045925 4287927444 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287927444 4290098613 4292269782 4293388263 4293914607 4293388263 4293914607 4293388263 4293914607 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4290624957 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4292269782 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4288453788 0 4279769112 4283058762 4282532418 4280887593 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286874756 4289045925 4291217094 4293388263 4294440951 4293388263 4292796126 4293388263 4294967295 4294440951 4293388263 4292796126 4293914607 4294967295 4290624957 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4292269782 4293914607 4294440951 4294967295 4294967295 4294967295 4292796126 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4286874756 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4294440951 4294967295 4294967295 4290624957 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4288453788 4290098613 4291217094 4292796126 4293388263 4292796126 4292796126 4294967295 4294967295 4294440951 4294440951 4294440951 4293388263 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290098613 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4288453788 4292269782 4293914607 4294440951 4294967295 4294967295 4294967295 4293914607 4293388263 4293388263 4294967295 4294967295 4292796126 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4288453788 4289572269 4290098613 4290624957 4290098613 4290098613 4291743438 4293388263 4293914607 4291743438 4290624957 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4294440951 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4289045925 4292269782 4293914607 4293388263 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286282619 4287927444 4288453788 4287927444 4287401100 4287927444 4289045925 4290624957 4290098613 4283585106 4280361249 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4291743438 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4288453788 4290624957 4293388263 4293388263 4292796126 4293914607 4293914607 4294440951 4294967295 4293914607 4293388263 4294967295 4294967295 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4282532418 4285229931 4285756275 4284111450 4285756275 4287401100 4288453788 4288453788 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4287401100 4289572269 4292269782 4293388263 4293914607 4293388263 4293914607 4293388263 4293388263 4294440951 4293914607 4293914607 4292796126 4293388263 4293388263 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286874756 4288453788 4290624957 4291743438 4292269782 4294440951 4294967295 4293914607 4293388263 4293388263 4292796126 4293388263 4289572269 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4279769112 0 4280361249 4283585106 4284703587 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286874756 4289572269 4291743438 4293388263 4294440951 4292796126 4292796126 4293388263 4294967295 4294967295 4292796126 4292796126 4294440951 4294967295 4291217094 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284703587 4287927444 4287927444 4288453788 4290098613 4292796126 4294967295 4294440951 4293914607 4294440951 4292796126 4287927444 4281940281 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4288453788 4290098613 4291743438 4292796126 4293914607 4292269782 4292796126 4294440951 4294967295 4294967295 4293914607 4293914607 4293388263 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4282532418 4284111450 4286874756 4287927444 4290624957 4293388263 4292796126 4293914607 4293388263 4287401100 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4288453788 4289572269 4290098613 4290624957 4290098613 4290098613 4292269782 4292796126 4293914607 4291743438 4290624957 4287927444 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286282619 4291217094 4293388263 4293914607 4293914607 4292269782 4287927444 4281940281 0 0 0 0 4279242768 4284111450 4287401100 4288453788 4287927444 4284703587 4284703587 4285229931 4280361249 0 0 0 0 0 0 0 0 4283058762 4290624957 4293914607 4293914607 4292269782 4285756275 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286874756 4287927444 4288453788 4287927444 4287401100 4287927444 4289045925 4290624957 4290098613 4283058762 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4282532418 4282532418 4280361249 0 4284703587 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287401100 0 0 0 0 4279769112 4282532418 4283585106 4280361249 0 4279242768 0 0 4278716424 4279242768 0 4278716424 4286282619 4289572269 4285229931 4285756275 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4285229931 4285756275 4283585106 4285756275 4287401100 4288453788 4289045925 4284703587 4278716424 0 0 0 0 0 0 0 0 4278716424 4283058762 4285229931 4284703587 4280887593 0 4287401100 4293914607 4294967295 4294967295 4293914607 4290098613 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 4278716424 0 0 0 0 0 4283585106 4292269782 4293914607 4290098613 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287401100 4283585106 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4278716424 4280361249 4284111450 4284703587 4282532418 4279769112 0 0 0 0 0 0 0 0 4281940281 4291743438 4294967295 4294967295 4294967295 4293914607 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286874756 4286282619 4286874756 4283585106 4278716424 0 0 0 0 4282532418 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 4280887593 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291217094 4280887593 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4279769112 0 0 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286874756 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293914607 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4293388263 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4291217094 4278716424 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4291743438 4291743438 4293914607 4294967295 4294440951 4293914607 4294440951 4294440951 4293914607 4292796126 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4293914607 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4291743438 4278716424 0 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293914607 4294967295 4294967295 4294440951 4292796126 4293914607 4293914607 4292796126 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4292796126 4292269782 4292796126 4292269782 4292269782 4294440951 4294967295 4294440951 4293914607 4294440951 4294440951 4294440951 4294967295 4294440951 4294440951 4293914607 4293388263 4291217094 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4292796126 4292269782 4292796126 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4291743438 4291217094 4291217094 4292269782 4293914607 4294967295 4294967295 4294967295 4293914607 4293388263 4293914607 4294440951 4293914607 4293914607 4293388263 4292796126 4293388263 4291743438 4278716424 4290098613 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4294967295 4293388263 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4293388263 4293388263 4292796126 4291743438 4293388263 4293914607 4289572269 4278716424 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4293914607 4294967295 4292796126 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4292269782 4292269782 4292796126 4294440951 4293388263 4283585106 0 4288453788 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294440951 4293914607 4293388263 4292796126 4292796126 4294440951 4294440951 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4293388263 4294440951 4294967295 4294440951 4293388263 4280361249 0 4283058762 4292269782 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4292796126 4293914607 4294440951 4294440951 4293914607 4293914607 4293914607 4294440951 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4294967295 4294967295 4294440951 4293388263 4285756275 0 0 4284703587 4291217094 4293388263 4293914607 4293914607 4293914607 4294440951 4293914607 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4291743438 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294440951 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4293388263 4293388263 4293914607 4294440951 4294440951 4293914607 4292796126 4286874756 0 0 0 4282532418 4291743438 4292269782 4293388263 4292796126 4293388263 4293914607 4292796126 4292269782 4292796126 4292796126 4293388263 4294440951 4294440951 4294440951 4293914607 4293388263 4287927444 4282532418 4279242768 0 0 0 0 4278716424 4281413937 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4292269782 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4293388263 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4292796126 4293388263 4294440951 4294440951 4293914607 4292796126 4292269782 4285756275 0 0 0 4286282619 4289572269 4290624957 4292269782 4292796126 4293914607 4294967295 4293914607 4293388263 4293914607 4292269782 4291743438 4292796126 4292796126 4292269782 4292269782 4291743438 4283058762 0 0 0 0 0 4279769112 4288453788 4293914607 4293388263 4285229931 4281940281 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4292269782 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294440951 4293388263 4293388263 4294440951 4294967295 4294440951 4293388263 4292796126 4291743438 4290624957 4281940281 0 0 0 4286282619 4288453788 4289045925 4290098613 4291743438 4292796126 4292796126 4293388263 4292796126 4292269782 4290624957 4289572269 4289572269 4290098613 4290098613 4290624957 4290098613 4283058762 0 0 0 0 0 4285756275 4294967295 4294967295 4294967295 4294967295 4293388263 4291217094 4285756275 4283585106 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4288453788 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4293914607 4293388263 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4292796126 4291743438 4291217094 4285229931 0 0 0 0 4283585106 4286874756 4288453788 4289572269 4290624957 4290098613 4290624957 4291217094 4290624957 4290624957 4289572269 4287927444 4287927444 4287927444 4289045925 4289572269 4288453788 4280887593 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4289045925 4286282619 4284703587 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4287927444 4292796126 4293388263 4293914607 4293388263 4293388263 4293388263 4293388263 4293914607 4293388263 4293388263 4292796126 4292796126 4292269782 4292796126 4293388263 4294440951 4294440951 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4293388263 4292269782 4290098613 4289045925 4283585106 4278716424 0 0 0 0 4278716424 4284111450 4286874756 4287927444 4289045925 4289572269 4289572269 4290098613 4289572269 4289572269 4287927444 4287401100 4287927444 4288453788 4288453788 4287927444 4285229931 0 0 0 0 4279242768 4285229931 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4287927444 4290624957 4291217094 4292796126 4292796126 4292796126 4292269782 4293388263 4294440951 4293914607 4292796126 4292269782 4292269782 4292796126 4292796126 4292796126 4292796126 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292269782 4286874756 4278716424 4278716424 0 0 0 0 0 0 0 0 4281413937 4283585106 4286874756 4287401100 4287927444 4288453788 4287927444 4287401100 4286282619 4286282619 4286874756 4286874756 4286874756 4285229931 4279242768 0 0 0 0 4286282619 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4290624957 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4289045925 4289572269 4289572269 4290624957 4292269782 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4293914607 4293914607 4293914607 4293388263 4291217094 4291217094 4292269782 4292269782 4292796126 4292269782 4292269782 4292269782 4292269782 4291217094 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4286874756 4286874756 4287401100 4286874756 4286282619 4281940281 4279242768 4281940281 4282532418 4280887593 4278716424 0 0 0 0 4279242768 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4292796126 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4287927444 4288453788 4289045925 4289045925 4290098613 4291217094 4292269782 4292796126 4292796126 4293388263 4293388263 4293388263 4293388263 4292269782 4291743438 4290624957 4289572269 4290098613 4290098613 4290098613 4290624957 4290098613 4290098613 4291217094 4290098613 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4284111450 4284111450 4284111450 4281940281 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286874756 4286874756 4288453788 4289572269 4289572269 4290624957 4291217094 4290624957 4291217094 4291743438 4291217094 4291217094 4290624957 4290624957 4290624957 4289045925 4287927444 4287927444 4288453788 4288453788 4288453788 4289572269 4290098613 4289572269 4289045925 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4294440951 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279242768 0 0 0 0 0 0 0 0 4284111450 4286282619 4286874756 4288453788 4289045925 4290098613 4290624957 4290098613 4289572269 4290098613 4291217094 4290624957 4290098613 4290098613 4290098613 4287927444 4287927444 4287927444 4287927444 4288453788 4289045925 4289045925 4289045925 4288453788 4287401100 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4287401100 4288453788 4288453788 4284703587 4279769112 0 0 0 0 0 0 0 0 4278716424 4284703587 4291743438 4293388263 4293914607 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4292269782 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4281413937 4279769112 4283058762 4289045925 4289572269 4283058762 0 0 0 0 0 0 0 4278716424 4283058762 4285756275 4286874756 4287927444 4288453788 4288453788 4289045925 4289572269 4289572269 4289572269 4289572269 4289572269 4289045925 4287927444 4286874756 4287401100 4287401100 4287927444 4287927444 4287927444 4287927444 4287927444 4287927444 4281940281 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 4283058762 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4284703587 0 0 0 0 0 0 0 4280361249 4287927444 4289572269 4292269782 4293388263 4293914607 4293388263 4293914607 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4285229931 4287401100 4287927444 4291743438 4293914607 4294440951 4290624957 4281940281 4280887593 0 0 0 0 0 0 0 4279242768 4281940281 4284111450 4286282619 4287401100 4287401100 4287927444 4287927444 4288453788 4288453788 4288453788 4287927444 4286874756 4286282619 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4286874756 4281940281 0 0 0 0 0 4279769112 4279769112 0 0 4285756275 4291743438 4292269782 4289045925 4285229931 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4285229931 0 0 0 0 0 0 4280361249 4286874756 4289045925 4291743438 4293914607 4293914607 4292796126 4292796126 4293388263 4294967295 4294440951 4293388263 4292796126 4293914607 4294967295 4291217094 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286282619 4289572269 4290624957 4292269782 4294440951 4294967295 4294967295 4294967295 4293388263 4292269782 4284703587 0 0 0 0 0 0 0 0 0 4280361249 4286874756 4287401100 4287401100 4287401100 4287401100 4287927444 4286874756 4286874756 4286874756 4280361249 4280361249 4283585106 4284703587 4284703587 4284703587 4282532418 4279242768 0 0 0 0 4281940281 4291217094 4294440951 4293388263 4289045925 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4281413937 4280887593 4280361249 0 0 0 0 4283058762 4288453788 4290624957 4291217094 4292796126 4293388263 4292796126 4292796126 4294440951 4294967295 4294440951 4294440951 4294440951 4293914607 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4285756275 4289572269 4291743438 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4279769112 0 0 0 0 0 0 0 0 0 4281940281 4285756275 4286282619 4286874756 4286282619 4286282619 4286282619 4286282619 4282532418 0 0 0 0 0 0 0 0 0 0 0 4281940281 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4294440951 4289572269 4279769112 0 0 0 4284703587 4288453788 4289572269 4290098613 4290624957 4289572269 4290098613 4292269782 4292796126 4293914607 4291743438 4290624957 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4287927444 4290098613 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4280361249 0 0 0 0 0 0 0 0 0 0 4279769112 4283058762 4283585106 4284111450 4284111450 4282532418 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4279242768 0 0 4280887593 4286874756 4287927444 4287927444 4288453788 4287927444 4287927444 4289045925 4291217094 4290098613 4283058762 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4288453788 4291743438 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4285229931 0 0 4278716424 4282532418 4285229931 4285756275 4283585106 4285756275 4287401100 4288453788 4289045925 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4288453788 4291743438 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4280887593 4279769112 0 0 0 0 0 0 0 0 0 0 4282532418 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294967295 4294440951 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4290624957 0 0 0 0 4279769112 4279769112 0 4280361249 4284111450 4285229931 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4287401100 4290624957 4292796126 4293388263 4293914607 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4292796126 4294967295 4294967295 4293914607 4288453788 4279769112 0 0 0 0 0 0 0 0 4283058762 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293914607 4293914607 4294440951 4293914607 4293914607 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4291743438 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286282619 4287927444 4290624957 4293388263 4293914607 4293914607 4294967295 4293914607 4292269782 4294440951 4294967295 4293388263 4281940281 0 0 0 0 0 0 4279769112 4281413937 4278716424 4279769112 4289045925 4292269782 4287927444 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4279242768 0 0 0 0 0 0 0 4280887593 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4292796126 4293388263 4292796126 4292796126 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281940281 4281940281 4279769112 4283585106 4286282619 4283585106 0 0 0 0 4281413937 4287927444 4289045925 4291743438 4294967295 4294440951 4294440951 4294967295 4293388263 4292269782 4294967295 4294967295 4293914607 4283585106 0 0 0 0 0 4285756275 4293914607 4294967295 4292269782 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 4286282619 4284703587 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4291743438 4291743438 4291743438 4292796126 4294967295 4294967295 4294440951 4293388263 4294440951 4294440951 4293914607 4294440951 4293388263 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283058762 4286874756 4287927444 4287927444 4292269782 4294440951 4292269782 4283585106 4280361249 4278716424 0 4280361249 4286874756 4290624957 4292796126 4294967295 4293914607 4294440951 4294967295 4293914607 4293388263 4294967295 4294967295 4294967295 4285229931 0 0 0 0 4283585106 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4278716424 0 0 0 4280887593 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4292796126 4293388263 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4293914607 4293914607 4292796126 4292269782 4293388263 4291743438 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284111450 4288453788 4290624957 4291743438 4293914607 4294967295 4294967295 4294967295 4293914607 4291743438 4288453788 4280887593 4278716424 4283585106 4289572269 4293914607 4294440951 4293388263 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4282532418 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286874756 0 0 4278716424 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4292796126 4292269782 4293388263 4294440951 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4284111450 4287927444 4290098613 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045925 4278716424 4279242768 4283058762 4290624957 4293914607 4293388263 4293388263 4293388263 4293914607 4294967295 4294967295 4294967295 4290624957 4279242768 0 0 0 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4293914607 4291217094 0 0 4283585106 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4292796126 4292796126 4293914607 4294440951 4294440951 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285756275 4289045925 4291217094 4293388263 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289045925 4278716424 0 0 4286874756 4293914607 4294440951 4292796126 4293914607 4294967295 4294967295 4294440951 4289045925 4281413937 0 0 0 0 0 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294440951 4291743438 4278716424 0 4286874756 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293388263 4293914607 4294967295 4294967295 4293914607 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4288453788 4291743438 4293388263 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4285229931 0 0 0 4283585106 4290624957 4292796126 4293388263 4293914607 4294967295 4294967295 4289045925 4279242768 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4291743438 4291743438 4292269782 4293914607 4294967295 4294440951 4293914607 4294440951 4294440951 4293914607 4293914607 4291743438 4279242768 0 4287401100 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4293388263 4293388263 4293914607 4294967295 4294440951 4293388263 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4287401100 4290098613 4292796126 4293388263 4294440951 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4285229931 0 0 0 0 4280887593 4284703587 4288453788 4290624957 4293914607 4292796126 4282532418 0 0 0 0 0 0 4278716424 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4293914607 4294967295 4294967295 4294440951 4292796126 4293914607 4293388263 4292796126 4293388263 4291217094 0 0 4285229931 4292796126 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293388263 4292796126 4293388263 4293914607 4294440951 4293388263 4292796126 4286874756 0 0 0 0 0 0 0 0 0 0 4278716424 4279242768 4279769112 0 0 4279242768 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286874756 4287927444 4290624957 4293914607 4293914607 4293914607 4294967295 4293914607 4292796126 4294440951 4294967295 4293914607 4282532418 0 0 4280361249 4280361249 4280361249 4286874756 4288453788 4283585106 4283058762 4281413937 0 0 0 0 0 0 0 4285756275 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4292269782 4292796126 4294440951 4286282619 0 0 4280361249 4291217094 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4293914607 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4293388263 4292796126 4293388263 4294440951 4294440951 4293388263 4292796126 4291743438 4284703587 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4289045925 4287401100 4283585106 4279769112 4289572269 4290624957 4289572269 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4287927444 4289045925 4292796126 4294967295 4294440951 4294440951 4294967295 4293914607 4292269782 4294967295 4294967295 4294440951 4282532418 0 4281940281 4286282619 4289045925 4290624957 4294440951 4294440951 4287401100 4283058762 4279769112 0 0 0 0 0 0 0 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4294967295 4294440951 4285756275 0 0 0 4283585106 4292269782 4292796126 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4293914607 4293914607 4293388263 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4293388263 4292796126 4291743438 4289572269 4280361249 0 0 0 0 0 0 0 0 0 4284703587 4292796126 4293914607 4294440951 4292269782 4292796126 4294967295 4294967295 4294967295 4292796126 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4290098613 4293388263 4294967295 4293914607 4294440951 4294967295 4294440951 4293388263 4294967295 4294967295 4294967295 4285229931 4282532418 4287401100 4291217094 4292796126 4294440951 4294967295 4294967295 4294440951 4294440951 4289045925 4279242768 0 0 0 0 0 0 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4293914607 4293914607 4293388263 4293914607 4294440951 4293914607 4288453788 0 0 0 0 4283058762 4289572269 4292796126 4292796126 4293914607 4293388263 4293914607 4293914607 4293914607 4293388263 4293914607 4293388263 4292796126 4292269782 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4292796126 4291743438 4289572269 4282532418 0 0 0 0 0 0 0 0 0 0 4290624957 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4282532418 4289572269 4294440951 4293388263 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4292796126 4284111450 4285756275 4289572269 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4291217094 4279242768 0 0 0 0 0 0 4288453788 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4293388263 4294440951 4293914607 4293388263 4287401100 0 0 0 0 0 4281413937 4290624957 4292269782 4292796126 4292796126 4292796126 4292269782 4293914607 4293914607 4292796126 4292269782 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4293914607 4292796126 4286282619 4282532418 4279769112 0 0 0 0 0 0 0 0 4279769112 4281940281 4282532418 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4292796126 4294440951 4293914607 4292796126 4294967295 4294967295 4294967295 4293914607 4286282619 4279242768 4284703587 4289572269 4292796126 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 4281940281 4291743438 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4292796126 4293388263 4294967295 4294967295 4294440951 4293914607 4294440951 4294440951 4292796126 4291217094 4283585106 0 0 0 0 0 4286874756 4290098613 4290098613 4291743438 4292796126 4292796126 4293914607 4294440951 4294967295 4293388263 4293388263 4293388263 4293388263 4292269782 4291743438 4292796126 4292796126 4292796126 4292796126 4292796126 4292269782 4291743438 4283058762 0 0 0 0 0 0 0 0 0 4280887593 4284703587 4287401100 4289045925 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4288453788 4292796126 4293388263 4292796126 4294967295 4294967295 4293388263 4284703587 4279242768 4278716424 4285229931 4289045925 4292796126 4293914607 4294440951 4294967295 4293914607 4294440951 4294967295 4286282619 0 0 0 0 0 0 0 0 4282532418 4290098613 4292796126 4293914607 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4292796126 4292796126 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4292796126 4291217094 4286874756 4278716424 0 0 0 0 4278716424 4287401100 4289045925 4289045925 4289572269 4291743438 4292269782 4293388263 4293388263 4293914607 4293914607 4293914607 4293388263 4292796126 4291217094 4290098613 4291217094 4291217094 4291217094 4291217094 4291217094 4291743438 4290098613 4283058762 0 0 0 0 0 0 0 0 0 4282532418 4286874756 4288453788 4291217094 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4281940281 4285229931 4289572269 4292796126 4293914607 4286874756 0 0 4279769112 4286874756 4290098613 4293914607 4294440951 4294967295 4294440951 4292796126 4294440951 4294967295 4285229931 0 0 0 0 0 0 0 0 0 4282532418 4291217094 4292269782 4292796126 4292796126 4293388263 4293914607 4292796126 4292269782 4292269782 4292796126 4293388263 4293914607 4294440951 4293914607 4293914607 4292796126 4286282619 4281413937 0 0 0 0 0 0 4278716424 4286282619 4287401100 4288453788 4289045925 4289572269 4291217094 4291743438 4291743438 4291743438 4292269782 4292269782 4291217094 4291743438 4290098613 4288453788 4288453788 4289045925 4289045925 4289045925 4289572269 4290098613 4289572269 4281940281 0 0 0 0 0 0 0 0 0 4283585106 4288453788 4289572269 4292269782 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4281940281 4283058762 4279769112 0 0 4278716424 4283585106 4290624957 4294440951 4294440951 4294967295 4294440951 4293914607 4294967295 4294967295 4286874756 0 0 0 0 0 0 0 0 0 4286874756 4289572269 4290098613 4291743438 4292796126 4293914607 4294440951 4293914607 4293388263 4293914607 4291743438 4291217094 4292269782 4292269782 4292269782 4292269782 4291217094 4283585106 0 0 0 0 0 0 0 0 4283058762 4285756275 4287401100 4289045925 4289572269 4290624957 4290624957 4290098613 4290098613 4290624957 4290624957 4290098613 4290098613 4289045925 4287927444 4287927444 4287927444 4288453788 4289045925 4289572269 4289045925 4287401100 4279769112 0 0 0 0 0 0 0 0 4278716424 4284703587 4289045925 4291217094 4292796126 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286282619 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4292796126 4293914607 4293388263 4294440951 4294967295 4294967295 4294440951 4285229931 0 0 0 0 0 0 0 0 0 4285756275 4287927444 4289045925 4290098613 4291217094 4292269782 4292796126 4292796126 4292796126 4291743438 4290624957 4289045925 4289045925 4289572269 4289572269 4290098613 4289572269 4282532418 0 0 0 0 0 0 0 0 4278716424 4284111450 4285756275 4287401100 4288453788 4289045925 4289572269 4290098613 4290098613 4290098613 4289572269 4289572269 4289572269 4287927444 4287401100 4287927444 4288453788 4288453788 4288453788 4288453788 4287927444 4283585106 0 0 0 0 0 0 0 0 0 4280361249 4285756275 4289045925 4290624957 4292796126 4293914607 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4292269782 4286282619 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4284703587 4290098613 4292269782 4293914607 4294967295 4292269782 4283585106 0 0 0 0 0 0 0 0 0 0 4282532418 4286282619 4288453788 4289572269 4290624957 4290098613 4290098613 4290624957 4290624957 4290098613 4289572269 4287927444 4287927444 4288453788 4289045925 4289045925 4288453788 4280361249 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4284703587 4286874756 4287927444 4287927444 4287927444 4288453788 4288453788 4288453788 4288453788 4287927444 4286874756 4287401100 4287401100 4287401100 4287401100 4287401100 4287401100 4285229931 4279242768 0 0 0 0 0 0 0 0 0 4281413937 4286874756 4289045925 4290624957 4292796126 4294440951 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4294440951 4294967295 4294967295 4294967295 4293388263 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4281940281 4285229931 4289572269 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4286282619 4287927444 4289045925 4289045925 4289572269 4289572269 4289572269 4289045925 4287401100 4287401100 4287927444 4287927444 4287927444 4288453788 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4284703587 4287401100 4287401100 4287401100 4287927444 4287927444 4287401100 4286874756 4284111450 4283058762 4285756275 4286282619 4286874756 4285756275 4283058762 4278716424 0 0 0 0 0 0 0 0 0 0 4282532418 4287401100 4288453788 4290624957 4292269782 4293914607 4292269782 4293388263 4294440951 4294440951 4294967295 4294967295 4292796126 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4282532418 4286282619 4287401100 4287401100 4288453788 4287927444 4287401100 4285756275 4285229931 4286874756 4286874756 4286874756 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285756275 4286282619 4286282619 4286874756 4286874756 4286282619 4285756275 4280361249 0 4279242768 4280361249 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4285229931 4288453788 4289572269 4291217094 4293914607 4292796126 4292796126 4293388263 4293914607 4294440951 4294967295 4293388263 4291743438 4293388263 4294967295 4294967295 4294967295 4294967295 4293388263 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286282619 4286874756 4286874756 4286874756 4286282619 4281413937 4278716424 4280887593 4280887593 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4284111450 4285756275 4285756275 4285756275 4284703587 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4289045925 4290624957 4291743438 4292796126 4293388263 4293388263 4293914607 4294440951 4294967295 4294967295 4293388263 4293388263 4294440951 4294967295 4294967295 4294967295 4293388263 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4283585106 4283585106 4283585106 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279242768 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4286874756 4288453788 4289572269 4291743438 4293388263 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4289572269 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4287401100 4288453788 4291217094 4293914607 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4293388263 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4287927444 4288453788 4290624957 4293388263 4294967295 4294440951 4293388263 4294440951 4294967295 4293914607 4293914607 4294967295 4294967295 4294967295 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4287401100 4288453788 4290098613 4292796126 4294440951 4294440951 4293388263 4293388263 4293914607 4292796126 4293914607 4294967295 4294967295 4294967295 4293914607 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4283058762 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286874756 4288453788 4290098613 4291743438 4293914607 4294440951 4293914607 4293388263 4293388263 4292796126 4293388263 4294967295 4294967295 4294967295 4294967295 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4289572269 4292269782 4294967295 4288453788 4280887593 4280887593 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281413937 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4282532418 4286874756 4289045925 4290624957 4291743438 4293914607 4294440951 4293914607 4293914607 4293388263 4293388263 4293914607 4294440951 4294440951 4291217094 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4290098613 4294967295 4294967295 4294967295 4294967295 4292796126 4289045925 4288453788 4283585106 4280361249 4279242768 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4287927444 4293914607 4293388263 4285756275 4281940281 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4283585106 4285756275 4284703587 4287927444 4292796126 4293388263 4294967295 4293914607 4292796126 4292796126 4291217094 4289045925 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4289045925 4287927444 4284703587 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294967295 4294967295 4294967295 4294967295 4293914607 4290624957 4285756275 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 0 0 0 0 4279769112 0 4281940281 4288453788 4292269782 4291743438 4289572269 4286874756 4288453788 4284111450 4280361249 4279242768 4281940281 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4287927444 4285756275 4285229931 4284111450 4278716424 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4289045925 4285756275 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4281940281 4282532418 4278716424 4280887593 4284111450 4287401100 4288453788 4285756275 4281413937 0 0 0 4278716424 4280361249 4284703587 4283585106 4280361249 4283058762 4289045925 4288453788 4283058762 4287401100 4290624957 4291743438 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4291217094 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293388263 4293388263 4293388263 4284703587 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287927444 4291217094 4293914607 4289045925 4291217094 4292796126 4294967295 4294967295 4294967295 4285756275 0 0 0 0 0 0 0 4278716424 4290624957 4293914607 4293914607 4294440951 4293914607 4294967295 4294967295 4292269782 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285229931 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290098613 0 0 0 0 0 0 0 0 0 4286282619 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4290624957 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 0 0 0 0 0 4278716424 4280361249 4284111450 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4292796126 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4284111450 4279769112 0 0 0 0 0 0 4279242768 4290624957 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4292269782 4292269782 4293914607 4294440951 4294967295 4294967295 4294967295 4292796126 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279769112 4281940281 4281940281 4289572269 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4281940281 0 0 0 0 4281940281 4286282619 4289572269 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289572269 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4289045925 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293388263 4293388263 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4293388263 4288453788 4278716424 0 0 0 0 0 0 4290098613 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284703587 4287927444 4289045925 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4279242768 0 0 4279242768 4286282619 4289572269 4291743438 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4290098613 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4291743438 4291743438 4292796126 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4293914607 4284111450 0 0 0 0 0 0 4284111450 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4294440951 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286282619 4289045925 4290624957 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4280887593 0 0 4280887593 4287927444 4290624957 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294967295 4294967295 4289572269 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4292796126 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4293914607 4294440951 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 4278716424 4284703587 4291743438 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4292796126 4293388263 4293388263 4292796126 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287927444 4290098613 4292269782 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294440951 4288453788 4279242768 0 4283058762 4287927444 4290098613 4293914607 4293388263 4293914607 4294967295 4294967295 4294967295 4292796126 4293914607 4294967295 4294967295 4294967295 4289045925 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4292269782 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4294440951 4294967295 4294967295 4294967295 4293914607 4287401100 0 0 0 0 0 4280887593 4287401100 4289572269 4292269782 4293388263 4293914607 4293388263 4293914607 4293388263 4293388263 4294440951 4293914607 4293914607 4292796126 4293388263 4293388263 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4289045925 4291217094 4293388263 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4288453788 4280361249 4284111450 4287927444 4290624957 4293388263 4293388263 4293388263 4294440951 4294967295 4294967295 4293388263 4292796126 4294440951 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4289572269 4292796126 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4293914607 4294440951 4293914607 4294440951 4292796126 4284111450 0 0 0 0 0 4279769112 4286874756 4289572269 4291743438 4293388263 4294440951 4292796126 4292796126 4293388263 4294967295 4294967295 4292796126 4292796126 4294440951 4294967295 4291217094 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286282619 4289045925 4290624957 4292796126 4293914607 4293388263 4294440951 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4294440951 4294967295 4294967295 4294967295 4294440951 4282532418 4284703587 4287401100 4290098613 4291217094 4292796126 4293388263 4293914607 4294440951 4294967295 4294440951 4293388263 4294440951 4294967295 4294440951 4291217094 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285229931 4289045925 4292269782 4292796126 4293388263 4293914607 4294440951 4294440951 4294440951 4294440951 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4294440951 4293388263 4292796126 4292796126 4292796126 4293388263 4290098613 4280361249 0 0 0 0 0 0 4283058762 4288453788 4290098613 4291743438 4292796126 4293914607 4292269782 4292796126 4294440951 4294967295 4294967295 4293914607 4293914607 4293388263 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287401100 4288453788 4290098613 4292269782 4293914607 4292796126 4293388263 4294440951 4294440951 4294967295 4294967295 4292269782 4292269782 4294440951 4294967295 4294967295 4294967295 4294967295 4286282619 4281940281 4283585106 4287927444 4289045925 4291743438 4293914607 4294440951 4293914607 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287401100 4289045925 4290624957 4292269782 4292796126 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293914607 4294440951 4294440951 4293388263 4292796126 4293388263 4293388263 4291217094 4285756275 0 0 0 0 0 0 0 0 4284703587 4288453788 4289572269 4290098613 4290624957 4290098613 4290098613 4292269782 4292796126 4293914607 4291743438 4290624957 4287927444 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4286874756 4288453788 4289572269 4291217094 4293388263 4292796126 4293388263 4293914607 4293914607 4294440951 4294967295 4294440951 4292269782 4293388263 4294967295 4294967295 4294967295 4294967295 4288453788 0 4279242768 4286282619 4287927444 4289572269 4293914607 4294967295 4293914607 4294440951 4293914607 4294440951 4294967295 4294967295 4294440951 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286874756 4288453788 4289572269 4291743438 4292796126 4294440951 4293914607 4292796126 4292796126 4292796126 4292796126 4293914607 4294440951 4294440951 4293388263 4293388263 4292796126 4293388263 4293914607 4294967295 4293388263 4286282619 4280361249 0 4278716424 0 0 0 0 0 0 4281413937 4286874756 4287927444 4288453788 4287927444 4287401100 4287927444 4289045925 4290624957 4290098613 4283058762 4280361249 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285229931 4287927444 4288453788 4289572269 4291743438 4292269782 4293914607 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4294967295 4294967295 4294440951 4286874756 0 4279242768 4284703587 4287927444 4289572269 4293388263 4294440951 4293914607 4293388263 4292796126 4293388263 4294440951 4293914607 4291217094 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285229931 4287927444 4289572269 4291217094 4292269782 4293388263 4294440951 4293388263 4292796126 4292796126 4293388263 4294967295 4294967295 4294967295 4293914607 4293388263 4293388263 4293914607 4294967295 4294440951 4292269782 4282532418 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4285229931 4285756275 4283585106 4285756275 4287401100 4288453788 4289045925 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4284111450 4287401100 4287927444 4289045925 4292269782 4293914607 4294967295 4294440951 4294440951 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4294967295 4291217094 4281940281 0 0 4281413937 4285229931 4287927444 4289572269 4291743438 4293914607 4292796126 4292269782 4291743438 4286874756 4285229931 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4286282619 4289045925 4290098613 4290624957 4291743438 4292796126 4293388263 4293388263 4292269782 4292269782 4293914607 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4293914607 4293388263 4289045925 4280361249 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4278716424 4280361249 4284111450 4284703587 4282532418 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286282619 4287401100 4288453788 4291743438 4294440951 4294967295 4293914607 4293914607 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4294967295 4288453788 0 0 0 0 4279769112 4280887593 4281413937 4283585106 4286282619 4286874756 4284111450 4280887593 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4287401100 4289045925 4289572269 4290098613 4290624957 4291217094 4291743438 4290624957 4290624957 4292269782 4292796126 4293914607 4294440951 4294440951 4293388263 4292796126 4291743438 4289572269 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286282619 4287927444 4289045925 4290624957 4293914607 4294967295 4293914607 4293388263 4293914607 4293914607 4292796126 4293914607 4294967295 4294967295 4294967295 4290624957 0 0 0 0 0 0 0 4278716424 4279242768 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4287401100 4288453788 4289045925 4289572269 4289572269 4289045925 4288453788 4288453788 4290098613 4291217094 4292269782 4292796126 4291743438 4287401100 4285756275 4286874756 4283058762 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4287927444 4289045925 4290624957 4292269782 4293914607 4294440951 4292796126 4293914607 4293388263 4292796126 4293914607 4294967295 4294967295 4294440951 4289045925 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4286282619 4287401100 4287927444 4287927444 4287927444 4287401100 4287401100 4287401100 4287927444 4289045925 4290098613 4290624957 4287927444 4281413937 4278716424 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4285229931 4286874756 4289572269 4288453788 4289572269 4293388263 4294440951 4294440951 4294967295 4292796126 4292269782 4292796126 4291743438 4288453788 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4285756275 4286282619 4286282619 4285756275 4285229931 4286874756 4288453788 4288453788 4289045925 4289045925 4288453788 4283058762 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4281413937 4281413937 4280887593 4280887593 4289045925 4292269782 4292269782 4291743438 4290098613 4286282619 4284703587 4282532418 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4282532418 4283058762 4280887593 4279769112 4284111450 4286874756 4287401100 4287927444 4286282619 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4284703587 4284703587 4282532418 4279242768 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4278716424 0 0 4279769112 4281413937 4283585106 4282532418 4280887593 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279769112 4287927444 4293388263 4292269782 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4286874756 4289572269 4294440951 4294967295 4294967295 4292796126 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4286874756 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4285756275 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4285756275 4293388263 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4294440951 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4288453788 4292269782 4293914607 4294440951 4294967295 4294967295 4293914607 4292269782 4293914607 4294967295 4294967295 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287927444 4291743438 4293914607 4293914607 4294440951 4294440951 4294967295 4294440951 4294440951 4294440951 4294967295 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286282619 4290098613 4292796126 4293388263 4293388263 4293914607 4294440951 4294967295 4294440951 4294440951 4294967295 4294440951 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287927444 4290624957 4291217094 4292796126 4294440951 4294440951 4293914607 4293388263 4293388263 4294440951 4292796126 4282532418 4280361249 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4281940281 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4285756275 4287927444 4289572269 4293388263 4294967295 4293914607 4293914607 4293914607 4292269782 4286282619 4283058762 4290624957 4292796126 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4291217094 4294967295 4289572269 4284703587 4281413937 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285229931 4287927444 4290624957 4293388263 4293388263 4293914607 4291743438 4285756275 4288453788 4292269782 4294967295 4294967295 4292796126 4286282619 4281413937 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294967295 4294967295 4294967295 4294967295 4292796126 4289045925 4284703587 4280887593 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284111450 4286282619 4284703587 4283058762 4284703587 4281413937 4280887593 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4290624957 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4279769112 4278716424 0 0 0 4282532418 4292796126 4294967295 4294967295 4294440951 4293388263 4294440951 4294967295 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4291743438 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283058762 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4285229931 4281413937 0 0 4278716424 4286282619 4292796126 4294440951 4294440951 4294967295 4294440951 4294440951 4294967295 4289045925 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4292796126 4294440951 4294440951 4294967295 4294967295 4286282619 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287927444 4294440951 4293914607 4288453788 4284703587 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4291743438 4294967295 4292269782 4283585106 0 0 4284111450 4291217094 4293388263 4293914607 4294440951 4294440951 4293914607 4293914607 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4294440951 4294967295 4294967295 4290624957 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4293914607 4294967295 4294967295 4294967295 4294967295 4292269782 4289045925 4283585106 4281413937 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4288453788 4291743438 4294967295 4294967295 4294967295 4293388263 4285756275 4280361249 4283058762 4287401100 4290098613 4291743438 4294967295 4293914607 4293388263 4286282619 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4290624957 4293914607 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293914607 4293914607 4288453788 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286874756 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4285229931 4281940281 4285229931 4289045925 4291217094 4290098613 4285756275 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4289572269 4292269782 4293914607 4293914607 4293914607 4293914607 4293914607 4294440951 4294440951 4292796126 4293388263 4292269782 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4287927444 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4294967295 4294967295 4292269782 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4286874756 4294440951 4294967295 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4292269782 4279769112 4279769112 4283058762 4281940281 4279769112 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4288453788 4291743438 4293914607 4293914607 4292796126 4293388263 4294967295 4293914607 4293388263 4293914607 4294440951 4287401100 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293388263 4294440951 4294967295 4294967295 4293388263 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4290098613 4293914607 4294967295 4294967295 4294967295 4293914607 4292269782 4293914607 4294967295 4293914607 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286282619 4290098613 4291217094 4292269782 4292269782 4292269782 4294440951 4294440951 4294440951 4293914607 4292269782 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4289045925 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4294440951 4294967295 4294967295 4294967295 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4290098613 4293388263 4294440951 4294440951 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4289045925 4289572269 4289045925 4289045925 4290624957 4292796126 4289572269 4285229931 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4292796126 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4293914607 4292796126 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4290098613 4292796126 4293914607 4293388263 4293914607 4294967295 4294967295 4294440951 4294440951 4294967295 4290098613 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4286282619 4285756275 4285756275 4287401100 4289045925 4289045925 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287927444 4291217094 4293388263 4294440951 4293388263 4293914607 4293914607 4294440951 4294440951 4293914607 4292796126 4293914607 4287927444 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287927444 4290624957 4291743438 4292796126 4294967295 4294440951 4293914607 4293388263 4293388263 4292269782 4284111450 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4280361249 4279769112 4279769112 4284111450 4284703587 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286874756 4290098613 4292796126 4293914607 4293388263 4292796126 4293914607 4294967295 4293388263 4293914607 4294967295 4292269782 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285229931 4287401100 4287927444 4290098613 4293914607 4294967295 4293914607 4294440951 4291217094 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4288453788 4290098613 4291743438 4292269782 4291743438 4292796126 4294967295 4294967295 4293914607 4292796126 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4285229931 4287927444 4291217094 4290624957 4290098613 4290098613 4283058762 0 0 0 0 0 0 4278716424 4283058762 4284703587 4284111450 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4287927444 4289045925 4289045925 4288453788 4289045925 4291217094 4291217094 4285756275 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284703587 4284703587 4280887593 4280361249 4280361249 0 0 0 0 4283058762 4283585106 4281940281 4290098613 4294967295 4294967295 4294967295 4292796126 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4284703587 4285756275 4284703587 4286282619 4288453788 4289045925 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4291743438 4289045925 4289045925 4294440951 4294967295 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4285229931 4282532418 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4278716424 4281413937 4283585106 4283058762 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 4284111450 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290098613 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 0 0 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4278716424 0 4291743438 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4294440951 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 0 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4291743438 4292796126 4294440951 4294440951 4294440951 4294967295 4294967295 4293914607 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293914607 4294967295 4294967295 4293388263 4293388263 4293388263 4292796126 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292796126 4293388263 4293388263 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4293388263 4294440951 4294440951 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293914607 4293914607 4293388263 4293388263 4294440951 4293914607 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4291743438 4293914607 4294440951 4294440951 4294967295 4294440951 4294967295 4294967295 4293914607 4293388263 4294440951 4294440951 4293914607 4293388263 4294440951 4294440951 4291743438 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4290624957 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4293914607 4291217094 4287401100 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285756275 4291217094 4292796126 4292796126 4293914607 4294440951 4292796126 4292796126 4292796126 4293388263 4294440951 4293914607 4293388263 4291217094 4282532418 4278716424 0 0 0 4280361249 4286282619 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4287401100 4289045925 4290098613 4292269782 4293388263 4293914607 4293388263 4293388263 4291217094 4290098613 4290624957 4290624957 4291217094 4288453788 4279769112 0 0 0 4279242768 4290098613 4294967295 4294967295 4291743438 4287401100 4283058762 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284703587 4287927444 4289572269 4290624957 4290624957 4291217094 4291217094 4290624957 4289045925 4287927444 4288453788 4289045925 4289572269 4286282619 4278716424 0 0 0 4281940281 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4291743438 4286282619 4284111450 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284703587 4287927444 4288453788 4289045925 4289572269 4289572269 4289045925 4287927444 4287401100 4287927444 4288453788 4287927444 4282532418 0 0 0 4280887593 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4285229931 4286874756 4286874756 4287401100 4286874756 4284703587 4284703587 4285756275 4285229931 4282532418 0 0 0 4279242768 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4294440951 4294967295 4294967295 4293388263 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280887593 4281413937 4282532418 4281940281 4278716424 0 4279242768 4279242768 0 0 0 0 4279769112 4292269782 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4292269782 4293388263 4294440951 4294967295 4294967295 4294440951 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286874756 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4294440951 4294967295 4294440951 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4292796126 4293914607 4294440951 4294967295 4294440951 4294440951 4294967295 4294967295 4293914607 4292796126 4293388263 4292269782 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281940281 4281940281 4283585106 4290624957 4290098613 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4287927444 4290624957 4293388263 4293914607 4293388263 4293388263 4293914607 4294440951 4293388263 4293914607 4293388263 4293914607 4285756275 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4287927444 4290098613 4293388263 4294440951 4294967295 4290624957 4286874756 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285756275 4290098613 4292269782 4293914607 4293388263 4292796126 4294440951 4294967295 4294440951 4293388263 4294967295 4291217094 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4289045925 4291743438 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4290624957 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4287401100 4289572269 4291217094 4291743438 4290624957 4292269782 4293914607 4294440951 4292796126 4291743438 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287401100 4290624957 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4287401100 4288453788 4287927444 4287927444 4289045925 4290624957 4290098613 4283058762 4280887593 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287927444 4291743438 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4284703587 4283058762 4285756275 4287927444 4287927444 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4287401100 4291217094 4292796126 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4288453788 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283058762 4285756275 4285756275 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 0 4280361249 4281940281 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287927444 4290098613 4293388263 4293388263 4294967295 4294440951 4292796126 4294967295 4294440951 4284703587 0 0 0 0 0 4278716424 0 0 4283585106 4285229931 4283058762 4289045925 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4288453788 4292269782 4294967295 4294440951 4294967295 4293388263 4292796126 4294967295 4294440951 4284111450 0 0 0 0 4285229931 4292269782 4291217094 4289572269 4294440951 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287401100 4284703587 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4289572269 4293914607 4294440951 4294440951 4294967295 4293914607 4293914607 4294967295 4294967295 4285756275 0 0 0 4283058762 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 4280361249 4287401100 4293388263 4294440951 4293388263 4294440951 4294440951 4294967295 4294967295 4294967295 4283058762 0 0 0 4288453788 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294967295 4294967295 4294967295 4293914607 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 0 4279769112 4289045925 4294440951 4293388263 4293388263 4294967295 4294967295 4294967295 4287401100 4279242768 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4293914607 4293914607 4294440951 4294967295 4294967295 4294967295 4293388263 4286282619 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4293388263 4293388263 4293388263 4294967295 4294967295 4286282619 4278716424 0 0 0 0 4285229931 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292269782 4291743438 4292269782 4294440951 4294440951 4293914607 4294440951 4294967295 4292269782 4285229931 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4287927444 4290624957 4292796126 4289572269 4279242768 0 0 0 0 0 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4293914607 4294967295 4294967295 4293388263 4293388263 4292796126 4291217094 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4281940281 4284703587 4290098613 4285229931 4281940281 4279242768 0 0 0 0 0 4283058762 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4292796126 4292796126 4292269782 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4287927444 4291217094 4294440951 4294967295 4292269782 4287927444 4281940281 0 0 0 0 0 4285756275 4294440951 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4293914607 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281940281 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4287927444 0 0 0 0 0 4285229931 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4293388263 4292796126 4292796126 4294440951 4292796126 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4292269782 4293914607 4294967295 4294967295 4294967295 4294967295 4285756275 0 0 0 0 0 4279769112 4291217094 4293388263 4293914607 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4293914607 4294967295 4294440951 4293388263 4294967295 4293914607 4291743438 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4291743438 4294440951 4294967295 4293914607 4293914607 4294440951 4283058762 0 0 0 0 0 0 4281413937 4288453788 4293388263 4293914607 4293914607 4293914607 4293914607 4293388263 4292796126 4293388263 4294440951 4294967295 4294967295 4294967295 4293914607 4291743438 4287401100 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4287401100 4294440951 4294440951 4294967295 4293388263 4293914607 4294440951 4283585106 0 0 0 0 0 0 0 4284703587 4290624957 4292269782 4292796126 4293914607 4293914607 4292796126 4292796126 4292796126 4292796126 4293914607 4293388263 4293388263 4291743438 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4284111450 4293388263 4293914607 4294440951 4294440951 4294967295 4294967295 4284111450 0 0 0 0 0 0 0 4286282619 4288453788 4290098613 4291743438 4292796126 4293388263 4293388263 4293388263 4291217094 4290098613 4290624957 4290098613 4291217094 4289572269 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285229931 4291217094 4292796126 4294967295 4293914607 4285756275 4279242768 0 0 0 0 0 0 0 4284111450 4286874756 4289045925 4290624957 4290624957 4291217094 4291217094 4290624957 4289572269 4287401100 4288453788 4288453788 4289572269 4287927444 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4282532418 4287401100 4285756275 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4286874756 4288453788 4289045925 4289045925 4289572269 4289045925 4287927444 4287401100 4287401100 4288453788 4287927444 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284703587 4287401100 4287401100 4287927444 4286874756 4284703587 4284111450 4285229931 4285229931 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4285756275 4285756275 4284703587 4279769112 0 4279242768 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279242768 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286282619 4290098613 4284703587 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294967295 4294967295 4294440951 4292269782 4288453788 4284111450 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289572269 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291743438 4287927444 4285756275 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4283585106 4283058762 4280887593 4285229931 4288453788 4287401100 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4287401100 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4289572269 4293914607 4293914607 4292269782 4293914607 4294967295 4294967295 4290624957 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4294440951 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4293388263 4294440951 4294967295 4294967295 4292796126 4283058762 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4285229931 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4292796126 4294440951 4294440951 4294967295 4294967295 4290098613 4279242768 0 0 0 0 0 0 0 0 0 4280361249 4284703587 4287401100 4291217094 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290098613 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4291743438 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4294967295 4290624957 4279242768 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4290098613 4292796126 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4290098613 4292796126 4294440951 4293914607 4294440951 4294440951 4294440951 4294967295 4294440951 4293388263 4293388263 4293388263 4285229931 0 0 0 0 0 0 0 0 0 0 4283585106 4289045925 4291217094 4293388263 4293914607 4294967295 4294967295 4294967295 4294967295 4294440951 4294967295 4294440951 4293914607 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284111450 4289045925 4291743438 4293914607 4293914607 4293388263 4293388263 4293914607 4293914607 4293388263 4293388263 4293914607 4290098613 4279769112 0 0 0 0 0 0 0 0 0 4279242768 4285756275 4289572269 4292269782 4293914607 4293914607 4294967295 4294967295 4294967295 4294967295 4293388263 4293914607 4294967295 4294440951 4290624957 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287927444 4290624957 4292269782 4293914607 4292796126 4292796126 4294967295 4294967295 4293914607 4294440951 4293914607 4285229931 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4289045925 4291217094 4293914607 4293388263 4293914607 4294967295 4294967295 4294967295 4292796126 4292796126 4294967295 4294967295 4293914607 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4288453788 4289572269 4290624957 4290098613 4290624957 4292269782 4293914607 4292796126 4290098613 4287401100 4279769112 0 0 0 0 0 0 0 0 0 0 4281940281 4286874756 4288453788 4290624957 4293388263 4292796126 4293388263 4293914607 4294440951 4294967295 4293914607 4292796126 4294440951 4294967295 4294440951 4290098613 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285756275 4287401100 4287927444 4287927444 4287401100 4289572269 4290624957 4285229931 4279769112 4278716424 0 0 0 0 0 0 0 0 0 0 0 4279242768 4284703587 4287401100 4289045925 4290624957 4292269782 4293914607 4293914607 4294440951 4294967295 4294967295 4294440951 4293914607 4294967295 4294440951 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4283058762 4282532418 4282532418 4286282619 4287401100 4285229931 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4287401100 4288453788 4291743438 4294967295 4294967295 4293914607 4294967295 4294967295 4293914607 4294440951 4294967295 4294967295 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287401100 4288453788 4291217094 4294440951 4294440951 4293388263 4293914607 4293914607 4293388263 4294440951 4294967295 4294440951 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286874756 4288453788 4290624957 4292796126 4294440951 4293388263 4293914607 4293388263 4292796126 4294440951 4294967295 4294440951 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4282532418 4286282619 4287927444 4287401100 4290624957 4293914607 4294440951 4294967295 4292269782 4291743438 4291217094 4286874756 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4279769112 4278716424 4281940281 4289045925 4290098613 4287927444 4285229931 4282532418 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4280887593 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281413937 4285756275 4288453788 4284703587 4283585106 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 4283585106 4286874756 4291743438 4293388263 4294967295 4294967295 4291743438 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4290624957 4291217094 4294967295 4294440951 4293914607 4294967295 4294440951 4293914607 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4290098613 4294967295 4294967295 4294440951 4293914607 4293388263 4294967295 4293914607 4293388263 4290098613 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4289045925 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4293914607 4293914607 4290624957 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294440951 4294440951 4286282619 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4292269782 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287927444 4292796126 4293914607 4294440951 4292796126 4291743438 4290098613 4288453788 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280361249 4287401100 4290624957 4292269782 4291217094 4288453788 4285229931 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4284703587 4286874756 4287927444 4284703587 4279769112 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4278716424 4280361249 4281940281 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 4279769112 4279769112 0 4283058762 4281413937 4279242768 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283058762 4287927444 4287401100 4290098613 4289045925 4291743438 4293388263 4287927444 4281940281 0 4279242768 4283058762 4282532418 4286282619 4285756275 4281413937 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4294967295 4294967295 4294440951 4294967295 4294967295 4294440951 4294440951 4292796126 4284703587 4284111450 4293388263 4292269782 4293388263 4294967295 4291217094 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4289572269 4294967295 4294967295 4294967295 4293914607 4293388263 4294967295 4294967295 4293914607 4289572269 4287401100 4294967295 4294967295 4293388263 4294440951 4294440951 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4291743438 4294967295 4294967295 4294967295 4294967295 4293914607 4294967295 4293388263 4293914607 4288453788 4289045925 4294967295 4294967295 4294440951 4294967295 4293388263 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4288453788 4293914607 4294967295 4294967295 4294440951 4294440951 4294967295 4294440951 4292796126 4284703587 4283585106 4292269782 4294967295 4294440951 4293914607 4291217094 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4290624957 4293388263 4294440951 4293388263 4292796126 4294440951 4292796126 4287927444 4279769112 4279769112 4286282619 4290098613 4289572269 4290098613 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4285229931 4290624957 4291743438 4290098613 4290098613 4289572269 4287401100 4280887593 0 4279242768 4280887593 4286874756 4283585106 4281413937 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283058762 4285756275 4284111450 4283058762 4283585106 4281940281 4280887593 4281413937 4283058762 4284703587 4286282619 4285229931 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279242768 4278716424 0 4279242768 4288453788 4293914607 4291743438 4294440951 4294440951 4291743438 4289045925 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4292269782 4294967295 4294967295 4293914607 4293914607 4294967295 4294440951 4287927444 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4283585106 4294967295 4294967295 4294967295 4294440951 4293914607 4294440951 4293914607 4286874756 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4293914607 4294967295 4294967295 4294440951 4294967295 4294440951 4293914607 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4290624957 4294440951 4294967295 4293914607 4294967295 4294440951 4291217094 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4286874756 4292269782 4292796126 4291743438 4291743438 4291743438 4284703587 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4281413937 4285756275 4288453788 4287927444 4285756275 4286282619 4280361249 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4281940281 4281413937 4280361249 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286282619 4285756275 4281940281 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4286282619 4294967295 4294967295 4291217094 4288453788 4281940281 4279769112 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4292796126 4294967295 4294967295 4294967295 4294967295 4291743438 4287401100 4284111450 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4286282619 4292796126 4294967295 4294967295 4294967295 4294967295 4294440951 4294440951 4294967295 4293388263 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4278716424 4279769112 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4294967295 4294440951 4292796126 4294440951 4294440951 4294967295 4290098613 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4284111450 4282532418 4284703587 4289572269 4286874756 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4293914607 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4294967295 4294967295 4294440951 4288453788 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4289045925 4292796126 4294440951 4293388263 4294967295 4293914607 4286874756 4279769112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4288453788 4292796126 4294967295 4294440951 4294440951 4294440951 4294967295 4294967295 4293914607 4294440951 4294967295 4289572269 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292269782 4285229931 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4287401100 4291217094 4293388263 4293914607 4293914607 4293914607 4293914607 4294967295 4293388263 4293388263 4292269782 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4292796126 4294967295 4294967295 4294967295 4294440951 4294440951 4293914607 4293388263 4291217094 4285229931 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4285229931 4290098613 4292796126 4292269782 4292796126 4294440951 4294967295 4293914607 4294440951 4293914607 4285756275 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4289045925 4294967295 4294967295 4294967295 4293388263 4293914607 4294440951 4293388263 4292796126 4294440951 4292269782 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287927444 4289572269 4290098613 4290098613 4292269782 4294440951 4293914607 4292796126 4289045925 4280887593 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4287401100 4294967295 4294967295 4294967295 4293914607 4292269782 4293914607 4294967295 4294967295 4293388263 4293914607 4293388263 4283585106 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4283585106 4285229931 4285756275 4287927444 4289045925 4290624957 4286282619 4284703587 4281940281 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4280361249 4280361249 4280887593 0 0 0 0 0 4287401100 4293388263 4294967295 4294967295 4294440951 4293388263 4293388263 4294967295 4294967295 4294440951 4293914607 4294440951 4292796126 4283058762 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4280361249 4283058762 4285756275 4284703587 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280887593 4286282619 4287401100 4290624957 4289045925 4281413937 0 0 0 4282532418 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294440951 4293914607 4294967295 4294967295 4292269782 4285229931 4279242768 0 0 0 0 0 0 0 0 0 4280887593 4281940281 4287927444 4286282619 4283585106 4280887593 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4285229931 4294440951 4294440951 4294967295 4294967295 4286874756 4279242768 0 0 4282532418 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293914607 4294440951 4292796126 4290624957 4287927444 4280361249 0 0 0 0 0 0 4279769112 4279242768 4285229931 4288453788 4293388263 4293914607 4294967295 4293914607 4287927444 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4289572269 4294967295 4294967295 4294967295 4294967295 4292796126 4284111450 0 0 4280361249 4289045925 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293388263 4293388263 4292269782 4289572269 4289045925 4287927444 4280887593 0 0 0 0 0 4279769112 4287401100 4290098613 4293388263 4294967295 4293914607 4294440951 4294967295 4294440951 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4291743438 4294967295 4294967295 4294967295 4294440951 4294440951 4290624957 4283585106 0 0 4281413937 4287927444 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4293388263 4293388263 4290624957 4287927444 4287401100 4284703587 4279242768 0 0 0 0 0 4283585106 4293388263 4294967295 4294967295 4294440951 4293388263 4293914607 4294440951 4293388263 4292796126 4284111450 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4286282619 4291743438 4294440951 4294440951 4294440951 4293914607 4293914607 4294440951 4289572269 4278716424 0 0 4283058762 4294440951 4294967295 4294967295 4294967295 4293914607 4293914607 4293914607 4292269782 4290098613 4287401100 4283585106 4280361249 0 0 0 0 0 0 4283058762 4294440951 4294967295 4294967295 4294967295 4293914607 4294967295 4294440951 4293914607 4293914607 4284703587 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4290624957 4292796126 4293914607 4294967295 4293914607 4294440951 4294967295 4291743438 4279242768 0 0 4279769112 4289045925 4292269782 4293914607 4293388263 4292796126 4292796126 4292269782 4290098613 4289045925 4286874756 4279769112 0 0 0 0 0 0 0 4280361249 4292269782 4294967295 4294967295 4294967295 4294967295 4293914607 4294440951 4294440951 4291743438 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4286282619 4290098613 4293388263 4294967295 4294967295 4293914607 4294967295 4290624957 4279242768 0 0 0 4281413937 4285229931 4284111450 4287927444 4290098613 4290098613 4289045925 4288453788 4287927444 4284111450 4279242768 0 0 0 0 0 0 0 4278716424 4292269782 4294967295 4294967295 4294967295 4294440951 4293914607 4293914607 4293388263 4289045925 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281940281 4287401100 4292269782 4294440951 4294440951 4293914607 4294967295 4288453788 4279242768 0 0 0 0 4279242768 0 4281940281 4285229931 4285229931 4285229931 4283585106 4282532418 4280361249 0 0 0 0 0 0 0 0 0 4285756275 4290624957 4294440951 4294440951 4293914607 4292269782 4290624957 4290098613 4285756275 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4280361249 4284703587 4289045925 4291217094 4291743438 4292796126 4289572269 4287401100 4280887593 4280361249 0 0 0 0 0 4279242768 4280887593 4279769112 4279242768 4279242768 4278716424 0 0 0 0 0 0 0 0 0 0 4279242768 4283585106 4290098613 4291743438 4292269782 4290624957 4286874756 4285756275 4282532418 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4279769112 4280887593 4281413937 4284111450 4283058762 4289572269 4289045925 4292796126 4286282619 4279242768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4284111450 4286282619 4288453788 4286874756 4281940281 4280361249 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 0 0 4278716424 4283585106 4292269782 4294440951 4294967295 4292269782 4283585106 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4279769112 4281940281 4281413937 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4285756275 4294967295 4294967295 4294440951 4294440951 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279769112 4286282619 4293388263 4294967295 4294440951 4293914607 4294967295 4282532418 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4281413937 4289572269 4293914607 4294440951 4294440951 4292269782 4281413937 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278716424 4283585106 4291217094 4289572269 4289045925 4283058762 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4279242768 4281413937 4281413937 4278716424 4278716424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !


!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 23:06'!
arguments
	^ arguments! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 23:06'!
arguments: anArgumentArray
	arguments _ anArgumentArray! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 23:10'!
cp
	^ currentPosition x @ currentPosition z.! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 15:50'!
currentPosition
	^ currentPosition! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 22:35'!
currentPosition: a3DVector
	| myPosition |
	currentPosition _ a3DVector.
	" self boundInWorld. "
	myPosition _ currentPosition x @ currentPosition z.
	" self center: ( owner topLeft + myPosition). "
	self center: myPosition.
	self align: self center with: myPosition.
! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 19:19'!
maxSpeed
	^ maxSpeed! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 19:20'!
maxSpeed: anInteger
	maxSpeed _ anInteger! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 23:06'!
selector
	^ selector! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 23:07'!
selector: aSymbol
	selector _ aSymbol! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 11:59'!
target
	target
		ifNil: [^ B3DVector3 zero].
	^ target target! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/2/2002 11:59'!
target: aTargetMorph
	target _ aTargetMorph.! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/4/2002 20:08'!
targetVector 
	^ targetVector! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 2/4/2002 20:09'!
targetVector: aB3DVector 
	targetVector _ aB3DVector! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 23:13'!
vel
	^ velocity x @ velocity z.! !

!DeliverMorph methodsFor: 'accessing' stamp: 'jlb 11/14/2001 23:13'!
velocity
	^ velocity! !

!DeliverMorph methodsFor: 'initialization' stamp: 'jlb 2/5/2002 08:14'!
initialize
	super initialize.
	behaviourList _ OrderedCollection new.
	currentPosition _ B3DVector3 zero.
	targetVector _ B3DVector3 zero.
	velocity _ B3DVector3 zero.
	maxSpeed _ 100.0.
	maxForce _ 10.0.
	self extent: 28@28.
	self stopStepping.
	self addBehaviour: #arrival.
! !

!DeliverMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/5/2002 08:10'!
startStepping
	super startStepping.
! !

!DeliverMorph methodsFor: 'stepping and presenter' stamp: 'jlb 2/5/2002 08:05'!
step
	" go through the list of behaviours, and come up with the new steering force vector "

	| force |
	force _ B3DVector3 zero.
	behaviourList do: [ :aBehaviour |
		force _ force + ( aBehaviour calculate: self target: target ). ].
	velocity _ velocity + force.
	self currentPosition: ( currentPosition + velocity ).! !

!DeliverMorph methodsFor: 'stepping and presenter' stamp: 'jlb 11/14/2001 19:18'!
stepTime
	^ 0.! !

!DeliverMorph methodsFor: 'stepping and presenter' stamp: 'jlb 11/14/2001 19:35'!
wantsSteps
	^ false.! !

!DeliverMorph methodsFor: 'geometry' stamp: 'jlb 11/14/2001 22:55'!
boundInWorld
	" This is just a trick to let the boids wander around in the flock world "
	| flockBounds x y z |
	
	owner ifNil: [ ^ self ].
	flockBounds _ 0 @ 0 corner: ( owner bounds extent ).
	x _ currentPosition x.
	y _ currentPosition y.
	z _ currentPosition z.
	( x < flockBounds left)
		 ifTrue: [ x _ flockBounds width ]
		ifFalse: [ x > flockBounds right ifTrue: [ x _ 0 ]].

	( y < flockBounds left)
		 ifTrue: [ y _ flockBounds width ]
		ifFalse: [ y > flockBounds right ifTrue: [y _ 0 ]].

	( z < flockBounds top)
		 ifTrue: [ z _ flockBounds height ]
		ifFalse: [ z > flockBounds bottom ifTrue: [z _ 0 ]].

	currentPosition _ ( B3DVector3 x: x y: y z: z ).
! !

!DeliverMorph methodsFor: 'geometry' stamp: 'jlb 2/2/2002 12:07'!
radius
	^ 16! !

!DeliverMorph methodsFor: 'drawing' stamp: 'jlb 2/2/2002 23:34'!
drawOn: aCanvas
	| sourceRect |

	" draw the target using an alpha factor "
	sourceRect _ target bounds align: (target bounds center ) with: self center.
	aCanvas
		image: target form
		at: sourceRect topLeft
		sourceRect: target form boundingBox
		rule: Form blendAlpha
		alpha: 160.

	" vb _ 0@0 corner: 8@8.
	vb _ vb align: vb center with: self center.
	aCanvas fillOval: vb fillStyle: self fillStyle borderWidth: 1 borderColor: Color black. "
	" self drawVelocityVector: aCanvas. "
	! !

!DeliverMorph methodsFor: 'drawing' stamp: 'jlb 11/15/2001 19:48'!
drawVelocityVector: aCanvas
	| cp vel |
	cp _ self cp + owner topLeft.
	vel _ self vel * 10.
	aCanvas line: cp to: cp + vel color: Color blue.
	! !

!DeliverMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:48'!
collapse
	" Don't do anything ; not collapsible "! !

!DeliverMorph methodsFor: 'behaviours' stamp: 'jlb 11/15/2001 20:13'!
addBehaviour: symbol
	| aBehaviour |
	aBehaviour _ SteeringBehaviour perform: symbol.
	aBehaviour ifNotNil: [ behaviourList add: aBehaviour ].! !

!DeliverMorph methodsFor: 'behaviours' stamp: 'jlb 2/11/2002 20:17'!
arrived
	"done with the travel ; send message to interested party"
	target
		ifNotNil: [
			selector
				ifNotNil: [
					self stop.
					target perform: selector withArguments: arguments]]! !

!DeliverMorph methodsFor: 'behaviours' stamp: 'jlb 11/15/2001 20:14'!
clearAllBehaviours
	behaviourList _ OrderedCollection new.! !

!DeliverMorph methodsFor: 'behaviours' stamp: 'jlb 11/14/2001 19:43'!
fleeBehaviour: targetVector

	| desiredVelocity |
	desiredVelocity _ (( currentPosition - targetVector ) safelyNormalized * maxSpeed ) .
	^ desiredVelocity - velocity.! !

!DeliverMorph methodsFor: 'behaviours' stamp: 'jlb 11/14/2001 19:54'!
seekBehaviour: targetVector

	| desiredVelocity |
	" remember that the targetVector and the currentPosition cannot be the same ; otherwise a zero velocity change occurs and it just sits there stuck like a big fat pig"
	desiredVelocity _ (( targetVector - currentPosition ) safelyNormalized * maxSpeed ) .
	^ desiredVelocity - velocity.! !


!HandMorph methodsFor: 'world menu commands' stamp: 'jlb 6/30/2000 00:37'!
collapseAll
	"Collapse all windows"
	(SystemWindow windowsIn: self world satisfying: [:w | w isCollapsed not])
		reverseDo: [:w | w collapseOrExpand. 
				Delay forMilliseconds: 200.
				self world displayWorld].
	" self collapseNonWindows "! !

!HandMorph methodsFor: 'world menu commands' stamp: 'jlb 6/30/2000 00:42'!
expandAll
	"Expand all windows"
	self world submorphs do: [ :m |
		( m isKindOf: WindowMorphIcon )
		ifTrue: [ m expand ].
			
		].
! !


!IconMorph methodsFor: 'accessing' stamp: 'jlb 3/19/2002 10:06'!
hideLabel
	self showLabel: false.! !

!IconMorph methodsFor: 'accessing' stamp: 'jlb 1/29/2002 19:51'!
label
	^ label! !

!IconMorph methodsFor: 'accessing' stamp: 'jlb 2/5/2002 16:04'!
label: aString 

	label ifNotNil: [ label label: aString ].
! !

!IconMorph methodsFor: 'accessing' stamp: 'jlb 3/19/2002 09:39'!
morphRepresented: aMorph

	super morphRepresented: aMorph.
	aMorph privateOwner: self.! !

!IconMorph methodsFor: 'accessing' stamp: 'jlb 1/29/2002 19:53'!
showLabel
	self showLabel: true.! !

!IconMorph methodsFor: 'accessing' stamp: 'jlb 4/8/2002 00:16'!
showLabel: aBoolean
	ZurglePreferences showIconTitle 
		ifTrue: [ 
			label ifNotNil: [
				" make sure that the label shows up in the right place. "
				self position: self position.
				label showLabel: aBoolean.
		 ]].
! !

!IconMorph methodsFor: 'geometry' stamp: 'jlb 1/29/2002 19:54'!
extent: newExtent 
	super extent: newExtent.
	" reposition the label to show up in the correct spot "
	label ifNotNil: [label position: self position - (3 @ label height)]! !

!IconMorph methodsFor: 'geometry' stamp: 'jlb 1/30/2002 20:00'!
fullBounds
	| subBounds |
	fullBounds ifNil:[
		fullBounds _ self bounds.
		submorphs do:[:m|
			m visible ifTrue: [
			subBounds _ m fullBounds.
			fullBounds _ fullBounds quickMerge: subBounds.]
		].
	].
	^fullBounds! !

!IconMorph methodsFor: 'geometry' stamp: 'jlb 2/5/2002 12:32'!
position: aPoint
	| height |
	super position: aPoint.
	label ifNotNil: [
		height _ ZurglePreferences iconFont height + 6.
		label position: aPoint - ( 3@height ). ].! !

!IconMorph methodsFor: 'parts bin' stamp: 'jlb 2/15/2002 23:18'!
isKindOf: aClass
	^ super isKindOf: aClass.! !

!IconMorph methodsFor: 'parts bin' stamp: 'jlb 1/29/2002 20:00'!
isPartsDonor

	self partRepresented ifNotNilDo: [ :m | ^ m isPartsDonor ].
	^ false.
! !

!IconMorph methodsFor: 'parts bin' stamp: 'jlb 1/29/2002 20:07'!
isPartsDonor: aBool
	self partRepresented ifNotNilDo: [ :m | m isPartsDonor: aBool ].
! !

!IconMorph methodsFor: 'drawing' stamp: 'jlb 2/2/2002 23:58'!
alphaFactor
	" alpha factor is the amount of transparency when the image is drawn.
	  0 is translucent
	  255 is opaque ; should be 160 "
	^ 220.! !

!IconMorph methodsFor: 'drawing' stamp: 'jlb 1/29/2002 20:10'!
drawOn: theCanvas

	" If the hand picks us up, act translucent "
	( owner isHandMorph) ifTrue: [ ^ self drawTranslucentOn: theCanvas. ].
	super drawOn: theCanvas.
! !

!IconMorph methodsFor: 'drawing' stamp: 'jlb 2/2/2002 15:48'!
drawTranslucentOn: theCanvas 
	| aForm aPoint sourceRect |
	aForm _ self rotatedForm.
	aPoint _ bounds origin.
	sourceRect _ aForm boundingBox.

	" theCanvas shadowColor ifNotNil: [ theCanvas
			stencil: aForm
			at: aPoint
			sourceRect: sourceRect
			color: theCanvas shadowColor]. "

	theCanvas
		image: aForm
		at: aPoint
		sourceRect: sourceRect
		rule: Form blendAlpha
		alpha: self alphaFactor.
! !

!IconMorph methodsFor: 'drawing' stamp: 'jlb 1/29/2002 20:39'!
hasTranslucentColor
	" We do this so that when the HandMorph picks us up, we can draw transparent "
	^ true.! !

!IconMorph methodsFor: 'event handling' stamp: 'jlb 1/29/2002 23:13'!
click: evt
	self expandRepresentative.
! !

!IconMorph methodsFor: 'event handling' stamp: 'jlb 1/29/2002 22:04'!
doubleClick: evt
	self expandRepresentative.
! !

!IconMorph methodsFor: 'event handling' stamp: 'jlb 3/19/2002 10:16'!
startDrag: evt 
	label ifNotNil: [ 
		label owner ifNotNil: [ evt hand grabMorph: label] ].
	evt hand grabMorph: self ! !

!IconMorph methodsFor: 'menus' stamp: 'jlb 1/29/2002 21:07'!
collapse
	" Don't do anything ; I already represent a collapsed morph "! !

!IconMorph methodsFor: 'dropping/grabbing' stamp: 'jlb 4/26/2002 23:43'!
justDroppedInto: aMorph event: anEvent 
	"we just got dropped into a morph aMorph"
	| aRect |
	super justDroppedInto: aMorph event: anEvent.
	"get rid of the label gribble"
	aRect _ label bounds expandBy: 6 @ 6.
	self world ifNotNilDo: [ :aWorld | aWorld invalidRect: aRect].
	"Did we get dropped into a MorphDock?"
	(aMorph hasProperty: #morphDock)
		ifTrue: [label owner
				ifNotNil: ["have the hand drop the label; see startDrag:"
					anEvent hand privateRemoveMorph: label.
					"and add it to the world"
					label openInWorld: self world]].
	(self containsPoint: anEvent cursorPoint)
		ifTrue: [
			(aMorph hasProperty: #presentationFrame) ifFalse: [
			self showLabel]]! !

!IconMorph methodsFor: 'initialization' stamp: 'jlb 1/29/2002 20:23'!
initialExtent
	^ 170@140.! !

!IconMorph methodsFor: 'initialization' stamp: 'jlb 2/15/2002 22:36'!
initialize
	super initialize.
	self label: 'Untitled'.
	self extent: self initialExtent.
	label _ WindowIconTitle new.
	self on: #mouseEnter send: #showLabel to: self.	
	self on: #mouseLeave send: #hideLabel to: self.
	self on: #startDrag send: #startDrag: to: self.
	self on: #click send: #click: to: self.
	self on: #doubleClick send: #doubleClick: to: self.! !

!IconMorph methodsFor: '-- all --' stamp: 'jlb 3/19/2002 10:33'!
expandRepresentative
	morphRepresented ifNil: [ ^ self ].
	self hideLabel.
	self world addMorphFront: morphRepresented.
	self delete.
	morphRepresented show. ! !


!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 5/3/2002 10:31'!
dropPosition
	^ dropPosition! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 5/3/2002 10:31'!
dropPosition: aPoint
	dropPosition _ aPoint! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 20:58'!
isOpaque: aBool
	"Mark the receiver as being completely opaque or not"
	aBool == false
		ifTrue:[self removeProperty: #isOpaque]
		ifFalse:[self setProperty: #isOpaque toValue: aBool].
	self changed! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 10:00'!
originVector
	| target aPt |
	^ owner isHandMorph
		ifTrue: [target _ B3DVector3 zero.
			aPt _ self center.
			target x: aPt x.
			target z: aPt y.
			target]
		ifFalse: [originVector]! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 10:01'!
originVector: aB3DVector
	originVector _ aB3DVector.
! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 10:01'!
targetVector
	| target aPt |
	^ owner isHandMorph
		ifTrue: [target _ B3DVector3 zero.
			aPt _ self center.
			target x: aPt x.
			target z: aPt y.
			target]
		ifFalse: [targetVector]! !

!DesktopIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 10:01'!
targetVector: aB3DVector
	targetVector _ aB3DVector! !

!DesktopIcon methodsFor: 'animation' stamp: 'jlb 3/19/2002 10:53'!
doExpandAnimation
	| dockExtent |
	ZurglePreferences moveAnimation
		ifTrue: ["make sure we're in the current world"
			(owner hasProperty: #morphDock)
				ifTrue: ["we're in a morph dock ; get ready for animation"
					dockExtent _ ZurglePreferences dockHeight @ ZurglePreferences dockHeight.
					poof extent: ( self extent max: dockExtent).
					owner replaceSubmorph: self by: poof.]
				ifFalse: [
					poof align: poof center with: self center.
					poof openInWorld].
			self openInWorld.
			self startFollowing: true targetPoint:  morphRepresented center.
			self hide.
			poof start]
		ifFalse: [self expand: true]! !

!DesktopIcon methodsFor: 'animation' stamp: 'jlb 5/3/2002 10:45'!
scooch
	| now moveRectangle |
	now _ self position.
	moveRectangle _ Rectangle center: dropPosition extent: self extent.
	(moveRectangle containsPoint: now)
		ifTrue: [self position: self position - (8 @ 0)]! !

!DesktopIcon methodsFor: 'animation' stamp: 'jlb 5/3/2002 11:23'!
scooch: aPointAmount
	| now moveRectangle |
	now _ self position.
	moveRectangle _ Rectangle center: dropPosition extent: ( self extent / 2 ).
	(moveRectangle containsPoint: now)
		ifTrue: [self position: self position - aPointAmount]! !

!DesktopIcon methodsFor: 'animation' stamp: 'jlb 3/19/2002 10:54'!
startFollowing: expandFlag targetPoint: aPoint
	| position currentPosition |

	vehicle target: self;
		 selector: #expand:;
		 arguments: {expandFlag}.
	vehicle extent: bounds extent + (1 @ 1).
	vehicle maxSpeed: 500.
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle currentPosition: currentPosition.

	self originVector: currentPosition.
	self
		targetVector: (B3DVector3
				x: aPoint x
				y: 0
				z: aPoint y).
	vehicle openInWorld ; show ; start.
! !

!DesktopIcon methodsFor: 'drawing' stamp: 'jlb 3/19/2002 10:01'!
alphaFactor
	" alpha factor is the amount of transparency when the image is drawn.
	  0 is translucent
	  255 is opaque ; should be 160 "
	^ (self valueOfProperty: #carrying)
		ifTrue: [ 100 ]
		ifFalse: [ 180 ].! !

!DesktopIcon methodsFor: 'dropping/grabbing' stamp: 'jlb 5/3/2002 10:32'!
justDroppedInto: aMorph event: anEvent
	" the hand just dropped me "
	super justDroppedInto: aMorph event: anEvent.
	vehicle ifNotNil: [ vehicle stop ; delete ].
	self stopStepping.
	self removeProperty: #worldIcons.
	dropPosition _ self position.
! !

!DesktopIcon methodsFor: 'dropping/grabbing' stamp: 'jlb 3/19/2002 10:02'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph. This check is symmetric to #wantsDroppedMorph:event: to give both parties a chance of figuring out whether they like each other."
	self hideLabel.
	^true! !

!DesktopIcon methodsFor: 'geometry' stamp: 'jlb 3/19/2002 10:02'!
encompassingBounds
	" return the entire bounds of the morph including the title "
	^ super fullBounds! !

!DesktopIcon methodsFor: 'geometry' stamp: 'jlb 3/20/2002 00:39'!
extent: aPoint
	| myHand |
	super extent: aPoint.
	myHand _ self world currentHand.
	self owner == myHand ifTrue: [
			self align: self center with: myHand position.
		].
	vehicle ifNotNil: [ vehicle extent: aPoint ].! !

!DesktopIcon methodsFor: 'geometry' stamp: 'jlb 3/19/2002 10:02'!
fullBounds
	| subBounds |
	
	true ifTrue: [ ^ super fullBounds ].
	owner ifNotNil: [ 
	( owner hasProperty: #morphDock ) ifTrue: [ ^ self bounds ]].
	fullBounds ifNil:[
		fullBounds _ self bounds.
		submorphs do:[:m|
			m visible ifTrue: [
			subBounds _ m fullBounds.
			fullBounds _ fullBounds quickMerge: subBounds.]
		].
	].
	^fullBounds! !

!DesktopIcon methodsFor: 'initialization' stamp: 'jlb 3/20/2002 00:34'!
initialize
	super initialize.
	self extent: 128 @ (ZurglePreferences iconHeight ) ;
		setProperty: #carrying toValue: false.
	poof _ AnimationMorph explode.
	" self initializeFollower. "
	self isOpaque: false.
	self on: #mouseEnterDragging send: #mouseEnterDragging to: self.
	self setProperty: #desktopIcon toValue: true.
! !

!DesktopIcon methodsFor: 'initialization' stamp: 'jlb 3/19/2002 10:02'!
initializeFollower
	vehicle _ DeliverMorph new.
	vehicle target: self ;
		lock ;
		maxSpeed: 500 ;
		setProperty: #morphicLayerNumber toValue: 5.
! !

!DesktopIcon methodsFor: 'event handling' stamp: 'jlb 3/19/2002 10:55'!
expand
	owner isHandMorph
		ifTrue: [vehicle openInWorld.
				vehicle start]
		ifFalse: [self expandRepresentative]! !

!DesktopIcon methodsFor: 'event handling' stamp: 'jlb 3/19/2002 10:55'!
expand: expansionFlag 
	"If we expand the underlying morph, then get rid of the icon"
	expansionFlag
		ifTrue: [self delete.
			morphRepresented show]
		ifFalse: ["just carrying the icon from one place to another"
			self show.
			vehicle delete.
		]! !

!DesktopIcon methodsFor: 'event handling' stamp: 'jlb 3/19/2002 10:58'!
expandRepresentative
	morphRepresented ifNil: [ ^ self ].
	self hideLabel.
	self world addMorphFront: morphRepresented.
	self doExpandAnimation.! !

!DesktopIcon methodsFor: 'event handling' stamp: 'jlb 3/19/2002 23:48'!
mouseEnterDragging: event
	! !

!DesktopIcon methodsFor: 'stepping and presenter' stamp: 'jlb 5/3/2002 11:43'!
step
	| worldIcons ownerExtent ratio newHeight displayExtent aspectRatio newWidth y ownerBounds rect |
	"formerOwner ifNil: [ ^ self ] 
	ifNotNil: [ (formerOwner bounds intersects: ( self bounds)) 
	ifFalse: [ 
	^ self]].
	"

	formerOwner ifNotNil: [ (formerOwner bounds intersects: ( self bounds)) 
		ifFalse: [ 	newHeight _ ZurglePreferences iconHeight.
					displayExtent _ Display extent.
					aspectRatio _ (displayExtent x / displayExtent y) asFloat.
					newWidth _ aspectRatio * newHeight.
					^ self extent: newWidth @ newHeight.
 				]
		ifTrue: [
	"recalc my size based on my position"
	ownerExtent _ self valueOfProperty: #ownerExtent.
	ownerBounds _ self valueOfProperty: #ownerBounds.
	y _ self bottom - ownerBounds top.
	ratio _ y / ownerExtent y.
	"now calculate what the new extent should be"
	newHeight _ (self maxExtent - self minExtent * ratio + self minExtent) y.
	displayExtent _ Display extent.
	aspectRatio _ (displayExtent x / displayExtent y) asFloat.
	newWidth _ aspectRatio * newHeight.
	self extent: newWidth @ newHeight.
	"do I intersect any of my comrades?"
	worldIcons _ self
				valueOfProperty: #worldIcons
				ifAbsent: [^ self].
	worldIcons
		do: [:m | (m bounds intersects: self bounds)
				ifTrue: [self center x > m center x
						ifTrue: [m scooch: 8 @ 0]
						ifFalse: [m scooch: -8 @ 0]]
				ifFalse: [ rect _ m dropPosition extent: m extent.
					 ( rect intersects: self bounds ) ifFalse: [
					 m position: ( m dropPosition) ]]]]].! !

!DesktopIcon methodsFor: 'stepping and presenter' stamp: 'jlb 3/19/2002 23:39'!
stepTime
	^ 0! !

!DesktopIcon methodsFor: 'stepping and presenter' stamp: 'jlb 5/3/2002 11:21'!
stopStepping
	| worldIcons |
	super stopStepping.
	worldIcons _ self
				valueOfProperty: #worldIcons
				ifAbsent: [^ self].
	worldIcons
		do: [:m | m position: ( m dropPosition) ].	! !

!DesktopIcon methodsFor: 'stepping and presenter' stamp: 'jlb 3/19/2002 23:38'!
wantsSteps
	^ false.! !

!DesktopIcon methodsFor: 'submorphs-add/remove' stamp: 'jlb 3/19/2002 10:03'!
delete
	super delete.
	vehicle ifNotNil: [ vehicle delete].
	label ifNotNil: [ label delete ].! !

!DesktopIcon methodsFor: 'submorphs-add/remove' stamp: 'jlb 5/3/2002 11:42'!
justGrabbedFrom: formerOwnerMorph 
	"now in the hand"
	| position currentPosition icons |
	super justGrabbedFrom: formerOwnerMorph.
	vehicle
		ifNotNil: [vehicle extent: bounds extent + (1 @ 1).
			vehicle selector: nil].
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle
		ifNotNil: [vehicle currentPosition: currentPosition.
			vehicle maxSpeed: 80.
			vehicle openInWorld; show; start].
	(formerOwnerMorph hasProperty: #morphSpace)
		ifTrue: [formerOwner _ formerOwnerMorph.
			self startStepping]
		ifFalse: [ formerOwner _ nil ].
	icons _ formerOwnerMorph
				submorphsSatisfying: [:m | m hasProperty: #desktopIcon].
	self setProperty: #worldIcons toValue: icons.
	self setProperty: #ownerExtent toValue: formerOwnerMorph extent.
	self setProperty: #ownerBounds toValue: formerOwnerMorph bounds.
! !


!IconMorph class methodsFor: 'instance creation' stamp: 'jlb 3/19/2002 13:14'!
on: aMorph
	^ self new morphRepresented: aMorph.! !


!InvisibleExpandingMorph methodsFor: 'accessing' stamp: 'jlb 1/20/2001 12:35'!
expandExtent
	^ expandExtent.! !

!InvisibleExpandingMorph methodsFor: 'accessing' stamp: 'jlb 1/20/2001 12:35'!
expandExtent: aPoint
	expandExtent _ aPoint.! !

!InvisibleExpandingMorph methodsFor: 'accessing' stamp: 'jlb 10/17/2001 23:17'!
synchronized
	^ synchronized! !

!InvisibleExpandingMorph methodsFor: 'accessing' stamp: 'jlb 10/17/2001 23:17'!
synchronized: aShrinkingMorph
	synchronized _ aShrinkingMorph.! !

!InvisibleExpandingMorph methodsFor: 'geometry' stamp: 'jlb 1/20/2001 12:47'!
maximumExtent

	| ext |
	(ext _ self valueOfProperty: #maximumExtent)
		ifNotNil:
			[^ ext].
	^ 100 @ 80! !

!InvisibleExpandingMorph methodsFor: 'geometry' stamp: 'jlb 1/20/2001 12:48'!
maximumExtent: aPoint
	"Remember a minimumExtent, for possible future use"

	self setProperty: #maximumExtent toValue: aPoint
! !

!InvisibleExpandingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 10/17/2001 23:22'!
step
	
	| aPoint maxExtent |
	aPoint _ self extent + ( self expandExtent ).
	maxExtent _ self maximumExtent.
	( aPoint x >= ( maxExtent x ) or: [ aPoint y >= ( maxExtent y )] ) ifTrue: [ 
		self extent = maxExtent ifFalse: [ self extent: maxExtent ].
	synchronized ifNotNil: [
		synchronized synchStep ifTrue: [ synchronized _ nil ]].
		self stopStepping.
		^ self].
	self extent: aPoint.
	synchronized ifNotNil: [
		synchronized synchStep ifTrue: [ synchronized _ nil ]].
	self changed.
	! !

!InvisibleExpandingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 1/20/2001 12:50'!
stepTime
	^ stepTime.! !

!InvisibleExpandingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 1/20/2001 12:50'!
stepTime: anInteger
	stepTime _ anInteger.! !

!InvisibleExpandingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 10/17/2001 23:08'!
wantsSteps
	^ false.! !

!InvisibleExpandingMorph methodsFor: 'drawing' stamp: 'jlb 4/25/2002 01:41'!
drawOn: aCanvas
	" do nothing "
! !

!InvisibleExpandingMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:48'!
collapse
	" Don't do anything ; not collapsible "! !

!InvisibleExpandingMorph methodsFor: 'initialization' stamp: 'jlb 10/16/2001 14:22'!
initialExtent
	^ 0@40.! !

!InvisibleExpandingMorph methodsFor: 'initialization' stamp: 'jlb 10/18/2001 00:16'!
initialize
	super initialize.
	self color: Color green.
	self extent: ( self initialExtent ).
	expandExtent _ 20 @ 0 .
	stepTime _ 0.
	self maximumExtent: 100 @ 100.
	self setProperty: #expander toValue: true.
! !


!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/25/2002 01:41'!
drawOn: aCanvas
	" do nothing"
! !

!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 10/17/2001 22:54'!
step
	
	| aPoint |
	aPoint _ self extent - ( self shrinkExtent ).
	( aPoint x <= 0 or: [ aPoint y <= 0 ] ) ifTrue: [ 
		self stopStepping.
		^ self delete ].
	self extent: aPoint.
	! !

!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 1/8/2001 11:19'!
stepTime
	^ stepTime.! !

!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 1/8/2001 11:18'!
stepTime: anInteger
	stepTime _ anInteger.! !

!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 10/17/2001 23:19'!
synchStep
	
	| aPoint |
	aPoint _ self extent - ( self shrinkExtent ).
	( aPoint x <= 0 or: [ aPoint y <= 0 ] ) ifTrue: [ 
		self delete.
		^ true ].
	self extent: aPoint.
	^ false.
	! !

!InvisibleShrinkingMorph methodsFor: 'stepping and presenter' stamp: 'jlb 10/17/2001 23:08'!
wantsSteps
	^ false.! !

!InvisibleShrinkingMorph methodsFor: 'accessing' stamp: 'jlb 1/8/2001 11:12'!
shrinkExtent
	^ shrinkExtent.! !

!InvisibleShrinkingMorph methodsFor: 'accessing' stamp: 'jlb 1/8/2001 11:12'!
shrinkExtent: aPoint
	shrinkExtent _ aPoint! !

!InvisibleShrinkingMorph methodsFor: 'initialize' stamp: 'jlb 1/8/2001 11:17'!
initialExtent
	^ 100 @ 100.! !

!InvisibleShrinkingMorph methodsFor: 'initialize' stamp: 'jlb 1/28/2002 23:32'!
initialize
	super initialize.
	self color: Color red.
	self extent: ( self initialExtent ).
	shrinkExtent _ 20 @ 0 .
	stepTime _ 10.
	self minimumExtent: 0 @ 0.
	self setProperty: #shrinker toValue: true.
! !

!InvisibleShrinkingMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:48'!
collapse
	" Don't do anything ; not collapsible "! !


!MenuBarMorph methodsFor: 'geometry' stamp: 'jlb 3/26/2002 11:50'!
extent: aPoint 
	| aFill |
	super extent: aPoint.
	aFill _ self fillStyle.
	aFill isGradientFill
		ifTrue: [aFill direction: aPoint x @ 0]! !

!MenuBarMorph methodsFor: 'drawing' stamp: 'jlb 3/26/2002 13:21'!
drawOn: aCanvas 
	| bottomColor |
	super drawOn: aCanvas.
	( self fillStyle isColor | self fillStyle isGradientFill ) ifFalse: [ ^ self ].
	"draw a seperator line at the bottom of the morph"
	bottomColor _ MenuTheme current bottomColor.
	bottomColor ifNil: [ bottomColor _ MenuBarProperties menuBarFrameColor ].
	aCanvas
		line: bounds bottomLeft - (0 @ 1)
		to: bounds bottomRight - (1 @ 1)
		width: 1
		color: bottomColor.! !

!MenuBarMorph methodsFor: 'initialize' stamp: 'jlb 3/26/2002 11:44'!
barFillStyle

	| fill theme |
	theme _ MenuTheme current.
	theme ifNil: [ ^ nil ].
	fill _ GradientFillStyle ramp: {
		0.0 -> (theme leftColor). 
		1.0 -> (theme rightColor)}.
	fill origin: (0@0).
	fill direction: 40@0.
	fill radial: false.
	^ fill

! !

!MenuBarMorph methodsFor: 'initialize' stamp: 'jlb 3/29/2002 01:05'!
initialize
	super initialize.
	self color: MenuBarProperties menuBarColor.
	menuBarHeight _ MenuBarProperties menuBarHeight.
	MenuTheme current ifNotNil: [
			self setBarColor: MenuTheme current.
		].
	borderWidth _ 0.
	self beSticky.
	self layoutInset: -1.
	self on: #mouseDown send: #mouseDown: to: self.
! !

!MenuBarMorph methodsFor: 'initialize' stamp: 'jlb 3/26/2002 11:46'!
setBarColor: aMenuTheme
	
	aMenuTheme useGradient ifTrue: [
			self fillStyle: self barFillStyle.
		]
	ifFalse: [
		].! !

!MenuBarMorph methodsFor: 'event handling' stamp: 'jlb 3/29/2002 08:18'!
mouseDown: evt
	" Pay no attention to the man behind the curtain"! !


!MenuItemMorph methodsFor: 'accessing' stamp: 'jlb 3/24/2002 17:27'!
contents: aString

	| newString |
	newString _ aString.
	" MenuTheme current ifNotNil: [ newString _ self spaceString: aString ]. "
	^self contents: newString withMarkers: true! !

!MenuItemMorph methodsFor: 'accessing' stamp: 'jlb 3/24/2002 17:40'!
contents: aString withMarkers: aBool inverse: inverse
	"Set the menu item entry. If aBool is true, parse aString for embedded markers."
	| markerIndex marker indent |
	self contentString: nil. "get rid of old"
	aBool ifFalse:[^super contents: aString].
	self removeAllMorphs. "get rid of old markers if updating"
	(aString at: 1) = $< ifFalse:[^super contents: aString].
	markerIndex _ aString indexOf: $>.
	markerIndex = 0 ifTrue:[^super contents: aString].
	marker _ (aString copyFrom: 1 to: markerIndex) asLowercase.
	(#('<on>' '<off>' '<yes>' '<no>') includes: marker) ifFalse:[^super contents: aString].
	self contentString: aString. "remember actual string"
	(marker = '<on>' or:[marker = '<yes>']) ~= inverse
		ifTrue:[marker _ self onImage]
		ifFalse:[marker _ self offImage].
	"Indent the string using white spaces"
	indent _ ' '.
	font _ self fontToUse.
	[ (font widthOfString: (self spaceString: contents)) < (marker width + 4) ] 
		whileTrue:[indent _ indent copyWith: Character space].
	"Set the string"
	super contents: indent, (aString copyFrom: markerIndex+1 to: aString size).
	"And set the marker"
	marker _ ImageMorph new image: marker.
	marker position: (self left) @ (self top + 2).
	self addMorphFront: marker.! !

!MenuItemMorph methodsFor: 'accessing' stamp: 'jlb 3/24/2002 17:39'!
measureContents
	| f |
	f _ self fontToUse.
	^(((f widthOfString: (self spaceString: contents)) max: self minimumWidth)  @ ( f height max: self minHeight )).
! !

!MenuItemMorph methodsFor: 'accessing' stamp: 'jlb 3/24/2002 18:01'!
spaceString: aString
	" add some spaces so menu lines up nicer "
	MenuTheme current ifNil: [ ^ aString ].
	^ '    ' , aString , '     '
	! !

!MenuItemMorph methodsFor: 'drawing' stamp: 'jlb 3/24/2002 00:59'!
drawOn: aCanvas
	| selectionColor menuTheme |

	menuTheme _ MenuTheme current.
	menuTheme ifNotNil: [
		menuTheme simple ifTrue: [ ^ self drawOn: aCanvas theme: menuTheme ]].
	isSelected & isEnabled
		ifTrue:
			[selectionColor _ Display depth <= 2
				ifTrue: [Color gray]
				ifFalse: [owner color darker darker].
			aCanvas fillRectangle: self bounds color: selectionColor].
	super drawOn: aCanvas.
	subMenu ifNotNil:
		[aCanvas
			paintImage: SubMenuMarker
			at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)]! !

!MenuItemMorph methodsFor: 'drawing' stamp: 'jlb 3/29/2002 19:43'!
drawOn: aCanvas theme: aMenuTheme 
	| stringColor stringRect |

	stringColor _ isEnabled ifTrue: [ aMenuTheme enabledTextColor ]
			ifFalse: [ aMenuTheme disabledTextColor ].
	
	isSelected & isEnabled
		ifTrue: [
			aCanvas fillRectangle: self bounds color: aMenuTheme hilightBackgroundColor. 
			stringColor _ aMenuTheme hilightTextColor].
	stringRect _ self bounds topLeft + ( 16@0 ) corner: ( self bounds bottomRight).
	aCanvas
		drawString: contents
		in: stringRect
		font: self fontToUse
		color: stringColor.
	subMenu
		ifNotNil: [aCanvas paintImage: SubMenuMarker at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)] ! !

!MenuItemMorph methodsFor: 'events' stamp: 'jlb 5/11/2002 20:18'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	" make sure the menu is the frontmost morph in the world "
	owner comeToFront.
	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt.! !

!MenuItemMorph methodsFor: 'layout' stamp: 'jlb 3/24/2002 16:52'!
minHeight

	^ self fontToUse height + 2 ! !

!MenuItemMorph methodsFor: 'layout' stamp: 'jlb 3/24/2002 17:40'!
minWidth

	| f |
	f _ self fontToUse.
	^ (f widthOfString: (self spaceString: contents)) + (subMenu == nil ifTrue: [0] ifFalse: [10])! !

!MenuItemMorph methodsFor: 'copying' stamp: 'jlb 5/10/2002 11:07'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
isEnabled _ isEnabled veryDeepCopyWith: deepCopier.
subMenu _ subMenu veryDeepCopyWith: deepCopier.
isSelected _ isSelected veryDeepCopyWith: deepCopier.
"target _ target.		Weakly copied"
"selector _ selector.		a Symbol"
arguments _ arguments.		"All weakly copied"
cellBounds _ cellBounds.! !


!MenuLineMorph methodsFor: 'drawing' stamp: 'jlb 3/24/2002 00:27'!
drawOn: aCanvas
	| pref menuTheme |

	menuTheme _ MenuTheme current.
	menuTheme ifNotNil: [ 
		menuTheme simple ifTrue: [ ^ self drawOn: aCanvas color: menuTheme borderColor ]].
	aCanvas
		line: (bounds leftCenter) 
		to: (bounds rightCenter) 
		width: 1 
		color: ((pref _ Preferences menuColorFromWorld)
					ifTrue:
						[owner color darker]
					ifFalse:
						[Preferences menuLineUpperColor]).
	aCanvas
		line: (bounds leftCenter + ( 0@1)) 
		to: (bounds rightCenter + (0@1)) 
		width: 1 
		color: (pref
					ifTrue:
						[owner color lighter]
					ifFalse:
						[Preferences menuLineLowerColor])! !

!MenuLineMorph methodsFor: 'drawing' stamp: 'jlb 3/24/2002 00:45'!
drawOn: aCanvas color: aColor

	aCanvas
		line: ( bounds leftCenter + ( 1@0))
		to: ( bounds rightCenter - ( 2@0) )
		width: 1
		color: aColor.! !


!MenuMorph methodsFor: 'construction' stamp: 'jlb 3/29/2002 19:25'!
add: aString action: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the default target object."
	"Details: Note that the menu item added captures the default target object at the time the item is added; the default target can later be changed before added additional items without affecting the targets of previously added entries. The model is that each entry is like a button that knows everything it needs to perform its action."

	^ self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: EmptyArray.
! !

!MenuMorph methodsFor: 'construction' stamp: 'jlb 5/13/2002 11:58'!
addStayUpIcons
	| title closeBox pinBox menuTitle |

	title _ submorphs
		detect: [ :ea | ea hasProperty: #titleString ]
		ifNone: [
			self setProperty: #needsTitlebarWidgets toValue: true.
		 	^self ].
	closeBox _ IconicButton new target: self;
				 actionSelector: #delete;
				 labelGraphic: self class closeBoxImage;
				 color: Color transparent;
				 extent: 14@16;
				 borderWidth: 0.
	pinBox _ IconicButton new target: self;
				 actionSelector: #stayUp:;
				 arguments: {true};
				 labelGraphic: self class pushPinImage;
				 color: Color transparent;
				 extent: 14@15;
				 borderWidth: 0.
	Preferences noviceMode
		ifTrue: [closeBox setBalloonText: 'close this menu'.
			pinBox setBalloonText: 'keep this menu up'].
	menuTitle _  MenuTitleMorph newRow.
	menuTitle
			 addMorph: closeBox;
			 addMorphBack: title; 
			 addMorphBack: pinBox.
	self addMorphFront: menuTitle.
	self setProperty: #hasTitlebarWidgets toValue: true.
	self removeProperty: #needsTitlebarWidgets.
	self removeStayUpItems! !

!MenuMorph methodsFor: 'construction' stamp: 'jlb 5/11/2002 20:42'!
addTitle: aString updatingSelector: aSelector updateTarget: aTarget 
	"Add a title line at the top of this menu Make aString its initial  
	contents. If aSelector is not nil, then periodically obtain fresh  
	values for its contents by sending aSelector to aTarget.."
	| title theme |
	title _ (self hasProperty: #needsTitlebarWidgets)
				ifTrue: [AlignmentMorph new]
				ifFalse: [MenuTitleMorph new].
	self setTitleParametersFor: title.
	title vResizing: #shrinkWrap.
	title listDirection: #topToBottom.
	title wrapCentering: #center;
		 cellPositioning: #topCenter;
		 borderWidth: 0;
		 layoutInset: 0.
	aSelector
		ifNil: [(aString asString findTokens: String cr)
				do: [:line | title
						addMorphBack: (StringMorph contents: line font: Preferences standardMenuFont)]]
		ifNotNil: [title addMorphBack: (UpdatingStringMorph new lock; font: Preferences windowTitleFont emphasis: 1; useStringFormat; target: aTarget; getSelector: aSelector)].
	title
		on: #mouseDown
		send: #putInHand:
		to: self.
	theme _ MenuTheme current.
	theme
		ifNotNil: [title color: theme menuTitleBackgroundColor.
			title
				submorphsDo: [:m | m color: theme menuTitleTextColor]].
	title setProperty: #titleString toValue: aString.
	self addMorphFront: title.
	(self hasProperty: #needsTitlebarWidgets)
		ifTrue: [self addStayUpIcons]! !

!MenuMorph methodsFor: 'control' stamp: 'jlb 5/11/2002 20:19'!
putInHand: event
	" Put me in the hand "
	" Don't pick the menu up if it is sticking to it's owner "
	self isSticky ifTrue: [^self].
	event hand grabMorph: self.! !

!MenuMorph methodsFor: 'initialization' stamp: 'jlb 3/24/2002 16:05'!
initialize
	super initialize.
	bounds _ 0@0 corner: 40@10.
	self setDefaultParameters.
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	defaultTarget _ nil.
	selectedItem _ nil.
	stayUp _ false.
	popUpOwner _ nil.
	Preferences roundedMenuCorners ifTrue: [self useRoundedCorners].
	self addDropShadow.
	self shadowColor: (Color black alpha: 0.4).
! !

!MenuMorph methodsFor: 'initialization' stamp: 'jlb 3/23/2002 23:42'!
setDefaultParameters

	| worldColor theme |

	theme _ MenuTheme current.
	theme ifNotNil: [ theme simple ifTrue: [ 
			" if this is a simple, colored menu go set it up "
			^ self setSimpleColors: theme ]].

	((Preferences menuColorFromWorld and: [Display depth > 4]) and: [(worldColor _ self currentWorld color) isColor])
		ifTrue: [self setColor: (worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.8 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white])
						"Think about whether alpha should be included."
					borderWidth: Preferences menuBorderWidth
					borderColor: #raised]
		ifFalse: [self setColor: Preferences menuColor
					borderWidth: Preferences menuBorderWidth
					borderColor: Preferences menuBorderColor].
	self layoutInset: 3. ! !

!MenuMorph methodsFor: 'initialization' stamp: 'jlb 3/23/2002 23:47'!
setSimpleColors: menuTheme
	
	self setColor: menuTheme backgroundColor
					borderWidth: menuTheme borderWidth
					borderColor: menuTheme borderColor
! !

!MenuMorph methodsFor: 'events' stamp: 'jlb 5/11/2002 20:19'!
mouseDown: evt
	"Handle a mouse down event."
	self comeToFront.
	(stayUp or:[self fullContainsPoint: evt position]) 
		ifFalse:[^self deleteIfPopUp: evt]. "click outside"
	self isSticky ifTrue: [^self].
	"Grab the menu and drag it to some other place"
	" evt hand grabMorph: self. "! !


!FancyMenuMorph methodsFor: 'initialization' stamp: 'jlb 2/6/2002 23:18'!
defaultForm
^(Form
	extent: 50@50
	depth: 32
	fromArray: #( 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 15132390 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 8421504 8421504 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 15658734 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504 8421504)
	offset: 0@0)! !

!FancyMenuMorph methodsFor: 'initialization' stamp: 'jlb 2/6/2002 23:17'!
defaultForm1
^(Form
	extent: 15@18
	depth: 32
	fromArray: #( 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15461093 15461093 15461093 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16645116 16645116 16645116 14143957 14143957 14143957 14143957 14143957 14143957 14143957 14143957 14209750 14209750 14209750 14143957 14143957 14143957 14078164 7501433 7501433 7501433 7501433 7501433 7501433 7501433 7501433 7567226 7567226 7567226 7501433 7501433 7435640 7435640)
	offset: 0@0)! !

!FancyMenuMorph methodsFor: 'initialization' stamp: 'jlb 2/6/2002 22:14'!
initialize
	| fill |
	super initialize.
	fill _ BitmapFillStyle fromForm: self defaultForm.
	fill origin: self bounds origin.
	self fillStyle: fill.
	self borderColor: Color black.! !


!FancyMenuMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 2/6/2002 22:07'!
defaultForm
^(Form
	extent: 15@18
	depth: 32
	fromArray: #( 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 15461355 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16316664 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 15329769 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 16382457 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 15395562 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16514043 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 16448250 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15395300 15461093 15461093 15461093 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16382463 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16580596 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16710909 16645116 16645116 16645116 14143957 14143957 14143957 14143957 14143957 14143957 14143957 14143957 14209750 14209750 14209750 14143957 14143957 14143957 14078164 7501433 7501433 7501433 7501433 7501433 7501433 7501433 7501433 7567226 7567226 7567226 7501433 7501433 7435640 7435640)
	offset: 0@0)! !


!MenuTitleMorph methodsFor: 'drawing' stamp: 'jlb 5/13/2002 13:15'!
drawOn: aCanvas 
	| theme titleBounds inset |

	" test to see if someone stuck some pins in us "
	(owner isKindOf: self class) ifTrue: [ ^ self ].
	" Draw in the natural way "
	theme _ MenuTheme current.
	titleBounds _ self bounds.
	theme simple
		ifTrue: [owner
				ifNotNil: [inset _ owner layoutInset.
					titleBounds _ titleBounds topLeft - inset corner: titleBounds bottomRight + (inset @ 0)]].
	aCanvas
		fillRectangle: titleBounds
		fillStyle: self fillStyle
		borderStyle: self borderStyle. 
	theme simple
		ifTrue: [aCanvas
				line: ( titleBounds bottomLeft - (0@2))
				to: (titleBounds bottomRight  - (0@2))
				width: 1
				color: theme borderColor]! !

!MenuTitleMorph methodsFor: 'initialization' stamp: 'jlb 5/11/2002 19:58'!
initialize
	| theme |
	super initialize.
	self hResizing: #spaceFill;
		vResizing: #spaceFill;
		 listDirection: #leftToRight;
		 " wrapCentering: #center; "
		 cellPositioning: #topCenter ;
		 borderWidth: 0 ;
		name: #menuTitle.
	theme _ MenuTheme current.
	self color: theme menuTitleBackgroundColor.
! !

!MenuTitleMorph methodsFor: 'submorphs-add/remove' stamp: 'jlb 5/11/2002 20:44'!
addMorphBack: aStringMorph
	" This is a kludge to color the title of the string morph "
	| theme |

	(aStringMorph isKindOf: StringMorph) ifTrue: [
	theme _ MenuTheme current.
	aStringMorph color: theme menuTitleTextColor. ].
	super addMorphBack: aStringMorph.! !


!ModeButtonMorph methodsFor: 'stepping' stamp: 'jlb 4/20/2002 21:26'!
wantsSteps
	true ifTrue: [ ^ false ].
	^(self hasProperty: #doesButtonAction) or:[super wantsSteps]! !


!ControlButtonMorph methodsFor: 'event handling' stamp: 'jlb 4/29/2002 12:09'!
mouseEnter: evt
	self state: #pressedPassive.! !

!ControlButtonMorph methodsFor: 'event handling' stamp: 'jlb 4/29/2002 12:10'!
mouseLeave: evt
	self state: #off.! !

!ControlButtonMorph methodsFor: 'initialization' stamp: 'jlb 4/29/2002 12:00'!
initialize
	super initialize.
	self on: #mouseEnter send: #mouseEnter: to: self.! !


!MenuBarButtonMorph methodsFor: 'menu handling' stamp: 'jlb 3/26/2002 15:47'!
openMenu: hand 
	"open my menu under control of the given hand."
	menu ifNil: [ ^ self ].

	menu user: self.
	"Make sure that nothing is currently selected in the menu"
	menu submorphs
		do: [:m | (m isKindOf: MenuItemMorph)
				ifTrue: [m isSelected: false]].
	"menu pullDownAtPoint: bounds bottomLeft forHand: hand."
	self isExpanded: true.
	self state: #off.
	menu
		popUpAt: bounds bottomLeft - ( 0 @ 2 )
		forHand: hand
		in: self world.
! !

!MenuBarButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/29/2002 20:51'!
mouseEnterEvent: evt for: aMorph 
	"am I in a menu bar?"
	| openMenu |

	active ifFalse: [ ^ self ].
	(self containsPoint: evt cursorPoint)
		ifFalse: [^ self].
	( evt hand submorphs isEmpty ) ifFalse: [ ^ self ].
	(owner isKindOf: MenuBarMorph)
		ifTrue: [self isExpanded
				ifFalse: ["we may have another open menu in the menu  
					bar ;  
					if so close that one and open ours"
					openMenu _ owner closeOpenMenus.
					openMenu
						ifTrue: [self openMenu: evt hand.
							self state: #off]
						ifFalse: [self state: #mouseOver]]]
		ifFalse: [self state: #mouseOver]! !

!MenuBarButtonMorph methodsFor: 'drawing' stamp: 'jlb 3/26/2002 15:04'!
drawOn: aCanvas
	super drawOn: aCanvas.! !


!PasteUpMorph methodsFor: 'submorphs-add/remove' stamp: 'jlb 3/25/2002 15:48'!
addMorphInLayer: aMorph fullFrame: aLayoutFrame 

	aMorph layoutFrame: aLayoutFrame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.
	self addMorphInLayer: aMorph.
! !


!ProjectIcon methodsFor: 'event handling' stamp: 'jlb 3/20/2002 00:59'!
expand: expansionFlag 
	"If we expand the underlying morph, then get rid of the icon"
	expansionFlag
		ifTrue: [
			vehicle ifNotNil: [ vehicle delete].
			self show.
			morphRepresented removeProperty: #wasOpenedAsSubproject.
			morphRepresented enter.]
		ifFalse: ["just carrying the icon from one place to another"
			self show.
			vehicle ifNotNil: [ vehicle delete].
		]! !

!ProjectIcon methodsFor: 'event handling' stamp: 'jlb 3/19/2002 14:01'!
expandRepresentative
	" morphRepresented should be a ProjectViewMorph "
	morphRepresented
		ifNil: [^ self].
	self hideLabel.
	" make the animation go to the center of the screen "
	morphRepresented align: morphRepresented center with: self world center.
	self expand: true.
	" self doExpandAnimation "! !

!ProjectIcon methodsFor: 'initialization' stamp: 'jlb 3/20/2002 00:45'!
initialize
	| displayExtent aspectRatio myWidth currentHeight |
	currentHeight _ ZurglePreferences iconHeight.
	ZurglePreferences iconHeight: 128.
	super initialize.
	displayExtent _ Display extent.
	aspectRatio _ (displayExtent x / displayExtent y) asFloat.
	myWidth _ aspectRatio * ZurglePreferences iconHeight.
	self extent: myWidth asInteger @ ZurglePreferences iconHeight.
	ZurglePreferences iconHeight: currentHeight! !

!ProjectIcon methodsFor: 'geometry' stamp: 'jlb 3/20/2002 00:44'!
maxExtent
	| aspectRatio displayExtent myWidth |
	displayExtent _ Display extent.
	aspectRatio _ (displayExtent x / displayExtent y) asFloat.
	myWidth _ aspectRatio * 128.
	^ myWidth asInteger @ 128.
! !

!ProjectIcon methodsFor: 'geometry' stamp: 'jlb 4/8/2002 00:12'!
minExtent
	| aspectRatio displayExtent myWidth |
	displayExtent _ Display extent.
	aspectRatio _ (displayExtent x / displayExtent y) asFloat.
	myWidth _ aspectRatio * 32.
	^ myWidth asInteger @ 32.
! !

!ProjectIcon methodsFor: 'frame support' stamp: 'jlb 4/26/2002 19:08'!
imageRepresentative
	| projectWrapper |

	true ifTrue: [ ^ morphRepresented project imageForm ].
	projectWrapper _ ProjectWrapper new.
	projectWrapper image: (morphRepresented project imageForm).
	projectWrapper project: (morphRepresented project).
	^ projectWrapper.! !

!ProjectIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 11:09'!
morphRepresented: aProjectViewMorph

	super morphRepresented: aProjectViewMorph.
	self label: aProjectViewMorph project name.! !


!ProjectIcon class methodsFor: 'instance creation' stamp: 'jlb 5/1/2002 19:14'!
allProjects

	| history projectView icon |
	history _ ProjectHistory currentHistory mostRecentCopy.
	history do: [ :aProjectHistory |
			projectView _ ProjectViewMorph on: ((aProjectHistory fourth) first).
			icon _ ProjectIcon on: projectView.
			icon openInWorld.
		].
	! !


!ProjectPalette methodsFor: 'as yet unclassified' stamp: 'jlb 1/30/2002 21:07'!
initialExtent
	^ 400@300.! !

!ProjectPalette methodsFor: 'as yet unclassified' stamp: 'jlb 1/30/2002 21:08'!
initialPosition
	^ 64@600! !

!ProjectPalette methodsFor: 'as yet unclassified' stamp: 'jlb 1/30/2002 21:23'!
initialize
	super initialize.
	self color: Color lightOrange.
	self extent: self initialExtent.
	self position: self initialPosition.
	self enableDragNDrop.! !


!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 3/24/2002 20:10'!
buildMenuPage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| menuPage biggerFont smallFont |
	menuPage _ AlignmentMorph new.
	menuPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #menuPage put: menuPage.
	menuPage
		on: #mouseDown
		send: #yourself
		to: #().
	menuPage dropEnabled: false.
	menuPage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	menuPage addMorphBack: ( DialogStringMorph contents: 'Menu Preference Settings' font: biggerFont) ;
		addMorphBack: ( DialogStringMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogStringMorph contents: 'Define how menus look and behave   ' font: smallFont emphasis: 1) ;
		addMorphBack: ( menuPage transparentSpacerOfSize: (0@16)).

	(Preferences preferenceObjectsInCategory: #menus)
		do: [:aPreference | menuPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 5/12/2002 12:33'!
buildScrollbarPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the scrollbar option  
	checkboxes"
	| scrollbarPage biggerFont smallerFont |
	scrollbarPage _ AlignmentMorph new.
	scrollbarPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #scrollbarPage put: scrollbarPage.
	scrollbarPage
		on: #mouseDown
		send: #yourself
		to: #().
	scrollbarPage dropEnabled: false.
	scrollbarPage color: Color transparent;
		 layoutInset: 16.
	smallerFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallerFont familyName
				size: 21
				emphasized: 1.
	scrollbarPage
		addMorphBack: (DialogStringMorph contents: 'Scrollbar Preference Settings' font: biggerFont);
		addMorphBack: ( DialogStringMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogStringMorph contents: 'Define how scrollbars appear in windows' font: smallerFont emphasis: 1);
		addMorphBack: (scrollbarPage transparentSpacerOfSize: 0 @ 16).

	(Preferences preferenceObjectsInCategory: #scrolling)
		do: [:aPreference | scrollbarPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'tab controls' stamp: 'jlb 5/11/2002 07:55'!
buildWindowPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the window option 
	checkboxes "
	| windowPage aPref biggerFont smallFont |
	windowPage _ AlignmentMorph new.
	windowPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #windowPage put: windowPage.
	windowPage
		on: #mouseDown
		send: #yourself
		to: #().
	windowPage dropEnabled: false.
	windowPage color: Color transparent;
		 layoutInset: 16.
	windowPage position: self paneRectOrigin.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	windowPage addMorphBack: ( DialogStringMorph contents: 'Window Preference Settings' font: biggerFont) ;
		addMorphBack: ( DialogStringMorph contents: '' font: biggerFont);
		addMorphBack: ( DialogStringMorph contents: 'Define how windows look and behave    ' font: smallFont emphasis: 1) ;
		addMorphBack: ( windowPage transparentSpacerOfSize: (0@8)).
		
	"find the alternative window browse it"
	aPref _ (Preferences preferenceObjectsInCategory: #browsing)
				detect: [:pref | pref name == #alternativeWindowLook] ifNone: [nil].
	aPref
		ifNotNil: [windowPage
				addMorphBack: (self representativeButtonFromPreference: aPref)].
	(Preferences preferenceObjectsInCategory: #windows)
		do: [:aPreference | windowPage
				addMorphBack: (self representativeButtonFromPreference: aPreference)]! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 3/24/2002 20:11'!
buildFlapsPage: aPasteUpMorph 
	| flapsPage smallFont biggerFont aPref sharedFlapControl groupBox mainFlapsPage aboutButton aBounds |

	mainFlapsPage _ self newMainFlapsPage.

	flapsPage _ AlignmentMorph new.
	flapsPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	"pages at: #flapsPage put: flapsPage."
	flapsPage
		on: #mouseDown
		send: #yourself
		to: #().
	flapsPage dropEnabled: false.
	flapsPage color: Color transparent;
		 layoutInset: 16.
	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 21
				emphasized: 1.
	flapsPage
		addMorphBack: (DialogStringMorph contents: 'Flaps Preference Settings ' font: biggerFont);
		
		addMorphBack: (DialogStringMorph contents: '' font: biggerFont);
		
		addMorphBack: (DialogStringMorph
				contents: 'Define how flaps appear on the screen    '
				font: smallFont
				emphasis: 1);
		
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4).
	(Preferences preferenceObjectsInCategory: #flaps)
		do: [:aFlap | aFlap name == #showSharedFlaps
				ifTrue: [sharedFlap _ aFlap]
				ifFalse: [flapsPage
						addMorphBack: (self representativeButtonFromPreference: aFlap)]].
	flapsPage
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 16);
		
		addMorphBack: (DialogStringMorph
				contents: 'Define which flaps to show on the screen'
				font: smallFont
				emphasis: 1);
		
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4).
	aPref _ Preferences preferenceAt: #showProjectNavigator.
	flapsPage
		addMorphBack: (self representativeButtonFromPreference: aPref) ;
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 8).

	sharedFlapControl _ self representativeSpecialButtonFromPreference: sharedFlap.
	sharedFlapControl name: #sharedFlap.
	flapsPage addMorphBack: sharedFlapControl.
	sharedFlapControl addDependent: self.
	groupBox _ self buildSharedFlapsGroupBox.
	flapsPage
		addMorphBack: (flapsPage transparentSpacerOfSize: 0 @ 4);
		 addMorphBack: groupBox.

	mainFlapsPage addMorph: flapsPage.
	aboutButton _ self buildAboutButton: self.

	aBounds _ aboutButton bounds.
	aboutButton layoutFrame: ( LayoutFrame 
			fractions: ( 1@1 corner: (1@1))
			offsets: ( aBounds corner negated -16 corner: ( -16@-16))). 
	mainFlapsPage addMorph: aboutButton! !

!ScreenPreferencesPanel methodsFor: 'flaps' stamp: 'jlb 3/24/2002 20:10'!
buildSharedFlapsGroupBox 
	| groupBox namedFlap smallFont biggerFont |

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 18
				emphasized: 1.
	groupBox _ GroupBoxMorph newInstance.
	groupBox name: #sharedGroupBox.
	groupBox listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	groupBox
		addMorphBack: (DialogStringMorph contents: '  Current Shared Flaps ' font: biggerFont emphasis: 1) ;
		addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).
	Flaps globalFlapTabsIfAny
		do: [:aFlapTab | 
			namedFlap _ self representativeButtonFromFlap: aFlapTab.
			namedFlap disabled: sharedFlap preferenceValue not;
				 setProperty: #wantsShareInfo toValue: true.
			groupBox addMorphBack: namedFlap].
	^ groupBox.
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/24/2002 20:10'!
buildAppearancePage: aPasteUpMorph
	
	"build an AlignmentMorph tha contains all of the menu option 
	checkboxes "
	| appearancePage  smallFont biggerFont stringMorph leftMargin lineBase frameComboBox fontComboBox |

	leftMargin _ 16.
	appearancePage _ PasteUpMorph new.
	pages at: #appearancePage put: appearancePage.
	appearancePage
		on: #mouseDown
		send: #yourself
		to: #().
	appearancePage color: Color lightBlue ;
		setProperty: #wantsActivate toValue: true ;
	 	layoutInset: 16 ;
		extent: 600@600 ;
		borderWidth: 0 ;
		color: Color white.

	appearancePage dropEnabled: false.


	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	stringMorph _ ( DialogStringMorph contents: 'Appearance Preferences' font: biggerFont). 
	appearancePage addMorph: stringMorph.
	lineBase _ biggerFont height.
	stringMorph position: leftMargin @ lineBase.
	lineBase _ lineBase + (biggerFont height * 2 ).

	stringMorph _ DialogStringMorph contents: 'Frame Style: ' font: smallFont.
	appearancePage addMorph: stringMorph.
	stringMorph position: leftMargin + 8 @ lineBase.
	frameComboBox _ self buildFrameComboBox.
	appearancePage addMorph: frameComboBox.
	frameComboBox position: 140 @ lineBase.
	lineBase _ lineBase + frameComboBox height.
	lineBase _ lineBase + smallFont height + 16.

	stringMorph _ DialogStringMorph contents: 'Font Style: ' font: smallFont.
	appearancePage addMorph: stringMorph.
	stringMorph position: leftMargin + 8 @ lineBase.
	fontComboBox _ self buildFontComboBox.
	appearancePage addMorph: fontComboBox.
	fontComboBox position: 140@lineBase.

"	groupBox _ self buildFontSizeGroupBox.
	appearancePage addMorph: groupBox.
	groupBox position: leftMargin + 32 @ lineBase.
"

"
	| appearancePage biggerFont smallFont frameComboBox |

	appearancePage _ AlignmentMorph new.
	appearancePage listDirection: #topToBottom;
		 beSticky;
		 extent: 2 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #appearancePage put: appearancePage.
	appearancePage
		on: #mouseDown
		send: #yourself
		to: #().
	appearancePage dropEnabled: false.
	appearancePage color: Color transparent;
		 layoutInset: 16.

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont familyName: smallFont familyName size: 21 emphasized: 1.
	appearancePage addMorphBack: ( DialogTextMorph contents: 'Appearance Preferences' font: biggerFont) ;
		addMorphBack: ( DialogTextMorph contents: '' font: biggerFont).

	frameComboBox _ self buildFrameComboBox.
	appearancePage addMorphBack: frameComboBox.
"
! !

!ScreenPreferencesPanel methodsFor: 'appeareance panel' stamp: 'jlb 3/24/2002 20:10'!
buildFontSizeGroupBox
	| groupBox smallFont biggerFont outerButton |

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 18
				emphasized: 1.
	groupBox _ GroupBoxMorph newInstance.
	groupBox listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	groupBox
		addMorphBack: (DialogStringMorph contents: ' System Font Sizes ' font: biggerFont emphasis: 1) ;
		addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #toggleFontSize;
		getSelector: #isSmallFonts.
	outerButton label: 'Small'.
	outerButton setBalloonText: 'Select small system fonts'.
	groupBox addMorphBack: outerButton.

	groupBox addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #toggleFontSize;
		getSelector: #isLargeFonts.
	outerButton label: 'Large'.
	outerButton setBalloonText: 'Select large system fonts'.
	groupBox addMorphBack: outerButton.




	^ groupBox.
! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:22'!
buildSettingsGroupBox
	| groupBox smallFont biggerFont outerButton |

	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 18
				emphasized: 1.
	groupBox _ GroupBoxMorph newInstance.
	groupBox listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	groupBox
		addMorphBack: (DialogStringMorph contents: ' How to collapse window? ' font: biggerFont emphasis: 1) ;
		addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #collapseToTitleBar;
		getSelector: #isTitleBarCollapse.
	outerButton label: 'To a title bar'.
	outerButton setBalloonText: 'Collapse the window to just the title bar of the window'.
	groupBox addMorphBack: outerButton.

	groupBox addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #collapseToIcon;
		getSelector: #isIconCollapse.
	outerButton label: 'To an icon of the window'.
	outerButton setBalloonText: 'Collapse the window to a small picture'.
	groupBox addMorphBack: outerButton.

	groupBox addMorphBack: (groupBox transparentSpacerOfSize: 0 @ 4).

	outerButton _RadioButtonControlMorph new.
	outerButton makeUpdateable.
	outerButton
		target: self ;
		actionSelector: #collapseToMorphDock;
		getSelector: #isMorphDockCollapse.
	outerButton label: 'To a MorphDock'.
	outerButton setBalloonText: 'Collapse the window to an icon and place in a MorphDock'.
	groupBox addMorphBack: outerButton.



	^ groupBox.
! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 12:42'!
buildSettingsPage: aPasteUpMorph 
	"build an AlignmentMorph tha contains all of the menu option  
	checkboxes"
	| settingsPage biggerFont smallFont animationControl groupBox |
	settingsPage _ AlignmentMorph new.
	settingsPage listDirection: #topToBottom;
		 beSticky;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	pages at: #settingsPage put: settingsPage.
	settingsPage
		on: #mouseDown
		send: #yourself
		to: #().
	settingsPage dropEnabled: false.
	settingsPage color: Color transparent;
		 layoutInset: 16.
	smallFont _ ButtonTheme current systemFont.
	biggerFont _ StrikeFont
				familyName: smallFont familyName
				size: 21
				emphasized: 1.
	settingsPage
		addMorphBack: (DialogStringMorph contents: 'Window Collapse' font: biggerFont);
		addMorphBack: (DialogStringMorph contents: '' font: biggerFont).
	groupBox _ self buildSettingsGroupBox.
	settingsPage addMorphBack: groupBox.

	settingsPage
	addMorphBack: (DialogStringMorph contents: '' font: biggerFont) ;
		addMorphBack: (DialogStringMorph contents: '' font: biggerFont).

	animationControl _ CheckBoxControlMorph new.
	animationControl makeUpdateable.
	animationControl target: self;
		 actionSelector: #toggleAnimation;
		 getSelector: #isAnimationOn.
	animationControl label: 'Show animations'.
	settingsPage addMorphBack: animationControl.
	settingsPage
		addMorphBack: (DialogStringMorph contents: '' font: biggerFont).
! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:22'!
collapseToIcon
	ZurglePreferences collapseToMorphDock: false.
	ZurglePreferences collapseToTitleBar: false.! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:23'!
collapseToMorphDock
	ZurglePreferences collapseToMorphDock: true.
	ZurglePreferences collapseToTitleBar: false.! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:26'!
collapseToTitleBar
	ZurglePreferences collapseToMorphDock: false.
	ZurglePreferences collapseToTitleBar: true.! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 13:56'!
collpaseToMorphDock
	ZurglePreferences collapseToMorphDock: true.! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 12:27'!
isAnimationOn
	^ ZurglePreferences moveAnimation! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:26'!
isIconCollapse
	^ ZurglePreferences collapseToMorphDock not and: [ ZurglePreferences collapseToTitleBar not ]! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 13:54'!
isMorphDockCollapse
	^ ZurglePreferences collapseToMorphDock.! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:25'!
isTitleBarCollapse
	^ ZurglePreferences collapseToTitleBar! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 23:24'!
isTitleFrameCollapse
	^ ZurglePreferences collapseToTitleBar! !

!ScreenPreferencesPanel methodsFor: 'settings' stamp: 'jlb 5/12/2002 12:26'!
toggleAnimation
	ZurglePreferences moveAnimation: ( ZurglePreferences moveAnimation not ).! !


!ScrollBar methodsFor: 'initialize' stamp: 'jlb 4/29/2002 14:28'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self setProperty: #wantsActivate toValue: true .
	ScrollBarTheme current
		ifNotNil: [self borderColor: Color transparent]! !

!ScrollBar methodsFor: 'initialize' stamp: 'jlb 4/29/2002 12:41'!
themeInitializeSlider
	slider _ 
	bounds isWide ifTrue: [ ScrollBarTheme current newHorizontalSlider ]
		ifFalse: [ ScrollBarTheme current newVerticalSlider].
	slider bounds: ( self totalSliderArea ).
	sliderShadow _ TranslucentImageMorph new.
	sliderShadow alpha: 64.
	sliderShadow bounds: self totalSliderArea.
	sliderShadow image: slider image.
	slider on: #mouseMove send: #scrollAbsolute: to: self ;
		on: #mouseDown send: #mouseDownInSlider: to: self ;
		on: #mouseUp send: #mouseUpInSlider: to: self ;
		on: #mouseEnter send: #mouseEnterSlider: to: self ;
		on: #mouseLeave send: #mouseLeaveSlider: to: self.
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider ;
		computeSlider.
! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 4/29/2002 12:40'!
mouseEnterSlider: event 
	(slider isKindOf: EdgeImageMorph)
		ifTrue: [slider
				valueOfProperty: #mouseOverImage
				ifPresentDo: [:mouseOverImage | slider image: mouseOverImage]].
! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 4/29/2002 12:41'!
mouseLeaveSlider: event 
	(slider isKindOf: EdgeImageMorph)
		ifTrue: [slider
				valueOfProperty: #normalImage
				ifPresentDo: [:normalImage | slider image: normalImage]].
! !

!ScrollBar methodsFor: 'other events' stamp: 'jlb 4/29/2002 17:16'!
mouseUpInSlider: event 
	| imageSymbol |
	(slider isKindOf: EdgeImageMorph)
		ifTrue: [imageSymbol _ (slider containsPoint: event cursorPoint)
						ifTrue: [#mouseOverImage]
						ifFalse: [#normalImage].
			slider
				valueOfProperty: imageSymbol
				ifPresentDo: [:bimage | slider image: bimage]].
	super mouseUpInSlider: event! !


!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 4/29/2002 12:18'!
newDownArrowButton
	^ 	ControlButtonMorph new from4Images: (lookDictionary at: #downArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 4/29/2002 12:18'!
newLeftArrowButton
	^ 	ControlButtonMorph new from4Images: (lookDictionary at: #leftArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 4/29/2002 12:17'!
newMenuButton
	
	^ ControlButtonMorph new from4Images: (lookDictionary at: #menuButtonForm).
	
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 4/29/2002 12:17'!
newRightArrowButton
	^ 	ControlButtonMorph new from4Images: (lookDictionary at: #rightArrowForm).
! !

!ScrollBarTheme methodsFor: 'as yet unclassified' stamp: 'jlb 4/29/2002 11:55'!
newUpArrowButton
	^ 	ControlButtonMorph new from4Images: (lookDictionary at: #upArrowForm).
! !


!ScrollPane methodsFor: 'initialization' stamp: 'jlb 4/29/2002 14:52'!
initialize
	retractableScrollBar _ (Preferences valueOfFlag: #inboardScrollbars) not.
	scrollBarOnLeft _ (Preferences valueOfFlag: #scrollBarsOnRight) not.
	super initialize.
	hasFocus _ false.
	borderWidth _ 2.
	borderColor _ Color gray.

	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar borderWidth: 1.
	ScrollBarTheme current ifNil: [ scrollBar borderColor: Color black ].

	scroller := TransformMorph new color: Color transparent.
	scroller offset: -3@0.
	self addMorph: scroller.

	retractableScrollBar ifFalse: [self addMorph: scrollBar].

	self extent: 150@120.

	self setProperty: #wantsActivate toValue: true .
! !


!ComboBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 3/26/2002 20:36'!
newInstance
	| toReturn theme |
	toReturn _ self new.
	theme _ ButtonTheme current.
	theme ifNil: [ ^ toReturn ].
	toReturn fromImages: theme comboBoxForm.
	theme comboBoxEdges
		ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	^ toReturn! !


!SequenceDock methodsFor: 'initialization' stamp: 'jlb 10/17/2001 22:04'!
initialExtent
	^ 904 @ 130! !

!SequenceDock methodsFor: 'initialization' stamp: 'jlb 4/24/2002 23:33'!
initialize
	super initialize.
	self extent: self initialExtent.
	self hResizing: #rigid.
	self enableDragNDrop.
	self color: Color veryVeryLightGray.
	self
		on: #mouseDown
		send: #mouseDownEvent:
		to: self. 
	self on: #mouseLeaveDragging
		send: #mouseLeaveDragging:
		to: self.
	insertIndex _ 0! !

!SequenceDock methodsFor: 'initialization' stamp: 'jlb 10/17/2001 22:03'!
timelineHeight
	^ 130! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 10/14/2001 15:57'!
indexFor: aMorph at: evt 
	| layout horizontal morphList index aPoint currentlyOver cursorPt selectedMorph |

	cursorPt _ evt cursorPoint.
	selectedMorph _ ( self morphsAt: cursorPt) first.
	selectedMorph == self ifTrue: [ ^ submorphs size + 1].
	index _ self indexOfMorph: selectedMorph.
	(selectedMorph hasProperty: #expander)
	ifFalse: [ ].
	Transcript show: 'index: ' ; show: index printString ; cr.
	true ifTrue: [ ^ index ].

	layout _ self layoutPolicy.
	aPoint _ evt position.
	self hasSubmorphs
		ifFalse: [^ 1].
	aMorph disableTableLayout
		ifTrue: [^ 1].
	horizontal _ (#(#topToBottom #bottomToTop ) includes: self listDirection) not.
	morphList _ self submorphs.
	self reverseTableCells
		ifTrue: [morphList _ morphList reversed].
	index _ layout
				indexForInserting: aPoint
				inList: morphList
				horizontal: horizontal
				target: self.
	self reverseTableCells
		ifTrue: [index _ morphList size - index + 2].
	"done if I'm at the end"
	submorphs size <= index
		ifTrue: [^ index].
	"If I'm past the center of the current morph I'm over, slide  
	everything over"
	currentlyOver _ submorphs at: index.
	(currentlyOver hasProperty: #expander)
		ifFalse: [aPoint x > currentlyOver center x
				ifTrue: [
					" Transcript show: 'i+1 ' ; cr ;
						show: 'point x' ; show: ( aPoint x printString ) ; cr ;
						show: 'cOver' ; show: ( currentlyOver center x printString ) ; cr. "
				index _ index + 1]].
	^ index
		ifNil: [1]! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 10/17/2001 19:53'!
insertIndexForPoint: aPoint
	| index selectedMorph morphArray  |
	
	morphArray _ self morphsAt: aPoint.
	morphArray isEmpty ifTrue: [ ^ nil ].
	selectedMorph _ morphArray first.
	" dropped it onto the dock itself, append to end "
	selectedMorph == self ifTrue: [ ^ submorphs size + 1].
	index _ self indexOfMorph: selectedMorph.
	((aPoint x > selectedMorph center x) and: [ index notNil ])
	ifTrue: [ index _ index + 1 ].
	^ index! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 10/13/2001 23:11'!
maximumSubmorphHeight
	| maxHeight |
	submorphs isEmpty
		ifTrue: [ ^ self height ]
		ifFalse: [ maxHeight _ 0.
			submorphs do: [ :m | maxHeight _ maxHeight max: ( m height ) ]].
	^ maxHeight.! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 4/25/2002 00:47'!
maximumSubmorphWidth
	| maxWidth |
	submorphs isEmpty
		ifTrue: [ ^ self width ]
		ifFalse: [ maxWidth _ 0.
			submorphs do: [ :m | maxWidth _ maxWidth max: ( m width ) ]].
	^ maxWidth.! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 4/25/2002 01:05'!
oldIndexFor: aMorph at: evt 
	| layout horizontal morphList index aPoint currentlyOver |
	layout _ self layoutPolicy.
	aPoint _ evt position.
	self hasSubmorphs ifFalse: [^ 1].
	aMorph disableTableLayout ifTrue: [^ 1].
	horizontal _ (#(#topToBottom #bottomToTop ) includes: self listDirection) not.
	morphList _ self submorphs.
	self reverseTableCells
		ifTrue: [morphList _ morphList reversed].
	index _ layout
				indexForInserting: aPoint
				inList: morphList
				horizontal: horizontal
				target: self.
	self reverseTableCells
		ifTrue: [index _ morphList size - index + 2].
	"done if I'm at the end"
	submorphs size <= index
		ifTrue: [^ index].
	"If I'm past the center of the current morph I'm over, slide  
	everything over"
	currentlyOver _ submorphs at: index.
	(currentlyOver hasProperty: #expander)
		ifFalse: [bounds isWide
				ifTrue: [aPoint x > currentlyOver center x
						ifTrue: [index _ index + 1]]
				ifFalse: [aPoint y > currentlyOver center y
						ifTrue: [index _ index + 1]]].
	^ index
		ifNil: [1]! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 10/13/2001 22:11'!
privateAddMorph: aMorph atIndex: index 
	| iem si |
	(index >= 1
			and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	aMorph owner
		ifNotNil: [aMorph owner privateRemoveMorph: aMorph].
	aMorph privateOwner: self.
	iem _ self submorphs detect: [:m | m hasProperty: #expander ] ifNone: [nil ].
	iem
		ifNil: [submorphs _ submorphs
						copyReplaceFrom: index
						to: index - 1
						with: (Array with: aMorph)]
		ifNotNil: [si _ submorphs indexOf: iem.
			submorphs at: si put: aMorph.
			iem abandon].
	self layoutChanged.
	self isInWorld
		ifTrue: [self invalidRect: aMorph fullBounds from: aMorph].

! !

!SequenceDock methodsFor: 'private' stamp: 'jlb 10/17/2001 23:27'!
replaceExpandingByShrinkingMorph
	| shrinker |
	self submorphs
		withIndexDo: [:morph :index | (morph hasProperty: #expander)
				ifTrue: ["hoping here we only have one expander"
					"replace it with a shrinking morph"
					shrinker _ self newShrinkingMorph: morph extent.
					self replaceSubmorph: morph by: shrinker.
					morph synchronized ifNotNil: [ self privateRemoveMorph: morph synchronized ].
					^ shrinker]].
	^ nil! !

!SequenceDock methodsFor: 'submorphs-accessing' stamp: 'jlb 10/13/2001 18:09'!
indexOfMorph: aMorph
	
	self submorphs withIndexDo: [:mm :ii | 
		mm == aMorph  ifTrue: [^ ii]].
	^ nil.
! !

!SequenceDock methodsFor: 'meta actions' stamp: 'jlb 4/25/2002 01:33'!
grabMorph: aMorph event: event 
	"replace the morph with an invisible morph"
	| iem extent index |
	extent _ aMorph extent.
	"create an InvisibleExpandingMorph that's already done  
	expanding"
	iem _ self newExpandingMorph: extent.
	self replaceSubmorph: aMorph by: iem.
	"setup index clip"
	index _ self indexOfMorph: iem.
	index _ index + 1.
	indexClip _ index < submorphs size
				ifTrue: [submorphs at: index]
				ifFalse: [ nil ].
	^ aMorph grabMorph: event! !

!SequenceDock methodsFor: 'layout' stamp: 'jlb 4/25/2002 00:50'!
acceptDroppingMorph: aMorph event: evt 
	| dropLoc lastTopLeft ism placeAt stepSize lastBottomLeft |
	bounds isWide
		ifTrue: [dropLoc _ aMorph topLeft.
			lastTopLeft _ submorphs isEmpty
						ifTrue: [self topLeft]
						ifFalse: [self submorphs last topRight].
			placeAt _ dropLoc - lastTopLeft.
			dropLoc x > lastTopLeft x
				ifTrue: ["add an invisible shrinking morph at the end"
					ism _ self newShrinkingMorph: placeAt x @ self maximumSubmorphHeight.
					"calculate an time for the animation to last ; 
					closer should  
					take less time"
					stepSize _ ism width / self width * 300 / ism stepTime asInteger.
					ism shrinkExtent: ((ism width / stepSize) asInteger max: 1)
							@ 0.
					self addMorphBack: ism.
					ism start]]
		ifFalse: [
			dropLoc _ aMorph topLeft.
			lastBottomLeft _ submorphs isEmpty
						ifTrue: [self topLeft]
						ifFalse: [self submorphs last bottomLeft].
			placeAt _ dropLoc - lastBottomLeft.
			dropLoc y > lastBottomLeft y
				ifTrue: ["add an invisible shrinking morph at the end"
					ism _ self newShrinkingMorph: self maximumSubmorphWidth @ placeAt y.
 					"calculate an time for the animation to last ; 
					closer should  
					take less time"
					stepSize _ ism height / self height * 300 / ism stepTime asInteger.
					ism shrinkExtent: ( 0 @ ((ism height / stepSize) asInteger max: 1)).
					self addMorphBack: ism.
					ism start]
			].
	self addMorphBack: aMorph! !

!SequenceDock methodsFor: 'layout' stamp: 'jlb 4/25/2002 01:36'!
newExpandingMorph: aPoint 
	"create a new shrinking morph with the given maximum extent, aPoint"
	| stepSize iem width |
	iem _ InvisibleExpandingMorph new.
	iem color: Color blue.
	" set how big to grow to when done "
	" iem maximumExtent: ( aPoint + (4@0)). "
	iem maximumExtent: aPoint.
	bounds isWide ifFalse: [ 
		iem expandExtent: 0@1. iem stepTime: 20.
		iem extent: (aPoint x @ 1). ].
	iem height: aPoint y - 1.
	true ifTrue: [ ^ iem ].


	"calculate an time for the animation to last ; closer should  
	take less time"
	width _ aPoint x.
	stepSize _ width / self width * 200 / iem stepTime asInteger.
	iem expandExtent: ((width / stepSize) asInteger max: 1)
			@ 0.
	Transcript show: width printString ; cr ;
		show: iem stepTime printString ; cr ;
		show: self width printString .
	Transcript show: iem expandExtent printString ; cr.
	^ iem! !

!SequenceDock methodsFor: 'layout' stamp: 'jlb 4/29/2002 01:10'!
newShrinkingMorph: aPoint 
	"create a new shrinking morph with the given extent, aPoint"
	| ism stepSize |
	ism _ InvisibleShrinkingMorph new.
	ism color: Color green.
	ism extent: aPoint.
	"calculate an time for the animation to last ; closer should  
	take less time"
	bounds isWide
		ifTrue: [stepSize _ ism width / self width * 200 / ism stepTime asInteger.
			stepSize asInteger == 0
				ifTrue: [ism shrinkExtent: 1 @ 0]
				ifFalse: [ism shrinkExtent: ((ism width / stepSize) asInteger max: 1)
							@ 0]]
		ifFalse: [stepSize _ ism height / self height * 200 / ism stepTime asInteger.
			stepSize == 0.0
				ifTrue: [ism shrinkExtent: 0 @ 1]
				ifFalse: [ 0 @ 
							(ism shrinkExtent: ((ism height / stepSize) asInteger max: 1))]].
	^ ism! !

!SequenceDock methodsFor: 'layout' stamp: 'jlb 10/17/2001 23:25'!
removeExpandingMorphs
	"replace any expanding morphs with shrinking morphs"
	self submorphs
		do: [:m | (m hasProperty: #expander)
				ifTrue: [ m stopStepping. 
					m synchronized ifNotNil: [
					self privateRemoveMorph: ( m synchronized )].
					self privateRemoveMorph: m]]! !

!SequenceDock methodsFor: 'event handling' stamp: 'jlb 4/24/2002 23:33'!
handleMouseOver: event 
	| clip insertAt iem shrinker |
	"make sure the hand carrying something?"
	(event hand hasSubmorphs and: [ self hasSubmorphs ])
		ifFalse: [^ super handleMouseOver: event].
	clip _ event hand firstSubmorph.
	insertAt _ self oldIndexFor: clip at: event.
	insertAt > submorphs size
		ifTrue: [shrinker _ self replaceExpandingByShrinkingMorph.
			shrinker ifNotNil: [ shrinker start].
			indexClip _ nil.
			^ super handleMouseOver: event].
	((submorphs at: insertAt)
			hasProperty: #expander)
		ifTrue: [ ^ super handleMouseOver: event].
	(submorphs at: insertAt)
			= indexClip
		ifFalse: [indexClip _ submorphs at: insertAt.
			shrinker _ self replaceExpandingByShrinkingMorph.
			iem _ self newExpandingMorph: clip extent.
			"if there are other expanders around, this one should be 
			full grown"
			self addMorph: iem inFrontOf: indexClip.
			iem synchronized: shrinker.
			iem start.].
	^ super handleMouseOver: event! !

!SequenceDock methodsFor: 'event handling' stamp: 'jlb 4/24/2002 23:33'!
handlesMouseOver: evt
	^ true! !

!SequenceDock methodsFor: 'event handling' stamp: 'jlb 2/5/2002 12:12'!
mouseDownEvent: event 
	submorphs
		do: [:m | (m containsPoint: event cursorPoint)
				ifTrue: [^ self grabMorph: m event: event]]! !

!SequenceDock methodsFor: 'event handling' stamp: 'jlb 10/17/2001 23:13'!
mouseLeaveDragging: event 
	| shrinker |
	insertIndex _ 0.
	shrinker _ self replaceExpandingByShrinkingMorph.
	shrinker ifNotNil: [ shrinker start].
	indexClip _ nil.
! !

!SequenceDock methodsFor: 'accessing' stamp: 'jlb 10/14/2001 11:27'!
indexClip
	^ indexClip! !

!SequenceDock methodsFor: 'accessing' stamp: 'jlb 10/14/2001 11:27'!
indexClip: anInteger
	indexClip _ anInteger! !


!MorphDock methodsFor: 'initialization' stamp: 'jlb 5/12/2002 12:04'!
initialize
	| spacer |
	super initialize.
	borderWidth _ 1.
	borderColor _ #raised.
	self extent: ( (ZurglePreferences dockWidth )@ (ZurglePreferences dockHeight ) ).
 	" Insert a little spacer here so we can enter the first icon"
	spacer _ self transparentSpacerOfSize: 16 @ ( ZurglePreferences dockHeight ).
	self addMorphBack: spacer.
	spacer lock.
	self enableDragNDrop.
	self color: Color transparent.
	self setToAdhereToEdge: AdhereEdge.
	Current _ self.
	self setProperty: #morphDock toValue: true.! !

!MorphDock methodsFor: 'private' stamp: 'jlb 2/16/2002 09:22'!
expandSystemWindows
	self
		submorphsDo: [:m | (m hasProperty: #windowAlias)
				ifTrue: [m expand]]! !

!MorphDock methodsFor: 'private' stamp: 'jlb 4/24/2000 15:10'!
insertionIndexFor: aMorph 
	"Return the index at which the given morph should be inserted  
	into the submorphs of the receiver; Don't stomp the first entry"
	| newCenter |
	newCenter _ aMorph fullBounds center.
	orientation == #horizontal ifTrue: [submorphs
			doWithIndex: [:m :i | newCenter x < m fullBounds center x
					ifTrue: [i = 1
							ifTrue: [^ 2]
							ifFalse: [^ i]]]].
	orientation == #vertical ifTrue: [submorphs
			doWithIndex: [:m :i | newCenter y < m fullBounds center y
					ifTrue: [i = 1
							ifTrue: [^ 2]
							ifFalse: [^ i]]]].
	^ submorphs size + 1"insert after the last submorph"! !

!MorphDock methodsFor: 'submorphs-accessing' stamp: 'jlb 4/28/2000 00:54'!
elementOf: aMorph
	^ submorphs indexOf: aMorph! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 9/29/2001 11:13'!
edgeToAdhereTo
	^ self valueOfProperty: #edgeToAdhereTo! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 7/8/2000 09:39'!
layoutChanged
	self spanWorld.
	super layoutChanged! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 9/29/2001 11:11'!
orientation
	^ (#(#left #right ) includes: self edgeToAdhereTo)
		ifTrue: [#vertical]
		ifFalse: [#horizontal]! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 5/2/2000 17:21'!
originOfElementNumber: aNumber 
	" return the x y origin of the element number "
	^ aNumber <= submorphs size
		ifTrue: [(self submorphs at: aNumber - 1) bounds topRight]
		ifFalse: [self submorphs last bounds topRight]! !

!MorphDock methodsFor: 'geometry' stamp: 'jlb 7/8/2000 09:39'!
spanWorld
	| aPoint |
	aPoint _ (self world ifNil: [self currentWorld]) extent.
	(self orientation == #vertical)
		ifTrue:
			[self height: aPoint y]
		ifFalse:
			[self width: aPoint x] ! !

!MorphDock methodsFor: 'menu' stamp: 'jlb 7/7/2000 22:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'expand system windows' action: #expandSystemWindows.! !

!MorphDock methodsFor: 'menu' stamp: 'jlb 6/30/2000 00:06'!
collapse
	" Don't collapse me, I'm special "! !

!MorphDock methodsFor: 'submorphs-add/remove' stamp: 'jlb 2/4/2002 21:51'!
addThumbnail: aThumbnail 
	| aPt |
	ZurglePreferences moveAnimation
		ifTrue: [
			aPt _ (self originOfElementNumber: self submorphs size + 1) + (aThumbnail extent / 2).
			aThumbnail addToMorphDock: self to: aPt]
		ifFalse: [self addMorphBack: aThumbnail]! !

!MorphDock methodsFor: 'submorphs-add/remove' stamp: 'jlb 1/31/2002 15:18'!
dock: aThumbnail 

	| anIntegerIndex |
	anIntegerIndex _ aThumbnail iconInfo
	self addMorph: aThumbnail asElementNumber: anIntegerIndex

! !

!MorphDock methodsFor: 'submorphs-add/remove' stamp: 'jlb 1/31/2002 15:14'!
dock: aThumbnail index: anIntegerIndex
	self addMorph: aThumbnail asElementNumber: anIntegerIndex

! !

!MorphDock methodsFor: 'submorphs-add/remove' stamp: 'jlb 2/4/2002 22:07'!
positionThumbnail: aThumbnail atIndex: anIntegerIndex 
	| aPt |
	ZurglePreferences moveAnimation
		ifTrue: [
			aPt _ (self originOfElementNumber: anIntegerIndex)	 + (aThumbnail extent / 2).
			aThumbnail positionInMorphDock: self atIndex: anIntegerIndex to: aPt.
]
		ifFalse: [self dock: aThumbnail index: anIntegerIndex]! !


!MorphDock class methodsFor: 'class variables' stamp: 'jlb 4/25/2000 22:24'!
adhereEdge
	^ AdhereEdge! !

!MorphDock class methodsFor: 'class variables' stamp: 'jlb 4/25/2000 22:24'!
adhereEdge: anEdge
	" valid edge names are the symbols : 
		top right bottom left center topLeft topRight bottomRight bottomLeft none "
	AdhereEdge _ anEdge.! !

!MorphDock class methodsFor: 'class variables' stamp: 'jlb 5/12/2002 11:57'!
current
	| morphDock |
	Current
		ifNil: ["We don't have a MorphDock here ; look for one in this 
			world "
			Current _ World
						submorphThat: [:aSubMorph | aSubMorph hasProperty: #morphDock]
						ifNone: [morphDock _ MorphDock new openInWorld.
							morphDock refreshWorld]]
		ifNotNil: ["is the current MorphDock in this world?"
			(World submorphs includes: Current)
				ifTrue: [^ Current]
				ifFalse: [Current _ nil.
					"oh my, recursion"
					self current]].
	^ Current! !

!MorphDock class methodsFor: 'class variables' stamp: 'jlb 4/25/2000 22:25'!
current: aMorphDock
	 Current _ aMorphDock.! !

!MorphDock class methodsFor: 'initialization' stamp: 'jlb 4/25/2000 22:22'!
initialize
	AdhereEdge _ #bottomLeft.
	Current _ nil.! !


!ShakingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 20:59'!
intensity: n
	intensity _ n! !

!ShakingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 21:07'!
target: aMorph
	target _ aMorph.
	origin _ target position! !

!ShakingMorph methodsFor: 'initialization' stamp: 'LC 6/19/1999 21:04'!
initialize
	super initialize.
	self extent: 3 @ 3.
	self stopStepping.
	index _ 1.
	origin _ 0 @ 0! !

!ShakingMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:48'!
collapse
	" Don't do anything ; not collapsible "! !

!ShakingMorph methodsFor: 'stepping' stamp: 'jlb 10/18/2001 00:07'!
step
	| xsign ysign coef |
	index > intensity
		ifTrue: 
			[target position: origin.
			^ self stop].
	coef _ intensity / 20.
	xsign _ (index \\ 3 - 1) sign.
	ysign _ (index + 1 \\ 3 - 1) sign.
	target position: (30 // index * xsign @ (30 // index * ysign) * coef) rounded + origin.
	index _ index + 1.
! !

!ShakingMorph methodsFor: 'stepping' stamp: 'LC 6/19/1999 21:14'!
stepTime
	^ (10 * intensity / 20) rounded! !

!ShakingMorph methodsFor: 'stepping' stamp: 'jlb 10/18/2001 00:17'!
stop
	super stop.
	self delete.
	target changed.! !


!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/22/1999 01:05'!
includeInNewMorphMenu
	^ false! !

!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/19/1999 21:12'!
shake: aMorph 
	^ self shake: aMorph intensity: 20! !

!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/19/1999 21:12'!
shake: aMorph intensity: n 
	| answer |
	answer _ self new target: aMorph;
			 intensity: n.
	aMorph isInWorld ifFalse: [^ answer].
	aMorph world addMorph: answer.
	answer hide.
	answer startStepping.
	^ answer! !


!ShrinkingMorph methodsFor: 'drawing' stamp: 'jlb 1/31/2002 00:08'!
drawOn: aCanvas
	" calculate the image to place here "
	" self form displayInterpolatedIn: self bounds on: aCanvas form. "
	! !

!ShrinkingMorph methodsFor: 'geometry' stamp: 'jlb 1/30/2002 22:24'!
extent: aPoint

	bounds extent = aPoint ifTrue: [^ self].
	self changed.
	bounds _ bounds topLeft extent: aPoint.
	self layoutChanged.
	self changed.
! !

!ShrinkingMorph methodsFor: 'menus' stamp: 'jlb 2/16/2002 09:48'!
collapse
	" Don't do anything ; not collapsible "! !


!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'jlb 3/25/2002 22:19'!
initialize
	super initialize.
	self on: #mouseMove send: #mouseStillDown:onItem: to: self.
	self initializeForms! !

!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'jlb 3/25/2002 22:20'!
initializeForms
	expandedForm _ (Form
	extent: 9@9
	depth: 32
	fromArray: #( 11584211 7903413 7903413 7903413 7903413 7903413 7903413 7903413 11584211 7903413 16777215 16777215 16777215 16777215 16777215 16777215 16777215 7903413 7903413 16579835 16645627 16645627 16645627 16579835 16579834 16250611 7903413 7903413 16250869 16250869 16250868 16250868 16185076 15855851 15065562 7903413 7903413 16119281 4278190081 4278190081 4278190081 4278190081 4278190081 14670802 7903413 7903413 15921902 15790316 15592935 15526886 15395299 14934233 14407372 7903413 7903413 15000025 14473423 14209993 14144199 14078406 13814976 13617339 7903413 7903413 13814975 13024942 12761256 12695719 12695719 12629926 12827306 7903413 11584211 7903413 7903413 7903413 7903413 7903413 7903413 7903413 11584211)
	offset: 0@0).

	notExpandedForm _ (Form
	extent: 9@9
	depth: 32
	fromArray: #( 11584211 7903413 7903413 7903413 7903413 7903413 7903413 7903413 11584211 7903413 16777215 16777215 16777215 16777215 16777215 16777215 16777215 7903413 7903413 16579835 16645627 16645627 4278190081 16579835 16579834 16250611 7903413 7903413 16250869 16250869 16250868 4278190081 16185076 15855851 15065562 7903413 7903413 16119281 4278190081 4278190081 4278190081 4278190081 4278190081 14670802 7903413 7903413 15921902 15790316 15592935 4278190081 15395299 14934233 14407372 7903413 7903413 15000025 14473423 14209993 4278190081 14078406 13814976 13617339 7903413 7903413 13814975 13024942 12761256 12695719 12695719 12629926 12827306 7903413 11584211 7903413 7903413 7903413 7903413 7903413 7903413 7903413 11584211)
	offset: 0@0).! !

!SimpleHierarchicalListMorph methodsFor: 'updating' stamp: 'jlb 4/2/2002 20:35'!
update: aSymbol 

	aSymbol == getSelectionSelector ifTrue:
		[self selection: self getCurrentSelectionItem.
		^ self].
	aSymbol == getListSelector ifTrue: 
		[self list: self getList.
		^ self].
	((aSymbol isKindOf: Array) and: [aSymbol size > 0 and: [aSymbol first == #openPath]]) ifTrue: [
		^(scroller submorphs at: 1 ifAbsent: [^self]) openPath: aSymbol allButFirst
	].

! !


!SqueakWindowFrame methodsFor: 'frame buttons' stamp: 'jlb 3/23/2002 17:21'!
deleteCollapseBox
	self collapseBox ifNotNil: [ self collapseBox delete. collapseBox _ nil ].! !

!SqueakWindowFrame methodsFor: 'frame buttons' stamp: 'jlb 3/23/2002 17:21'!
deleteExpandBox
	self expandBox ifNotNil: [ self expandBox delete. expandBox _ nil ].! !


!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/16/2001 15:43'!
alignment: target with: aVehicleMorph 
	"steer in the same direction as my neighbors"
	| desiredVelocity averageDirection |
	averageDirection _ target getNeighborsDirection: aVehicleMorph distance: 100.
	desiredVelocity _ (( averageDirection - aVehicleMorph velocity ) safelyNormalized * aVehicleMorph maxSpeed ) .
	^ desiredVelocity .! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 2/11/2002 20:20'!
arrival: target with: aVehicleMorph 
	"slow to a stop when reaching a stationary target"
	| desiredVelocity decelTime targetOffset distance speed clippedSpeed |
	decelTime _ 1.75.
	targetOffset _ target targetVector - aVehicleMorph currentPosition.
	distance _ targetOffset length.
	speed _ distance / decelTime.
	clippedSpeed _ speed min: aVehicleMorph maxSpeed.
	distance = 0.0
		ifTrue: [desiredVelocity _ 0.0]
		ifFalse: [desiredVelocity _ targetOffset * (clippedSpeed / distance)].
	distance < 1.0
		ifTrue: [aVehicleMorph arrived].
	^ desiredVelocity - aVehicleMorph velocity! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/16/2001 15:45'!
cohesion: target with: aVehicleMorph 
	"group towards my neighbors"
	| averagePosition desiredVelocity |
	averagePosition _ target getNeighborsPosition: aVehicleMorph distance: 100.
	desiredVelocity _ (( averagePosition - aVehicleMorph currentPosition ) length:  aVehicleMorph maxSpeed ) .
	^ desiredVelocity - aVehicleMorph velocity.! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/16/2001 15:45'!
flee: target with: aVehicleMorph

	| desiredVelocity |
	" remember that the targetVector and the currentPosition cannot be the same ; otherwise a zero velocity change occurs and it just sits there stuck like a big fat pig"
	desiredVelocity _ (( aVehicleMorph currentPosition - target currentPosition ) length:  aVehicleMorph maxSpeed ) .
	^ desiredVelocity - aVehicleMorph velocity.! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 2/4/2002 15:16'!
leaveArrival: target with: aVehicleMorph 
	"slow to a stop when reaching a stationary target"
	| desiredVelocity decelTime targetOffset distance speed clippedSpeed accelTime originOffset maxSpeed leaveSpeed |

	"WARNING -- THIS DOES NOT WORK "
	accelTime _ 2.5.
	decelTime _ 2.5.
	"first check for acceleration"
	maxSpeed _ aVehicleMorph maxSpeed.
	originOffset _ target originVector - aVehicleMorph currentPosition.
	distance _ originOffset length.
	Transcript show: 'dis: ';
		 show: distance;
		 cr.
	leaveSpeed _ distance / accelTime.
	leaveSpeed < maxSpeed
		ifTrue: ["we're accelerating from the stop"
			clippedSpeed _ leaveSpeed.
			distance = 0.0
				ifTrue: [desiredVelocity _ originOffset * clippedSpeed]
				ifFalse: [desiredVelocity _ originOffset * (clippedSpeed / distance)].
			^ desiredVelocity]
		ifFalse: [targetOffset _ target targetVector - aVehicleMorph currentPosition.
			distance _ targetOffset length.
			speed _ distance / decelTime.
			clippedSpeed _ speed min: aVehicleMorph maxSpeed.
			distance = 0.0
				ifTrue: [desiredVelocity _ 0.0]
				ifFalse: [desiredVelocity _ targetOffset * (clippedSpeed / distance)].
			distance < 1.0
				ifTrue: [aVehicleMorph arrived].
			^ desiredVelocity - aVehicleMorph velocity]! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/15/2001 23:41'!
nop: target with: aVehicleMorph
	" I'm just a no op "! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/16/2001 15:45'!
seek: target with: aVehicleMorph

	| desiredVelocity |
	" remember that the targetVector and the currentPosition cannot be the same ; otherwise a zero velocity change occurs and it just sits there stuck like a big fat pig"
	desiredVelocity _ (( target targetVector - aVehicleMorph currentPosition ) length:  aVehicleMorph maxSpeed ) .
	^ desiredVelocity - aVehicleMorph velocity.! !

!SteeringBehaviour methodsFor: 'steering behaviours' stamp: 'jlb 11/16/2001 12:40'!
separation: target with: aVehicleMorph 
	"maintain a certain separation distance from others nearby"
	| buffer list steering searchDistance to distance testDistance |
	buffer _ 1.0.
	list _ target vehicles.
	steering _ B3DVector3 zero.
	searchDistance _ 2.0 * aVehicleMorph radius.
	list _ target getCollisionCandidates: aVehicleMorph currentPosition distance: searchDistance.
	list
		do: [:vehicle | "don't include ourselves"
			vehicle == aVehicleMorph
				ifFalse: [to _ aVehicleMorph currentPosition - vehicle currentPosition.
					distance _ to length.
					testDistance _ aVehicleMorph radius + vehicle radius + buffer.
					distance < testDistance squared
						ifTrue: [steering _ steering + (to / distance sqrt)]]].
	^ steering! !

!SteeringBehaviour methodsFor: 'initialization' stamp: 'jlb 11/15/2001 23:41'!
initialize
	self name: #nop.! !

!SteeringBehaviour methodsFor: 'execution' stamp: 'jlb 11/15/2001 23:50'!
calculate: aVehicleMorph target: aTarget
	^ self perform: name with: aTarget with: aVehicleMorph! !

!SteeringBehaviour methodsFor: 'accessing' stamp: 'jlb 11/15/2001 23:36'!
name
	^ name! !

!SteeringBehaviour methodsFor: 'accessing' stamp: 'jlb 11/15/2001 23:37'!
name: aSymbol
	name _ aSymbol.! !


!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 15:29'!
alignment
	" face in the same direction as my neighbors "

	^ self new name: #alignment:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 00:04'!
arrival
	" Arrival behaviour is identical to seek while the character is far from its target. But instead of moving through the target at full speed, this behaviour causes the character to slow down as it approaches the target "

	^ self new name: #arrival:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 13:58'!
cohesion
	" keep the group I belong to together "

	^ self new name: #cohesion:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 00:04'!
flee
	" the inverse of seek, acts to steer the character so that its velocity is radially aligned away from the target. The desired velocity points in the oppsosite direction"

	^ self new initialize ; name: #flee:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 2/3/2002 15:44'!
leaveArrival
	" Arrival behaviour is identical to seek while the character is far from its target. But instead of moving through the target at full speed, this behaviour causes the character to slow down as it approaches the target "

	^ self new name: #leaveArrival:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 00:04'!
seek
	" pursuit of a static target acts to steer the character towards a specified postion "

	^ self new name: #seek:with:.
	! !

!SteeringBehaviour class methodsFor: 'as yet unclassified' stamp: 'jlb 11/16/2001 00:36'!
separation
	" maintain a certain separation distance from others nearby "

	^ self new name: #separation:with:.
	! !


!SystemWindow methodsFor: 'open/close' stamp: 'jlb 5/12/2002 14:03'!
closeBoxHit
	"The user clicked on the close-box control in the window title.  
	For Mac users only, the Mac convention of  
	option-click-on-close-box is obeyed if the mac option key is  
	down."
	| poof |
	Preferences dismissAllOnOptionClose
		ifTrue: [Sensor rawMacOptionKeyPressed
				ifTrue: [^ self world closeUnchangedWindows]].
	self delete.
	" If the window closed, run an animation "
	(self owner isNil and: [ZurglePreferences moveAnimation])
		ifTrue: [self refreshWorld.
			poof _ AnimationMorph explode.
			poof setProperty: #morphicLayerNumber toValue: 5;
				 center: self center;
				 openInWorld;
				 start]! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/12/2002 23:19'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state"

	isCollapsed
		ifTrue: 
			["Expand -- restore panes to morphics structure"
			isCollapsed _ false.
			Preferences collapseWindowsInPlace
				ifTrue: 
					[fullFrame := fullFrame align: fullFrame topLeft with: self getBoundsWithFlex topLeft]
				ifFalse:
					[collapsedFrame _ self getBoundsWithFlex].
			self collapseBox ifNotNilDo: [ :m | m setBalloonText: 'collapse this window'].
			"First save latest collapsedFrame"
			self setBoundsWithFlex: fullFrame.
			self unlock.
			paneMorphs
				reverseDo: 
					[:m | 
					self addMorph: m unlock.
					self world startSteppingSubmorphsOf: m].
			windowFrame expand.
			self activate "-- mainly for findWindow"]
		ifFalse: 
			[ 
				ZurglePreferences collapseToTitleBar ifTrue: [ self collapseToTitleBar ]
					ifFalse: [self collapseToThumbnail] ].
	self layoutChanged! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/12/2002 11:29'!
collapseToThumbnail
	"Collapse -- remove panes from morphics structure"
	| cf icon |

	icon  _ WindowIcon new.
	icon morphRepresented: self.
 
	isCollapsed _ true.
	fullFrame _ self getBoundsWithFlex.
	self hide.
	"First save latest fullFrame"
	paneMorphs
		do: [:m | m delete; releaseCachedState].
	model modelSleep.
	"cf := self getCollapsedFrame."
	cf _ icon bounds.
	(collapsedFrame isNil
			and: [Preferences collapseWindowsInPlace not])
		ifTrue: [collapsedFrame _ cf].
	self setBoundsWithFlex: cf.
	windowFrame collapse.
	self collapseBox
		ifNotNilDo: [:m | m setBalloonText: 'expand this window'].
	self expandBox
		ifNotNilDo: [:m | m setBalloonText: 'expand to full screen'].
	self lock.
	icon addMorph: self.
	icon open.
! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/12/2002 23:39'!
collapseToTitleBar
	"Collapse -- remove panes from morphics structure"
	| cf |
	isCollapsed _ true.
	fullFrame _ self getBoundsWithFlex.
	"First save latest fullFrame"
	paneMorphs
		do: [:m | m delete; releaseCachedState].
	model modelSleep.
	cf _ self getCollapsedFrame.
	(collapsedFrame isNil
			and: [Preferences collapseWindowsInPlace not])
		ifTrue: [collapsedFrame _ cf].
	self setBoundsWithFlex: cf.
	self collapseBox
		ifNotNil: [self collapseBox setBalloonText: 'expand this window'].
	self expandBox
		ifNotNil: [self expandBox setBalloonText: 'expand to full screen'].
	self windowFrame hideGrowBox.! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 1/29/2002 23:07'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"

	| oldTop outerMorph sketchEditor pal |
	outerMorph _ self topRendererOrSelf.
	outerMorph owner ifNil: [^ self "avoid spurious activate when drop in trash"].
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop shortPassivate].
	outerMorph owner firstSubmorph == outerMorph
		ifFalse: ["Bring me (with any flex) to the top if not already"
				outerMorph owner addMorphFront: outerMorph].
	self submorphsDo: [:m | m unlock.
			" send activate to window frame and controls "
			(m hasProperty: #wantsActivate)
				ifTrue: [m activate]].
	" windowFrame ifNotNil: [ windowFrame activate ]. "
	self isCollapsed ifFalse:
		[model modelWakeUpIn: self.
		self positionSubmorphs.
		self labelArea ifNil: [self adjustBorderUponActivationWhenLabeless]].

	(sketchEditor _ self extantSketchEditor) ifNotNil:
		[sketchEditor comeToFront.
		(pal _ self world findA: PaintBoxMorph) ifNotNil:
			[pal comeToFront]].
! !

!SystemWindow methodsFor: 'top window' stamp: 'jlb 1/29/2002 23:06'!
shortPassivate
	"Make me unable to respond to mouse and keyboard"
	model modelSleep.
	"Nothing responds to the keyboard or mouse"
	" send passivate to controls and window frame "
	self
		submorphsDo: [:m | m lock.
			(m hasProperty: #wantsActivate)
				ifTrue: [m passivate]].
! !

!SystemWindow methodsFor: 'panes' stamp: 'jlb 4/1/2002 23:18'!
addMorphNoColor: aMorph fullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs _ paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).

	
	aMorph borderWidth: 2; borderColor: #inset; color: Color transparent.
! !

!SystemWindow methodsFor: 'panes' stamp: 'jlb 4/3/2002 17:58'!
replacePaneNoColor: oldPane with: newPane
	"Make newPane exactly occupy the position and extent of oldPane"

	| aLayoutFrame hadDep |
	hadDep _ model dependents includes: oldPane.
	oldPane owner replaceSubmorph: oldPane by: newPane.
	newPane
		position: oldPane position;
		extent: oldPane extent.
	aLayoutFrame _ oldPane layoutFrame.
	paneMorphs _ paneMorphs collect:
		[:each |
		each == oldPane ifTrue: [newPane] ifFalse: [each]].
	aLayoutFrame ifNotNil: [newPane layoutFrame: aLayoutFrame].
	
	hadDep ifTrue: [model removeDependent: oldPane. model addDependent: newPane].

	self changed

! !

!SystemWindow methodsFor: 'accessing' stamp: 'jlb 4/3/2002 22:58'!
paneMorphs: aCollection
	paneMorphs _ aCollection.! !


!DialogWindow methodsFor: 'initialization' stamp: 'jlb 3/24/2002 21:32'!
addYesNoButtons

	| aButton aPasteUpMorph |

	aPasteUpMorph _ self backgroundPane.
	aButton _ OSButtonMorph newInstance target: self;
				 actionSelector: #selectNo;
				 label: 'No'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-92 @ -31 corner: -17 @ -8)).
	aButton _ OSButtonMorph newInstance target: self;
				 actionSelector: #selectYes;
				 label: 'Yes'.
	"button size should be 75 x 23"
	aPasteUpMorph
		addMorph: aButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 1 corner: 1 @ 1)
				offsets: (-175 @ -31 corner: -100 @ -8)).
	aButton makeDefault! !

!DialogWindow methodsFor: 'initialization' stamp: 'jlb 3/24/2002 22:38'!
initialExtent
	^ 320 @ 150! !

!DialogWindow methodsFor: 'initialization' stamp: 'jlb 3/24/2002 22:40'!
initialize
	super initialize.
	self deleteCollapseBox.
	self deleteExpandBox.
	self addBackground.
	self extent: self initialExtent.
	self setProperty: #minimumExtent toValue: 260@128.! !

!DialogWindow methodsFor: 'frame' stamp: 'jlb 3/23/2002 17:14'!
deleteCollapseBox
	windowFrame ifNotNil: [ windowFrame deleteCollapseBox ].! !

!DialogWindow methodsFor: 'frame' stamp: 'jlb 3/23/2002 17:15'!
deleteExpandBox
	windowFrame ifNotNil: [ windowFrame deleteExpandBox ].! !

!DialogWindow methodsFor: 'accessing' stamp: 'jlb 3/23/2002 20:40'!
backgroundPane
	^ self submorphNamed: #backgroundPane.! !

!DialogWindow methodsFor: 'accessing' stamp: 'jlb 3/24/2002 21:29'!
modalAnswer
	^ modalAnswer.! !

!DialogWindow methodsFor: 'accessing' stamp: 'jlb 3/24/2002 21:29'!
modalAnswer: anAnswer
	modalAnswer _ anAnswer.! !

!DialogWindow methodsFor: 'accessing' stamp: 'jlb 3/23/2002 20:54'!
placeWarningForm
	
	| theme warningForm icon |
	theme _ DialogTheme current.
	theme ifNil: [  ^ self ].
	warningForm _ theme warningForm.
	warningForm ifNil: [ ^ self ].
	icon _ EdgeImageMorph new.
	icon image: warningForm.
	self backgroundPane addMorph: icon
		fullFrame: ( LayoutFrame
			fractions: ( theme warningFormFractions )
			offsets: ( theme warningFormOffsets )).
	icon lock.! !

!DialogWindow methodsFor: 'appearance' stamp: 'jlb 4/9/2002 15:58'!
addBackground
	| playfield |
	playfield _ PasteUpMorph new width: 100.
	playfield dropEnabled: false ;
		color: self defaultBackgroundColor ;
		name: #backgroundPane ;
		borderWidth: 0 ;
		layoutPolicy: ProportionalLayout new.

	playfield
		on: #mouseDown
		send: #yourself
		to: #().

	playfield setProperty: #morphicLayerNumber toValue: 100.
	self addMorph: playfield frame: (0 @ 0 extent: 1 @ 1).
	! !

!DialogWindow methodsFor: 'appearance' stamp: 'jlb 3/24/2002 22:36'!
addDialogText: aString
	" add text for simple dialog boxes such as message boxes and warning dialogs "
	
	| aPasteUpMorph textMorph |
	aPasteUpMorph _ self backgroundPane.
	textMorph _ DialogTextMorph new newContents: aString.
	 " aFont _ FontTheme current dialogFont.
	textMorph fontName: aFont name size: aFont pointSize. "
	" buttons live down to the bottom of the dialog to -39 "
	aPasteUpMorph
		addMorph: textMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (54@22 corner: -8 @ -39)).
	textMorph lock.
! !

!DialogWindow methodsFor: 'appearance' stamp: 'jlb 3/23/2002 20:18'!
defaultBackgroundColor
	 ^Color r: 233 g: 233 b: 214 range: 255! !

!DialogWindow methodsFor: 'modal processing' stamp: 'jlb 3/24/2002 21:31'!
cancelPanel
	modalAnswer _ #cancel.! !

!DialogWindow methodsFor: 'modal processing' stamp: 'jlb 3/24/2002 21:32'!
selectNo
	modalAnswer _ false.! !

!DialogWindow methodsFor: 'modal processing' stamp: 'jlb 3/24/2002 21:32'!
selectYes
	modalAnswer _ true.! !

!DialogWindow methodsFor: 'modal processing' stamp: 'jlb 3/24/2002 22:35'!
waitForAnswer
	"The dialog is open ; wait for an answer"
	" owner ~= nil is check to make sure the user didn't kill dialog box with halos"
	modalAnswer _ #notYet.
	[modalAnswer = #notYet
		and: [self owner ~= nil]]
		whileTrue: [self world doOneSubCycle].
	self delete.
	^ modalAnswer! !


!DialogWindow class methodsFor: 'as yet unclassified' stamp: 'jlb 3/24/2002 22:32'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	| toReturn |
	toReturn _ self new.
	toReturn placeWarningForm.
	toReturn addDialogText: queryString.
	toReturn addYesNoButtons.
	toReturn setLabel: 'Squeak Message'.
	toReturn closeBox disabled: true.
	toReturn setProperty: #morphicLayerNumber toValue: 20. 
	World addMorphCentered: toReturn.
	^ toReturn waitForAnswer.! !


!TextContainer methodsFor: 'access' stamp: 'jlb 4/22/2002 14:03'!
paragraphClass
	^ NewParagraph! !


!TextMorph methodsFor: 'accessing' stamp: 'jlb 4/16/2002 13:42'!
fontName: fontName size: fontSize
	| newTextStyle |
	newTextStyle _ (TextStyle named: fontName asSymbol) copy.
	newTextStyle ifNil: [self halt: 'Error: font ', fontName, ' not found.'].

	textStyle _ newTextStyle.
	text addAttribute: (TextFontChange fontNumber: (newTextStyle fontIndexOfSize: fontSize)).
	paragraph ifNotNil: [paragraph textStyle: newTextStyle]! !


!DialogTextMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/24/2002 20:12'!
activate
	self color:  ( ButtonTheme current enabledTextColor ).! !

!DialogTextMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/24/2002 20:12'!
initialize
	super initialize.
	self setProperty: #wantsActivate toValue: true .

	! !

!DialogTextMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/24/2002 20:12'!
passivate
	self color: ( ButtonTheme current disabledTextColor ).! !


!ToolBarButtonMorph methodsFor: 'events-processing' stamp: 'jlb 4/9/2002 00:38'!
mouseEnterEvent: evt for: aMorph 
	state = #selected
		ifFalse: [self state: #mouseOver]! !

!ToolBarButtonMorph methodsFor: 'events-processing' stamp: 'jlb 4/9/2002 00:38'!
mouseLeave: evt 
	super mouseLeave: evt.
	state = #selected
		ifFalse: [self state: #off]! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/26/2002 22:45'!
icon
	^ icon! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/30/2002 17:07'!
icon: aThreeImageForm
	" normal, hot, disabled "
	" split it up and put it into the form dictionary "
	| aForm top |
	iconForm _ aThreeImageForm.
	aForm _ aThreeImageForm copy: ( 0@0 extent: 16@16 ).
	icon _ ImageMorph new.
	icon image: aForm.
	icon name: #icon.
	self addMorph: icon.
	top _ ( self bounds height - icon bounds height ) / 2 asInteger.
	icon position: 4@top.! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/27/2002 19:08'!
label
	^ label! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/30/2002 17:08'!
label: aString
	| font left stringMorph top |
	
	ButtonTheme current ifNotNilDo: [ :theme | font _ theme systemFont ].
	label _ aString.
	stringMorph _ StringMorph contents: aString font: font.
	stringMorph name: #label.
	self addMorph: stringMorph.
	" position the string to the right of an icon if applicable "
	left _ 4.
	icon ifNotNil: [ left _ icon right + left ].
	top _ ( self bounds height - stringMorph bounds height ) / 2 asInteger.
	stringMorph position: left@top.
	self extent:  (stringMorph right + 6) @ ( self height).
	! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/30/2002 17:23'!
positionIcon
	| top |
	top _ ( self bounds height - icon bounds height ) / 2 asInteger.
	icon position: 4@top.! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 3/30/2002 17:36'!
positionIcon: pressedFlag
	| top aPoint |

	" if the icon is pressed, move it a little bit "
	top _ ( self bounds height - icon bounds height ) / 2 asInteger.
	aPoint _ 4@top + self topLeft.
	pressedFlag ifTrue: [ aPoint _ aPoint + (1@1) ].
	icon position: aPoint.! !

!ToolBarButtonMorph methodsFor: 'accessing' stamp: 'jlb 4/9/2002 00:32'!
state: aStateSymbol 
	"Change the image and invalidate the rect."
	"This controls two settings ; the 'bounding' frame as well as the 
	contained icon"
	| symbol iconFormExtent iconOffset aForm singleFormHeight |
	state _ aStateSymbol.
	symbol _ nil.
	iconFormExtent _ iconForm boundingBox extent.
	singleFormHeight _ iconForm boundingBox height / 3.
	iconOffset _ 0 @ 0.
	self positionIcon: false.
	(disabled
			or: [active not])
		ifTrue: [symbol _ #disabled.
			iconOffset _ 0 @ (2 * singleFormHeight)]
		ifFalse: [state caseOf: {
				[#selected] -> [ symbol _ #selected ].
				[#pressed] -> 
					[symbol _ #pressed.
					self positionIcon: true.
					iconOffset _ 0 @ singleFormHeight].
				[#off] -> [symbol _ #normal].
				[#on] -> 
					[symbol _ #selected.].
				[#mouseOver] -> 
					[symbol _ #focus.
					iconOffset _ 0 @ singleFormHeight]}].
	self
		image: (forms at: symbol).
	aForm _ iconForm
				copy: (iconOffset extent: iconFormExtent x @ singleFormHeight).
	icon image: aForm! !

!ToolBarButtonMorph methodsFor: 'initialization' stamp: 'jlb 4/9/2002 00:31'!
fromImages: buttonImages 

	self fromImages: buttonImages symbols: #( #normal #pressed #disabled #focus #selected ).
	self state: #off.
! !

!ToolBarButtonMorph methodsFor: 'initialization' stamp: 'jlb 3/26/2002 20:51'!
initialize
	super initialize.
	self on: #mouseEnter send: #mouseEnterEvent:for: to: self.
! !


!ToolBarMorph methodsFor: 'geometry' stamp: 'jlb 3/26/2002 11:50'!
extent: aPoint 
	| aFill |
	super extent: aPoint.
	aFill _ self fillStyle.
	aFill isGradientFill
		ifTrue: [aFill direction: aPoint x @ 0]! !

!ToolBarMorph methodsFor: 'initialization' stamp: 'jlb 3/26/2002 10:35'!
barFillStyle

	| fill theme |
	theme _ ToolbarTheme current.
	theme ifNil: [ ^ nil ].
	fill _ GradientFillStyle ramp: {
		0.0 -> (theme leftColor). 
		1.0 -> (theme rightColor)}.
	fill origin: (0@0).
	fill direction: 40@0.
	fill radial: false.
	^ fill

! !

!ToolBarMorph methodsFor: 'initialization' stamp: 'jlb 3/28/2002 23:28'!
initialize
	super initialize.
	self alignmentLayout.
	self fillStyle: self barFillStyle.
	self layoutInset: 0.
	self on: #mouseDown send: #mouseDown: to: self. 

! !

!ToolBarMorph methodsFor: 'events-processing' stamp: 'jlb 3/28/2002 23:30'!
mouseDown: anEvent
	" I don't respond to the mouse "! !

!ToolBarMorph methodsFor: 'drawing' stamp: 'jlb 3/26/2002 13:24'!
drawOn: aCanvas
	| bottomColor theme topColor |
	super drawOn: aCanvas.
	theme _ ToolbarTheme current.
	topColor _ theme ifNil: [ Color white ]
			ifNotNil: [ theme topColor ].
	aCanvas
		line: bounds topLeft 
		to: bounds topRight - ( 1@0 )
		width: 1
		color: topColor.	

	bottomColor _ theme ifNil: [ Color black ]
			ifNotNil: [ theme bottomColor ].
	aCanvas
		line: bounds bottomLeft - (0 @ 1)
		to: bounds bottomRight - (1 @ 1)
		width: 1
		color: bottomColor.! !


!ToolBarSeparator methodsFor: 'drawing' stamp: 'jlb 3/27/2002 07:12'!
drawOn: aCanvas 
	"draw the separator bar"
	| x |
	x _ self width / 2 .
	aCanvas line: ( (x@2) asIntegerPoint + self topLeft )
		to: ((x@(self height - 4)) asIntegerPoint + self topLeft )
		color: barColor.! !

!ToolBarSeparator methodsFor: 'initialization' stamp: 'jlb 3/30/2002 23:28'!
initialize
	| theme |
	super initialize.
	theme _ ToolbarTheme current.
	barColor _ Color black.
	theme
		ifNotNil: [self extent: theme separatorWidth @ theme toolBarHeight.
			self color: Color transparent.
			barColor _ theme separatorColor]! !


!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
bottomColor
  ^ lookDictionary at: #bottomColor ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
leftColor
  ^ lookDictionary at: #leftColor ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
rightColor
  ^ lookDictionary at: #rightColor ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
separatorColor
  ^ lookDictionary at: #separatorColor ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
separatorWidth
  ^ lookDictionary at: #separatorWidth ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 07:11'!
toolBarHeight
  ^ lookDictionary at: #toolBarHeight ifAbsent: [ 32 ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
toolButtonEdges
  ^ lookDictionary at: #toolButtonEdges ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
toolButtonForm
  ^ lookDictionary at: #toolButtonForm ifAbsent: [ nil ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 07:11'!
toolbarHeight
  ^ lookDictionary at: #toolbarHeight ifAbsent: [ 32 ]! !

!ToolbarTheme methodsFor: 'accessors' stamp: 'jlb 3/27/2002 06:48'!
topColor
  ^ lookDictionary at: #topColor ifAbsent: [ nil ]! !


!TwoModeButtonMorph class methodsFor: 'example' stamp: 'jlb 4/28/2002 12:31'!
example
	| form |
	" TwoModeButtonMorph example "
	" The file 'close.bmp' should be in the current directory "
	form _ Form fromFileNamed: 'helpButton.bmp' .
	" For this demo, the corners of the button appear to be rounded. Transparencies are coded as black in the bitmap of the button "
	form replaceColor: Color magenta withColor: Color transparent.
	" open an X button ; click on button to open a Browser "
	^ self new fromImages: form ; 
		target: Browser ;
		actionSelector: #openBrowser ;
		position: 10 @ 10 ;
		openInWorld.! !


!CheckBoxMorph class methodsFor: 'instance creation' stamp: 'jlb 3/26/2002 20:38'!
newInstance
	| toReturn theme |
	toReturn _ self new.
	theme _ ButtonTheme current.
	theme ifNil: [ ^ toReturn ].
	toReturn fromImages:  (theme checkBoxForm).
	theme checkBoxEdges	ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	^ toReturn.! !


!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 9/24/2001 21:46'!
fromMenuMorph:  aMenuMorph
	| newMorph |

	newMorph _ aMenuMorph as: PulldownMenuMorph.
	aMenuMorph become: newMorph.
	aMenuMorph setColors.
	aMenuMorph color: Color transparent.
	aMenuMorph borderWidth: 0.
	aMenuMorph initializeCover.
	aMenuMorph extent: ( aMenuMorph extent ).
	^ self label: ( aMenuMorph getTitleString ) 
		menu: aMenuMorph.! !

!MenuBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 3/26/2002 15:38'!
fromMenuMorphPlain:  aMenuMorph
	| newMorph |

	newMorph _ aMenuMorph as: PulldownMenuMorph.
	aMenuMorph become: newMorph.
	aMenuMorph extent: ( aMenuMorph extent ).
	^ self label: ( aMenuMorph getTitleString ) 
		menu: aMenuMorph.
! !


!ToolBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 3/26/2002 20:39'!
newInstance
	| toReturn theme |
	toReturn _ self new.
	theme _ ToolbarTheme current.
	theme ifNil: [ ^ toReturn ].
	toReturn fromImages:  (theme toolButtonForm).
	theme toolButtonEdges	ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	^ toReturn.! !

!ToolBarButtonMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 3/30/2002 17:23'!
newInstance: iconFileName

	| toReturn graphicsPath aForm theme |
	toReturn _ self new.
	graphicsPath _ ((FileDirectory default directoryNamed: 'Toolbar') pathName), 
		(FileDirectory slash).
	aForm _ ButtonTheme readFormXlateMagenta: (graphicsPath,iconFileName).
	toReturn icon: aForm.
	theme _ ToolbarTheme current.
	theme ifNil: [ ^ toReturn ].
	toReturn fromImages:  (theme toolButtonForm).
	theme toolButtonEdges	ifNotNilDo: [:aRect | toReturn setEdges: aRect].
	toReturn positionIcon.
	^ toReturn.
! !


!UpdatingMenuItemMorph methodsFor: 'world' stamp: 'jlb 3/24/2002 09:43'!
updateContents
	"Update the receiver's contents"

	| newString enablement nArgs compareString |
	((wordingProvider == nil) or: [wordingSelector == nil]) ifTrue: [^ self].
	newString _ contents.
	nArgs _ wordingSelector numArgs.
	newString _ nArgs == 0
		ifTrue:
			[wordingProvider perform: wordingSelector]
		ifFalse:
			[(nArgs == 1 and: [wordingArgument notNil])
				ifTrue:
					[wordingProvider perform: wordingSelector with: wordingArgument]
				ifFalse:
					[nArgs == arguments size ifTrue:
						[wordingProvider perform: wordingSelector withArguments: arguments]]].
	compareString _ newString.
	MenuTheme current ifNotNil: [ compareString _ self spaceString: newString ].
	compareString = contents ifFalse: [ self contents: newString].
	enablementSelector ifNotNil:
		[(enablement _ self enablement) == isEnabled 
			ifFalse:	[self isEnabled: enablement]]! !


!WarpBlt methodsFor: 'primitives' stamp: 'jlb 2/15/2002 23:52'!
warpBackwards
	| deltaP12 deltaP43 pA pB deltaPAB sp fixedPtOne picker poker nSteps |

	(width < 1) | (height < 1) ifTrue: [^ self].
	fixedPtOne _ 16384.  "1.0 in fixed-pt representation"

	nSteps _ height-1 max: 1.
	deltaP12 _ (self deltaFrom: p1x to: p2x nSteps: nSteps)
			@ (self deltaFrom: p1y to: p2y nSteps: nSteps).
	pA _ (self startFrom: p1x to: p2x offset: nSteps*deltaP12 x)
		@ (self startFrom: p1y to: p2y offset: nSteps*deltaP12 y).
	deltaP43 _ (self deltaFrom: p4x to: p3x nSteps: nSteps)
			@ (self deltaFrom: p4y to: p3y nSteps: nSteps).
	pB _ (self startFrom: p4x to: p3x offset: nSteps*deltaP43 x)
		@ (self startFrom: p4y to: p3y offset: nSteps*deltaP43 y).

	picker _ BitBlt bitPeekerFromForm: destForm.		"ugly"
	poker _ BitBlt bitPokerToForm: sourceForm .
	poker clipRect: sourceForm boundingBox.
	nSteps _ width-1 max: 1.
	destY to: destY+height-1 do: [:y |
		deltaPAB _ (self deltaFrom: pA x to: pB x nSteps: nSteps)
				@ (self deltaFrom: pA y to: pB y nSteps: nSteps).
		sp _ (self startFrom: pA x to: pB x offset: nSteps*deltaPAB x)
			@ (self startFrom: pA y to: pB y offset: nSteps*deltaPAB y).
		destX to: destX+width-1 do: [:x | 
			poker pixelAt: sp // fixedPtOne asPoint put: (picker pixelAt: x@y).
			sp _ sp + deltaPAB.
		].
		pA _ pA + deltaP12.
		pB _ pB + deltaP43.
	]. ! !


!WarpBlt class methodsFor: 'examples' stamp: 'jlb 2/15/2002 23:53'!
warpToQuad
"An experiment in warping FROM a rectangle TO a quad"

 "Here is an example: there is a Form whose bounding box is
(0@0 corner: 10@10), and I'd like to transform it onto a
quad specified as {0@0. 2@12. 7@8. 16@-6}.  It's ok the
edges are distorted (inward) by WarpBlt but I want the
original corners to be transformed onto the corners of the
resulting quad."
"WarpBlt warpToQuad"

	| sourceForm destQuad destRect destForm |

	sourceForm _ Color colorRampForDepth: 32 extent: 256@80.
	destQuad _ {0@0. 2@12. 7@8. 16@-6}.
	destRect _ destQuad min corner: destQuad max.
	(destForm _ Form extent: destRect extent depth: 32) fillColor: Color white.
	(self toForm: sourceForm)
		sourceForm: destForm;
		combinationRule: Form over;
		sourceQuad: (destQuad collect: [ :pt | pt - destRect topLeft]) 
		destRect: sourceForm boundingBox;
		warpBackwards.
	destForm bitEdit.
! !


!WindowBorderCornerMorph methodsFor: 'event handling' stamp: 'jlb 4/20/2002 21:06'!
mouseDown: event 
	"calculate the offset from the cursor point to the edge of the 
	owner bounds"
	| resizer localPt newBounds symbolName offsetPt |
	symbolName _ self knownName.
	offsetPt _ self calculateOffset: event cursorPoint.
	self fastFramingOn
		ifTrue: [^ self doFastWindowReframe: symbolName offset: offsetPt].
	resizer _ NewHandleMorph new.
	resizer color: Color transparent;
		 borderWidth: 0.
	resizer position: event cursorPoint - (resizer extent / 2).
	"set up the follow block"
	resizer
		followHand: event hand
		forEachPointDo: [:p | 
			localPt _ self pointFromWorld: p.
			newBounds _ owner bounds
						withSideOrCorner: symbolName
						setToPoint: localPt + offsetPt
						minExtent: owner windowMinimumExtent.
			newBounds = owner bounds
				ifFalse: [owner setWindowBounds: newBounds]]
		lastPointDo: [:p | "check to make sure that we're still in the frame border"
			(self containsPoint: p)
				ifFalse: [self mouseLeave: nil].
				self stop].
	"place the resizer into the worlds top layer"
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!WindowBorderCornerMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/20/2002 21:18'!
wantsSteps
	^ false.! !


!WindowBorderMorph methodsFor: 'stepping and presenter' stamp: 'jlb 4/20/2002 21:12'!
wantsSteps
	^ false.! !


!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 3/23/2002 17:21'!
deleteCollapseBox
	self collapseBox ifNotNil: [ self collapseBox delete ].! !

!WindowFrameMorph methodsFor: 'buttons' stamp: 'jlb 3/23/2002 17:21'!
deleteExpandBox
	self expandBox ifNotNil: [ self expandBox delete ].! !

!WindowFrameMorph methodsFor: 'layout' stamp: 'jlb 3/21/2002 21:48'!
paneInset: aRectangle
	" define the inset of the pane in the window frame "
	topLeftInset _ aRectangle origin.
	bottomRightInset _ aRectangle corner.! !


!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/26/2002 11:13'!
addMenuBar
	" add a menu bar to the window frame and return the menu bar "
	^ self addMenuBar: theme.! !

!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/26/2002 11:48'!
addMenuBar: aTheme 
	| menuBar paneInset menuBarHeight newTop |
	menuBar _ MenuBarMorph new.
	menuBar borderWidth: 0.
	menuBarHeight _ aTheme menuBarHeight.
	paneInset _ self paneInset.
	newTop _ paneInset top - self borderWidth.
	self
		addMorph: menuBar
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (-1@newTop corner: (1 @ (menuBarHeight+newTop) ))).
	paneInset _ paneInset origin + (0 @ menuBarHeight) corner: paneInset corner.
	self paneInset: paneInset.
	owner layoutChanged.
	^ menuBar! !

!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/26/2002 11:09'!
addStatusBar
	" add a status bar to the window frame and return the status bar "
	^ self addStatusBar: theme.! !

!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/30/2002 23:40'!
addStatusBar: aTheme 
	| statusBar fill  paneInset statusBarHeight |
	statusBar _ RectangleMorph new.
	statusBar layoutPolicy: ProportionalLayout new.
	statusBar borderWidth: 0.
	statusBarHeight _ aTheme statusBarHeight.
	aTheme statusBar
		ifNotNilDo: [:aForm | 
			fill _ BitmapFillStyle fromForm: aForm.
			fill origin: statusBar topLeft.
			statusBar fillStyle: fill.
			statusBarHeight _ aForm height - 1].
	self
		addMorph: statusBar
		fullFrame: (LayoutFrame
				fractions: (0@1 corner: 1 @ 1)
				offsets: ((-1@ ( statusBarHeight negated ) corner: 1@1))).
	paneInset _ self paneInset.
	paneInset _ paneInset origin corner: ( paneInset corner + ( 0 @ statusBarHeight) ).
	self paneInset: paneInset.
	owner layoutChanged.
	^ statusBar.! !

!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/26/2002 12:12'!
addToolBar
	" add a tool bar to the window frame and return the menu bar "
	^ self addToolBar: theme.! !

!WindowFrameImagedMorph methodsFor: 'menu, tool and status bar' stamp: 'jlb 3/26/2002 12:15'!
addToolBar: aTheme 
	|  paneInset  newTop toolBar toolBarHeight |
	toolBar _ ToolBarMorph new.
	toolBar borderWidth: 0.
	toolBarHeight _ aTheme toolBarHeight.
	paneInset _ self paneInset.
	newTop _ paneInset top - self borderWidth.
	self
		addMorph: toolBar
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (-1@newTop corner: (1 @ (toolBarHeight+newTop) ))).
	paneInset _ paneInset origin + (0 @ toolBarHeight) corner: paneInset corner.
	self paneInset: paneInset.
	owner layoutChanged.
	^ toolBar! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 5/14/2002 07:25'!
color: aColor
	" I should always be transparent "
	color _ Color transparent.! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 5/12/2002 23:36'!
growBox
	^ self submorphWithProperty: #growBox! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 5/12/2002 23:37'!
hideGrowBox
	| gb |
	gb _ self growBox.
	gb ifNotNil: [ gb hide ].
	! !

!WindowFrameImagedMorph methodsFor: 'accessing' stamp: 'jlb 5/12/2002 23:37'!
showGrowBox
	| gb |
	gb _ self growBox.
	gb ifNotNil: [ gb show ].
	! !

!WindowFrameImagedMorph methodsFor: 'initialization' stamp: 'jlb 5/14/2002 07:23'!
initialize
	super initialize.
	borderWidth _ 4.
	self showResizeEdges.
	color _ Color transparent.
! !


!WindowIcon methodsFor: 'event handling' stamp: 'jlb 2/15/2002 20:28'!
addToDockBack: aMorphDock
	vehicle delete.
	self show.
	aMorphDock addMorphBack: self.
! !

!WindowIcon methodsFor: 'event handling' stamp: 'jlb 2/15/2002 23:19'!
expand
	owner isHandMorph
		ifTrue: [vehicle openInWorld.
				vehicle start]
		ifFalse: [self expandRepresentative]! !

!WindowIcon methodsFor: 'event handling' stamp: 'jlb 2/15/2002 21:32'!
expand: expansionFlag 
	"If we expand the underlying morph, then get rid of the icon"
	expansionFlag
		ifTrue: [self delete.
			morphRepresented show]
		ifFalse: ["just carrying the icon from one place to another"
			self show.
			vehicle delete.
		]! !

!WindowIcon methodsFor: 'event handling' stamp: 'jlb 1/31/2002 10:06'!
expandRepresentative
	| iconInfo |
	
	morphRepresented ifNil: [ ^ self ].
	self hideLabel.
	iconInfo _ self iconInfo.
	morphRepresented setProperty: #iconInfo toValue: iconInfo.
	morphRepresented expand.
	self world addMorphFront: morphRepresented.
	self doExpandAnimation.! !

!WindowIcon methodsFor: 'event handling' stamp: 'jlb 2/15/2002 20:28'!
positionDock: aMorphDock index: anIntegerIndex
	vehicle delete.
	self show.
	aMorphDock dock: self index: anIntegerIndex.
! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 1/31/2002 14:52'!
iconInfo
	" return the information about me in a IconInfo object "
	| iconInfo |
	iconInfo _ IconInfo new.
	iconInfo position: self position.
	iconInfo bounds: self bounds.
	owner valueOfProperty: #morphDock ifPresentDo: [ :props |
		iconInfo ownerDock: owner.
		iconInfo index: ( owner elementOf: self ).
	 ]. 
	^ iconInfo.! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 3/19/2002 13:12'!
morphRepresented: aSystemWindow

	self extent: ( aSystemWindow width @ ZurglePreferences iconHeight ).
	morphRepresented _ aSystemWindow.
	self computeThumbnail.
	self label: aSystemWindow label.
	self align: self topRight with: morphRepresented topRight.
! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 2/3/2002 00:17'!
originVector
	| target aPt |
	^ owner isHandMorph
		ifTrue: [target _ B3DVector3 zero.
			aPt _ self center.
			target x: aPt x.
			target z: aPt y.
			target]
		ifFalse: [originVector]! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 2/3/2002 00:18'!
originVector: aB3DVector
	originVector _ aB3DVector.
! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 2/2/2002 21:56'!
targetVector
	| target aPt |
	^ owner isHandMorph
		ifTrue: [target _ B3DVector3 zero.
			aPt _ self center.
			target x: aPt x.
			target z: aPt y.
			target]
		ifFalse: [targetVector]! !

!WindowIcon methodsFor: 'accessing' stamp: 'jlb 2/2/2002 21:46'!
targetVector: aB3DVector
	targetVector _ aB3DVector! !

!WindowIcon methodsFor: 'drawing' stamp: 'jlb 2/2/2002 17:20'!
alphaFactor
	" alpha factor is the amount of transparency when the image is drawn.
	  0 is translucent
	  255 is opaque ; should be 160 "
	^ (self valueOfProperty: #carrying)
		ifTrue: [ 100 ]
		ifFalse: [ 180 ].! !

!WindowIcon methodsFor: 'drawing' stamp: 'jlb 2/15/2002 23:04'!
drawOn: aCanvas 
	(self valueOfProperty: #carrying)
		ifTrue: [^ self drawTranslucentOn: aCanvas]
		ifFalse: [super drawOn: aCanvas]! !

!WindowIcon methodsFor: 'initialization' stamp: 'jlb 2/16/2002 09:26'!
initialize

	super initialize.
	self extent: 128 @ (ZurglePreferences iconHeight ) ;
		setProperty: #carrying toValue: false ;
		setProperty: #windowAlias toValue: true.
	poof _ AnimationMorph explode.
	poof setProperty: #morphicLayerNumber toValue: 5.
	self initializeFollower.
! !

!WindowIcon methodsFor: 'initialization' stamp: 'jlb 2/15/2002 20:33'!
initializeFollower
	vehicle _ DeliverMorph new.
	vehicle target: self ;
		lock ;
		maxSpeed: 500 ;
		setProperty: #morphicLayerNumber toValue: 5.
! !

!WindowIcon methodsFor: 'opening' stamp: 'jlb 5/12/2002 11:50'!
open
	| iconInfo ownerDock |

	ZurglePreferences collapseToMorphDock ifFalse: [ ^ self doCollapseAnimation ].
	iconInfo _ morphRepresented valueOfProperty: #iconInfo.
	iconInfo
		ifNil: ["put into MorphDock"
			MorphDock current addThumbnail: self]
		ifNotNil: [ownerDock _ iconInfo ownerDock.
			ownerDock
				ifNil: ["sits on desktop"
					self doCollapseAnimation]
				ifNotNil: [(World submorphs includes: ownerDock)
						ifTrue: ["try to replace into owners dock at 
							remembered location"
							self openInWorld.
							ownerDock positionThumbnail: self atIndex: iconInfo index]
						ifFalse: ["the owner dock has been deleted or is in 
							a different project/world"
							MorphDock current addThumbnail: self]]]! !

!WindowIcon methodsFor: 'dropping/grabbing' stamp: 'jlb 2/15/2002 21:28'!
justDroppedInto: aMorph event: anEvent
	" the hand just dropped me "
	super justDroppedInto: aMorph event: anEvent.
	vehicle stop ; delete.
! !

!WindowIcon methodsFor: 'dropping/grabbing' stamp: 'jlb 2/15/2002 22:59'!
justGrabbedFrom: formerOwner 
	"now in the hand"
	| position currentPosition |
	super justGrabbedFrom: formerOwner.
	vehicle extent: bounds extent + (1 @ 1).
	vehicle selector: nil.
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle currentPosition: currentPosition.
	vehicle maxSpeed: 80.
	vehicle openInWorld ; show ; start.
! !

!WindowIcon methodsFor: 'dropping/grabbing' stamp: 'jlb 1/30/2002 19:58'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph. This check is symmetric to #wantsDroppedMorph:event: to give both parties a chance of figuring out whether they like each other."
	self hideLabel.
	^true! !

!WindowIcon methodsFor: 'submorphs-add/remove' stamp: 'jlb 2/14/2002 21:43'!
delete
	super delete.
	vehicle ifNotNil: [ vehicle delete].
	label ifNotNil: [ label delete ].! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 2/15/2002 20:29'!
addToMorphDock: aMorphDock to: aTargetPt 
	"animate going from current position to the morph dock"
	| position currentPosition |
	vehicle target: self;
		 selector: #addToDockBack:;
		 arguments: {aMorphDock}.
	vehicle extent: bounds extent + (1 @ 1).
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle currentPosition: currentPosition.
	self
		targetVector: (B3DVector3
				x: aTargetPt x
				y: 0
				z: aTargetPt y).
	self openInWorld ; hide.
	vehicle openInWorld ;
		show ;
		start.
! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 5/12/2002 11:38'!
doCollapseAnimation
	| iconInfo aSystemWindow |
	aSystemWindow _ morphRepresented.
	iconInfo _ aSystemWindow valueOfProperty: #iconInfo.
	self align: self topRight with: aSystemWindow topRight.
	self openInWorld.
	iconInfo
		ifNotNil: [self position = iconInfo position
				ifFalse: [ZurglePreferences moveAnimation
						ifTrue: [self startCollapseAnimation]
						ifFalse: [self position: iconInfo bounds topLeft]]]! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 2/15/2002 22:45'!
doExpandAnimation
	| dockExtent |
	ZurglePreferences moveAnimation
		ifTrue: ["make sure we're in the current world"
			(owner hasProperty: #morphDock)
				ifTrue: ["we're in a morph dock ; get ready for animation"
					dockExtent _ ZurglePreferences dockHeight @ ZurglePreferences dockHeight.
					poof extent: ( self extent max: dockExtent).
					owner replaceSubmorph: self by: poof.]
				ifFalse: [
					poof align: poof center with: self center.
					poof openInWorld].
			self openInWorld.
			self startFollowing: true targetPoint:  morphRepresented center.
			self hide.
			poof start]
		ifFalse: [self expand: true]! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 2/15/2002 20:31'!
positionInMorphDock: aMorphDock atIndex: anIntegerIndex to: aTargetPt 
	"animate going from current position to the morph dock"
	| position currentPosition |
	vehicle target: self;
		 selector: #positionDock:index:;
		 arguments: {aMorphDock. anIntegerIndex}.
	vehicle extent: bounds extent + (1 @ 1).
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle currentPosition: currentPosition.
	self
		targetVector: (B3DVector3
				x: aTargetPt x
				y: 0
				z: aTargetPt y).

	self openInWorld ; hide.
	vehicle openInWorld ; show ; start.
! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 5/12/2002 11:35'!
startCollapseAnimation
	| iconInfo |
	iconInfo _ morphRepresented valueOfProperty: #iconInfo.
	self hide.
	self startFollowing: false targetPoint: (iconInfo bounds center). 
	self position: iconInfo bounds topLeft.
! !

!WindowIcon methodsFor: 'animation' stamp: 'jlb 2/15/2002 22:58'!
startFollowing: expandFlag targetPoint: aPoint
	| position currentPosition |

	vehicle target: self;
		 selector: #expand:;
		 arguments: {expandFlag}.
	vehicle extent: bounds extent + (1 @ 1).
	vehicle maxSpeed: 500.
	position _ self center.
	currentPosition _ B3DVector3
				x: position x
				y: 0
				z: position y.
	vehicle currentPosition: currentPosition.

	self originVector: currentPosition.
	self
		targetVector: (B3DVector3
				x: aPoint x
				y: 0
				z: aPoint y).
	vehicle openInWorld ; show ; start.
! !

!WindowIcon methodsFor: 'geometry' stamp: 'jlb 2/2/2002 00:26'!
encompassingBounds
	" return the entire bounds of the morph including the title "
	^ super fullBounds! !

!WindowIcon methodsFor: 'geometry' stamp: 'jlb 2/2/2002 15:35'!
extent: aPoint
	super extent: aPoint.
	vehicle ifNotNil: [ vehicle extent: aPoint ].! !

!WindowIcon methodsFor: 'geometry' stamp: 'jlb 2/2/2002 09:42'!
fullBounds
	| subBounds |
	
	true ifTrue: [ ^ super fullBounds ].
	owner ifNotNil: [ 
	( owner hasProperty: #morphDock ) ifTrue: [ ^ self bounds ]].
	fullBounds ifNil:[
		fullBounds _ self bounds.
		submorphs do:[:m|
			m visible ifTrue: [
			subBounds _ m fullBounds.
			fullBounds _ fullBounds quickMerge: subBounds.]
		].
	].
	^fullBounds! !

!WindowIcon methodsFor: 'testing' stamp: 'jlb 2/2/2002 00:12'!
isCollapsed
	^ true.! !


!WindowIconTitle methodsFor: 'dropping/grabbing' stamp: 'jlb 2/5/2002 20:31'!
wantsToBeDroppedInto: aMorph 
	"Return true if it's okay to drop the receiver into aMorph. This 
	check is symmetric to #wantsDroppedMorph:event: to give both 
	parties a chance of figuring out whether they like each other."
	(aMorph hasProperty: #morphDock)
		ifTrue: [^ false].
	^ true! !

!WindowIconTitle methodsFor: 'label' stamp: 'jlb 2/5/2002 15:55'!
label: aString 
	"this isn't very straightforward ; I create a StringMorph with the 
	title,  
	create a RectangleMorph to put it in and add both to the 
	MorphIcon "
	| sm height |
	label _ aString.
	sm _ StringMorph
				contents: aString
				font: ZurglePreferences iconFont
				emphasis: 1.
	sm color: ZurglePreferences labelTextColor ;
		setProperty: #morphicLayerNumber toValue: 10.
	height _ ZurglePreferences iconFont height + 3.
	self extent: ( (sm bounds expandBy: 3@3) extent).
	sm position: (self topLeft + (3@3)).
	self removeAllMorphs.
	self addMorph: sm.
! !

!WindowIconTitle methodsFor: 'label' stamp: 'jlb 2/15/2002 23:05'!
showLabel: aBoolean 
	ZurglePreferences showIconTitle
		ifTrue: [label
				ifNotNil: ["label visible: aBoolean."
					aBoolean
						ifTrue: [self openInWorld.
							self show]
						ifFalse: [self delete].
					fullBounds _ nil.
					self refreshWorld]]! !

!WindowIconTitle methodsFor: 'initialization' stamp: 'jlb 2/16/2002 09:25'!
initialize
	super initialize.
	self color: ZurglePreferences labelColor ;
		 borderWidth: 1;
		 borderColor: ZurglePreferences labelTextColor;
		 setProperty: #morphicLayerNumber toValue: 10.
! !


!WindowTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 11:07'!
menuBarHeight
  ^ lookDictionary at: #menuBarHeight ifAbsent: [ 20 ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 3/21/2002 20:41'!
statusBar
  ^ lookDictionary at: #statusBar ifAbsent: [ nil ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 10:58'!
statusBarHeight
  ^ lookDictionary at: #statusBarHeight ifAbsent: [ 20 ]! !

!WindowTheme methodsFor: 'accessors' stamp: 'jlb 3/26/2002 11:08'!
toolBarHeight
  ^ lookDictionary at: #toolBarHeight ifAbsent: [ 20 ]! !


!ZurglePreferences methodsFor: 'see class side' stamp: 'jlb 5/2/2000 17:03'!
seeClassSide
	"All the code for ZurlgePreferences is on the class side"! !


!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/12/2002 11:26'!
collapseToMorphDock
	^ CollapseToMorphDock! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/12/2002 11:26'!
collapseToMorphDock: aBoolean
	CollapseToMorphDock _ aBoolean! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/12/2002 23:10'!
collapseToTitleBar
	^ CollapseToTitleBar! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/12/2002 23:11'!
collapseToTitleBar: aBoolean
	 CollapseToTitleBar _ aBoolean! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:46'!
dockHeight
	^ DockHeight.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:47'!
dockHeight: anInteger
	DockHeight _ anInteger.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:47'!
dockWidth
	^ DockWidth.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:47'!
dockWidth: anInteger
	DockWidth _ anInteger.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/8/2000 22:04'!
iconFont
	^ IconFont! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/8/2000 22:04'!
iconFont: aFont
	IconFont _ aFont.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/7/2000 20:44'!
iconHeight
	^ IconHeight! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/7/2000 20:44'!
iconHeight: anInteger
	IconHeight _ anInteger! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/9/2000 12:00'!
labelColor
	^ LabelColor! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/9/2000 12:00'!
labelColor: aColor
	LabelColor _ aColor.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/9/2000 12:00'!
labelTextColor
	^ LabelTextColor! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/9/2000 12:00'!
labelTextColor: aColor
	LabelTextColor _ aColor.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:47'!
moveAnimation
	^ MoveAnimation! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:48'!
moveAnimation: aBoolean
	 MoveAnimation _ aBoolean.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:48'!
shakeAnimation
	^  ShakeAnimation ! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 5/1/2000 23:48'!
shakeAnimation: aBoolean
	 ShakeAnimation _ aBoolean.! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/8/2000 21:53'!
showIconTitle
	^ ShowIconTitle.  " should be a boolean "! !

!ZurglePreferences class methodsFor: 'access preferences' stamp: 'jlb 7/8/2000 21:53'!
showIconTitle: aBoolean
	ShowIconTitle _ aBoolean.! !

!ZurglePreferences class methodsFor: 'class initialization' stamp: 'jlb 5/12/2002 23:11'!
initialize	
	" ZurglePreferences initialize "
	DockHeight _ 96.
	DockWidth _ 96.
	MoveAnimation _ true.
	ShakeAnimation _ true.
	IconHeight _ 96.
	" Should we show the icon title string or not "
	ShowIconTitle _ true.
	" The font to show associated with a window icon "
	IconFont _ (StrikeFont familyName: #NewYork size: 15).
	LabelColor _ Color lightYellow.
	LabelTextColor _ Color black.
	CollapseToMorphDock _ false.
	CollapseToTitleBar _ false.! !

ZurglePreferences initialize!

!ZurglePreferences class reorganize!
('access preferences' collapseToMorphDock collapseToMorphDock: collapseToTitleBar collapseToTitleBar: dockHeight dockHeight: dockWidth dockWidth: iconFont iconFont: iconHeight iconHeight: labelColor labelColor: labelTextColor labelTextColor: moveAnimation moveAnimation: shakeAnimation shakeAnimation: showIconTitle showIconTitle:)
('class initialization' initialize)
!


!ZurglePreferences reorganize!
('see class side' seeClassSide)
!


!WindowIcon reorganize!
('event handling' addToDockBack: expand expand: expandRepresentative positionDock:index:)
('accessing' iconInfo morphRepresented: originVector originVector: targetVector targetVector:)
('drawing' alphaFactor drawOn:)
('initialization' initialize initializeFollower)
('opening' open)
('dropping/grabbing' justDroppedInto:event: justGrabbedFrom: wantsToBeDroppedInto:)
('submorphs-add/remove' delete)
('animation' addToMorphDock:to: doCollapseAnimation doExpandAnimation positionInMorphDock:atIndex:to: startCollapseAnimation startFollowing:targetPoint:)
('geometry' encompassingBounds extent: fullBounds)
('testing' isCollapsed)
!


!WindowFrameImagedMorph reorganize!
('menu, tool and status bar' addMenuBar addMenuBar: addStatusBar addStatusBar: addToolBar addToolBar:)
('theme support' addBottomFromTheme: addCloseBox: addGrowBox addGrowBox: addLeftFromTheme: addMaxBox: addMinBox: addRightFromTheme: addTopFromTheme: fromTheme:)
('window frame' addDefaultFrame: labelHeight setLabel:)
('accessing' color: growBox hideGrowBox showGrowBox theme theme:)
('initialization' initialize)
!


!TextMorph reorganize!
('accessing' asText autoFit: backgroundColor backgroundColor: borderWidth: contents contents: contents:wrappedTo: contentsAsIs: contentsWrapped: crAction crAction: currentDataValue editor fillStyle fillStyle: fontName:size: getCharacters getFirstCharacter hasTranslucentColor isAutoFit isTextMorph isWrapped margins margins: newContents: setCharacters: setFirstCharacter: setNumericValue: text textColor textColor: textStyle userString wrapFlag:)
('alignment' centered justified leftFlush rightFlush)
('anchors' acceptDroppingMorph:event: addMorphFront:fromWorldPosition: adjustTextAnchor: anchorMorph:at:type: privateRemoveMorph:)
('card & stack' basicType couldHoldSeparateDataForEachInstance newContents:fromCard: setNewContentsFrom: variableDocks)
('containment' fillingOnOff occlusionsOnOff ownerChanged privateOwner: recognizerArena setContainer:)
('copying' veryDeepFixupWith: veryDeepInner:)
('drawing' debugDrawLineRectsOn: drawNullTextOn: drawOn:)
('editing' acceptContents cancelEdits chooseAlignment chooseEmphasis chooseEmphasisOrAlignment chooseFont chooseStyle clearTypeIn enterClickableRegion: handleEdit: handleInteraction:fromEvent: handleKeystroke: handleMouseMove: handlesKeyboard: handlesMouseDown: hasFocus hasUnacceptedEdits: keyStroke: keyboardFocusChange: mouseDown: mouseMove: mouseUp: passKeyboardFocusTo: xeqLinkText:withParameter:)
('genie-dispatching' gestureHandler handleGesture: lastGesture lastGesture: setAlignment:)
('genie-processing' defaultGestureDictionaryOrName)
('geometry' areasRemainingToFill: bounds container containsPoint: defaultLineHeight extent: goBehind layoutChanged minimumExtent privateMoveBy: textBounds)
('initialization' beAllFont: configureForKids copy defaultColor initialize releaseCachedState setTextStyle: string:fontName:size: string:fontName:size:wrap:)
('linked frames' addPredecessor: addSuccessor: firstCharacterIndex firstInChain isLinkedTo: lastCharacterIndex predecessor recomposeChain startingIndex successor withSuccessorsDo:)
('menu' addCustomMenuItems:hand: autoFitOnOff autoFitString changeMargins: changeTextColor followCurve reverseCurveDirection setCurveBaseline: shiftedYellowButtonActivity wrapOnOff wrapString yellowButtonActivity)
('object fileIn' convertToCurrentVersion:refStream:)
('printing' fullPrintOn:)
('scripting access' getAllButFirstCharacter getNumericValue setAllButFirstCharacter:)
('private' adjustLineIndicesBy: clippingRectangle composeToBounds compositionRectangle delete fit installEditor installEditorToReplace: loadCachedState paragraph paragraphClass predecessor:successor: predecessorChanged releaseEditor releaseParagraph releaseParagraphReally selectionChanged setDefaultContentsIfNil setPredecessor: setSuccessor: text:textStyle: text:textStyle:wrap:color:predecessor:successor: updateFromParagraph updateReferencesUsing: wouldAcceptKeyboardFocusUponTab)
!

MorphDock initialize!

!MorphDock class reorganize!
('class variables' adhereEdge adhereEdge: current current:)
('initialization' initialize)
!


!DesktopIcon reorganize!
('accessing' dropPosition dropPosition: isOpaque: originVector originVector: targetVector targetVector:)
('animation' doExpandAnimation scooch scooch: startFollowing:targetPoint:)
('drawing' alphaFactor)
('dropping/grabbing' justDroppedInto:event: wantsToBeDroppedInto:)
('geometry' encompassingBounds extent: fullBounds)
('initialization' initialize initializeFollower)
('event handling' expand expand: expandRepresentative mouseEnterDragging:)
('stepping and presenter' step stepTime stopStepping wantsSteps)
('submorphs-add/remove' delete justGrabbedFrom:)
!


!IconMorph reorganize!
('accessing' hideLabel label label: morphRepresented: showLabel showLabel:)
('geometry' extent: fullBounds position:)
('parts bin' isKindOf: isPartsDonor isPartsDonor:)
('drawing' alphaFactor drawOn: drawTranslucentOn: hasTranslucentColor)
('event handling' click: doubleClick: startDrag:)
('menus' collapse)
('representative')
('dropping/grabbing' justDroppedInto:event:)
('initialization' initialExtent initialize)
('-- all --' expandRepresentative)
!

MenuBarProperties initialize!

!IconInfo reorganize!
('thumbnail' dock:)
('accessing' bounds bounds: inDock inDock: index index: ownerDock ownerDock: position position:)
!

